FCKit
=====

[![fckit release version](https://img.shields.io/github/release/ecmwf/fckit.svg)](https://github.com/ecmwf/fckit/releases/latest)
[![travis master](https://img.shields.io/travis/ecmwf/fckit/master.svg?label=master&logo=travis)](http://travis-ci.org/ecmwf/fckit "master")
[![travis develop](https://img.shields.io/travis/ecmwf/fckit/develop.svg?label=develop&logo=travis)](http://travis-ci.org/ecmwf/fckit "develop")
[![codecov](https://codecov.io/gh/ecmwf/fckit/branch/develop/graph/badge.svg)](https://codecov.io/gh/ecmwf/fckit)

Fortran toolkit for interoperating Fortran with C/C++.

In addition useful algorithms from ecKit are wrapped with Fortran.

Project website and reference documentation on released versions:
https://confluence.ecmwf.int/display/FCKIT

## fctest

Unit Testing Framwork for Fortran, made easy.

- C Preprocessor Macros are used to make writing tests extremely fast
- Tests in one file are bundled in a Test Suite (Fortran Module)
- Python script generates a main program for a Test Suite
- Driven by CMake build system ( and ctest )

### To use in your ecbuild project

Simply add following line to your project's CMakeLists.txt

```
ecbuild_add_option( FEATURE FCTEST  DEFAULT ${ENABLE_TESTS}
                    DESCRIPTION "Fortran Unit Testing Framework"
                    REQUIRED_PACKAGES "NAME fckit" )
```

See src/examples folder how to add and create the unit-tests.

## fckit

Various Fortran modules helpful to create mixed-language applications

- MPI
- Logging

### Offline build of fckit Python virtual environment

An offline build/installation of the fckit Python virtual environment can be completed as follows:

1. Download all necessary Python dependencies of src/fckit/fckit_yaml_reader. `ruamel.yaml.clib`
is not a pure Python package, so we have to ensure a wheel compatible with the target platform is
downloaded. pip compatibility tags for any system can be displayed using `python3 -m pip debug --verbose`,
and buit-distributions (i.e. wheels) for ruamel.yaml.clib can be found [here](https://pypi.org/project/ruamel.yaml.clib/#files).
For a linux installation based on an x86 architecture using Python3.10, the following command can be used:

```
FCKIT_WHEEL_ARCH=manylinux_2_17_x86_64 FCKIT_WHEEL_PYTHON_VERSION=310 ./populate
```

This will download all the wheels to `<source-dir>/artifacts.` It should
be noted that if `FCKIT_WHEEL_ARCH` and `FCKIT_WHEEL_PYTHON_VERSION`
are not specified then the wheels are downloaded for the calling system's Python interpreter.

2. scp/rsync/copy the directory containing the dependencies to the offline system.

3. Add the path to the `artifacts` directory to the fckit CMake configuration step, i.e. `-DARTIFACTS_DIR=<path-to-artifacts-dir>`.

### License

Please read LICENSE.

---------------------------------------------------------------------

ECMWF

FCKit
=====

[![fckit release version](https://img.shields.io/github/release/ecmwf/fckit.svg)](https://github.com/ecmwf/fckit/releases/latest)
[![travis master](https://img.shields.io/travis/ecmwf/fckit/master.svg?label=master&logo=travis)](http://travis-ci.org/ecmwf/fckit "master")
[![travis develop](https://img.shields.io/travis/ecmwf/fckit/develop.svg?label=develop&logo=travis)](http://travis-ci.org/ecmwf/fckit "develop")
[![codecov](https://codecov.io/gh/ecmwf/fckit/branch/develop/graph/badge.svg)](https://codecov.io/gh/ecmwf/fckit)

Fortran toolkit for interoperating Fortran with C/C++.

In addition useful algorithms from ecKit are wrapped with Fortran.

Project website and reference documentation on released versions:
https://confluence.ecmwf.int/display/FCKIT

## fctest

Unit Testing Framwork for Fortran, made easy.

- C Preprocessor Macros are used to make writing tests extremely fast
- Tests in one file are bundled in a Test Suite (Fortran Module)
- Python script generates a main program for a Test Suite
- Driven by CMake build system ( and ctest )

### To use in your ecbuild project

Simply add following line to your project's CMakeLists.txt

```
ecbuild_add_option( FEATURE FCTEST  DEFAULT ${ENABLE_TESTS}
                    DESCRIPTION "Fortran Unit Testing Framework"
                    REQUIRED_PACKAGES "NAME fckit" )
```

See src/examples folder how to add and create the unit-tests.

## fckit

Various Fortran modules helpful to create mixed-language applications

- MPI
- Logging

### License

Please read LICENSE.

---------------------------------------------------------------------

ECMWF

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fctest.h"
#define TEST_ABORT 0

subroutine abort_func_0()
  use fckit_module
  type(fckit_mpi_comm) :: mpi
  call fckit_log%info("custom_abort 0",flush=.true.)
  mpi = fckit_mpi_comm("world")
  call mpi%abort()
end subroutine

subroutine abort_func_1(msg)
  use fckit_module
  type(fckit_mpi_comm) :: mpi

  character(len=*), intent(in) :: msg
  character(len=1024) :: string
  write(string,*) "custom abort 1,  msg = ", msg
  call fckit_log%info(string,flush=.true.)

  mpi = fckit_mpi_comm("world")
  call mpi%abort()
end subroutine

subroutine abort_func_2(msg,file,line)
  use fckit_module
  type(fckit_mpi_comm) :: mpi

  character(len=*), intent(in) :: msg
  character(len=*), intent(in) :: file
  integer, intent(in) :: line

  character(len=1024) :: string
  write(string,*) "custom abort 2,  msg = ", msg, ", file = ",file, ", line = ",line
  call fckit_log%info(string,flush=.true.)

  mpi = fckit_mpi_comm("world")
  call mpi%abort()
end subroutine

module fckit_test_abort_fx
public
contains

subroutine abort_wrapper()
  use fckit_module
  if( fckit_exception%location%is_set() ) then
    call abort_func_2( fckit_exception%what(), fckit_exception%location%file(), fckit_exception%location%line() )
  else
    call abort_func_1( fckit_exception%what() )
  endif
end subroutine

subroutine sig_handler(signum) bind(c)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  use fckit_module
  integer(c_int32_t), value, intent(in) :: signum
  character(len=1024) :: string
  write(string,*) "signal handler intercepted signal ",signum
  call fckit_log%info(string,flush=.true.)
end subroutine

end module

TESTSUITE( fckit_test_abort )

TESTSUITE_INIT
  use fckit_module
  call fckit_main%init()
END_TESTSUITE_INIT

TESTSUITE_FINALIZE
  use fckit_module
  call fckit_main%final()
END_TESTSUITE_FINALIZE

TEST( test_signal )
  use fckit_module
  use fckit_test_abort_fx
  implicit none
  procedure(fckit_signal_handler), pointer:: signal_handler
  signal_handler => sig_handler
#if TEST_ABORT
!   call fckit_signal%restore_handlers()
!   call fckit_signal%raise(fckit_signal%SIGABRT())
#endif
  call fckit_signal%set_handler(fckit_signal%SIGABRT(),signal_handler)
  call fckit_signal%raise(fckit_signal%SIGABRT())
END_TEST

TEST( test_abort_1 )
  use fckit_module
  implicit none
  interface
    subroutine abort_func_0()
    end subroutine
  end interface
  procedure(fckit_exception_handler), pointer:: exception_handler
  exception_handler => abort_func_0
  call fckit_exception%set_handler( exception_handler )
#if TEST_ABORT
!   call fckit_exception%abort()
#endif
END_TEST

TEST( test_abort_2 )
  use fckit_module
  use fckit_test_abort_fx
  implicit none
  procedure(fckit_exception_handler), pointer:: exception_handler
  exception_handler => abort_wrapper
  call fckit_exception%set_handler( exception_handler )
# if TEST_ABORT
!   call fckit_exception%abort("test_abort_2")
#endif
END_TEST

TEST( test_abort_3 )
  use fckit_module
  use fckit_test_abort_fx
  implicit none
  procedure(fckit_exception_handler), pointer:: exception_handler
  exception_handler => abort_wrapper
  call fckit_exception%set_handler( exception_handler )
#if TEST_ABORT
!   call fckit_exception%abort("test_abort_3","test_abort.F90",__LINE__)
#endif
END_TEST

TEST( test_throw )
  use fckit_module
  implicit none
#if TEST_ABORT
!   call fckit_exception%throw("Exception: test throw","test_abort.F90",__LINE__)
#endif
END_TEST

TEST( test_interrupt )
  use fckit_module
  implicit none
#if TEST_ABORT
  call fckit_log%info("Please write CTRL+C to interrupt",flush=.true.)
  call sleep(5)
#endif
END_TEST

TEST( test_summary )
write(0,*) "Change inside this file (test_abort.F90) the definition TEST_ABORT to 1, and expect tests to fail"
END_TEST

END_TESTSUITE

! (C) Copyright 2013 ECMWF.
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

! This File contains Unit Tests for testing the
! C++ / Fortran Interfaces to the State Datastructure
! @author Willem Deconinck

#include "fckit/fctest.h"

module test_Grid_module

use fckit_owned_object_module, only: fckit_owned_object
use, intrinsic :: iso_c_binding, only : c_ptr

implicit none

private :: fckit_owned_object
private :: c_ptr

public :: test_Grid
public :: test_StructuredGrid

private

interface
    function new_Object(i) bind(c,name="new_Object")
      use, intrinsic :: iso_c_binding, only : c_ptr, c_int32_t
      type(c_ptr) :: new_Object
      integer(c_int32_t), value :: i
    end function

   subroutine delete_Object(cptr) bind(c,name="delete_Object")
     use, intrinsic :: iso_c_binding, only : c_ptr
     type(c_ptr), value :: cptr
   end subroutine
end interface

!------------------------------------------------------------------------------
TYPE, extends(fckit_owned_object) :: test_Grid

! Purpose :
! -------
!   *test_Grid* : Object Grid specifications for Grids

! Methods :
! -------

! Author :
! ------
!   9-Oct-2014 Willem Deconinck     *ECMWF*

!------------------------------------------------------------------------------
contains

#if FCKIT_FINAL_NOT_INHERITING
  final :: test_Grid__final_auto
#endif

END TYPE test_Grid

interface test_Grid
  module procedure test_Grid__ctor_id
  module procedure test_Grid__ctor_cptr
end interface

!------------------------------------------------------------------------------

TYPE, extends(test_Grid) :: test_StructuredGrid

! Purpose :
! -------
!   *test_StructuredGrid* : Object Grid specifications for Reduced Grids

! Methods :
! -------

! Author :
! ------
!   9-Oct-2014 Willem Deconinck     *ECMWF*

!------------------------------------------------------------------------------
contains
#if FCKIT_FINAL_NOT_INHERITING
  final :: test_StructuredGrid__final_auto
#endif

END TYPE test_StructuredGrid

interface test_StructuredGrid
  module procedure test_StructuredGrid__ctor_id
end interface

!------------------------------------------------------------------------------

!========================================================
contains
!========================================================

! -----------------------------------------------------------------------------
! Destructor

#if FCKIT_FINAL_NOT_INHERITING
impure elemental subroutine test_Grid__final_auto(this)
  type(test_Grid), intent(inout) :: this
#if FCKIT_FINAL_NOT_PROPAGATING
  call this%final()
#endif
  FCKIT_SUPPRESS_UNUSED( this )
end subroutine

impure elemental subroutine test_StructuredGrid__final_auto(this)
  type(test_StructuredGrid), intent(inout) :: this
#if FCKIT_FINAL_NOT_PROPAGATING
  call this%final()
#endif
  FCKIT_SUPPRESS_UNUSED( this )
end subroutine
#endif


! -----------------------------------------------------------------------------
! Constructors

function test_Grid__ctor_id(identifier) result(this)
  use fckit_c_interop_module, only: c_str
  type(test_Grid) :: this
  integer, intent(in) :: identifier
  call this%reset_c_ptr( new_Object(identifier) )
  call this%return()
end function

function test_Grid__ctor_cptr(cptr) result(this)
  use fckit_c_interop_module, only: c_str
  type(test_Grid) :: this
  type(c_ptr), intent(in) :: cptr
  call this%reset_c_ptr( cptr )
  call this%return()
end function

! -----------------------------------------------------------------------------

function test_StructuredGrid__ctor_id(identifier) result(this)
  use fckit_c_interop_module, only: c_str
  type(test_StructuredGrid) :: this
  integer, intent(in) :: identifier
  call this%reset_c_ptr( new_Object(identifier) )
  call this%return()
end function

function test_StructuredGrid__ctor_cptr(cptr) result(this)
  use fckit_c_interop_module, only: c_str
  type(test_StructuredGrid) :: this
  type(c_ptr), intent(in) :: cptr
  call this%reset_c_ptr( cptr )
  call this%return()
end function

! ----------------------------------------------------------------------------------------

end module test_grid_module


module fcta_FunctionSpace_fxt
use, intrinsic :: iso_c_binding
implicit none



contains

end module

! -----------------------------------------------------------------------------

TESTSUITE_WITH_FIXTURE(fcta_FunctionSpace,fcta_FunctionSpace_fxt)

! -----------------------------------------------------------------------------

TESTSUITE_INIT
  use fckit_module, only : fckit_main
  call fckit_main%initialise()
END_TESTSUITE_INIT

! -----------------------------------------------------------------------------

TESTSUITE_FINALIZE
  use fckit_module, only : fckit_main
  call fckit_main%finalise()
END_TESTSUITE_FINALIZE

! -----------------------------------------------------------------------------


TEST( test_nodescolumns )
use test_grid_module
#if 1
type(test_Grid) :: grid

grid = test_StructuredGrid(24)

FCTEST_CHECK_EQUAL( grid%owners(), 1 )
call grid%final()
#else
#warning test test_nodescolumns disabled
#endif
END_TEST

! -----------------------------------------------------------------------------



! -----------------------------------------------------------------------------

END_TESTSUITE

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_shared_ptr_module

#if FCKIT_HAVE_ECKIT
use fckit_refcount_module, only : &
  & fckit_refcount, &
  & fckit_refcount_interface, &
  & fckit_external, &
  & fckit_owned
#else
use fckit_refcount_module, only : &
  & fckit_refcount, &
  & fckit_refcount_interface, &
  & fckit_external
#endif
implicit none
private

!========================================================================
! Public interface

public fckit_shared_ptr
public fckit_make_shared
public fckit_refcount
public fckit_refcount_interface
public fckit_external

#if FCKIT_HAVE_ECKIT
public fckit_owned
#endif

!========================================================================

type :: fckit_shared_ptr
  class(*), pointer, private :: shared_ptr_ ! => null()
  class(fckit_refcount), pointer , private :: refcount_ => null()

  logical, private :: is_null_ = .true.
    ! Compiler bug for gcc > 7 : we may not default assign shared_ptr_ to null()
    ! Instead we use this `is_null` variable (See JIRA issue FCKIT-21)

  logical, private :: return_value = .false.
    ! This variable should not be necessary,
    ! but seems to overcome compiler issues ( gfortran 5.3, 6.3 )

contains
  procedure, public :: final => fckit_shared_ptr__final
  procedure, public :: fckit_shared_ptr__final

#if FCKIT_HAVE_FINAL
  final :: fckit_shared_ptr__final_auto
#endif

  procedure, private :: clear_shared_ptr
  procedure, public :: reset_shared_ptr
  generic, public :: reset => clear_shared_ptr, reset_shared_ptr
  generic, public :: assignment(=) => reset_shared_ptr
  procedure, public :: owners
  procedure, public :: attach
  procedure, public :: detach
  procedure, public :: return
  procedure, public :: shared_ptr => get_shared_ptr

  procedure, public :: shared_ptr_cast
  procedure, public :: clear
  procedure, public :: share

  procedure, public :: consumed

end type

!========================================================================
CONTAINS
!========================================================================

subroutine deallocate_shared_ptr( shared_ptr )
  use fckit_final_module, only: fckit_final
  class(*), pointer :: shared_ptr
#ifndef __ibmxl__
  deallocate(shared_ptr)
#else
  ! FCKIT-17: Runtime error when deallocating unlimited polymorphic pointer
  !  MEMORY LEAK!!!
  ! IBM XL COMPILER AT RUNTIME GIVES ERROR:
  !     1525-109 Error encountered while attempting to deallocate a data object.
  !     The program will stop.
#endif
  nullify( shared_ptr )
end subroutine

subroutine fckit_finalise( shared_ptr )
  use fckit_final_module, only: fckit_final
  use fckit_object_module, only: fckit_object
  class(*), pointer :: shared_ptr
  select type( shared_ptr)
#ifdef _CRAYFTN
  ! Cray compiler cce/14 has problem with typebound procedure if it is using 'class'
  type is(fckit_object)
#if FCKIT_FINAL_DEBUGGING
      write(0,*) "fckit_object%final()"
#endif
      call shared_ptr%final()
#endif
    class is(fckit_final)
#if FCKIT_FINAL_DEBUGGING
      write(0,*) "fckit_final%final()"
#endif
      call shared_ptr%final()
  end select
end subroutine

FCKIT_FINAL subroutine fckit_shared_ptr__final_auto(this)
#ifdef _CRAYFTN
  use, intrinsic :: iso_c_binding, only : c_loc, c_null_ptr
#endif
  type(fckit_shared_ptr), intent(inout) :: this
#if FCKIT_FINAL_DEBUGGING
  write(0,*) "fckit_shared_ptr__final_auto"
#endif
  ! Guard necessary for Cray compiler...
  ! ... when "this" has already been deallocated, and then
  ! fckit_shared_ptr__final_auto is called...
#ifdef _CRAYFTN
  if( c_loc(this) == c_null_ptr ) then
    return
  endif
#endif
  if( .not. this%is_null_ ) then
    if( this%owners() > 0 ) then
      call this%final()
    endif
  endif
end subroutine

subroutine fckit_shared_ptr__final(this)
  class(fckit_shared_ptr), intent(inout) :: this

#if FCKIT_FINAL_DEBUGGING
    write(0,*) "fckit_shared_ptr__final"
#endif

  if( this%is_null_ ) then
#if FCKIT_FINAL_DEBUGGING
    write(0,*) "fckit_shared_ptr__final  (uninitialised --> no-op)"
#endif
    call this%clear()
    return
  endif

#if FCKIT_FINAL_DEBUGGING
  if( this%return_value ) then
    write(0,'(A,I0)') " fckit_shared_ptr__final on return value, owners = ", this%owners()
  endif
#endif

  if( this%owners() >= 0 ) then
#if FCKIT_FINAL_DEBUGGING
    write(0,'(A,I0)') " fckit_shared_ptr__final  , owners = ", this%owners()
#endif
    call this%detach()
    if( this%owners() == 0 ) then
#if FCKIT_FINAL_DEBUGGING
      write(0,*) " + call fckit_finalise(this%shared_ptr_)"
#endif
      call fckit_finalise(this%shared_ptr_)
      call deallocate_shared_ptr(this%shared_ptr_)
      deallocate(this%refcount_)
    endif
  endif

  call this%clear()
end subroutine

subroutine clear_shared_ptr(obj_out)
  class(fckit_shared_ptr), intent(inout) :: obj_out
  if( .not. obj_out%is_null_ ) then
    nullify(obj_out%shared_ptr_)
    nullify(obj_out%refcount_)
    obj_out%is_null_ = .true.
  endif
end subroutine

subroutine clear(obj_out)
  class(fckit_shared_ptr), intent(inout) :: obj_out
  call obj_out%clear_shared_ptr()
end subroutine


subroutine reset_shared_ptr(obj_out,obj_in)
  class(fckit_shared_ptr), intent(inout) :: obj_out
  class(fckit_shared_ptr), intent(in)    :: obj_in
#if FCKIT_FINAL_DEBUGGING
  write(0,*) "fckit_shared_ptr::reset_shared_ptr(out,in)"
#endif

  if( obj_in%is_null_ ) then
    write(0,*) "ERROR! obj_in was not initialised"
  endif
#if FCKIT_FINAL_DEBUGGING
  if( obj_in%return_value ) then
    write(0,*) "obj_in is a return value"
  endif
#endif

  if( obj_out%is_null_ ) then
    nullify( obj_out%shared_ptr_ ) ! so that we can check association
  endif

  if( .not. associated( obj_out%shared_ptr_, obj_in%shared_ptr_ ) ) then
#if FCKIT_FINAL_DEBUGGING
    if( obj_out%is_null_ ) then
      write(0,*) "reset_shared_ptr of uninitialised"
    else
      write(0,*) "reset_shared_ptr of initialised"
    endif
#endif
    call obj_out%final()
    obj_out%shared_ptr_ => obj_in%shared_ptr_
    obj_out%refcount_   => obj_in%refcount_
    obj_out%is_null_ = .not. associated( obj_out%shared_ptr_ )
    if( obj_out%shared_ptr_cast() ) then
      call obj_out%attach()
    else
      call obj_out%clear()
      call bad_cast()
    endif
  else
#if FCKIT_FINAL_DEBUGGING
    write(0,*) "reset_shared_ptr ( obj_out = obj_in )"
#endif
    if( obj_out%shared_ptr_cast() ) then ; endif
  endif
end subroutine

subroutine attach(this)
  class(fckit_shared_ptr), intent(inout) :: this
  if( .not. this%is_null_ ) then
    call this%refcount_%attach()
  endif
end subroutine

subroutine detach(this)
  class(fckit_shared_ptr), intent(inout) :: this
  if( .not. this%is_null_ ) then
    call this%refcount_%detach()
  endif
end subroutine

function owners(this)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: owners
  class(fckit_shared_ptr), intent(in) :: this
  if( .not. this%is_null_ ) then
    owners = this%refcount_%owners()
  else
    owners = 0
  endif
end function

subroutine return(this)
  !! Transfer ownership to left hand side of "assignment(=)"
  class(fckit_shared_ptr), intent(inout) :: this
#if FCKIT_FINAL_FUNCTION_RESULT
  ! Cray example
  ! final will be called, which will detach, so attach first
  if( this%owners() == 0 ) then
#if FCKIT_FINAL_DEBUGGING
        write(0,*) "return --> attach"
#endif
    call this%attach()
  endif
#else
  ! final will not be called, so detach manually
  if( this%owners() > 0 ) then
#if FCKIT_FINAL_DEBUGGING
    write(0,*) "return --> detach"
#endif
    call this%detach()
  endif
#endif
#if FCKIT_FINAL_DEBUGGING
  this%return_value = .true.
#endif
end subroutine

function get_shared_ptr(this) result(shared_ptr)
  class(*), pointer :: shared_ptr
  class(fckit_shared_ptr), intent(in) :: this
  shared_ptr => this%shared_ptr_
end function

function shared_ptr_cast(this) result(success)
  class(fckit_shared_ptr) :: this
  logical :: success
  success = .true.
  FCKIT_SUPPRESS_UNUSED( this )
end function

function fckit_make_shared( ptr ) result(this)
  type(fckit_shared_ptr) :: this
  class(*), target :: ptr
#if FCKIT_FINAL_DEBUGGING
  write(0,*) "begin fckit_make_shared"
#endif
  call this%share( ptr )
  call this%return()
#if FCKIT_FINAL_DEBUGGING
  write(0,*) " this%owners() = ", this%owners()
  write(0,*) "end   fckit_make_shared"
#endif
end function

subroutine share( this, ptr, refcount )
  use, intrinsic :: iso_c_binding, only : c_funptr, c_f_procpointer
  class(fckit_shared_ptr) :: this
  class(*), target :: ptr
  type(c_funptr), optional :: refcount
  procedure(fckit_refcount_interface), pointer :: opt_refcount
  if( present(refcount) ) then
    call c_f_procpointer( refcount, opt_refcount )
  else
    opt_refcount => fckit_external()
  endif
  this%shared_ptr_ => ptr
  this%is_null_ = .not. associated( this%shared_ptr_ )
  call opt_refcount(this%refcount_, this%shared_ptr_)
  call this%refcount_%attach()
#if FCKIT_FINAL_DEBUGGING
  write(0,*) "share --> attach"
#endif
end subroutine


subroutine bad_cast(message)
  character(len=*), optional :: message
  if( present(message) ) then
    write(0,'("ERROR: bad_cast -- ",A)') message
  else
    write(0,'("ERROR: bad cast")')
  endif
end subroutine

subroutine consumed(this)
  class(fckit_shared_ptr), intent(in) :: this
  type(fckit_shared_ptr) :: consumed_object
  consumed_object = this
  call consumed_object%final()
end subroutine



end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_resource_module
  !! Fortran interface to eckit Resource

implicit none
private

public :: fckit_resource

!------------------------------------------------------------------------------
interface
  !int fckit__resource_int (const char* resource, int default_value, int &value)
  function fckit__resource_int32(resource,default_value,value) result(error_code) bind(c)
    use iso_c_binding, only: c_int32_t, c_char
    integer(c_int32_t) :: error_code
    character(kind=c_char), dimension(*) :: resource
    integer(c_int32_t), value :: default_value
    integer(c_int32_t) :: value
  end function
  !int fckit__resource_int64 (const char* resource, int64 default_value, int64 &value)
  function fckit__resource_int64(resource,default_value,value) result(error_code) bind(c)
    use iso_c_binding, only: c_int32_t, c_int64_t, c_char
    integer(c_int64_t) :: error_code
    character(kind=c_char), dimension(*) :: resource
    integer(c_int64_t), value :: default_value
    integer(c_int64_t) :: value
  end function
  !int fckit__resource_float (const char* resource, int default_value, int &value)
  function fckit__resource_float(resource,default_value,value) result(error_code) bind(c)
    use iso_c_binding, only: c_int32_t, c_float, c_char
    integer(c_int32_t) :: error_code
    character(kind=c_char), dimension(*) :: resource
    real(c_float), value :: default_value
    real(c_float) :: value
  end function
  !int fckit__resource_double (const char* resource, int default_value, int &value)
  function fckit__resource_double(resource,default_value,value) result(error_code) bind(c)
    use iso_c_binding, only: c_int32_t, c_double, c_char
    integer(c_int32_t) :: error_code
    character(kind=c_char), dimension(*) :: resource
    real(c_double), value :: default_value
    real(c_double) :: value
  end function
  !int fckit__resource_string (const char* resource, const char* default_value, char* &value, int &value_size)
  function fckit__resource_string(resource,default_value,value,value_size) result(error_code) bind(c)
    use iso_c_binding, only: c_int32_t, c_ptr, c_char, c_size_t
    integer(c_int32_t) :: error_code
    character(kind=c_char), dimension(*) :: resource
    character(kind=c_char), dimension(*) :: default_value
    type(c_ptr) :: value
    integer(c_size_t) :: value_size
  end function
end interface
!------------------------------------------------------------------------------

interface fckit_resource

! Purpose :
! -------
!   *resource* : Configuration
!
! Author :
! ------
!   October-2016 Willem Deconinck     *ECMWF*
! -----------------------------------------------------------------------------
  module procedure resource_get_int32
  module procedure resource_get_int64
  module procedure resource_get_real32
  module procedure resource_get_real64
  module procedure resource_get_string
end interface fckit_resource

! =============================================================================
CONTAINS
! =============================================================================

subroutine resource_get_int32(resource_str,default_value,value)
  use fckit_main_module
  use fckit_c_interop_module
  use, intrinsic :: iso_c_binding
  character(kind=c_char,len=*), intent(in) :: resource_str
  integer(c_int32_t), intent(in) :: default_value
  integer(c_int32_t), intent(out) :: value
  integer(c_int32_t) :: error_code
  error_code = fckit__resource_int32(c_str(resource_str),default_value,value)
end subroutine

subroutine resource_get_int64(resource_str,default_value,value)
  use fckit_main_module
  use fckit_c_interop_module
  use, intrinsic :: iso_c_binding
  character(kind=c_char,len=*), intent(in) :: resource_str
  integer(c_int64_t), intent(in) :: default_value
  integer(c_int64_t), intent(out) :: value
  integer(c_int32_t) :: error_code
  error_code = int(fckit__resource_int64(c_str(resource_str),default_value,value),c_int32_t)
end subroutine

subroutine resource_get_real32(resource_str,default_value,value)
  use fckit_main_module
  use fckit_c_interop_module
  use, intrinsic :: iso_c_binding
  character(kind=c_char,len=*), intent(in) :: resource_str
  real(c_float), intent(in) :: default_value
  real(c_float), intent(out) :: value
  integer(c_int32_t) :: error_code
  error_code = fckit__resource_float(c_str(resource_str),default_value,value)
end subroutine

subroutine resource_get_real64(resource_str,default_value,value)
  use fckit_main_module
  use fckit_c_interop_module
  use, intrinsic :: iso_c_binding
  character(kind=c_char,len=*), intent(in) :: resource_str
  real(c_double), intent(in) :: default_value
  real(c_double), intent(out) :: value
  integer(c_int32_t) :: error_code
  error_code = fckit__resource_double(c_str(resource_str),default_value,value)
end subroutine

subroutine resource_get_string(resource_str,default_value,value)
  use fckit_main_module
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module
  character(kind=c_char,len=*), intent(in) :: resource_str
  character(kind=c_char,len=*), intent(in) :: default_value
  character(kind=c_char,len=:), allocatable, intent(inout) :: value
  type(c_ptr) :: value_c_ptr
  integer(c_size_t) :: value_size
  integer(c_int32_t) :: error_code
  error_code = fckit__resource_string(c_str(resource_str),c_str(default_value),value_c_ptr,value_size)
  FCKIT_ALLOCATE_CHARACTER(value,value_size)
  value = c_ptr_to_string(value_c_ptr)
  call c_ptr_free(value_c_ptr)
end subroutine

end module fckit_resource_module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_pathname_module
  !! Module holding the [[fckit_pathname_module:fckit_pathname(type)]] type
  !! for strong typing of file paths

use, intrinsic :: iso_c_binding, only : c_char, c_int32_t

implicit none

public :: fckit_pathname
private :: c_char, c_int32_t

private


TYPE :: fckit_pathname
  !! Type encapsulated string, used for strong typing file paths.
  character(kind=c_char,len=1), allocatable, private :: string(:)
contains
  procedure :: str => fckit_pathname__str
    !! Function that returns the file path as string
END TYPE fckit_pathname

interface fckit_pathname
  !! Constructor for [[fckit_pathname_module:fckit_pathname(type)]]
  module procedure fckit_pathname__ctor_str
end interface

!========================================================
contains
!========================================================


function fckit_pathname__ctor_str(str) result(pathname)
  type(fckit_pathname) :: pathname
  character(kind=c_char,len=*), intent(in) :: str
  integer(c_int32_t) ::  i, nchars
  nchars = len(str)
  allocate( pathname%string(nchars) )
  do i=1,nchars
    pathname%string(i) = str(i:i)
  enddo
end function

function fckit_pathname__str(this) result(str)
  character(kind=c_char,len=:), allocatable :: str
  class(fckit_pathname) :: this
  integer(c_int32_t) :: i, nchars
  nchars = size(this%string)
  FCKIT_ALLOCATE_CHARACTER(str,nchars)
  do i=1,nchars
    str(i:i) = this%string(i)
  enddo
end function

end module fckit_pathname_module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

#if FCKIT_FINAL_DEBUGGING
#define FCKIT_WRITE_LOC write(0,'(A,I0,A)',advance='NO') "fckit_shared_ptr.F90 @ ",__LINE__,'  : '
#define FCKIT_WRITE(unit,format) write(unit,format)
#endif


module fckit_shared_ptr_module

#if FCKIT_HAVE_ECKIT
use fckit_refcount_module, only : &
  & fckit_refcount, &
  & fckit_refcount_interface, &
  & fckit_external, &
  & fckit_owned
#else
use fckit_refcount_module, only : &
  & fckit_refcount, &
  & fckit_refcount_interface, &
  & fckit_external
#endif

implicit none
private

!========================================================================
! Public interface

public fckit_shared_ptr
public fckit_make_shared
public fckit_refcount
public fckit_refcount_interface
public fckit_external

#if FCKIT_HAVE_ECKIT
public fckit_owned
#endif

!========================================================================

type :: fckit_shared_ptr
  class(*), pointer, private :: shared_ptr_ ! => null()
  class(fckit_refcount), pointer , private :: refcount_ => null()

  logical, private :: is_null_ = .true.
    ! Compiler bug for gcc > 7 : we may not default assign shared_ptr_ to null()
    ! Instead we use this `is_null` variable (See JIRA issue FCKIT-21)

  logical, private :: return_value = .false.
    ! This variable should not be necessary,
    ! but seems to overcome compiler issues ( gfortran 5.3, 6.3 )

contains
  procedure, public :: final => fckit_shared_ptr__final
  procedure, public :: fckit_shared_ptr__final

#if FCKIT_HAVE_FINAL
  final :: fckit_shared_ptr__final_auto
#endif

  procedure, private :: clear_shared_ptr
  procedure, public :: reset_shared_ptr
  generic, public :: reset => clear_shared_ptr, reset_shared_ptr
  generic, public :: assignment(=) => reset_shared_ptr
  procedure, public :: owners
  procedure, public :: attach
  procedure, public :: detach
  procedure, public :: return
  procedure, public :: shared_ptr => get_shared_ptr

  procedure, public :: shared_ptr_cast
  procedure, public :: clear
  procedure, public :: share

  procedure, public :: consumed

end type

!========================================================================
CONTAINS
!========================================================================

subroutine deallocate_shared_ptr( shared_ptr )
  use fckit_final_module, only: fckit_final
  class(*), pointer :: shared_ptr
#ifndef __ibmxl__
  deallocate(shared_ptr)
#else
  ! FCKIT-17: Runtime error when deallocating unlimited polymorphic pointer
  !  MEMORY LEAK!!!
  ! IBM XL COMPILER AT RUNTIME GIVES ERROR:
  !     1525-109 Error encountered while attempting to deallocate a data object.
  !     The program will stop.
#endif
  nullify( shared_ptr )
end subroutine

subroutine fckit_finalise( shared_ptr )
  use fckit_final_module, only: fckit_final
  use fckit_object_module, only: fckit_object
  class(*), pointer :: shared_ptr
  select type( shared_ptr)
#ifdef _CRAYFTN
  ! Cray compiler cce/14 has problem with typebound procedure if it is using 'class'
  type is(fckit_object)
#if FCKIT_FINAL_DEBUGGING
      write(0,*) "fckit_object%final()"
#endif
      call shared_ptr%final()
#endif
    class is(fckit_final)
#if FCKIT_FINAL_DEBUGGING
      write(0,*) "fckit_final%final()"
#endif
      call shared_ptr%final()
  end select
end subroutine

FCKIT_FINAL subroutine fckit_shared_ptr__final_auto(this)
#ifdef _CRAYFTN
  use, intrinsic :: iso_c_binding, only : c_loc, c_null_ptr
#endif
  type(fckit_shared_ptr), intent(inout) :: this
#if FCKIT_FINAL_DEBUGGING
  FCKIT_WRITE_LOC
  FCKIT_WRITE(0,*) "fckit_shared_ptr__final_auto"
#endif

#ifdef _CRAYFTN
  ! Guard necessary for Cray compiler...
  ! ... when "this" has already been deallocated, and then
  ! fckit_shared_ptr__final_auto is called...
  if( c_loc(this) == c_null_ptr ) then
    return
  endif
#endif

  if (.not. this%return_value) then
    if( .not. this%is_null_ ) then
      if( this%owners() > 0 ) then
        call this%final()
      endif
    endif
  else
#if FCKIT_FINAL_DEBUGGING
    FCKIT_WRITE_LOC
    FCKIT_WRITE(0,'(A)') "Applying return-value-optimisation during assignment_operator, this%final not called"
#endif
  endif
end subroutine

subroutine fckit_shared_ptr__final(this)
  class(fckit_shared_ptr), intent(inout) :: this

#if FCKIT_FINAL_DEBUGGING
    write(0,*) "fckit_shared_ptr__final"
#endif

  if( this%is_null_ ) then
#if FCKIT_FINAL_DEBUGGING
    FCKIT_WRITE(0,*) "fckit_shared_ptr__final  (uninitialised --> no-op)"
#endif
    call this%clear()
    return
  endif

#if FCKIT_FINAL_DEBUGGING
  if( this%return_value ) then
    FCKIT_WRITE(0,'(A,I0)') " fckit_shared_ptr__final on return value, owners = ", this%owners()
  endif
#endif

  if( this%owners() >= 0 ) then
#if FCKIT_FINAL_DEBUGGING
    FCKIT_WRITE(0,'(A,I0)') " fckit_shared_ptr__final  , owners = ", this%owners()
#endif
    call this%detach()
    if( this%owners() == 0 ) then
#if FCKIT_FINAL_DEBUGGING
      FCKIT_WRITE(0,*) " + call fckit_finalise(this%shared_ptr_)"
#endif
      call fckit_finalise(this%shared_ptr_)
      call deallocate_shared_ptr(this%shared_ptr_)
      deallocate(this%refcount_)
    endif
  endif

  call this%clear()
end subroutine

subroutine clear_shared_ptr(obj_out)
  class(fckit_shared_ptr), intent(inout) :: obj_out
  if( .not. obj_out%is_null_ ) then
    nullify(obj_out%shared_ptr_)
    nullify(obj_out%refcount_)
    obj_out%is_null_ = .true.
  endif
end subroutine

subroutine clear(obj_out)
  class(fckit_shared_ptr), intent(inout) :: obj_out
  call obj_out%clear_shared_ptr()
end subroutine


subroutine reset_shared_ptr(obj_out,obj_in)
  class(fckit_shared_ptr), intent(inout) :: obj_out
  class(fckit_shared_ptr), intent(in)    :: obj_in
#if FCKIT_FINAL_DEBUGGING
  FCKIT_WRITE(0,*) "fckit_shared_ptr::reset_shared_ptr(out,in)"
#endif

  if( obj_in%is_null_ ) then
    write(0,*) "ERROR! obj_in was not initialised"
  endif

  if( obj_out%is_null_ ) then
    nullify( obj_out%shared_ptr_ ) ! so that we can check association
  endif

  if( .not. associated( obj_out%shared_ptr_, obj_in%shared_ptr_ ) ) then
#if FCKIT_FINAL_DEBUGGING
    if( obj_out%is_null_ ) then
      FCKIT_WRITE(0,'(A)') "reset_shared_ptr of uninitialised"
    else
      FCKIT_WRITE(0,'(A)') "reset_shared_ptr of initialised"
    endif
#endif
    call obj_out%final()
    obj_out%shared_ptr_ => obj_in%shared_ptr_
    obj_out%refcount_   => obj_in%refcount_
    obj_out%is_null_ = .not. associated( obj_out%shared_ptr_ )
    if( obj_out%shared_ptr_cast() ) then
      call obj_out%attach()
    else
      call obj_out%clear()
      call bad_cast()
    endif
  else
#if FCKIT_FINAL_DEBUGGING
    FCKIT_WRITE(0,*) "reset_shared_ptr ( obj_out = obj_in )"
#endif
    if( obj_out%shared_ptr_cast() ) then ; endif
  endif
end subroutine

subroutine attach(this)
  class(fckit_shared_ptr), intent(inout) :: this
  if( .not. this%is_null_ ) then
    call this%refcount_%attach()
  endif
end subroutine

subroutine detach(this)
  class(fckit_shared_ptr), intent(inout) :: this
  if( .not. this%is_null_ ) then
    call this%refcount_%detach()
  endif
end subroutine

function owners(this)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: owners
  class(fckit_shared_ptr), intent(in) :: this
  if( .not. this%is_null_ ) then
    owners = this%refcount_%owners()
  else
    owners = 0
  endif
end function

subroutine return(this)
  !! Transfer ownership to left hand side of "assignment(=)"
  class(fckit_shared_ptr), intent(inout) :: this
  this%return_value = .true.
  call this%detach()
end subroutine

function get_shared_ptr(this) result(shared_ptr)
  class(*), pointer :: shared_ptr
  class(fckit_shared_ptr), intent(in) :: this
  shared_ptr => this%shared_ptr_
end function

function shared_ptr_cast(this) result(success)
  class(fckit_shared_ptr) :: this
  logical :: success
  success = .true.
  FCKIT_SUPPRESS_UNUSED( this )
end function

function fckit_make_shared( ptr ) result(this)
  type(fckit_shared_ptr) :: this
  class(*), target :: ptr
#if FCKIT_FINAL_DEBUGGING
  FCKIT_WRITE(0,*) "begin fckit_make_shared"
#endif
  call this%share( ptr )
  call this%return()
#if FCKIT_FINAL_DEBUGGING
  write(0,*) " this%owners() = ", this%owners()
  write(0,*) "end   fckit_make_shared"
#endif
end function

subroutine share( this, ptr, refcount )
  use, intrinsic :: iso_c_binding, only : c_funptr, c_f_procpointer
  class(fckit_shared_ptr) :: this
  class(*), target :: ptr
  type(c_funptr), optional :: refcount
  procedure(fckit_refcount_interface), pointer :: opt_refcount
  if( present(refcount) ) then
    call c_f_procpointer( refcount, opt_refcount )
  else
    call fckit_external(opt_refcount)
  endif
  this%shared_ptr_ => ptr
  this%is_null_ = .not. associated( this%shared_ptr_ )
  call opt_refcount(this%refcount_, this%shared_ptr_)
  call this%refcount_%attach()
#if FCKIT_FINAL_DEBUGGING
  FCKIT_WRITE(0,*) "share --> attach"
#endif
end subroutine


subroutine bad_cast(message)
  character(len=*), optional :: message
  if( present(message) ) then
    write(0,'("ERROR: bad_cast -- ",A)') message
  else
    write(0,'("ERROR: bad cast")')
  endif
end subroutine

subroutine consumed(this)
  class(fckit_shared_ptr), intent(in) :: this
  type(fckit_shared_ptr) :: consumed_object
  consumed_object = this
  call consumed_object%final()
end subroutine



end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_configuration_module
  !! author: Willem Deconinck
  !!
  !! Module providing the [[fckit_configuration_module:fckit_configuration(type)]] type
  !!
  !! The [[fckit_configuration_module:fckit_configuration(type)]] type can be used to
  !! encapsulate name-value configurations, including nesting of subconfigurations.
  !!
  !! The [[fckit_configuration_module:fckit_YAMLConfiguration(interface)]] constructor
  !! for [[fckit_configuration_module:fckit_configuration(type)]] can create the
  !! configuration from a YAML file

use, intrinsic :: iso_c_binding, only : c_ptr, c_int32_t, c_int64_t, c_float, c_double, c_size_t, c_char
use fckit_shared_object_module, only : fckit_shared_object, fckit_c_deleter, fckit_c_nodeleter
use fckit_pathname_module, only : fckit_pathname
use fckit_buffer_module, only : fckit_buffer

implicit none

public  :: fckit_configuration
public  :: fckit_YAMLConfiguration
public  :: deallocate_fckit_configuration

private

#include "fckit_configuration.inc"

!----------------------------------------------------------------------------
TYPE, extends(fckit_shared_object) :: fckit_configuration
  !! Name-Value configuration type
  !!
  !! Names are strings, and values can be
  !!
  !! - basic types int32, int64, real32, real64, string, or arrays of these.
  !! - arrays of basic types
  !! - Subconfiguration, or arrays of subconfigurations
  !!
  !!#### Example construction
  !!
  !! From JSON or YAML file (all MPI tasks read)
  !!
  !!```fortran
  !! type(fckit_configuration) :: config
  !! config = fckit_YAMLConfiguration( fckit_pathname("filepath" )
  !!```
  !!
  !! From JSON or YAML file (only one MPI task reads, and broadcasts)
  !!
  !!```fortran
  !! type(fckit_configuration) :: config
  !! type(fckit_mpi_comm)      :: comm
  !! comm = fckit_mpi_comm("world")
  !! config = fckit_YAMLConfiguration( comm%broadcast_file("filepath", root=0) )
  !!```

contains

#if FCKIT_FINAL_NOT_INHERITING
  final :: fckit_configuration__final_auto
#endif

  procedure, public :: has
    !! Function that returns whether a name is contained in the configuration
    !!
    !!#### Example usage:
    !!
    !!```fortran
    !! if( .not. fckit_configuration%has('levels') ) call abort()
    !!```
  procedure, public :: get_size
    !! Function that returns the size of a name in the configuration
    !!
    !!#### Example usage:
    !!
    !!```fortran
    !! nlev = fckit_configuration%get_size('levels')
    !!```

  procedure, private :: set_config
  procedure, private :: set_config_list
  procedure, private :: set_logical
  procedure, private :: set_int32
  procedure, private :: set_int64
  procedure, private :: set_real32
  procedure, private :: set_real64
  procedure, private :: set_string
  procedure, private :: set_array_string
  procedure, private :: set_array_int32
  procedure, private :: set_array_int64
  procedure, private :: set_array_real32
  procedure, private :: set_array_real64

  !----------------------------------------------------------------------------
  !> Subroutine to set a name-value configuration
  !!
  !! Name is a string, and value any of the basic types, or subconfigurations
  !!
  !!#### Example usage
  !!
  !!```fortran
  !! type(fckit_configuration) :: config
  !! config = fckit_configuration()
  !! call config%set('grid','O1280')
  !! call config%set('levels',137)
  !!```
  !! Or with subconfiguration:
  !!
  !!```fortran
  !! type(fckit_configuration) :: config
  !! type(fckit_configuration) :: grid_config
  !!
  !! grid_config = fckit_configuration()
  !! call grid_config%set('type','reduced_gaussian')
  !! call grid_config%set('pl',[20,24,28,32,32,28,24,20])
  !! call grid_config%set('levels',137)
  !!
  !! config = fckit_configuration()
  !! call config%set('grid',grid_config)
  !!```
  generic, public :: set => &
    set_config, &
    set_config_list, &
    set_logical, &
    set_int32, &
    set_int64, &
    set_real32, &
    set_real64, &
    set_string, &
    set_array_string, &
    set_array_int32, &
    set_array_int64, &
    set_array_real32, &
    set_array_real64

  procedure, private :: get_config
  procedure, private :: get_config_list
  procedure, private :: get_int32
  procedure, private :: get_int64
  procedure, private :: get_logical
  procedure, private :: get_real32
  procedure, private :: get_real64
  procedure, private :: get_string
  procedure, private :: get_array_logical
  procedure, private :: get_array_int32
  procedure, private :: get_array_int64
  procedure, private :: get_array_real32
  procedure, private :: get_array_real64
  procedure, private :: get_array_string

  !----------------------------------------------------------------------------
  !> Function that gets a name-value configuration
  !!
  !! Name is a string, and value any of the basic types, or subconfigurations
  !!
  !! @Note
  !! This is a function that returns a logical which is ```.true.``` if the name is found
  !! in the configuration, and ```.false.``` otherwise.
  !! @Endnote
  !!
  !!#### Example usage
  !!
  !!```fortran
  !! type(fckit_configuration), intent(in) :: config
  !! character(kind=c_char,len=:), allocatable :: grid_id
  !! integer(c_int32_t) :: levels
  !! if( .not. config%get('grid',grid_id) ) then
  !!   grid_id = 'O1280' ! Default if not found
  !! endif
  !! if( .not. config%get('levels',levels) ) then
  !!   levels = 137 ! Default if not found
  !! endif
  !!```
  !! Or with subconfiguration:
  !!
  !!```fortran
  !! type(fckit_configuration), intent(in) :: config
  !! type(fckit_configuration) :: grid_config
  !! character(kind=c_char,len=:), allocatable :: grid_type
  !! integer(c_int32_t) :: grid_levels
  !! integer, allocatable :: grid_pl(:)
  !!
  !! if( .not. config%get('grid',grid_config) ) then
  !!    ! You could abort, or create a default grid_config:
  !!    grid_config = fckit_configuration()
  !!    call grid_config%set('type','reduced_gaussian')
  !!    call grid_config%set('pl',[20,24,28,32,32,28,24,20])
  !!    call grid_config%set('levels',137)
  !! endif
  !! if( .not. grid_config%get('type',grid_type) ) call abort()
  !! if( .not. grid_config%get('pl',grid_pl) )     call abort()
  !! if( .not. grid_config%get('levels',levels) )  call abort()
  !!```
  generic, public :: get => &
    get_config, &
    get_config_list, &
    get_int32, &
    get_int64, &
    get_logical, &
    get_real32, &
    get_real64, &
    get_string, &
    get_array_logical, &
    get_array_int32, &
    get_array_int64, &
    get_array_real32, &
    get_array_real64, &
    get_array_string

    procedure, private :: get_config_or_die
    procedure, private :: get_config_list_or_die
    procedure, private :: get_int32_or_die
    procedure, private :: get_int64_or_die
    procedure, private :: get_logical_or_die
    procedure, private :: get_real32_or_die
    procedure, private :: get_real64_or_die
    procedure, private :: get_string_or_die
    procedure, private :: get_array_logical_or_die
    procedure, private :: get_array_int32_or_die
    procedure, private :: get_array_int64_or_die
    procedure, private :: get_array_real32_or_die
    procedure, private :: get_array_real64_or_die
    procedure, private :: get_array_string_or_die

    !----------------------------------------------------------------------------
    !> Subroutine that gets a name-value configuration, and throws exception
    !! when not found
    !!
    !! Name is a string, and value any of the basic types, or subconfigurations
    !!
    !!#### Example usage
    !!
    !!```fortran
    !! type(fckit_configuration), intent(in) :: config
    !! character(kind=c_char,len=:), allocatable :: grid_id
    !! integer(c_int32_t) :: levels
    !! call config%get_or_die('grid',grid_id) )
    !! call config%get_or_die('levels',levels) )
    !!```
    !! Or with subconfiguration:
    !!
    !!```fortran
    !! type(fckit_configuration), intent(in) :: config
    !! type(fckit_configuration) :: grid_config
    !! character(kind=c_char,len=:), allocatable :: grid_type
    !! integer(c_int32_t) :: grid_levels
    !! integer, allocatable :: grid_pl(:)
    !!
    !! call config%get_or_die('grid',grid_config)
    !! call grid_config%get_or_die('type',grid_type) )
    !! call grid_config%get_or_die('pl',grid_pl) )
    !! call grid_config%get_or_die('levels',levels) )
    !!```
    generic, public :: get_or_die => &
      get_config_or_die, &
      get_config_list_or_die, &
      get_int32_or_die, &
      get_int64_or_die, &
      get_logical_or_die, &
      get_real32_or_die, &
      get_real64_or_die, &
      get_string_or_die, &
      get_array_logical_or_die, &
      get_array_int32_or_die, &
      get_array_int64_or_die, &
      get_array_real32_or_die, &
      get_array_real64_or_die, &
      get_array_string_or_die

  procedure :: json
    !! Return a json string corresponding to this configuration
    !!
    !!#### Example usage
    !!
    !!```fortran
    !! type(fckit_configuration), intent(in) :: config
    !! character(kind=c_char,len=:), allocatable :: json_str
    !! json_str = config%json()
    !!```

END TYPE fckit_configuration

!------------------------------------------------------------------------------

interface fckit_configuration
  module procedure ctor
  module procedure ctor_from_cptr
end interface

interface fckit_YAMLConfiguration
  module procedure ctor_from_yaml_file
  module procedure ctor_from_yamlstr
  module procedure ctor_from_buffer
end interface

!------------------------------------------------------------------------------

private :: c_ptr, c_int32_t, c_int64_t, c_float, c_double, c_size_t, c_char
private :: fckit_shared_object
private :: fckit_c_deleter
private :: fckit_c_nodeleter
private :: fckit_pathname
private :: fckit_buffer

!========================================================
contains
!========================================================

subroutine throw_configuration_not_found( name )
  use fckit_c_interop_module, only : c_str
  character(kind=c_char,len=*), intent(in) :: name
  call c_fckit_throw_configuration_not_found(c_str(name))
end subroutine

! -----------------------------------------------------------------------------
! Config routines

subroutine deallocate_fckit_configuration( array )
  type(fckit_configuration), allocatable, intent(inout) :: array(:)
  integer(c_int32_t) :: j
  if( allocated(array) ) then
    do j=1,size(array)
#if FCKIT_FINAL_DEBUGGING
    write(0,'(A,I0,A)') "     + call array(",j,")%final()"
#endif
      call array(j)%final()
    enddo
#if FCKIT_FINAL_DEBUGGING
    write(0,*) "    + deallocate(array)"
#endif
    deallocate(array)
  endif
end subroutine

#if FCKIT_FINAL_NOT_INHERITING
FCKIT_FINAL subroutine fckit_configuration__final_auto(this)
  type(fckit_configuration), intent(inout) :: this
#if FCKIT_FINAL_DEBUGGING
  write(0,*) "fckit_configuration__final_auto"
#endif
#if FCKIT_FINAL_NOT_PROPAGATING
  call this%final()
#endif
  FCKIT_SUPPRESS_UNUSED( this )
end subroutine
#endif

function ctor() result(this)
  type(fckit_Configuration) :: this
  call this%reset_c_ptr( c_fckit_configuration_new(), &
    & fckit_c_deleter(c_fckit_configuration_delete) )
  call this%return()
end function

function ctor_from_cptr(cptr,own) result(this)
  type(c_ptr), value :: cptr
  type(fckit_Configuration) :: this
  logical, optional :: own
  logical :: opt_own
  opt_own = .false.
  if( present(own) ) opt_own = own
  if( opt_own ) then
    call this%reset_c_ptr( cptr, fckit_c_deleter(c_fckit_configuration_delete) )
  else
    call this%reset_c_ptr( cptr, fckit_c_nodeleter() )
  endif
  call this%return()
end function


function ctor_from_yamlstr(yaml) result(this)
  use fckit_c_interop_module, only : c_str
  type(fckit_Configuration) :: this
  character(kind=c_char,len=*), intent(in) :: yaml
  call this%reset_c_ptr( c_fckit_configuration_new_from_yaml(c_str(yaml)), &
    & fckit_c_deleter(c_fckit_configuration_delete) )
  call this%return()
end function

function ctor_from_yaml_file(path) result(this)
  use fckit_c_interop_module, only : c_str
  type(fckit_Configuration) :: this
  type(fckit_pathname), intent(in) :: path
  call this%reset_c_ptr( c_fckit_configuration_new_from_file(c_str(path%str())), &
    & fckit_c_deleter(c_fckit_configuration_delete) )
  call this%return()
end function

function ctor_from_buffer(buffer) result(this)
  use fckit_c_interop_module, only : c_str
  type(fckit_Configuration) :: this
  type(fckit_buffer), intent(in) :: buffer
  call this%reset_c_ptr( c_fckit_configuration_new_from_buffer(buffer%CPTR_PGIBUG_B), &
    & fckit_c_deleter(c_fckit_configuration_delete) )
  call buffer%consumed() ! If buffer was constructed inline, this will delete the buffer
  call this%return()
end function


function has(this, name) result(value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  logical :: value
  integer(c_int32_t) :: value_int
  value_int =  c_fckit_configuration_has(this%CPTR_PGIBUG_B, c_str(name) )
  if( value_int == 1 ) then
    value = .True.
  else
    value = .False.
  end if
end function

function get_size(this, name) result(val)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int32_t) :: val
  val =  c_fckit_configuration_get_size(this%CPTR_PGIBUG_B, c_str(name) )
end function

subroutine set_config(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  class(fckit_Configuration), intent(in) :: value
  call c_fckit_configuration_set_config(this%CPTR_PGIBUG_B, c_str(name), value%CPTR_PGIBUG_B )
end subroutine

subroutine set_config_list(this, name, value)
  use, intrinsic :: iso_c_binding, only : c_loc
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  type(fckit_Configuration), intent(in) :: value(:) !PGI (17.7) compiler bug when "type" replaced with "class"
  type(c_ptr), target :: value_cptrs(size(value))
  integer(c_int32_t) :: j
  if( size(value) > 0 ) then
    do j=1,size(value)
      value_cptrs(j) = value(j)%CPTR_PGIBUG_B
    enddo
    call c_fckit_configuration_set_config_list(this%CPTR_PGIBUG_B, c_str(name),  &
      c_loc(value_cptrs(1)), size(value_cptrs,kind=c_size_t) )
  endif
end subroutine


subroutine set_logical(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  logical, intent(in) :: value
  integer(c_int32_t) :: value_int
  if( value ) then
    value_int = 1
  else
    value_int = 0
  end if
  call c_fckit_configuration_set_bool(this%CPTR_PGIBUG_B, c_str(name), value_int )
end subroutine

subroutine set_int32(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int32_t), intent(in) :: value
  call c_fckit_configuration_set_int32(this%CPTR_PGIBUG_B, c_str(name), value)
end subroutine

subroutine set_int64(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int64_t), intent(in) :: value
  call c_fckit_configuration_set_int64(this%CPTR_PGIBUG_B, c_str(name), value)
end subroutine

subroutine set_real32(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_float), intent(in) :: value
  call c_fckit_configuration_set_float(this%CPTR_PGIBUG_B, c_str(name) ,value)
end subroutine

subroutine set_real64(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_double), intent(in) :: value
  call c_fckit_configuration_set_double(this%CPTR_PGIBUG_B, c_str(name) ,value)
end subroutine

subroutine set_string(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  character(kind=c_char,len=*), intent(in) :: value
  call c_fckit_configuration_set_string(this%CPTR_PGIBUG_B, c_str(name) , c_str(value) )
end subroutine

subroutine set_array_string(this, name, value)
  use, intrinsic :: iso_c_binding, only : c_f_pointer
  use fckit_c_interop_module, only : c_str, c_ptr_to_string, c_ptr_free
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  character(kind=c_char,len=*), intent(in) :: value(:)
  character(kind=c_char,len=:), allocatable :: flatvalue
  integer(c_size_t) :: length
  integer(c_int32_t) :: ii
  length = 0
  if( size(value) > 0 ) then
    length = len(value(1))
    allocate( character(len=length*size(value) ) :: flatvalue )
    do ii = 1, size(value)
      flatvalue((ii-1)*length+1:ii*length) = value(ii)
    enddo
    call c_fckit_configuration_set_array_string(this%CPTR_PGIBUG_B, c_str(name), &
      &  c_str(flatvalue), length, size(value,kind=c_size_t) )
  endif
end subroutine

subroutine set_array_int32(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int32_t), intent(in) :: value(:)
  call c_fckit_configuration_set_array_int32(this%CPTR_PGIBUG_B, c_str(name), value, size(value,kind=c_size_t) )
end subroutine

subroutine set_array_int64(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int64_t), intent(in) :: value(:)
  call c_fckit_configuration_set_array_int64(this%CPTR_PGIBUG_B, c_str(name), value, size(value,kind=c_size_t) )
end subroutine

subroutine set_array_real32(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_float), intent(in) :: value(:)
  call c_fckit_configuration_set_array_float(this%CPTR_PGIBUG_B, c_str(name), value, size(value,kind=c_size_t) )
end subroutine

subroutine set_array_real64(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_double), intent(in) :: value(:)
  call c_fckit_configuration_set_array_double(this%CPTR_PGIBUG_B, c_str(name), value, size(value,kind=c_size_t) )
end subroutine

function get_config(this, name, value) result(found)
  use fckit_c_interop_module, only : c_str
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  class(fckit_Configuration), intent(inout) :: value
  integer(c_int32_t) :: found_int
  value = fckit_Configuration()
  found_int = c_fckit_configuration_get_config(this%CPTR_PGIBUG_B, &
    c_str(name), value%CPTR_PGIBUG_B )
  found = .False.
  if (found_int == 1) then
    found = .True.
  endif
end function

subroutine get_config_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  class(fckit_Configuration), intent(inout) :: value
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_config_list(this, name, value) result(found)
  use, intrinsic :: iso_c_binding, only : c_f_pointer, c_null_ptr
  use fckit_c_interop_module, only : c_str, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  type(fckit_Configuration), allocatable, intent(inout) :: value(:)
  type(c_ptr) :: value_list_cptr
  type(c_ptr), pointer :: value_cptrs(:)
  integer(c_size_t) :: value_list_size
  integer(c_int32_t) :: found_int
  integer(c_size_t) :: j
  call deallocate_fckit_configuration(value)
  value_list_cptr = c_null_ptr
  found_int = c_fckit_configuration_get_config_list(this%CPTR_PGIBUG_B, c_str(name), &
    & value_list_cptr, value_list_size)
  found = .False.
  if( found_int == 1 ) then
    found = .true.
    call c_f_pointer(value_list_cptr,value_cptrs,(/value_list_size/))
    allocate(value(value_list_size))
    do j=1,value_list_size
      call value(j)%reset_c_ptr( value_cptrs(j), fckit_c_deleter(c_fckit_configuration_delete) )
    enddo
  endif
end function

subroutine get_config_list_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  type(fckit_Configuration), allocatable, intent(inout) :: value(:)
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_logical(this, name, value) result(found)
  use fckit_c_interop_module, only : c_str
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  logical, intent(inout) :: value
  integer(c_int32_t) :: value_int
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_bool(this%CPTR_PGIBUG_B,c_str(name), value_int )
  found = .False.
  if (found_int == 1) found = .True.
  if (found) then
    if (value_int > 0) then
      value = .True.
    else
      value = .False.
    end if
  endif
end function

subroutine get_logical_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  logical, intent(inout) :: value
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_int32(this, name, value) result(found)
  use fckit_c_interop_module, only : c_str
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int32_t), intent(inout) :: value
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_int32(this%CPTR_PGIBUG_B, c_str(name), value )
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_int32_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int32_t), intent(inout) :: value
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_int64(this, name, value) result(found)
  use fckit_c_interop_module, only : c_str
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int64_t), intent(inout) :: value
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_int64(this%CPTR_PGIBUG_B, c_str(name), value )
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_int64_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int64_t), intent(inout) :: value
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_real32(this, name, value) result(found)
  use fckit_c_interop_module, only : c_str
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_float), intent(inout) :: value
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_float(this%CPTR_PGIBUG_B, c_str(name), value )
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_real32_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_float), intent(inout) :: value
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_real64(this, name, value) result(found)
  use fckit_c_interop_module, only : c_str
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_double), intent(inout) :: value
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_double(this%CPTR_PGIBUG_B, c_str(name), value )
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_real64_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_double), intent(inout) :: value
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_string(this, name, value) result(found)
  use fckit_c_interop_module, only : c_str, c_ptr_to_string, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  character(kind=c_char,len=:), allocatable, intent(inout) :: value
  type(c_ptr) :: value_cptr
  integer(c_int32_t) :: found_int
  integer(c_size_t) :: value_size
  found_int = c_fckit_configuration_get_string(this%CPTR_PGIBUG_B,c_str(name),value_cptr,value_size)
  if( found_int == 1 ) then
    if( allocated(value) ) deallocate(value)
    FCKIT_ALLOCATE_CHARACTER(value,value_size)
    if ( value_size > 0 ) then
      value = c_ptr_to_string(value_cptr)
      call c_ptr_free(value_cptr)
    endif
  endif
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_string_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  character(kind=c_char,len=:), allocatable, intent(inout) :: value
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_array_logical(this, name, value) result(found)
  use, intrinsic :: iso_c_binding, only : c_f_pointer
  use fckit_c_interop_module, only : c_str, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  logical, allocatable, intent(inout) :: value(:)
  type(c_ptr) :: value_cptr
  integer(c_int32_t), pointer :: value_fptr(:)
  integer(c_size_t) :: j, value_size
  integer(c_int32_t), allocatable :: value_int(:)
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_array_int32(this%CPTR_PGIBUG_B, c_str(name), &
   & value_cptr, value_size )
  if( found_int == 1 ) then
    call c_f_pointer(value_cptr,value_fptr,(/value_size/))
    allocate(value_int(value_size))
    value_int(:) = value_fptr(:)
    if( allocated(value) ) deallocate(value)
    allocate(value(value_size))
    do j = 1, value_size
      if (value_int(j) > 0) then
        value(j) = .True.
      else
        value(j) = .False.
      endif
    end do
    call c_ptr_free(value_cptr)
  endif
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_array_logical_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  logical, allocatable, intent(inout) :: value(:)
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_array_int32(this, name, value) result(found)
  use, intrinsic :: iso_c_binding, only : c_f_pointer
  use fckit_c_interop_module, only : c_str, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int32_t), allocatable, intent(inout) :: value(:)
  type(c_ptr) :: value_cptr
  integer(c_int32_t), pointer :: value_fptr(:)
  integer(c_size_t) :: value_size
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_array_int32(this%CPTR_PGIBUG_B, c_str(name), &
   & value_cptr, value_size )
  if( found_int == 1 ) then
    call c_f_pointer(value_cptr,value_fptr,(/value_size/))
    if( allocated(value) ) deallocate(value)
    allocate(value(value_size))
    value(:) = value_fptr(:)
    call c_ptr_free(value_cptr)
  endif
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_array_int32_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int32_t), allocatable, intent(inout) :: value(:)
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_array_int64(this, name, value) result(found)
  use, intrinsic :: iso_c_binding, only : c_f_pointer
  use fckit_c_interop_module, only : c_str, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int64_t), allocatable, intent(inout) :: value(:)
  type(c_ptr) :: value_cptr
  integer(c_int64_t), pointer :: value_fptr(:)
  integer(c_size_t) :: value_size
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_array_int64(this%CPTR_PGIBUG_B, c_str(name), &
   & value_cptr, value_size )
  if( found_int == 1 ) then
    call c_f_pointer(value_cptr,value_fptr,(/value_size/))
    if( allocated(value) ) deallocate(value)
    allocate(value(value_size))
    value(:) = value_fptr(:)
    call c_ptr_free(value_cptr)
  endif
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_array_int64_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int64_t), allocatable, intent(inout) :: value(:)
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_array_real32(this, name, value) result(found)
  use, intrinsic :: iso_c_binding, only : c_f_pointer
  use fckit_c_interop_module, only : c_str, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_float), allocatable, intent(inout) :: value(:)
  type(c_ptr) :: value_cptr
  real(c_float), pointer :: value_fptr(:)
  integer(c_size_t) :: value_size
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_array_float(this%CPTR_PGIBUG_B, c_str(name), &
   & value_cptr, value_size )
  if( found_int == 1 ) then
    call c_f_pointer(value_cptr,value_fptr,(/value_size/))
    if( allocated(value) ) deallocate(value)
    allocate(value(value_size))
    value(:) = value_fptr(:)
    call c_ptr_free(value_cptr)
  endif
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_array_real32_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_float), allocatable, intent(inout) :: value(:)
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_array_real64(this, name, value) result(found)
  use, intrinsic :: iso_c_binding, only : c_f_pointer
  use fckit_c_interop_module, only : c_str, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_double), allocatable, intent(inout) :: value(:)
  type(c_ptr) :: value_cptr
  real(c_double), pointer :: value_fptr(:)
  integer(c_size_t) :: value_size
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_array_double(this%CPTR_PGIBUG_B, c_str(name), &
   & value_cptr, value_size )
  if( found_int == 1 ) then
    call c_f_pointer(value_cptr,value_fptr,(/value_size/))
    if( allocated(value) ) deallocate(value)
    allocate(value(value_size))
    value(:) = value_fptr(:)
    call c_ptr_free(value_cptr)
  endif
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_array_real64_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_double), allocatable, intent(inout) :: value(:)
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_array_string(this,name,value) result(found)
  use, intrinsic :: iso_c_binding, only : c_f_pointer
  use fckit_c_interop_module, only : c_str, c_ptr_to_string, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(len=*), intent(in) :: name
  character(len=:), allocatable, intent(inout) :: value(:)
  type(c_ptr) :: value_cptr
  type(c_ptr) :: offsets_cptr
  integer(c_size_t), pointer :: offsets_fptr(:)
  integer(c_size_t), allocatable :: offsets(:)
  integer(c_size_t) :: value_size
  integer(c_size_t) :: value_numelem
  integer(c_int32_t) :: found_int
  integer(c_size_t) :: maxelemlen
  integer(c_size_t) :: elemlen
  integer(c_size_t) :: j
  character(len=:), allocatable :: flatvalue
  found_int =   c_fckit_configuration_get_array_string(this%CPTR_PGIBUG_B, c_str(name), &
   & value_cptr, value_size, offsets_cptr, value_numelem)
  if( found_int == 1 ) then
    ! Get flat character array
    allocate(character(len=value_size) :: flatvalue )
    if ( value_size > 0 ) then
      flatvalue = c_ptr_to_string(value_cptr)
      call c_ptr_free(value_cptr)
    end if
    ! Get offsets
    call c_f_pointer(offsets_cptr,offsets_fptr,(/value_numelem/))
    allocate(offsets(value_numelem))
    offsets(:) = offsets_fptr(:)
    call c_ptr_free(offsets_cptr)
    ! Find maximum length of an element
    maxelemlen = 0
    do j=1,value_numelem
      if( j < value_numelem ) then
        maxelemlen = max( maxelemlen, offsets(j+1) - offsets(j) )
      else
        maxelemlen = max( maxelemlen, value_size - offsets(j) )
      endif  
    enddo
    ! Extract values 
    if( allocated(value) ) deallocate(value)
    allocate(character(len=maxelemlen) :: value(value_numelem) )
    do j=1,value_numelem
      if( j < value_numelem ) then
        elemlen = offsets(j+1) - offsets(j)
      else
        elemlen = value_size - offsets(j)
      endif  
      value(j) = flatvalue(offsets(j)+1:offsets(j)+elemlen)
    enddo  
  endif
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_array_string_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(len=*), intent(in) :: name
  character(len=:), allocatable, intent(inout) :: value(:)
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function json(this) result(jsonstr)
  use fckit_c_interop_module, only : c_str, c_ptr_to_string, c_ptr_free
  character(kind=c_char,len=:), allocatable :: jsonstr
  class(fckit_Configuration), intent(in) :: this
  type(c_ptr) :: json_cptr
  integer(c_size_t) :: json_size
  call c_fckit_configuration_json(this%CPTR_PGIBUG_B,json_cptr,json_size)
  FCKIT_ALLOCATE_CHARACTER(jsonstr,json_size)
  jsonstr = c_ptr_to_string(json_cptr)
  call c_ptr_free(json_cptr)
end function

end module fckit_configuration_module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_log_module
  !! Provides [[fckit_log_module:fckit_log(variable)]] for logging and to configure logging

use fckit_object_module, only: fckit_object
use, intrinsic :: iso_c_binding, only : c_int32_t

implicit none
private
public :: log ! DEPRECATED, USE fckit_log INSTEAD!
public :: fckit_log
public :: fckit_logchannel
private :: fckit_object
private :: c_int32_t

#include "fckit_log.inc"

type, FORD_PRIVATE :: fckit_log_type
  !! Private type of [[fckit_log_module:fckit_log(variable)]] module variable
  !!
  !! It wraps ```eckit::Log```, allowing Fortran and C++ code to log to the
  !! same output channels

  integer(c_int32_t) :: SIMPLE = 0
    !! Style for logging without any prefix
  integer(c_int32_t) :: PREFIX = 1
    !! Style for logging with prefix
    !!
    !!    (I) --> info
    !!    (W) --> warning
    !!    (E) --> error
    !!    (D) --> debug

  integer(c_int32_t) :: TIMESTAMP = 2
    !! Style for logging with prefix that contains time stamp and taskID
    !!
    !!    <taskID> <TIME> (I) --> info
    !!    <taskID> <TIME> (W) --> warning
    !!    <taskID> <TIME> (E) --> error
    !!    <taskID> <TIME> (D) --> debug

contains

  procedure, nopass, public :: debug
    !! Log to debug channel

  procedure, nopass, public :: info
    !! Log to info channel

  procedure, nopass, public :: warning
    !! Log to warning channel

  procedure, nopass, public :: error
    !! Log to error channel

  procedure, nopass, public :: panic
    !! Log to panic channel (fortran_unit 0, always)

  procedure, nopass, public :: reset
    !! Reset all log channels (No more logging)

  procedure, nopass, public :: flush => fckit_log__flush
    !! Flush all log channels (empty buffers)

  procedure, nopass, public :: add_stdout
    !! Add the C++ ```std::cout``` output stream to each logchannel

  procedure, nopass, public :: set_stdout
    !! Replace each logchannels streams with the C++ ```std::cout``` output stream

  procedure, nopass, public :: add_fortran_unit
    !! Add a given fortran unit as output stream to each logchannel

  procedure, nopass, public :: set_fortran_unit
    !! Replace each logchannel streams with a given fortran unit

  procedure, nopass, public :: add_file
    !! Add a given file as output stream to each logchannel.
    !!
    !! The file will be (re)created.

  procedure, nopass, public :: set_file
    !! Replace each logchannels streams with a given file
    !!
    !! The file will be (re)created.

  procedure, nopass, public :: info_channel
    !! Return the info [[fckit_logchannel(type)]]

  procedure, nopass, public :: warning_channel
    !! Return the warning [[fckit_logchannel(type)]]

  procedure, nopass, public :: error_channel
    !! Return the error [[fckit_logchannel(type)]]

  procedure, nopass, public :: debug_channel
    !! Return the debug [[fckit_logchannel(type)]]

end type fckit_log_type

type(fckit_log_type) :: fckit_log
  !! Instance of [[fckit_log_module:fckit_log_type(type)]]

type(fckit_log_type) :: log
  !! deprecated: true
  !! Deprecated instance of [[fckit_log_module:fckit_log_type(type)]].
  !! Use [[fckit_log_module:fckit_log(variable)]] instead!

!------------------------------------------------------------------------------

type, extends(fckit_object) :: fckit_logchannel
  !! Log channel (any of info, warning, error, debug)
  !!
  !! Wraps ```eckit::Channel```. This channel can be passed as
  !! arguments to functions that expect a ```std::ostream``` to log to.
contains
  procedure, public :: delete
    !! Delete internal C++ pointer
end type fckit_logchannel

!========================================================
contains
!========================================================

subroutine debug(msg,newl,flush)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module, only : c_str_right_trim
  character(kind=c_char,len=*), intent(in) :: msg
    !! Message to be logged
  logical, intent(in), optional :: newl
    !! Add newline character (```\n```) after message.
    !! Default ```.true.```
  logical, intent(in), optional :: flush
    !! Flush channel after message.
    !! Default ```.true.```
  integer(c_int32_t) :: opt_newl, opt_flush
  opt_newl  = 1 ; if( present(newl) ) then; if( .not.  newl ) opt_newl  = 0; endif
  opt_flush = 1 ; if( present(flush)) then; if( .not. flush ) opt_flush = 0; endif
  call fckit__log_debug(c_str_right_trim(msg),opt_newl,opt_flush)
end subroutine


subroutine info(msg,newl,flush)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module, only : c_str_right_trim
  character(kind=c_char,len=*), intent(in) :: msg
    !! Message to be logged
  logical, intent(in), optional :: newl
    !! Add newline character (```\n```) after message.
    !! Default ```.true.```
  logical, intent(in), optional :: flush
    !! Flush channel after message.
    !! Default ```.true.```
  integer(c_int32_t) :: opt_newl, opt_flush
  opt_newl  = 1 ; if( present(newl) ) then; if( .not.  newl ) opt_newl  = 0; endif
  opt_flush = 1 ; if( present(flush)) then; if( .not. flush ) opt_flush = 0; endif
  call fckit__log_info(c_str_right_trim(msg),opt_newl,opt_flush)
end subroutine


subroutine warning(msg,newl,flush)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module, only : c_str_right_trim
  character(kind=c_char,len=*), intent(in) :: msg
    !! Message to be logged
  logical, intent(in), optional :: newl
    !! Add newline character (```\n```) after message.
    !! Default ```.true.```
  logical, intent(in), optional :: flush
    !! Flush channel after message.
    !! Default ```.true.```
  integer(c_int32_t) :: opt_newl, opt_flush
  opt_newl  = 1 ; if( present(newl) ) then; if( .not.  newl ) opt_newl  = 0; endif
  opt_flush = 1 ; if( present(flush)) then; if( .not. flush ) opt_flush = 0; endif
  call fckit__log_warning(c_str_right_trim(msg),opt_newl,opt_flush)
end subroutine


subroutine error(msg,newl,flush)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module, only : c_str_right_trim
  character(kind=c_char,len=*), intent(in) :: msg
    !! Message to be logged
  logical, intent(in), optional :: newl
    !! Add newline character (```\n```) after message.
    !! Default ```.true.```
  logical, intent(in), optional :: flush
    !! Flush channel after message.
    !! Default ```.true.```
  integer(c_int32_t) :: opt_newl, opt_flush
  opt_newl  = 1 ; if( present(newl) ) then; if( .not.  newl ) opt_newl  = 0; endif
  opt_flush = 1 ; if( present(flush)) then; if( .not. flush ) opt_flush = 0; endif
  call fckit__log_error(c_str_right_trim(msg),opt_newl,opt_flush)
end subroutine


subroutine panic(msg)
  use, intrinsic :: iso_c_binding
  character(kind=c_char,len=*), intent(in) :: msg
    !! Message to be logged
  write(0,'(A)') msg
end subroutine


subroutine add_fortran_unit(unit,style)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module
  integer(c_int32_t), intent(in) :: unit
    !! Fortran unit
  integer(c_int32_t), intent(in), optional :: style
    !! Style to prefix the stream with. Options are:
    !!
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):SIMPLE(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):PREFIX(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):TIMESTAMP(variable)]]
  integer(c_int) :: opt_style
  opt_style = fckit_log%PREFIX
  if( present( style ) ) opt_style = style
  call fckit__log_add_fortran_unit(unit,opt_style)
end subroutine


subroutine set_fortran_unit(unit,style)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module
  integer(c_int32_t), intent(in) :: unit
    !! Fortran unit
  integer(c_int32_t), intent(in), optional :: style
    !! Style to prefix the stream with. Options are:
    !!
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):SIMPLE(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):PREFIX(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):TIMESTAMP(variable)]]
  integer(c_int32_t) :: opt_style
  opt_style = fckit_log%PREFIX
  if( present( style ) ) opt_style = style
  call fckit__log_set_fortran_unit(unit,opt_style)
end subroutine

subroutine add_file(path,style)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module
  character(kind=c_char,len=*), intent(in) :: path
    !! Path to file. File will be (re)created
  integer(c_int32_t), intent(in), optional :: style
    !! Style to prefix the stream with. Options are:
    !!
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):SIMPLE(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):PREFIX(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):TIMESTAMP(variable)]]
  integer(c_int32_t) :: opt_style
  opt_style = fckit_log%PREFIX
  if( present( style ) ) opt_style = style
  call fckit__log_add_file(c_str(path),opt_style)
end subroutine


subroutine set_file(path,style)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module
  character(kind=c_char,len=*), intent(in) :: path
    !! Path to file. File will be (re)created
  integer(c_int32_t), intent(in), optional :: style
    !! Style to prefix the stream with. Options are:
    !!
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):SIMPLE(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):PREFIX(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):TIMESTAMP(variable)]]
  integer(c_int32_t) :: opt_style
  opt_style = fckit_log%PREFIX
  if( present( style ) ) opt_style = style
  call fckit__log_set_file(c_str(path),opt_style)
end subroutine

subroutine add_stdout(style)
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), intent(in), optional :: style
    !! Style to prefix the stream with. Options are:
    !!
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):SIMPLE(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):PREFIX(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):TIMESTAMP(variable)]]
  integer(c_int32_t) :: opt_style
  opt_style = fckit_log%PREFIX
  if( present( style ) ) opt_style = style
  call fckit__log_add_stdout(opt_style)
end subroutine


subroutine set_stdout(style)
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), intent(in), optional :: style
    !! Style to prefix the stream with. Options are:
    !!
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):SIMPLE(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):PREFIX(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):TIMESTAMP(variable)]]
  integer(c_int32_t) :: opt_style
  opt_style = fckit_log%PREFIX
  if( present( style ) ) opt_style = style
  call fckit__log_set_stdout(opt_style)
end subroutine


subroutine reset()
  call fckit__log_reset()
end subroutine

subroutine fckit_log__flush()
  call fckit__log_flush()
end subroutine

function info_channel() result(channel)
  type(fckit_logchannel) :: channel
  call channel%reset_c_ptr( fckit__log_info_channel() )
end function


function warning_channel() result(channel)
  type(fckit_logchannel) :: channel
  call channel%reset_c_ptr( fckit__log_warning_channel() )
end function


function error_channel() result(channel)
  type(fckit_logchannel) :: channel
  call channel%reset_c_ptr( fckit__log_error_channel() )
end function


function debug_channel() result(channel)
  type(fckit_logchannel) :: channel
  call channel%reset_c_ptr( fckit__log_debug_channel() )
end function


subroutine delete(this)
  class(fckit_logchannel), intent(inout) :: this
  ! do nothing
  FCKIT_SUPPRESS_UNUSED(this)
end subroutine

end module fckit_log_module

program main
use fckit_module, only: fckit_log
use downstream
use downstream_override
implicit none

call fckit_log%info("Printing downstream compile flags")

call print_downstream_compile_flags()

call fckit_log%info("Asserting downstream compile flags")

call assert_downstream_compile_flags()


call fckit_log%info("Printing downstream_override compile flags")

call print_downstream_override_compile_flags()

call fckit_log%info("Asserting downstream_override compile flags")

call assert_downstream_override_compile_flags()

call fckit_log%info("End of main")

end program

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_configuration_module
  !! author: Willem Deconinck
  !!
  !! Module providing the [[fckit_configuration_module:fckit_configuration(type)]] type
  !!
  !! The [[fckit_configuration_module:fckit_configuration(type)]] type can be used to
  !! encapsulate name-value configurations, including nesting of subconfigurations.
  !!
  !! The [[fckit_configuration_module:fckit_YAMLConfiguration(interface)]] constructor
  !! for [[fckit_configuration_module:fckit_configuration(type)]] can create the
  !! configuration from a YAML file

use, intrinsic :: iso_c_binding, only : c_ptr, c_int32_t, c_int64_t, c_float, c_double, c_size_t, c_char
use fckit_shared_object_module, only : fckit_shared_object, fckit_c_deleter, fckit_c_nodeleter
use fckit_pathname_module, only : fckit_pathname
use fckit_buffer_module, only : fckit_buffer

implicit none

public  :: fckit_configuration
public  :: fckit_YAMLConfiguration
public  :: deallocate_fckit_configuration

private

#include "fckit_configuration.inc"

!----------------------------------------------------------------------------
TYPE, extends(fckit_shared_object) :: fckit_configuration
  !! Name-Value configuration type
  !!
  !! Names are strings, and values can be
  !!
  !! - basic types int32, int64, real32, real64, string, or arrays of these.
  !! - arrays of basic types
  !! - Subconfiguration, or arrays of subconfigurations
  !!
  !!#### Example construction
  !!
  !! From JSON or YAML file (all MPI tasks read)
  !!
  !!```fortran
  !! type(fckit_configuration) :: config
  !! config = fckit_YAMLConfiguration( fckit_pathname("filepath" )
  !!```
  !!
  !! From JSON or YAML file (only one MPI task reads, and broadcasts)
  !!
  !!```fortran
  !! type(fckit_configuration) :: config
  !! type(fckit_mpi_comm)      :: comm
  !! comm = fckit_mpi_comm("world")
  !! config = fckit_YAMLConfiguration( comm%broadcast_file("filepath", root=0) )
  !!```

contains

#if FCKIT_FINAL_NOT_INHERITING
  final :: fckit_configuration__final_auto
#endif

  procedure, public :: size => fckit_configuration_size
    !! Function that returns the number of entries

  procedure, public :: key

  procedure, public :: has
    !! Function that returns whether a name is contained in the configuration
    !!
    !!#### Example usage:
    !!
    !!```fortran
    !! if( .not. fckit_configuration%has('levels') ) call abort()
    !!```
  procedure, public :: get_size
    !! Function that returns the size of a name in the configuration
    !!
    !!#### Example usage:
    !!
    !!```fortran
    !! nlev = fckit_configuration%get_size('levels')
    !!```

  procedure, private :: set_config
  procedure, private :: set_config_list
  procedure, private :: set_logical
  procedure, private :: set_int32
  procedure, private :: set_int64
  procedure, private :: set_real32
  procedure, private :: set_real64
  procedure, private :: set_string
  procedure, private :: set_array_string
  procedure, private :: set_array_int32
  procedure, private :: set_array_int64
  procedure, private :: set_array_real32
  procedure, private :: set_array_real64

  !----------------------------------------------------------------------------
  !> Subroutine to set a name-value configuration
  !!
  !! Name is a string, and value any of the basic types, or subconfigurations
  !!
  !!#### Example usage
  !!
  !!```fortran
  !! type(fckit_configuration) :: config
  !! config = fckit_configuration()
  !! call config%set('grid','O1280')
  !! call config%set('levels',137)
  !!```
  !! Or with subconfiguration:
  !!
  !!```fortran
  !! type(fckit_configuration) :: config
  !! type(fckit_configuration) :: grid_config
  !!
  !! grid_config = fckit_configuration()
  !! call grid_config%set('type','reduced_gaussian')
  !! call grid_config%set('pl',[20,24,28,32,32,28,24,20])
  !! call grid_config%set('levels',137)
  !!
  !! config = fckit_configuration()
  !! call config%set('grid',grid_config)
  !!```
  generic, public :: set => &
    set_config, &
    set_config_list, &
    set_logical, &
    set_int32, &
    set_int64, &
    set_real32, &
    set_real64, &
    set_string, &
    set_array_string, &
    set_array_int32, &
    set_array_int64, &
    set_array_real32, &
    set_array_real64

  procedure, private :: get_config
  procedure, private :: get_config_list
  procedure, private :: get_int32
  procedure, private :: get_int64
  procedure, private :: get_logical
  procedure, private :: get_real32
  procedure, private :: get_real64
  procedure, private :: get_string
  procedure, private :: get_array_logical
  procedure, private :: get_array_int32
  procedure, private :: get_array_int64
  procedure, private :: get_array_real32
  procedure, private :: get_array_real64
  procedure, private :: get_array_string

  !----------------------------------------------------------------------------
  !> Function that gets a name-value configuration
  !!
  !! Name is a string, and value any of the basic types, or subconfigurations
  !!
  !! @Note
  !! This is a function that returns a logical which is ```.true.``` if the name is found
  !! in the configuration, and ```.false.``` otherwise.
  !! @Endnote
  !!
  !!#### Example usage
  !!
  !!```fortran
  !! type(fckit_configuration), intent(in) :: config
  !! character(kind=c_char,len=:), allocatable :: grid_id
  !! integer(c_int32_t) :: levels
  !! if( .not. config%get('grid',grid_id) ) then
  !!   grid_id = 'O1280' ! Default if not found
  !! endif
  !! if( .not. config%get('levels',levels) ) then
  !!   levels = 137 ! Default if not found
  !! endif
  !!```
  !! Or with subconfiguration:
  !!
  !!```fortran
  !! type(fckit_configuration), intent(in) :: config
  !! type(fckit_configuration) :: grid_config
  !! character(kind=c_char,len=:), allocatable :: grid_type
  !! integer(c_int32_t) :: grid_levels
  !! integer, allocatable :: grid_pl(:)
  !!
  !! if( .not. config%get('grid',grid_config) ) then
  !!    ! You could abort, or create a default grid_config:
  !!    grid_config = fckit_configuration()
  !!    call grid_config%set('type','reduced_gaussian')
  !!    call grid_config%set('pl',[20,24,28,32,32,28,24,20])
  !!    call grid_config%set('levels',137)
  !! endif
  !! if( .not. grid_config%get('type',grid_type) ) call abort()
  !! if( .not. grid_config%get('pl',grid_pl) )     call abort()
  !! if( .not. grid_config%get('levels',levels) )  call abort()
  !!```
  generic, public :: get => &
    get_config, &
    get_config_list, &
    get_int32, &
    get_int64, &
    get_logical, &
    get_real32, &
    get_real64, &
    get_string, &
    get_array_logical, &
    get_array_int32, &
    get_array_int64, &
    get_array_real32, &
    get_array_real64, &
    get_array_string

    procedure, private :: get_config_or_die
    procedure, private :: get_config_list_or_die
    procedure, private :: get_int32_or_die
    procedure, private :: get_int64_or_die
    procedure, private :: get_logical_or_die
    procedure, private :: get_real32_or_die
    procedure, private :: get_real64_or_die
    procedure, private :: get_string_or_die
    procedure, private :: get_array_logical_or_die
    procedure, private :: get_array_int32_or_die
    procedure, private :: get_array_int64_or_die
    procedure, private :: get_array_real32_or_die
    procedure, private :: get_array_real64_or_die
    procedure, private :: get_array_string_or_die

    !----------------------------------------------------------------------------
    !> Subroutine that gets a name-value configuration, and throws exception
    !! when not found
    !!
    !! Name is a string, and value any of the basic types, or subconfigurations
    !!
    !!#### Example usage
    !!
    !!```fortran
    !! type(fckit_configuration), intent(in) :: config
    !! character(kind=c_char,len=:), allocatable :: grid_id
    !! integer(c_int32_t) :: levels
    !! call config%get_or_die('grid',grid_id) )
    !! call config%get_or_die('levels',levels) )
    !!```
    !! Or with subconfiguration:
    !!
    !!```fortran
    !! type(fckit_configuration), intent(in) :: config
    !! type(fckit_configuration) :: grid_config
    !! character(kind=c_char,len=:), allocatable :: grid_type
    !! integer(c_int32_t) :: grid_levels
    !! integer, allocatable :: grid_pl(:)
    !!
    !! call config%get_or_die('grid',grid_config)
    !! call grid_config%get_or_die('type',grid_type) )
    !! call grid_config%get_or_die('pl',grid_pl) )
    !! call grid_config%get_or_die('levels',levels) )
    !!```
    generic, public :: get_or_die => &
      get_config_or_die, &
      get_config_list_or_die, &
      get_int32_or_die, &
      get_int64_or_die, &
      get_logical_or_die, &
      get_real32_or_die, &
      get_real64_or_die, &
      get_string_or_die, &
      get_array_logical_or_die, &
      get_array_int32_or_die, &
      get_array_int64_or_die, &
      get_array_real32_or_die, &
      get_array_real64_or_die, &
      get_array_string_or_die

  procedure :: json
    !! Return a json string corresponding to this configuration
    !!
    !!#### Example usage
    !!
    !!```fortran
    !! type(fckit_configuration), intent(in) :: config
    !! character(kind=c_char,len=:), allocatable :: json_str
    !! json_str = config%json()
    !!```

END TYPE fckit_configuration

!------------------------------------------------------------------------------

interface fckit_configuration
  module procedure ctor
  module procedure ctor_from_cptr
end interface

interface fckit_YAMLConfiguration
  module procedure ctor_from_yaml_file
  module procedure ctor_from_yamlstr
  module procedure ctor_from_buffer
end interface

!------------------------------------------------------------------------------

private :: c_ptr, c_int32_t, c_int64_t, c_float, c_double, c_size_t, c_char
private :: fckit_shared_object
private :: fckit_c_deleter
private :: fckit_c_nodeleter
private :: fckit_pathname
private :: fckit_buffer

!========================================================
contains
!========================================================

subroutine throw_configuration_not_found( name )
  use fckit_c_interop_module, only : c_str
  character(kind=c_char,len=*), intent(in) :: name
  call c_fckit_throw_configuration_not_found(c_str(name))
end subroutine

! -----------------------------------------------------------------------------
! Config routines

subroutine deallocate_fckit_configuration( array )
  type(fckit_configuration), allocatable, intent(inout) :: array(:)
  integer(c_int32_t) :: j
  if( allocated(array) ) then
    do j=1,size(array)
#if FCKIT_FINAL_DEBUGGING
    write(0,'(A,I0,A)') "     + call array(",j,")%final()"
#endif
      call array(j)%final()
    enddo
#if FCKIT_FINAL_DEBUGGING
    write(0,*) "    + deallocate(array)"
#endif
    deallocate(array)
  endif
end subroutine

#if FCKIT_FINAL_NOT_INHERITING
FCKIT_FINAL subroutine fckit_configuration__final_auto(this)
  type(fckit_configuration), intent(inout) :: this
#if FCKIT_FINAL_DEBUGGING
  write(0,*) "fckit_configuration__final_auto"
#endif
#if FCKIT_FINAL_NOT_PROPAGATING
  call this%final()
#endif
  FCKIT_SUPPRESS_UNUSED( this )
end subroutine
#endif

function ctor() result(this)
  type(fckit_Configuration) :: this
  call this%reset_c_ptr( c_fckit_configuration_new(), &
    & fckit_c_deleter(c_fckit_configuration_delete) )
  call this%return()
end function

function ctor_from_cptr(cptr,own) result(this)
  type(c_ptr), value :: cptr
  type(fckit_Configuration) :: this
  logical, optional :: own
  logical :: opt_own
  opt_own = .false.
  if( present(own) ) opt_own = own
  if( opt_own ) then
    call this%reset_c_ptr( cptr, fckit_c_deleter(c_fckit_configuration_delete) )
  else
    call this%reset_c_ptr( cptr, fckit_c_nodeleter() )
  endif
  call this%return()
end function


function ctor_from_yamlstr(yaml) result(this)
  use fckit_c_interop_module, only : c_str
  type(fckit_Configuration) :: this
  character(kind=c_char,len=*), intent(in) :: yaml
  call this%reset_c_ptr( c_fckit_configuration_new_from_yaml(c_str(yaml)), &
    & fckit_c_deleter(c_fckit_configuration_delete) )
  call this%return()
end function

function ctor_from_yaml_file(path) result(this)
  use fckit_c_interop_module, only : c_str
  type(fckit_Configuration) :: this
  type(fckit_pathname), intent(in) :: path
  call this%reset_c_ptr( c_fckit_configuration_new_from_file(c_str(path%str())), &
    & fckit_c_deleter(c_fckit_configuration_delete) )
  call this%return()
end function

function ctor_from_buffer(buffer) result(this)
  use fckit_c_interop_module, only : c_str
  type(fckit_Configuration) :: this
  type(fckit_buffer), intent(in) :: buffer
  call this%reset_c_ptr( c_fckit_configuration_new_from_buffer(buffer%CPTR_PGIBUG_B), &
    & fckit_c_deleter(c_fckit_configuration_delete) )
  call buffer%consumed() ! If buffer was constructed inline, this will delete the buffer
  call this%return()
end function

function fckit_configuration_size(this) result(val)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(in) :: this
  integer(c_int32_t) :: val
  val =  c_fckit_configuration_size(this%CPTR_PGIBUG_B)
  write(0,*) "fckit_configuration_size " , val
end function

function has(this, name) result(value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  logical :: value
  integer(c_int32_t) :: value_int
  value_int =  c_fckit_configuration_has(this%CPTR_PGIBUG_B, c_str(name) )
  if( value_int == 1 ) then
    value = .True.
  else
    value = .False.
  end if
end function

function key(this, index) result(key_str)
  use fckit_c_interop_module, only : c_str, c_ptr_to_string, c_ptr_free
  character(kind=c_char,len=:), allocatable :: key_str
  class(fckit_Configuration), intent(in) :: this
  integer(c_int32_t), intent(in) :: index
  type(c_ptr) :: key_cptr
  integer(c_size_t) :: key_size
  call c_fckit_configuration_key(this%CPTR_PGIBUG_B, index, key_cptr, key_size)
  FCKIT_ALLOCATE_CHARACTER(key_str, key_size)
  key_str = c_ptr_to_string(key_cptr)
  call c_ptr_free(key_cptr)
end function

function get_size(this, name) result(val)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int32_t) :: val
  val = c_fckit_configuration_get_size(this%CPTR_PGIBUG_B, c_str(name) )
end function

subroutine set_config(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  class(fckit_Configuration), intent(in) :: value
  call c_fckit_configuration_set_config(this%CPTR_PGIBUG_B, c_str(name), value%CPTR_PGIBUG_B )
end subroutine

subroutine set_config_list(this, name, value)
  use, intrinsic :: iso_c_binding, only : c_loc
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  type(fckit_Configuration), intent(in) :: value(:) !PGI (17.7) compiler bug when "type" replaced with "class"
  type(c_ptr), target :: value_cptrs(size(value))
  integer(c_int32_t) :: j
  if( size(value) > 0 ) then
    do j=1,size(value)
      value_cptrs(j) = value(j)%CPTR_PGIBUG_B
    enddo
    call c_fckit_configuration_set_config_list(this%CPTR_PGIBUG_B, c_str(name),  &
      c_loc(value_cptrs(1)), size(value_cptrs,kind=c_size_t) )
  endif
end subroutine


subroutine set_logical(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  logical, intent(in) :: value
  integer(c_int32_t) :: value_int
  if( value ) then
    value_int = 1
  else
    value_int = 0
  end if
  call c_fckit_configuration_set_bool(this%CPTR_PGIBUG_B, c_str(name), value_int )
end subroutine

subroutine set_int32(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int32_t), intent(in) :: value
  call c_fckit_configuration_set_int32(this%CPTR_PGIBUG_B, c_str(name), value)
end subroutine

subroutine set_int64(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int64_t), intent(in) :: value
  call c_fckit_configuration_set_int64(this%CPTR_PGIBUG_B, c_str(name), value)
end subroutine

subroutine set_real32(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_float), intent(in) :: value
  call c_fckit_configuration_set_float(this%CPTR_PGIBUG_B, c_str(name) ,value)
end subroutine

subroutine set_real64(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_double), intent(in) :: value
  call c_fckit_configuration_set_double(this%CPTR_PGIBUG_B, c_str(name) ,value)
end subroutine

subroutine set_string(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(inout) :: this
  character(kind=c_char,len=*), intent(in) :: name
  character(kind=c_char,len=*), intent(in) :: value
  call c_fckit_configuration_set_string(this%CPTR_PGIBUG_B, c_str(name) , c_str(value) )
end subroutine

subroutine set_array_string(this, name, value)
  use, intrinsic :: iso_c_binding, only : c_f_pointer
  use fckit_c_interop_module, only : c_str, c_ptr_to_string, c_ptr_free
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  character(kind=c_char,len=*), intent(in) :: value(:)
  character(kind=c_char,len=:), allocatable :: flatvalue
  integer(c_size_t) :: length
  integer(c_int32_t) :: ii
  length = 0
  if( size(value) > 0 ) then
    length = len(value(1))
    allocate( character(len=length*size(value) ) :: flatvalue )
    do ii = 1, size(value)
      flatvalue((ii-1)*length+1:ii*length) = value(ii)
    enddo
    call c_fckit_configuration_set_array_string(this%CPTR_PGIBUG_B, c_str(name), &
      &  c_str(flatvalue), length, size(value,kind=c_size_t) )
  endif
end subroutine

subroutine set_array_int32(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int32_t), intent(in) :: value(:)
  call c_fckit_configuration_set_array_int32(this%CPTR_PGIBUG_B, c_str(name), value, size(value,kind=c_size_t) )
end subroutine

subroutine set_array_int64(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int64_t), intent(in) :: value(:)
  call c_fckit_configuration_set_array_int64(this%CPTR_PGIBUG_B, c_str(name), value, size(value,kind=c_size_t) )
end subroutine

subroutine set_array_real32(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_float), intent(in) :: value(:)
  call c_fckit_configuration_set_array_float(this%CPTR_PGIBUG_B, c_str(name), value, size(value,kind=c_size_t) )
end subroutine

subroutine set_array_real64(this, name, value)
  use fckit_c_interop_module, only : c_str
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_double), intent(in) :: value(:)
  call c_fckit_configuration_set_array_double(this%CPTR_PGIBUG_B, c_str(name), value, size(value,kind=c_size_t) )
end subroutine

function get_config(this, name, value) result(found)
  use fckit_c_interop_module, only : c_str
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  class(fckit_Configuration), intent(inout) :: value
  integer(c_int32_t) :: found_int
  value = fckit_Configuration()
  found_int = c_fckit_configuration_get_config(this%CPTR_PGIBUG_B, &
    c_str(name), value%CPTR_PGIBUG_B )
  found = .False.
  if (found_int == 1) then
    found = .True.
  endif
end function

subroutine get_config_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  class(fckit_Configuration), intent(inout) :: value
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_config_list(this, name, value) result(found)
  use, intrinsic :: iso_c_binding, only : c_f_pointer, c_null_ptr
  use fckit_c_interop_module, only : c_str, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  type(fckit_Configuration), allocatable, intent(inout) :: value(:)
  type(c_ptr) :: value_list_cptr
  type(c_ptr), pointer :: value_cptrs(:)
  integer(c_size_t) :: value_list_size
  integer(c_int32_t) :: found_int
  integer(c_size_t) :: j
  call deallocate_fckit_configuration(value)
  value_list_cptr = c_null_ptr
  found_int = c_fckit_configuration_get_config_list(this%CPTR_PGIBUG_B, c_str(name), &
    & value_list_cptr, value_list_size)
  found = .False.
  if( found_int == 1 ) then
    found = .true.
    call c_f_pointer(value_list_cptr,value_cptrs,(/value_list_size/))
    allocate(value(value_list_size))
    do j=1,value_list_size
      call value(j)%reset_c_ptr( value_cptrs(j), fckit_c_deleter(c_fckit_configuration_delete) )
    enddo
    call c_ptr_free(value_list_cptr)
  endif
end function

subroutine get_config_list_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  type(fckit_Configuration), allocatable, intent(inout) :: value(:)
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_logical(this, name, value) result(found)
  use fckit_c_interop_module, only : c_str
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  logical, intent(inout) :: value
  integer(c_int32_t) :: value_int
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_bool(this%CPTR_PGIBUG_B,c_str(name), value_int )
  found = .False.
  if (found_int == 1) found = .True.
  if (found) then
    if (value_int > 0) then
      value = .True.
    else
      value = .False.
    end if
  endif
end function

subroutine get_logical_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  logical, intent(inout) :: value
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_int32(this, name, value) result(found)
  use fckit_c_interop_module, only : c_str
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int32_t), intent(inout) :: value
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_int32(this%CPTR_PGIBUG_B, c_str(name), value )
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_int32_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int32_t), intent(inout) :: value
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_int64(this, name, value) result(found)
  use fckit_c_interop_module, only : c_str
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int64_t), intent(inout) :: value
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_int64(this%CPTR_PGIBUG_B, c_str(name), value )
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_int64_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int64_t), intent(inout) :: value
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_real32(this, name, value) result(found)
  use fckit_c_interop_module, only : c_str
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_float), intent(inout) :: value
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_float(this%CPTR_PGIBUG_B, c_str(name), value )
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_real32_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_float), intent(inout) :: value
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_real64(this, name, value) result(found)
  use fckit_c_interop_module, only : c_str
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_double), intent(inout) :: value
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_double(this%CPTR_PGIBUG_B, c_str(name), value )
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_real64_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_double), intent(inout) :: value
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_string(this, name, value) result(found)
  use fckit_c_interop_module, only : c_str, c_ptr_to_string, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  character(kind=c_char,len=:), allocatable, intent(inout) :: value
  type(c_ptr) :: value_cptr
  integer(c_int32_t) :: found_int
  integer(c_size_t) :: value_size
  found_int = c_fckit_configuration_get_string(this%CPTR_PGIBUG_B,c_str(name),value_cptr,value_size)
  if( found_int == 1 ) then
    if( allocated(value) ) deallocate(value)
    FCKIT_ALLOCATE_CHARACTER(value,value_size)
    if ( value_size > 0 ) then
      value = c_ptr_to_string(value_cptr)
      call c_ptr_free(value_cptr)
    endif
  endif
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_string_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  character(kind=c_char,len=:), allocatable, intent(inout) :: value
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_array_logical(this, name, value) result(found)
  use, intrinsic :: iso_c_binding, only : c_f_pointer
  use fckit_c_interop_module, only : c_str, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  logical, allocatable, intent(inout) :: value(:)
  type(c_ptr) :: value_cptr
  integer(c_int32_t), pointer :: value_fptr(:)
  integer(c_size_t) :: j, value_size
  integer(c_int32_t), allocatable :: value_int(:)
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_array_int32(this%CPTR_PGIBUG_B, c_str(name), &
   & value_cptr, value_size )
  if( found_int == 1 ) then
    call c_f_pointer(value_cptr,value_fptr,(/value_size/))
    allocate(value_int(value_size))
    value_int(:) = value_fptr(:)
    if( allocated(value) ) deallocate(value)
    allocate(value(value_size))
    do j = 1, value_size
      if (value_int(j) > 0) then
        value(j) = .True.
      else
        value(j) = .False.
      endif
    end do
    call c_ptr_free(value_cptr)
  endif
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_array_logical_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  logical, allocatable, intent(inout) :: value(:)
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_array_int32(this, name, value) result(found)
  use, intrinsic :: iso_c_binding, only : c_f_pointer
  use fckit_c_interop_module, only : c_str, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int32_t), allocatable, intent(inout) :: value(:)
  type(c_ptr) :: value_cptr
  integer(c_int32_t), pointer :: value_fptr(:)
  integer(c_size_t) :: value_size
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_array_int32(this%CPTR_PGIBUG_B, c_str(name), &
   & value_cptr, value_size )
  if( found_int == 1 ) then
    call c_f_pointer(value_cptr,value_fptr,(/value_size/))
    if( allocated(value) ) deallocate(value)
    allocate(value(value_size))
    value(:) = value_fptr(:)
    call c_ptr_free(value_cptr)
  endif
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_array_int32_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int32_t), allocatable, intent(inout) :: value(:)
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_array_int64(this, name, value) result(found)
  use, intrinsic :: iso_c_binding, only : c_f_pointer
  use fckit_c_interop_module, only : c_str, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int64_t), allocatable, intent(inout) :: value(:)
  type(c_ptr) :: value_cptr
  integer(c_int64_t), pointer :: value_fptr(:)
  integer(c_size_t) :: value_size
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_array_int64(this%CPTR_PGIBUG_B, c_str(name), &
   & value_cptr, value_size )
  if( found_int == 1 ) then
    call c_f_pointer(value_cptr,value_fptr,(/value_size/))
    if( allocated(value) ) deallocate(value)
    allocate(value(value_size))
    value(:) = value_fptr(:)
    call c_ptr_free(value_cptr)
  endif
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_array_int64_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  integer(c_int64_t), allocatable, intent(inout) :: value(:)
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_array_real32(this, name, value) result(found)
  use, intrinsic :: iso_c_binding, only : c_f_pointer
  use fckit_c_interop_module, only : c_str, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_float), allocatable, intent(inout) :: value(:)
  type(c_ptr) :: value_cptr
  real(c_float), pointer :: value_fptr(:)
  integer(c_size_t) :: value_size
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_array_float(this%CPTR_PGIBUG_B, c_str(name), &
   & value_cptr, value_size )
  if( found_int == 1 ) then
    call c_f_pointer(value_cptr,value_fptr,(/value_size/))
    if( allocated(value) ) deallocate(value)
    allocate(value(value_size))
    value(:) = value_fptr(:)
    call c_ptr_free(value_cptr)
  endif
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_array_real32_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_float), allocatable, intent(inout) :: value(:)
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_array_real64(this, name, value) result(found)
  use, intrinsic :: iso_c_binding, only : c_f_pointer
  use fckit_c_interop_module, only : c_str, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_double), allocatable, intent(inout) :: value(:)
  type(c_ptr) :: value_cptr
  real(c_double), pointer :: value_fptr(:)
  integer(c_size_t) :: value_size
  integer(c_int32_t) :: found_int
  found_int = c_fckit_configuration_get_array_double(this%CPTR_PGIBUG_B, c_str(name), &
   & value_cptr, value_size )
  if( found_int == 1 ) then
    call c_f_pointer(value_cptr,value_fptr,(/value_size/))
    if( allocated(value) ) deallocate(value)
    allocate(value(value_size))
    value(:) = value_fptr(:)
    call c_ptr_free(value_cptr)
  endif
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_array_real64_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(kind=c_char,len=*), intent(in) :: name
  real(c_double), allocatable, intent(inout) :: value(:)
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function get_array_string(this,name,value) result(found)
  use, intrinsic :: iso_c_binding, only : c_f_pointer
  use fckit_c_interop_module, only : c_str, c_ptr_to_string, c_ptr_free
  logical :: found
  class(fckit_Configuration), intent(in) :: this
  character(len=*), intent(in) :: name
  character(len=:), allocatable, intent(inout) :: value(:)
  type(c_ptr) :: value_cptr
  type(c_ptr) :: offsets_cptr
  integer(c_size_t), pointer :: offsets_fptr(:)
  integer(c_size_t), allocatable :: offsets(:)
  integer(c_size_t) :: value_size
  integer(c_size_t) :: value_numelem
  integer(c_int32_t) :: found_int
  integer(c_size_t) :: maxelemlen
  integer(c_size_t) :: elemlen
  integer(c_size_t) :: j
  character(len=:), allocatable :: flatvalue
  found_int =   c_fckit_configuration_get_array_string(this%CPTR_PGIBUG_B, c_str(name), &
   & value_cptr, value_size, offsets_cptr, value_numelem)
  if( found_int == 1 ) then
    ! Get flat character array
    allocate(character(len=value_size) :: flatvalue )
    if ( value_size > 0 ) then
      flatvalue = c_ptr_to_string(value_cptr)
      call c_ptr_free(value_cptr)
    end if
    ! Get offsets
    call c_f_pointer(offsets_cptr,offsets_fptr,(/value_numelem/))
    allocate(offsets(value_numelem))
    offsets(:) = offsets_fptr(:)
    call c_ptr_free(offsets_cptr)
    ! Find maximum length of an element
    maxelemlen = 0
    do j=1,value_numelem
      if( j < value_numelem ) then
        maxelemlen = max( maxelemlen, offsets(j+1) - offsets(j) )
      else
        maxelemlen = max( maxelemlen, value_size - offsets(j) )
      endif  
    enddo
    ! Extract values 
    if( allocated(value) ) deallocate(value)
    allocate(character(len=maxelemlen) :: value(value_numelem) )
    do j=1,value_numelem
      if( j < value_numelem ) then
        elemlen = offsets(j+1) - offsets(j)
      else
        elemlen = value_size - offsets(j)
      endif  
      value(j) = flatvalue(offsets(j)+1:offsets(j)+elemlen)
    enddo  
  endif
  found = .False.
  if (found_int == 1) found = .True.
end function

subroutine get_array_string_or_die(this,name,value)
  class(fckit_Configuration), intent(in) :: this
  character(len=*), intent(in) :: name
  character(len=:), allocatable, intent(inout) :: value(:)
  if( .not. this%get(name,value) ) call throw_configuration_not_found(name)
end subroutine

function json(this) result(jsonstr)
  use fckit_c_interop_module, only : c_str, c_ptr_to_string, c_ptr_free
  character(kind=c_char,len=:), allocatable :: jsonstr
  class(fckit_Configuration), intent(in) :: this
  type(c_ptr) :: json_cptr
  integer(c_size_t) :: json_size
  call c_fckit_configuration_json(this%CPTR_PGIBUG_B,json_cptr,json_size)
  FCKIT_ALLOCATE_CHARACTER(jsonstr,json_size)
  jsonstr = c_ptr_to_string(json_cptr)
  call c_ptr_free(json_cptr)
end function

end module fckit_configuration_module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_refcount_module
use, intrinsic :: iso_c_binding, only : c_ptr, c_null_ptr
implicit none
private

!========================================================================
! Public interface

public :: fckit_refcount
public :: fckit_refcount_interface
public :: fckit_external

#if FCKIT_HAVE_ECKIT
public :: fckit_owned
#endif

!========================================================================

type, abstract :: fckit_refcount
contains
procedure(fckit_refcount_owners), public, deferred :: owners
procedure(fckit_refcount_attach), public, deferred :: attach
procedure(fckit_refcount_detach), public, deferred :: detach
end type

interface
  function fckit_refcount_owners(this)
    use, intrinsic :: iso_c_binding, only: c_int32_t
    import fckit_refcount
    integer(c_int32_t) :: fckit_refcount_owners
    class(fckit_refcount), intent(in) :: this
  end function
  subroutine fckit_refcount_attach(this)
    import fckit_refcount
    class(fckit_refcount), intent(inout) :: this
  end subroutine
  subroutine fckit_refcount_detach(this)
    import fckit_refcount
    class(fckit_refcount), intent(inout) :: this
  end subroutine
end interface

abstract interface
  subroutine fckit_refcount_interface(refcount,shared_ptr)
    import fckit_refcount
    class(fckit_refcount), pointer, intent(inout) :: refcount
    class(*), target, intent(in) :: shared_ptr
  end subroutine
end interface

!========================================================================

type, extends(fckit_refcount) :: fckit_refcount_external
  integer, private :: refcount_ = 0
  contains
  procedure, public :: owners => fckit_refcount_external_owners
  procedure, public :: attach => fckit_refcount_external_attach
  procedure, public :: detach => fckit_refcount_external_detach
end type

!========================================================================

interface

  function fckit__Owned__owners(this) bind(c,name="fckit__Owned__owners")
    use, intrinsic :: iso_c_binding, only: c_int32_t, c_ptr
    integer(c_int32_t) :: fckit__Owned__owners
    type(c_ptr), value :: this
  end function

  subroutine fckit__Owned__attach(this) bind(c,name="fckit__Owned__attach")
    use, intrinsic :: iso_c_binding, only: c_ptr
    type(c_ptr), value :: this
  end subroutine

  subroutine fckit__Owned__detach(this) bind(c,name="fckit__Owned__detach")
    use, intrinsic :: iso_c_binding, only: c_ptr
    type(c_ptr), value :: this
  end subroutine

end interface

#if FCKIT_HAVE_ECKIT
type, extends(fckit_refcount) :: fckit_refcount_owned
  type(c_ptr), private :: cptr_ = c_null_ptr
  contains
  procedure, public :: owners => fckit_refcount_owned_owners
  procedure, public :: attach => fckit_refcount_owned_attach
  procedure, public :: detach => fckit_refcount_owned_detach
end type
#endif

private :: c_ptr, c_null_ptr

!========================================================================
CONTAINS
!========================================================================

subroutine allocate_fckit_external(refcount,shared_ptr)
  class(fckit_refcount), pointer, intent(inout) :: refcount
  class(*), target, intent(in) :: shared_ptr
  allocate( fckit_refcount_external::refcount )
  FCKIT_SUPPRESS_UNUSED( shared_ptr )
end subroutine

function fckit_external() result(funptr)
  procedure(fckit_refcount_interface), pointer :: funptr
  funptr => allocate_fckit_external
end function

#if FCKIT_HAVE_ECKIT
subroutine allocate_fckit_refcount_owned(refcount,shared_ptr)
  use fckit_object_module, only : fckit_object
  use, intrinsic :: iso_c_binding, only : c_ptr
  class(fckit_refcount), pointer, intent(inout) :: refcount
  class(*), target, intent(in) :: shared_ptr
  type(c_ptr) :: cptr
  allocate( fckit_refcount_owned::refcount )
  select type( shared_ptr )
    class is( fckit_object )
      cptr = shared_ptr%CPTR_PGIBUG_A
  end select
  select type( refcount )
    class is( fckit_refcount_owned )
      refcount%cptr_ = cptr
  end select
end subroutine

function fckit_owned() result(funptr)
  procedure(fckit_refcount_interface), pointer :: funptr
  funptr => allocate_fckit_refcount_owned
end function

#endif


subroutine fckit_refcount_external_attach(this)
  class(fckit_refcount_external), intent(inout) :: this
  this%refcount_ = this%refcount_ + 1
end subroutine

subroutine fckit_refcount_external_detach(this)
  class(fckit_refcount_external), intent(inout) :: this
  this%refcount_ = max(0, this%refcount_ - 1)
end subroutine

function fckit_refcount_external_owners(this) result(owners)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: owners
  class(fckit_refcount_external), intent(in) :: this
  owners = this%refcount_
end function

#if FCKIT_HAVE_ECKIT
subroutine fckit_refcount_owned_attach(this)
  class(fckit_refcount_owned), intent(inout) :: this
  call fckit__Owned__attach(this%cptr_)
end subroutine

subroutine fckit_refcount_owned_detach(this)
  class(fckit_refcount_owned), intent(inout) :: this
  call fckit__Owned__detach(this%cptr_)
end subroutine

function fckit_refcount_owned_owners(this) result(owners)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: owners
  class(fckit_refcount_owned), intent(in) :: this
  owners = fckit__Owned__owners(this%cptr_)
end function
#endif

end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_log_module
  !! Provides [[fckit_log_module:fckit_log(variable)]] for logging and to configure logging

use fckit_object_module, only: fckit_object
use, intrinsic :: iso_c_binding, only : c_int32_t

implicit none
private
public :: log ! DEPRECATED, USE fckit_log INSTEAD!
public :: fckit_log
public :: fckit_logchannel
private :: fckit_object
private :: c_int32_t

#include "fckit_log.inc"

type, FORD_PRIVATE :: fckit_log_type
  !! Private type of [[fckit_log_module:fckit_log(variable)]] module variable
  !!
  !! It wraps ```eckit::Log```, allowing Fortran and C++ code to log to the
  !! same output channels

  integer(c_int32_t) :: SIMPLE = 0
    !! Style for logging without any prefix
  integer(c_int32_t) :: PREFIX = 1
    !! Style for logging with prefix
    !!
    !!    (I) --> info
    !!    (W) --> warning
    !!    (E) --> error
    !!    (D) --> debug

  integer(c_int32_t) :: TIMESTAMP = 2
    !! Style for logging with prefix that contains time stamp and taskID
    !!
    !!    <taskID> <TIME> (I) --> info
    !!    <taskID> <TIME> (W) --> warning
    !!    <taskID> <TIME> (E) --> error
    !!    <taskID> <TIME> (D) --> debug

contains

  procedure, nopass, public :: debug
    !! Log to debug channel

  procedure, nopass, public :: info
    !! Log to info channel

  procedure, nopass, public :: warning
    !! Log to warning channel

  procedure, nopass, public :: error
    !! Log to error channel

  procedure, nopass, public :: panic
    !! Log to panic channel (fortran_unit 0, always)

  procedure, nopass, public :: reset
    !! Reset all log channels (No more logging)

  procedure, nopass, public :: flush => fckit_log__flush
    !! Flush all log channels (empty buffers)

  procedure, nopass, public :: add_stdout
    !! Add the C++ ```std::cout``` output stream to each logchannel

  procedure, nopass, public :: set_stdout
    !! Replace each logchannels streams with the C++ ```std::cout``` output stream

  procedure, nopass, public :: add_fortran_unit
    !! Add a given fortran unit as output stream to each logchannel

  procedure, nopass, public :: set_fortran_unit
    !! Replace each logchannel streams with a given fortran unit

  procedure, nopass, public :: add_file
    !! Add a given file as output stream to each logchannel.
    !!
    !! The file will be (re)created.

  procedure, nopass, public :: set_file
    !! Replace each logchannels streams with a given file
    !!
    !! The file will be (re)created.

  procedure, nopass, public :: info_channel
    !! Return the info [[fckit_logchannel(type)]]

  procedure, nopass, public :: warning_channel
    !! Return the warning [[fckit_logchannel(type)]]

  procedure, nopass, public :: error_channel
    !! Return the error [[fckit_logchannel(type)]]

  procedure, nopass, public :: debug_channel
    !! Return the debug [[fckit_logchannel(type)]]

end type fckit_log_type

type(fckit_log_type) :: fckit_log
  !! Instance of [[fckit_log_module:fckit_log_type(type)]]

type(fckit_log_type) :: log
  !! deprecated: true
  !! Deprecated instance of [[fckit_log_module:fckit_log_type(type)]].
  !! Use [[fckit_log_module:fckit_log(variable)]] instead!

!------------------------------------------------------------------------------

type, extends(fckit_object) :: fckit_logchannel
  !! Log channel (any of info, warning, error, debug)
  !!
  !! Wraps ```eckit::Channel```. This channel can be passed as
  !! arguments to functions that expect a ```std::ostream``` to log to.
contains
  procedure, public :: delete
    !! Delete internal C++ pointer
end type fckit_logchannel

!========================================================
contains
!========================================================

subroutine debug(msg,newl,flush)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module, only : c_str_right_trim
  character(kind=c_char,len=*), intent(in) :: msg
    !! Message to be logged
  logical, intent(in), optional :: newl
    !! Add newline character (```\n```) after message.
    !! Default ```.true.```
  logical, intent(in), optional :: flush
    !! Flush channel after message.
    !! Default ```.true.```
  integer(c_int32_t) :: opt_newl, opt_flush
  opt_newl  = 1 ; if( present(newl) ) then; if( .not.  newl ) opt_newl  = 0; endif
  opt_flush = 1 ; if( present(flush)) then; if( .not. flush ) opt_flush = 0; endif
  call fckit__log_debug(c_str_right_trim(msg),opt_newl,opt_flush)
end subroutine


subroutine info(msg,newl,flush)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module, only : c_str_right_trim
  character(kind=c_char,len=*), intent(in) :: msg
    !! Message to be logged
  logical, intent(in), optional :: newl
    !! Add newline character (```\n```) after message.
    !! Default ```.true.```
  logical, intent(in), optional :: flush
    !! Flush channel after message.
    !! Default ```.true.```
  integer(c_int32_t) :: opt_newl, opt_flush
  opt_newl  = 1 ; if( present(newl) ) then; if( .not.  newl ) opt_newl  = 0; endif
  opt_flush = 1 ; if( present(flush)) then; if( .not. flush ) opt_flush = 0; endif
  call fckit__log_info(c_str_right_trim(msg),opt_newl,opt_flush)
end subroutine


subroutine warning(msg,newl,flush)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module, only : c_str_right_trim
  character(kind=c_char,len=*), intent(in) :: msg
    !! Message to be logged
  logical, intent(in), optional :: newl
    !! Add newline character (```\n```) after message.
    !! Default ```.true.```
  logical, intent(in), optional :: flush
    !! Flush channel after message.
    !! Default ```.true.```
  integer(c_int32_t) :: opt_newl, opt_flush
  opt_newl  = 1 ; if( present(newl) ) then; if( .not.  newl ) opt_newl  = 0; endif
  opt_flush = 1 ; if( present(flush)) then; if( .not. flush ) opt_flush = 0; endif
  call fckit__log_warning(c_str_right_trim(msg),opt_newl,opt_flush)
end subroutine


subroutine error(msg,newl,flush)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module, only : c_str_right_trim
  character(kind=c_char,len=*), intent(in) :: msg
    !! Message to be logged
  logical, intent(in), optional :: newl
    !! Add newline character (```\n```) after message.
    !! Default ```.true.```
  logical, intent(in), optional :: flush
    !! Flush channel after message.
    !! Default ```.true.```
  integer(c_int32_t) :: opt_newl, opt_flush
  opt_newl  = 1 ; if( present(newl) ) then; if( .not.  newl ) opt_newl  = 0; endif
  opt_flush = 1 ; if( present(flush)) then; if( .not. flush ) opt_flush = 0; endif
  call fckit__log_error(c_str_right_trim(msg),opt_newl,opt_flush)
end subroutine


subroutine panic(msg)
  use, intrinsic :: iso_c_binding
  character(kind=c_char,len=*), intent(in) :: msg
    !! Message to be logged
  write(0,'(A)') msg
end subroutine


subroutine add_fortran_unit(unit,style)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module
  integer(c_int32_t), intent(in) :: unit
    !! Fortran unit
  integer(c_int32_t), intent(in), optional :: style
    !! Style to prefix the stream with. Options are:
    !!
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):SIMPLE(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):PREFIX(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):TIMESTAMP(variable)]]
  integer(c_int) :: opt_style
  opt_style = fckit_log%PREFIX
  if( present( style ) ) opt_style = style
  call fckit__log_add_fortran_unit(unit,opt_style)
end subroutine


subroutine set_fortran_unit(unit,style)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module
  integer(c_int32_t), intent(in) :: unit
    !! Fortran unit
  integer(c_int32_t), intent(in), optional :: style
    !! Style to prefix the stream with. Options are:
    !!
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):SIMPLE(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):PREFIX(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):TIMESTAMP(variable)]]
  integer(c_int32_t) :: opt_style
  opt_style = fckit_log%PREFIX
  if( present( style ) ) opt_style = style
  call fckit__log_set_fortran_unit(unit,opt_style)
end subroutine

subroutine add_file(path,style)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module
  character(kind=c_char,len=*), intent(in) :: path
    !! Path to file. File will be (re)created
  integer(c_int32_t), intent(in), optional :: style
    !! Style to prefix the stream with. Options are:
    !!
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):SIMPLE(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):PREFIX(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):TIMESTAMP(variable)]]
  integer(c_int32_t) :: opt_style
  opt_style = fckit_log%PREFIX
  if( present( style ) ) opt_style = style
  call fckit__log_add_file(c_str(path),opt_style)
end subroutine


subroutine set_file(path,style)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module
  character(kind=c_char,len=*), intent(in) :: path
    !! Path to file. File will be (re)created
  integer(c_int32_t), intent(in), optional :: style
    !! Style to prefix the stream with. Options are:
    !!
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):SIMPLE(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):PREFIX(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):TIMESTAMP(variable)]]
  integer(c_int32_t) :: opt_style
  opt_style = fckit_log%PREFIX
  if( present( style ) ) opt_style = style
  call fckit__log_set_file(c_str(path),opt_style)
end subroutine

subroutine add_stdout(style)
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), intent(in), optional :: style
    !! Style to prefix the stream with. Options are:
    !!
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):SIMPLE(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):PREFIX(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):TIMESTAMP(variable)]]
  integer(c_int32_t) :: opt_style
  opt_style = fckit_log%PREFIX
  if( present( style ) ) opt_style = style
  call fckit__log_add_stdout(opt_style)
end subroutine


subroutine set_stdout(style)
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), intent(in), optional :: style
    !! Style to prefix the stream with. Options are:
    !!
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):SIMPLE(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):PREFIX(variable)]]
    !! - [[fckit_log_module:fckit_log(variable)]]%[[fckit_log_type(type):TIMESTAMP(variable)]]
  integer(c_int32_t) :: opt_style
  opt_style = fckit_log%PREFIX
  if( present( style ) ) opt_style = style
  call fckit__log_set_stdout(opt_style)
end subroutine


subroutine reset()
  call fckit__log_reset()
end subroutine

subroutine fckit_log__flush()
  call fckit__log_flush()
end subroutine

function info_channel() result(channel)
  type(fckit_logchannel) :: channel
  call channel%reset_c_ptr( fckit__log_info_channel() )
  call channel%return()
end function


function warning_channel() result(channel)
  type(fckit_logchannel) :: channel
  call channel%reset_c_ptr( fckit__log_warning_channel() )
  call channel%return()
end function


function error_channel() result(channel)
  type(fckit_logchannel) :: channel
  call channel%reset_c_ptr( fckit__log_error_channel() )
  call channel%return()
end function


function debug_channel() result(channel)
  type(fckit_logchannel) :: channel
  call channel%reset_c_ptr( fckit__log_debug_channel() )
  call channel%return()
end function


subroutine delete(this)
  class(fckit_logchannel), intent(inout) :: this
  ! do nothing
  FCKIT_SUPPRESS_UNUSED(this)
end subroutine

end module fckit_log_module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fctest.h"

! -----------------------------------------------------------------------------

TESTSUITE(fckit_test_resource)

TESTSUITE_INIT
  use fckit_module
  call fckit_main%init()
END_TESTSUITE_INIT
! -----------------------------------------------------------------------------

TEST( test_resource )
  use, intrinsic :: iso_c_binding
  use fckit_module

  integer(c_int32_t) :: intval
  integer(c_int64_t) :: longval
  real(c_float) :: floatval
  real(c_double) :: doubleval
  character(len=:), allocatable :: stringval

  call fckit_resource("-integer",0_c_int32_t,intval)
  FCTEST_CHECK_EQUAL(intval, 10_c_int32_t)
  write(0,*) "integer = ",intval

  call fckit_resource("-long",0_c_int64_t,longval)
  write(0,*) "long = ",longval
  FCTEST_CHECK_EQUAL(longval, 5000000000_c_int64_t)

  call fckit_resource("-float",0._c_float,floatval)
  FCTEST_CHECK_EQUAL(floatval, 0.123456_c_float )
  write(0,*) "float = ",floatval

  call fckit_resource("-double",0._c_double,doubleval)
  FCTEST_CHECK_EQUAL(doubleval, 0.1234567890123456789_c_double )
  write(0,*) "double = ",doubleval

  call fckit_resource("-string","default",stringval)
  FCTEST_CHECK_EQUAL(stringval, "hello world")
  write(0,*) "string = ",stringval
END_TEST

! -----------------------------------------------------------------------------

END_TESTSUITE

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fctest.h"

TESTSUITE( test_broadcast_file )

TESTSUITE_INIT
  use fckit_module
  call fckit_main%init()
  call fckit_log%set_fortran_unit(0)

  ! Write a json file
  if( fckit_main%taskID() == 0 ) then
    OPEN (UNIT=199 , FILE="fctest_broadcast.json", STATUS='REPLACE')
    write(199,'(A)') '{"location":{"city":"Reading","company":"ECMWF","street":"Shinfield Road"},'//&
        &          '"records":[{"age":42,"name":"Anne"},{"age":36,"name":"Bob"}]}'
    CLOSE(199)
  endif

END_TESTSUITE_INIT

TESTSUITE_FINALIZE
  use fckit_module
  call fckit_main%final()
END_TESTSUITE_FINALIZE

TEST( broadcast_file_inline )
#if 1
  use fckit_module
  implicit none
  type(fckit_mpi_comm) :: comm
  type(fckit_Configuration) :: config
  write(0,*) "~~~~~~~~~~~~~~ SCOPE BEGIN ~~~~~~~~~~~~~~~"
  comm = fckit_mpi_comm()
  config = fckit_YAMLConfiguration( comm%broadcast_file("fctest_broadcast.json",0) )
  FCTEST_CHECK( config%has("location") )
#if ! FCKIT_HAVE_FINAL
  call config%final()
#endif
  write(0,*) "~~~~~~~~~~~~~~~ SCOPE END ~~~~~~~~~~~~~~~~"
#else
#warning test broadcast_file_inline disabled
#endif
END_TEST

TEST( broadcast_file_arg )
#if 1
  use fckit_module
  implicit none
  type(fckit_mpi_comm) :: comm
  type(fckit_Configuration) :: config
  type(fckit_buffer) :: buffer
  write(0,*) "~~~~~~~~~~~~~~ SCOPE BEGIN ~~~~~~~~~~~~~~~"
  comm = fckit_mpi_comm()
  buffer = comm%broadcast_file("fctest_broadcast.json",0)
  config = fckit_YAMLConfiguration( buffer )
  FCTEST_CHECK( config%has("location") )
  FCTEST_CHECK_EQUAL( buffer%owners(), 1 )
#if ! FCKIT_HAVE_FINAL
  call buffer%final()
#endif
  write(0,*) "~~~~~~~~~~~~~~~ SCOPE END ~~~~~~~~~~~~~~~~"
#else
#warning test broadcast_file_arg disabled
#endif
END_TEST


END_TESTSUITE

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_refcount_module
use, intrinsic :: iso_c_binding, only : c_ptr, c_null_ptr
implicit none
private

!========================================================================
! Public interface

public :: fckit_refcount
public :: fckit_refcount_interface
public :: fckit_external

#if FCKIT_HAVE_ECKIT
public :: fckit_owned
#endif

!========================================================================

type, abstract :: fckit_refcount
contains
procedure(fckit_refcount_owners), public, deferred :: owners
procedure(fckit_refcount_attach), public, deferred :: attach
procedure(fckit_refcount_detach), public, deferred :: detach
end type

interface
  function fckit_refcount_owners(this)
    use, intrinsic :: iso_c_binding, only: c_int32_t
    import fckit_refcount
    integer(c_int32_t) :: fckit_refcount_owners
    class(fckit_refcount), intent(in) :: this
  end function
  subroutine fckit_refcount_attach(this)
    import fckit_refcount
    class(fckit_refcount), intent(inout) :: this
  end subroutine
  subroutine fckit_refcount_detach(this)
    import fckit_refcount
    class(fckit_refcount), intent(inout) :: this
  end subroutine
end interface

abstract interface
  subroutine fckit_refcount_interface(refcount,shared_ptr)
    import fckit_refcount
    class(fckit_refcount), pointer, intent(inout) :: refcount
    class(*), target, intent(in) :: shared_ptr
  end subroutine
end interface

!========================================================================

type, extends(fckit_refcount) :: fckit_refcount_external
  integer, private :: refcount_ = 0
  contains
  procedure, public :: owners => fckit_refcount_external_owners
  procedure, public :: attach => fckit_refcount_external_attach
  procedure, public :: detach => fckit_refcount_external_detach
end type

!========================================================================

interface

  function fckit__Owned__owners(this) bind(c,name="fckit__Owned__owners")
    use, intrinsic :: iso_c_binding, only: c_int32_t, c_ptr
    integer(c_int32_t) :: fckit__Owned__owners
    type(c_ptr), value :: this
  end function

  subroutine fckit__Owned__attach(this) bind(c,name="fckit__Owned__attach")
    use, intrinsic :: iso_c_binding, only: c_ptr
    type(c_ptr), value :: this
  end subroutine

  subroutine fckit__Owned__detach(this) bind(c,name="fckit__Owned__detach")
    use, intrinsic :: iso_c_binding, only: c_ptr
    type(c_ptr), value :: this
  end subroutine

end interface

#if FCKIT_HAVE_ECKIT
type, extends(fckit_refcount) :: fckit_refcount_owned
  type(c_ptr), private :: cptr_ = c_null_ptr
  contains
  procedure, public :: owners => fckit_refcount_owned_owners
  procedure, public :: attach => fckit_refcount_owned_attach
  procedure, public :: detach => fckit_refcount_owned_detach
end type
#endif

private :: c_ptr, c_null_ptr

!========================================================================
CONTAINS
!========================================================================

subroutine allocate_fckit_external(refcount,shared_ptr)
  class(fckit_refcount), pointer, intent(inout) :: refcount
  class(*), target, intent(in) :: shared_ptr
  allocate( fckit_refcount_external::refcount )
  FCKIT_SUPPRESS_UNUSED( shared_ptr )
end subroutine

subroutine fckit_external (funptr)
  procedure(fckit_refcount_interface), pointer :: funptr
  funptr => allocate_fckit_external
end subroutine fckit_external

#if FCKIT_HAVE_ECKIT
subroutine allocate_fckit_refcount_owned(refcount,shared_ptr)
  use fckit_object_module, only : fckit_object
  use, intrinsic :: iso_c_binding, only : c_ptr
  class(fckit_refcount), pointer, intent(inout) :: refcount
  class(*), target, intent(in) :: shared_ptr
  type(c_ptr) :: cptr
  allocate( fckit_refcount_owned::refcount )
  select type( shared_ptr )
    class is( fckit_object )
      cptr = shared_ptr%CPTR_PGIBUG_A
  end select
  select type( refcount )
    class is( fckit_refcount_owned )
      refcount%cptr_ = cptr
  end select
end subroutine

subroutine fckit_owned(funptr)
  procedure(fckit_refcount_interface), pointer :: funptr
  funptr => allocate_fckit_refcount_owned
end subroutine fckit_owned

#endif


subroutine fckit_refcount_external_attach(this)
  class(fckit_refcount_external), intent(inout) :: this
  this%refcount_ = this%refcount_ + 1
end subroutine

subroutine fckit_refcount_external_detach(this)
  class(fckit_refcount_external), intent(inout) :: this
  this%refcount_ = max(0, this%refcount_ - 1)
end subroutine

function fckit_refcount_external_owners(this) result(owners)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: owners
  class(fckit_refcount_external), intent(in) :: this
  owners = this%refcount_
end function

#if FCKIT_HAVE_ECKIT
subroutine fckit_refcount_owned_attach(this)
  class(fckit_refcount_owned), intent(inout) :: this
  call fckit__Owned__attach(this%cptr_)
end subroutine

subroutine fckit_refcount_owned_detach(this)
  class(fckit_refcount_owned), intent(inout) :: this
  call fckit__Owned__detach(this%cptr_)
end subroutine

function fckit_refcount_owned_owners(this) result(owners)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: owners
  class(fckit_refcount_owned), intent(in) :: this
  owners = fckit__Owned__owners(this%cptr_)
end function
#endif

end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_buffer_module
  !! Wrap eckit Buffer capabilities.

use fckit_shared_object_module, only: fckit_shared_object, fckit_c_deleter, fckit_c_nodeleter
implicit none

private :: fckit_shared_object
private :: fckit_c_deleter
private :: fckit_c_nodeleter

!========================================================================
! Public interface

public :: fckit_buffer

private

interface
!-------------------------------------------------------------------------------
! int c_fckit_buffer_str( const eckit::Buffer* This, const
!   char* &str, size_t &size)
!-------------------------------------------------------------------------------
function c_fckit_buffer_str( This, str, size ) bind(C,name="c_fckit_buffer_str")
    use iso_c_binding, only: c_ptr, c_int32_t, c_size_t
    integer(c_int32_t) :: c_fckit_buffer_str
    type(c_ptr), value :: This
    type(c_ptr) :: str
    integer(c_size_t) :: size
end function
!-------------------------------------------------------------------------------

subroutine c_fckit_buffer_delete( this ) bind(C, name="c_fckit_buffer_delete")
    use iso_c_binding, only: c_ptr
    type(c_ptr), value :: this
end subroutine

end interface


!========================================================================

type, extends(fckit_shared_object) :: fckit_buffer
  !! Buffer
  !!
  !! Can contain any data
  !! A typical use case is with the function [[fckit_mpi_module:fckit_mpi_comm(type):broadcast_file(function)]]
  !! where a file is read on one MPI task, and broadcast to all MPI tasks, storing it in a buffer.
  !! This buffer can then be used to construct a configuration
  !! (see e.g. [[fckit_configuration_module:fckit_YAMLConfiguration(interface)]] )
contains
  procedure, public :: str

#if FCKIT_FINAL_NOT_INHERITING
  final :: fckit_buffer__final_auto
#endif

endtype

interface fckit_buffer
  module procedure ctor_from_cptr
end interface

!========================================================================
contains
!---------------------------------------------------------------------------------------

function ctor_from_cptr(cptr, share) result(this)
  use, intrinsic :: iso_c_binding, only : c_ptr
  type(c_ptr), value :: cptr
  type(fckit_buffer) :: this
  logical, optional  :: share
  logical :: opt_share
  opt_share = .false.
  if( present(share) ) opt_share = share
  if( opt_share ) then
    call this%reset_c_ptr( cptr , fckit_c_deleter(c_fckit_buffer_delete) )
  else
    call this%reset_c_ptr( cptr , fckit_c_nodeleter() )
  endif
  call this%return()
end function


!---------------------------------------------------------------------------------------

function str(this)
  use, intrinsic :: iso_c_binding, only: c_ptr, c_int32_t, c_size_t, c_char
  use fckit_c_interop_module
  character(kind=c_char,len=:), allocatable :: str
  class(fckit_buffer), intent(in) :: this
  integer(c_int32_t) :: errcode
  integer(c_size_t) :: str_size
  type(c_ptr) :: str_cptr
  errcode = c_fckit_buffer_str(this%CPTR_PGIBUG_B,str_cptr,str_size)
  FCKIT_ALLOCATE_CHARACTER(str,str_size)
  str = c_ptr_to_string(str_cptr)
  call c_ptr_free(str_cptr)
end function

!========================================================================

#if FCKIT_FINAL_NOT_INHERITING
FCKIT_FINAL subroutine fckit_buffer__final_auto(this)
  type(fckit_buffer), intent(inout) :: this
#if FCKIT_FINAL_DEBUGGING
  write(0,*) "fckit_buffer__final_auto"
#endif
#if FCKIT_FINAL_NOT_PROPAGATING
  call this%final()
#endif
  FCKIT_SUPPRESS_UNUSED( this )
end subroutine
#endif

end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_exception_module
  !! author: Willem Deconinck
  !!
  !! Module providing [[fckit_exception_module:fckit_exception(variable)]] global variable

implicit none
private

#include "fckit_exception.inc"

public :: fckit_exception
public :: fckit_exception_handler

type, FORD_PRIVATE :: fckit_exception_location
  !! Type that gives API to read the location of the thrown exception

contains

  procedure, public, nopass :: is_set    => location_is_set
    !! Function that returns if a location where abort happens is present
    !!
    !! This function can be used in an abort handler

  procedure, public, nopass :: file      => location_file
    !! Function that returns the file where abort is called
    !!
    !! This function can be used in an abort handler

  procedure, public, nopass :: line      => location_line
    !! Function that returns the line where abort is called
    !!
    !! This function can be used in an abort handler

  procedure, public, nopass :: function  => location_function
    !! Function that returns the function where abort is called
    !!
    !! This function can be used in an abort handler

end type fckit_exception_location

type, FORD_PRIVATE :: fckit_exception_type
  !! Type of the global [[fckit_exception_module:fckit_exception(variable)]] variable

  type(fckit_exception_location) :: location
    !! Variable of the type [[fckit_exception_module:fckit_exception_location(type)]]
    !! exposing the location where the exception is thrown

contains

  procedure, public, nopass :: throw
    !! Throw exception
    !!
    !! If the exception is not caught, the program will try to terminate, and
    !! fckit terminate handler will be called, giving nice backtrace etc.
    !!
    !!####Example usage
    !!
    !!```fortran
    !! call fckit_exception%throw("I have my reasons",___FILE___,___LINE___)
    !!```

  procedure, public, nopass :: abort => fckit_exception__abort
    !! Throw the ```eckit::Abort``` exception
    !!
    !!####Example usage
    !!
    !!```fortran
    !! call fckit_exception%abort("I have my reasons",___FILE___,___LINE___)
    !!```
    !!
    !! You could create a macro to help:
    !!
    !!```fortran
    !! #define ABORT_HERE( what ) fckit_exception%abort(what,___FILE___,___LINE___)
    !!
    !! call ABORT_HERE("I have my reasons")
    !!```

  procedure, public, nopass :: what
    !! Function that returns the reason for the thrown exception
    !!
    !! This function can be used in an abort handler

  procedure, public, nopass :: callstack
    !! Function that returns the callstack where exception is thrown
    !!
    !! This function can be used in an abort handler

  procedure, public, nopass :: set_handler
    !! Subroutine to set custom abort handler
    !!
    !!####Example usage
    !!
    !!```fortran
    !! subroutine custom_exception_handler()
    !!   ! handle exception
    !! end subroutine
    !!
    !! subroutine set_custom_exception_handler()
    !!   external :: custom_exception_handler
    !!   procedure(fckit_exception_handler), pointer :: exception_handler => custom_exception_handler
    !!   call fckit_exception%set_handler( exception_handler )
    !! end subroutine
    !!```
end type fckit_exception_type

type(fckit_exception_type) :: fckit_exception
  !! Instance of the [[fckit_exception_module:fckit_exception_type(type)]] type

contains

!------------------------------------------------------------------------------

subroutine set_handler( exception_handler )


  use, intrinsic :: iso_c_binding, only : c_funloc
  procedure(fckit_exception_handler) :: exception_handler
  call fckit__set_abort_handler( c_funloc(exception_handler) )
end subroutine

!------------------------------------------------------------------------------

subroutine fckit_exception__abort( what, file, line, function )
  use, intrinsic :: iso_c_binding, only : c_char, c_int32_t
  use fckit_c_interop_module, only : c_str

  character(kind=c_char,len=*), optional :: what
    !! what for abort

  character(kind=c_char,len=*), optional :: file
    !! File path where aborted (hint: use ```___FILE___``` fortran-line-length permitting)

  integer(c_int32_t), optional :: line
    !! Line in file where aborted (hint: use ```___LINE___```)

  character(kind=c_char,len=*), optional :: function
    !!  Function where aborted

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  character(kind=c_char,len=:), allocatable :: opt_what
  character(kind=c_char,len=:), allocatable :: opt_file
  integer(c_int32_t) :: opt_line
  character(kind=c_char,len=:), allocatable :: opt_function

  if( present(what) ) then
    allocate( character(len=len_trim(what)) :: opt_what )
    opt_what = what
  else
    allocate( character(len=0) :: opt_what )
    opt_what = ""
  endif
  if( present(file) ) then
    allocate( character(len=len_trim(file)) :: opt_file )
    opt_file = file
  else
    allocate( character(len=0) :: opt_file )
    opt_file = ""
  endif
  if( present(line) ) then
    opt_line = line
  else
    opt_line = 0
  endif
  if( present(function) ) then
    allocate( character(len=len_trim(function)) :: opt_function )
    opt_function = function
  else
    allocate( character(len=0) :: opt_function )
    opt_function = ""
  endif

  call fckit__abort( c_str(opt_what), c_str(opt_file), opt_line, c_str(opt_function) )
end subroutine

!------------------------------------------------------------------------------

function what()
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module

  character(kind=c_char,len=:), allocatable :: what
    !! what for aborting

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  type(c_ptr)    :: what_c_ptr
  integer(c_size_t) :: what_size
  integer(c_int32_t) :: error_code

  error_code = fckit__exception_what(what_c_ptr,what_size)
  FCKIT_ALLOCATE_CHARACTER(what,what_size)
  what = c_ptr_to_string(what_c_ptr)
  call c_ptr_free(what_c_ptr)
end function

!------------------------------------------------------------------------------

function location_is_set() result(location)
  logical :: location
    !! True if location is present

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  if( fckit__exception_location() == 0 ) then
    location = .false.
  else
    location = .true.
  endif
end function

!------------------------------------------------------------------------------

function location_file() result(file)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module

  character(kind=c_char,len=:), allocatable :: file
    !! File where abort is called

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  type(c_ptr)    :: file_c_ptr
  integer(c_size_t) :: file_size
  integer(c_int32_t) :: error_code

  error_code = fckit__exception_file(file_c_ptr,file_size)
  FCKIT_ALLOCATE_CHARACTER(file,file_size)
  file = c_ptr_to_string(file_c_ptr)
  call c_ptr_free(file_c_ptr)
end function

!------------------------------------------------------------------------------

function location_line() result(line)
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: line
    !! Line where abort is called

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  line = fckit__exception_line()
end function

!------------------------------------------------------------------------------

function location_function() result(function)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module

  character(kind=c_char,len=:), allocatable :: function
    !! Function where abort is called

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  type(c_ptr)    :: function_c_ptr
  integer(c_size_t) :: function_size
  integer(c_int32_t) :: error_code

  error_code = fckit__exception_function(function_c_ptr,function_size)
  FCKIT_ALLOCATE_CHARACTER(function,function_size)
  function = c_ptr_to_string(function_c_ptr)
  call c_ptr_free(function_c_ptr)
end function

!------------------------------------------------------------------------------

function callstack()
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module

  character(kind=c_char,len=:), allocatable :: callstack
    !! Callstack is called

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  type(c_ptr)    :: callstack_c_ptr
  integer(c_size_t) :: callstack_size
  integer(c_int32_t) :: error_code

  error_code = fckit__exception_callstack(callstack_c_ptr,callstack_size)
  FCKIT_ALLOCATE_CHARACTER(callstack,callstack_size)
  callstack = c_ptr_to_string(callstack_c_ptr)
  call c_ptr_free(callstack_c_ptr)
end function

!------------------------------------------------------------------------------

subroutine throw( what, file, line, function )
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module, only : c_str
  character(kind=c_char,len=*) :: what
  character(kind=c_char,len=*), optional :: file
  integer(c_int32_t), optional :: line
  character(kind=c_char,len=*), optional :: function

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  character(kind=c_char,len=:), allocatable :: opt_file
  integer(c_int32_t) :: opt_line
  character(kind=c_char,len=:), allocatable :: opt_function

  if( present(file) ) then
    allocate( character(len=len_trim(file)) :: opt_file )
    opt_file = file
  else
    allocate( character(len=0) :: opt_file )
    opt_file = ""
  endif
  if( present(line) ) then
    opt_line = line
  else
    opt_line = 0
  endif
  if( present(function) ) then
    allocate( character(len=len_trim(function)) :: opt_function )
    opt_function = function
  else
    allocate( character(len=0) :: opt_function )
    opt_function = ""
  endif

  call fckit__exception_throw( c_str(what), c_str(opt_file), opt_line, c_str(opt_function) )
end subroutine

!------------------------------------------------------------------------------

end module fckit_exception_module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

! Callback function, used from C++ side
subroutine fckit_write_to_fortran_unit(unit,msg_cptr) bind(C)
  use, intrinsic :: iso_c_binding, only: c_int32_t, c_ptr, c_char, c_associated
  use fckit_c_interop_module, only : copy_c_ptr_to_string
  integer(c_int32_t), value, intent(in) :: unit
  type(c_ptr), value, intent(in) :: msg_cptr
  character(kind=c_char,len=:), allocatable :: msg
  if( c_associated(msg_cptr) ) then
    call copy_c_ptr_to_string( msg_cptr, msg )
    write(unit,'(A)') msg
  endif
end subroutine

function fckit_fortranunit_stdout() result(stdout) bind(C)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  use, intrinsic :: iso_fortran_env, only : output_unit
  integer(c_int32_t) :: stdout
  stdout = output_unit
end function

function fckit_fortranunit_stderr() result(stderr) bind(C)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  use, intrinsic :: iso_fortran_env, only : error_unit
  integer(c_int32_t) :: stderr
  stderr = error_unit
end function

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fctest.h"

! -----------------------------------------------------------------------------

TESTSUITE(fctest_fckit_configuration)

! -----------------------------------------------------------------------------

TESTSUITE_INIT
  use fckit_module
  call fckit_main%init()
END_TESTSUITE_INIT

! -----------------------------------------------------------------------------

TESTSUITE_FINALIZE
  use fckit_module
  call fckit_main%final()
END_TESTSUITE_FINALIZE

! -----------------------------------------------------------------------------

TEST( test_configuration )
#if 1
  use fckit_configuration_module
  use fckit_log_module

  type(fckit_Configuration) :: config
  type(fckit_Configuration) :: nested
  type(fckit_Configuration), allocatable :: list(:)
  logical :: found
  logical :: logval
  integer :: intval
  integer :: j

  type(fckit_Configuration) :: anested
  type(fckit_Configuration), allocatable :: alist(:)

  write(0,*) "~~~~~~~~~~~~~~ SCOPE BEGIN ~~~~~~~~~~~~~~~"

  ! --------------------- SET ------------------

  ! Corresponding YAML:
  ! {
  !   nested:
  !     list:
  !       -
  !         l1: 21
  !         l2: 22
  !       -
  !         l1: 21
  !         l2: 22
  !     n1: 11
  !     n2: 12
  !   p1: 1
  !   p2: 2
  !   logical : True
  ! }

  config = fckit_Configuration()


  call config%set("p1",1)
  call config%set("p2",2)
  call config%set("logical_true",.True.)
  call config%set("logical_false",.False.)


  nested = fckit_Configuration()
  call nested%set("n1",11)
  call nested%set("n2",12)

  allocate( list(2) )
  do j=1,2
    list(j) = fckit_Configuration()
    call list(j)%set("l1",21)
    call list(j)%set("l2",22)
  enddo
  call nested%set("list",list)

#if ! FCKIT_HAVE_FINAL || FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY
do j=1,2
  call list(j)%final()
enddo
#endif
  call config%set("nested",nested)
#if ! FCKIT_HAVE_FINAL
  call nested%final()
#endif


  ! --------------------- JSON ------------------

  call fckit_log%info("config = "//config%json())

  FCTEST_CHECK_EQUAL( config%owners(), 1 )


  ! --------------------- GET ------------------

  found = config%get("p1",intval)
  FCTEST_CHECK( found )
  FCTEST_CHECK_EQUAL( intval , 1 )

  found = config%get("logical_true",logval)
  FCTEST_CHECK( found )
  FCTEST_CHECK( logval )

  found = config%get("logical_false",logval)
  FCTEST_CHECK( found )
  FCTEST_CHECK( .not. logval )

  found = config%get("nested",anested)
  FCTEST_CHECK( found )
  found = anested%get("n1",intval)
  FCTEST_CHECK( found )
  FCTEST_CHECK_EQUAL(intval, 11)

  found = anested%get("list",alist)
  FCTEST_CHECK( found )
  FCTEST_CHECK_EQUAL( size(alist), 2 )

  found = alist(1)%get("l1",intval)
  FCTEST_CHECK( found )
  FCTEST_CHECK_EQUAL(intval, 21)
  found = alist(1)%get("l2",intval)
  FCTEST_CHECK( found )
  FCTEST_CHECK_EQUAL(intval, 22)






  found = alist(2)%get("l1",intval)
  FCTEST_CHECK( found )
  FCTEST_CHECK_EQUAL(intval, 21)
  found = alist(2)%get("l2",intval)
  FCTEST_CHECK( found )
  FCTEST_CHECK_EQUAL(intval, 22)

  write(0,*) "deallocate alist..."
#if ! FCKIT_HAVE_FINAL || FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
  write(0,*) "  + deallocate_fckit_configuration(alist)"
  call deallocate_fckit_configuration(alist)
#else
   write(0,*) "Rely on automatic deallocation"
!  write(0,*) "  + deallocate(alist)"
!  deallocate(alist)
#endif
  write(0,*) "deallocate alist... done"

  call anested%final()

  ! There is a reported PGI/16.7 bug that makes this test segfault here.
  ! PGI/17.1 has this bug fixed.

  ! ---------------------------------------------

  write(0,*) "config%owners() = ", config%owners()

#if ! FCKIT_HAVE_FINAL
  call config%final()
#endif

  write(0,*) "~~~~~~~~~~~~~~~ SCOPE END ~~~~~~~~~~~~~~~~"

#else
#warning Test "test_configuration" disabled
#endif
END_TEST

! -----------------------------------------------------------------------------

TEST(test_configuration_json_string)
#if 1
  use fckit_configuration_module
  use fckit_log_module

  type(fckit_Configuration) :: config
  type(fckit_Configuration), allocatable :: records(:)
  character (len=:), allocatable :: name
  character (len=:), allocatable :: json
  character(len=1024) :: msg
  integer :: age
  integer :: jrec

  write(0,*) "~~~~~~~~~~~~~~ SCOPE BEGIN ~~~~~~~~~~~~~~~"

  allocate( character(len=256) :: json )
  json='{"records":['//&
   &       '{"name":"Joe",   "age":30},'//&
   &       '{"name":"Alison","age":43}' //&
   &    ']}'

  config = fckit_YAMLConfiguration(json)

  call fckit_log%info(config%json())
  if( config%get("records",records) ) then
    do jrec=1,size(records)
      FCTEST_CHECK( records(jrec)%get("name",name) )
      FCTEST_CHECK( records(jrec)%get("age",age)   )
      write(msg,'(2A,I0,A)') name," is ",age," years old"; call fckit_log%info(msg)
   enddo

   write(0,*) "deallocate records..."
#if ! FCKIT_HAVE_FINAL || FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
    call deallocate_fckit_configuration(records)
#else
    write(0,*) "Rely on automatic deallocation"

    !if( allocated(records) ) deallocate(records)
#endif
    write(0,*) "deallocate records... done"
  endif
  write(0,*) "config%owners() = ", config%owners()

#if ! FCKIT_HAVE_FINAL
  call config%final()
#endif

  write(0,*) "~~~~~~~~~~~~~~~ SCOPE END ~~~~~~~~~~~~~~~~"
#else
#warning Test "test_configuration_json_string" disabled
#endif
END_TEST

TEST(test_configuration_json_file)
#if 1
  use fckit_configuration_module
  use fckit_pathname_module
  use fckit_log_module

  type(fckit_Configuration) :: config
  type(fckit_Configuration), allocatable :: records(:)
  type(fckit_Configuration) :: location
  character(len=:), allocatable :: name, company, street, city
  character(len=:), allocatable :: variables(:)
  integer :: age
  integer :: jrec
  logical :: logval
  character(len=1024) :: msg

  write(0,*) "~~~~~~~~~~~~~~ SCOPE BEGIN ~~~~~~~~~~~~~~~"


  ! Write a json file
  OPEN (UNIT=9 , FILE="fctest_configuration.json", STATUS='REPLACE')
  write(9,'(A)') '{"location":{"city":"Reading","company":"ECMWF","street":"Shinfield Road"},'//&
  &'"records":[{"age":42,"name":"Anne"},{"age":36,"name":"Bob"}],"trueval": true ,"falseval":false,'//&
  &'"variables":["u","o3","co2"]}'
  CLOSE(9)

  config = fckit_YAMLConfiguration( fckit_PathName("fctest_configuration.json") )

  call fckit_log%info("config = "//config%json(),flush=.true.)

  if( config%get("records",records) ) then
    do jrec=1,size(records)
      FCTEST_CHECK( records(jrec)%get("name",name) )
      FCTEST_CHECK( records(jrec)%get("age",age)   )
      write(msg,'(2A,I0,A)') name," is ",age," years old"; call fckit_log%info(msg)
    enddo
    write(0,*) "deallocate records..."
#if ! FCKIT_HAVE_FINAL || FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
    call deallocate_fckit_configuration(records)
#else
    write(0,*) "Rely on automatic deallocation"
    !deallocate(records)
#endif
     write(0,*) "deallocate records... done"
  endif
  if( config%get("location",location) ) then
    call fckit_log%info("location = "//location%json(),flush=.true.)

    if( location%get("company",company) ) then
      write(0,*) "company = ",company
    endif
    if( location%get("street",street) ) then
      write(0,*) "street = ",street
    endif
    if( location%get("city",city) ) then
      write(0,*) "city = ",city
    endif
#if ! FCKIT_HAVE_FINAL
    call location%final()
#endif
  endif

  if( config%get("trueval",logval) ) then
    FCTEST_CHECK( logval )
  endif

  if( config%get("falseval",logval) ) then
    FCTEST_CHECK( .not. logval )
  endif

  if( config%get("variables",variables) ) then
    write(0,*) "variables: ", variables
    if( allocated(variables) ) deallocate(variables)
  endif

  write(0,*) "config%owners() = ", config%owners()
#if ! FCKIT_HAVE_FINAL
  call config%final()
#endif
  write(0,*) "~~~~~~~~~~~~~~~ SCOPE END ~~~~~~~~~~~~~~~~"
#else
#warning Test "test_configuration_json_file" disabled
#endif
END_TEST

! -----------------------------------------------------------------------------

END_TESTSUITE

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.
#ifndef FORD
#include "fckit/fckit.h"
#endif

module fckit_module
  !! author: Willem Deconinck
  !!
  !! Interface to fckit, forwarding the most used types, variables, and functions
  !!

use fckit_main_module,      only: &
  fckit_main

use fckit_log_module,       only: &
  fckit_log, &
  log ! DEPRECATED. Use fckit_log instead

use fckit_resource_module,  only: &
  fckit_resource

use fckit_mpi_module,       only: &
  fckit_mpi_comm, &
  fckit_mpi

use fckit_exception_module, only: &
  fckit_exception, &
  fckit_exception_handler

use fckit_signal_module, only: &
  fckit_signal, &
  fckit_signal_handler

use fckit_pathname_module, only: &
  fckit_pathname

use fckit_configuration_module, only: &
  fckit_configuration, &
  fckit_YAMLConfiguration, &
  deallocate_fckit_configuration

use fckit_buffer_module, only: &
  fckit_buffer

use fckit_map_module, only: &
  fckit_map

use fckit_tensor_module, only: &
  fckit_tensor_real32, &
  fckit_tensor_real64

implicit none
private

public :: fckit_main                      !! - [[fckit_main_module:fckit_main(variable)]]
public :: fckit_log                       !! - [[fckit_log_module:fckit_log(variable)]]
public :: fckit_resource                  !! - [[fckit_resource_module:fckit_resource(interface)]]
public :: fckit_mpi_comm                  !! - [[fckit_mpi_module:fckit_mpi_comm(type)]]
public :: fckit_mpi                       !! - [[fckit_mpi_module:fckit_mpi(variable)]]
public :: fckit_exception                 !! - [[fckit_exception_module:fckit_exception(variable)]]
public :: fckit_exception_handler         !! - [[fckit_exception_module:fckit_exception_handler(interface)]]
public :: fckit_signal                    !! - [[fckit_signal_module:fckit_signal(variable)]]
public :: fckit_signal_handler            !! - [[fckit_signal_module:fckit_signal_handler(interface)]]
public :: fckit_pathname                  !! - [[fckit_pathname_module:fckit_pathname(type)]]
public :: fckit_configuration             !! - [[fckit_configuration_module:fckit_configuration(type)]]
public :: fckit_YAMLConfiguration         !! - [[fckit_configuration_module:fckit_YAMLConfiguration(interface)]]
public :: fckit_buffer                    !! - [[fckit_buffer_module:fckit_buffer(type)]]
public :: fckit_map                       !! - [[fckit_map_module:fckit_map(type)]]
public :: fckit_version                   !! - [[fckit_module:fckit_version(function)]]
public :: fckit_git_sha1                  !! - [[fckit_module:fckit_git_sha1(function)]]
public :: deallocate_fckit_configuration  !! - [[fckit_configuration_module:deallocate_fckit_configuration(subroutine)]]
public :: fckit_tensor_real32              !! - [[fckit_tensor_module:fckit_tensor_real32(type)]]
public :: fckit_tensor_real64             !! - [[fckit_tensor_module:fckit_tensor_real64(type)]]

public :: log ! DEPRECATED. Use fckit_log instead.

! =============================================================================
CONTAINS
! =============================================================================

! -----------------------------------------------------------------------------

function fckit_version()
  !! Function that returns the version of fckit

  use, intrinsic :: iso_c_binding, only : c_char
  character(kind=c_char,len=8) :: fckit_version
  fckit_version = FCKIT_VERSION
end function

! -----------------------------------------------------------------------------

function fckit_git_sha1(length) result( sha1 )
  !! Function that returns the git-sha1 of fckit, if compiled from git repository

  use, intrinsic :: iso_c_binding, only : c_char, c_int32_t
  character(kind=c_char,len=40) :: sha1
  integer(c_int32_t), optional :: length
    !! Truncate git sha1 to specified length. Default truncates to 7 chars.
  integer(c_int32_t)           :: opt_length
  opt_length = 7
  if( present(length) ) opt_length = length
  sha1 = FCKIT_GIT_SHA1
  sha1 = sha1(1:min(opt_length, 40))
end function

! -----------------------------------------------------------------------------

end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit.h"

module fckit_array_module
use, intrinsic :: iso_c_binding, only: c_int32_t, c_int64_t, c_float, c_double
implicit none
private

!========================================================================
! Public interface

public :: array_view1d
public :: array_stride
public :: array_strides

!========================================================================

private :: c_int32_t, c_int64_t, c_float, c_double

integer(c_int32_t), target :: zero_length_array_int32(0)
integer(c_int64_t),target :: zero_length_array_int64(0)
real(c_float),  target :: zero_length_array_real32(0)
real(c_double), target :: zero_length_array_real64(0)
logical, target :: zero_length_array_logical(0)

interface array_view1d
  module procedure array_view1d_int32_r0
  module procedure array_view1d_int32_r1
  module procedure array_view1d_int32_r2
  module procedure array_view1d_int32_r3
  module procedure array_view1d_int32_r4
  module procedure array_view1d_int64_r0
  module procedure array_view1d_int64_r1
  module procedure array_view1d_int64_r2
  module procedure array_view1d_int64_r3
  module procedure array_view1d_int64_r4
  module procedure array_view1d_real32_r0
  module procedure array_view1d_real32_r1
  module procedure array_view1d_real32_r2
  module procedure array_view1d_real32_r3
  module procedure array_view1d_real32_r4
  module procedure array_view1d_real64_r0
  module procedure array_view1d_real64_r1
  module procedure array_view1d_real64_r2
  module procedure array_view1d_real64_r3
  module procedure array_view1d_real64_r4
  module procedure array_view1d_logical_r0
  module procedure array_view1d_logical_r1
  module procedure array_view1d_logical_r2
  module procedure array_view1d_logical_r3
  module procedure array_view1d_logical_r4
  module procedure array_view1d_logical_r0_mold_int32
  module procedure array_view1d_logical_r1_mold_int32
  module procedure array_view1d_logical_r2_mold_int32
  module procedure array_view1d_logical_r3_mold_int32
  module procedure array_view1d_logical_r4_mold_int32
end interface

interface array_stride
  module procedure array_stride_int32_r1_dim
  module procedure array_stride_int32_r2_dim
  module procedure array_stride_int32_r3_dim
  module procedure array_stride_int32_r4_dim
  module procedure array_stride_int64_r1_dim
  module procedure array_stride_int64_r2_dim
  module procedure array_stride_int64_r3_dim
  module procedure array_stride_int64_r4_dim
  module procedure array_stride_real32_r1_dim
  module procedure array_stride_real32_r2_dim
  module procedure array_stride_real32_r3_dim
  module procedure array_stride_real32_r4_dim
  module procedure array_stride_real64_r1_dim
  module procedure array_stride_real64_r2_dim
  module procedure array_stride_real64_r3_dim
  module procedure array_stride_real64_r4_dim
  module procedure array_stride_logical_r1_dim
  module procedure array_stride_logical_r2_dim
  module procedure array_stride_logical_r3_dim
  module procedure array_stride_logical_r4_dim
end interface

interface array_strides
  module procedure array_stride_int32_r1
  module procedure array_stride_int32_r2
  module procedure array_stride_int32_r3
  module procedure array_stride_int32_r4
  module procedure array_stride_int64_r1
  module procedure array_stride_int64_r2
  module procedure array_stride_int64_r3
  module procedure array_stride_int64_r4
  module procedure array_stride_real32_r1
  module procedure array_stride_real32_r2
  module procedure array_stride_real32_r3
  module procedure array_stride_real32_r4
  module procedure array_stride_real64_r1
  module procedure array_stride_real64_r2
  module procedure array_stride_real64_r3
  module procedure array_stride_real64_r4
  module procedure array_stride_logical_r1
  module procedure array_stride_logical_r2
  module procedure array_stride_logical_r3
  module procedure array_stride_logical_r4
end interface


! =============================================================================
CONTAINS
! =============================================================================

function c_loc_int32(x)
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), target :: x
  type(c_ptr) :: c_loc_int32
  c_loc_int32 = c_loc(x)
end function

! =============================================================================

function c_loc_int64(x)
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), target :: x
  type(c_ptr) :: c_loc_int64
  c_loc_int64 = c_loc(x)
end function

! =============================================================================

function c_loc_real32(x)
  use, intrinsic :: iso_c_binding
  real(c_float), target :: x
  type(c_ptr) :: c_loc_real32
  c_loc_real32 = c_loc(x)
end function

! =============================================================================

function c_loc_real64(x)
  use, intrinsic :: iso_c_binding
  real(c_double), target :: x
  type(c_ptr) :: c_loc_real64
  c_loc_real64 = c_loc(x)
end function

! =============================================================================

function c_loc_logical(x)
  use, intrinsic :: iso_c_binding
  logical, target :: x
  type(c_ptr) :: c_loc_logical
  c_loc_logical = c_loc(x)
end function

! =============================================================================
! view interface
! =============================================================================

function array_view1d_int32_r0(scalar,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), intent(in), target :: scalar
  integer(c_int32_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  array_c_ptr = c_loc_int32(scalar)
  call c_f_pointer ( array_c_ptr , view , (/1/) )
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_int32_r1(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), intent(in), target :: array(:)
  integer(c_int32_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int32(array(1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_int32_r2(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), intent(in), target :: array(:,:)
  integer(c_int32_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int32(array(1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_int32_r3(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), intent(in), target :: array(:,:,:)
  integer(c_int32_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int32(array(1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_int32_r4(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), intent(in), target :: array(:,:,:,:)
  integer(c_int32_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int32(array(1,1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_int64_r0(scalar,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), intent(in), target :: scalar
  integer(c_int64_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int64_t), pointer :: view(:)
  nullify(view)
  array_c_ptr = c_loc_int64(scalar)
  call c_f_pointer ( array_c_ptr , view , (/1/) )
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_int64_r1(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), intent(in), target :: array(:)
  integer(c_int64_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int64_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int64(array(1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int64
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_int64_r2(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), intent(in), target :: array(:,:)
  integer(c_int64_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int64_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int64(array(1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int64
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_int64_r3(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), intent(in), target :: array(:,:,:)
  integer(c_int64_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int64_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int64(array(1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int64
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_int64_r4(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), intent(in), target :: array(:,:,:,:)
  integer(c_int64_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int64_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int64(array(1,1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int64
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_real32_r0(scalar,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_float), intent(in), target :: scalar
  real(c_float), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_float), pointer :: view(:)
  nullify(view)
  array_c_ptr = c_loc_real32(scalar)
  call c_f_pointer ( array_c_ptr , view , (/1/) )
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_real32_r1(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_float), intent(in), target :: array(:)
  real(c_float), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_float), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real32(array(1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_real32_r2(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_float), intent(in), target :: array(:,:)
  real(c_float), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_float), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real32(array(1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_real32_r3(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_float), intent(in), target :: array(:,:,:)
  real(c_float), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_float), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real32(array(1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_real32_r4(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_float), intent(in), target :: array(:,:,:,:)
  real(c_float), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_float), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real32(array(1,1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_real64_r0(scalar,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_double), intent(in), target :: scalar
  real(c_double), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_double), pointer :: view(:)
  nullify(view)
  array_c_ptr = c_loc_real64(scalar)
  call c_f_pointer ( array_c_ptr , view , (/1/) )
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_real64_r1(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_double), intent(in), target :: array(:)
  real(c_double), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_double), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real64(array(1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real64
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_real64_r2(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_double), intent(in), target :: array(:,:)
  real(c_double), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_double), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real64(array(1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real64
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_real64_r3(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_double), intent(in), target :: array(:,:,:)
  real(c_double), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_double), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real64(array(1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real64
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_real64_r4(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_double), intent(in), target :: array(:,:,:,:)
  real(c_double), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_double), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real64(array(1,1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real64
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_logical_r0(scalar) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: scalar
  type(c_ptr) :: array_c_ptr
  logical, pointer :: view(:)
  nullify(view)
  array_c_ptr = c_loc_logical(scalar)
  call c_f_pointer ( array_c_ptr , view , (/1/) )
end function

! =============================================================================

function array_view1d_logical_r1(array) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:)
  type(c_ptr) :: array_c_ptr
  logical, pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_logical
  endif
end function

! =============================================================================

function array_view1d_logical_r2(array) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:,:)
  type(c_ptr) :: array_c_ptr
  logical, pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_logical
  endif
end function

! =============================================================================

function array_view1d_logical_r3(array) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:,:,:)
  type(c_ptr) :: array_c_ptr
  logical, pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_logical
  endif
end function

! =============================================================================

function array_view1d_logical_r4(array) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:,:,:,:)
  type(c_ptr) :: array_c_ptr
  logical, pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1,1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_logical
  endif
end function

! =============================================================================

function array_view1d_logical_r0_mold_int32(scalar,mold) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in)  :: scalar
  integer(c_int32_t), intent(in) :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  array_c_ptr = c_loc_logical(scalar)
  call c_f_pointer ( array_c_ptr , view , (/1/) )
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_logical_r1_mold_int32(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:)
  integer(c_int32_t), intent(in) :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_logical_r2_mold_int32(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:,:)
  integer(c_int32_t), intent(in) :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_logical_r3_mold_int32(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:,:,:)
  integer(c_int32_t), intent(in) :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_logical_r4_mold_int32(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:,:,:,:)
  integer(c_int32_t), intent(in) :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1,1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================
! stride interface

function array_stride_int32_r1_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: arr(:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2))-loc(arr(1)),c_int32_t)/int(4,c_int32_t)
end function

! =============================================================================

function array_stride_int32_r2_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: arr(:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2,1))-loc(arr(1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,1) > 1) stride = int(loc(arr(1,2))-loc(arr(1,1)),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_int32_r3_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: arr(:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2,1,1))-loc(arr(1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = int(loc(arr(1,2,1))-loc(arr(1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = int(loc(arr(1,1,2))-loc(arr(1,1,1)),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_int32_r4_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: arr(:,:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2,1,1,1))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = int(loc(arr(1,2,1,1))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = int(loc(arr(1,1,2,1))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 4 .AND. ubound(arr,4) > 1) stride = int(loc(arr(1,1,1,2))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_int64_r1_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t) :: arr(:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2))-loc(arr(1)),c_int32_t)/int(4,c_int32_t)
end function

! =============================================================================

function array_stride_int64_r2_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t) :: arr(:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2,1))-loc(arr(1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,1) > 1) stride = int(loc(arr(1,2))-loc(arr(1,1)),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_int64_r3_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t) :: arr(:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2,1,1))-loc(arr(1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = int(loc(arr(1,2,1))-loc(arr(1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = int(loc(arr(1,1,2))-loc(arr(1,1,1)),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_int64_r4_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t) :: arr(:,:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2,1,1,1))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = int(loc(arr(1,2,1,1))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = int(loc(arr(1,1,2,1))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 4 .AND. ubound(arr,4) > 1) stride = int(loc(arr(1,1,1,2))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real32_r1_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  real(c_float) :: arr(:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2))-loc(arr(1)),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real32_r2_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  real(c_float) :: arr(:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2,1))-loc(arr(1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = int(loc(arr(1,2))-loc(arr(1,1)),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real32_r3_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  real(c_float) :: arr(:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2,1,1))-loc(arr(1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = int(loc(arr(1,2,1))-loc(arr(1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = int(loc(arr(1,1,2))-loc(arr(1,1,1)),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real32_r4_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  real(c_float) :: arr(:,:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2,1,1,1))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = int(loc(arr(1,2,1,1))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = int(loc(arr(1,1,2,1))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 4 .AND. ubound(arr,4) > 1) stride = int(loc(arr(1,1,1,2))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real64_r1_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  real(c_double) :: arr(:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2))-loc(arr(1)),c_int32_t)/int(8,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real64_r2_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  real(c_double) :: arr(:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr)>0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2,1))-loc(arr(1,1)),c_int32_t)/int(8,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = int(loc(arr(1,2))-loc(arr(1,1)),c_int32_t)/int(8,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real64_r3_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  real(c_double) :: arr(:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr)>0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2,1,1))-loc(arr(1,1,1)),c_int32_t)/int(8,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = int(loc(arr(1,2,1))-loc(arr(1,1,1)),c_int32_t)/int(8,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = int(loc(arr(1,1,2))-loc(arr(1,1,1)),c_int32_t)/int(8,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real64_r4_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  real(c_double) :: arr(:,:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr)>0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2,1,1,1))-loc(arr(1,1,1,1)),c_int32_t)/int(8,c_int32_t)
    if (dim == 2) stride = int(loc(arr(1,2,1,1))-loc(arr(1,1,1,1)),c_int32_t)/int(8,c_int32_t)
    if (dim == 3) stride = int(loc(arr(1,1,2,1))-loc(arr(1,1,1,1)),c_int32_t)/int(8,c_int32_t)
    if (dim == 4) stride = int(loc(arr(1,1,1,2))-loc(arr(1,1,1,1)),c_int32_t)/int(8,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_logical_r1_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  logical :: arr(:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2))-loc(arr(1)),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_logical_r2_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  logical :: arr(:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr)>0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2,1))-loc(arr(1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = int(loc(arr(1,2))-loc(arr(1,1)),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_logical_r3_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  logical :: arr(:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr)>0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2,1,1))-loc(arr(1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = int(loc(arr(1,2,1))-loc(arr(1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = int(loc(arr(1,1,2))-loc(arr(1,1,1)),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_logical_r4_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  logical :: arr(:,:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr)>0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = int(loc(arr(2,1,1,1))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 2) stride = int(loc(arr(1,2,1,1))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 3) stride = int(loc(arr(1,1,2,1))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
    if (dim == 4) stride = int(loc(arr(1,1,1,2))-loc(arr(1,1,1,1)),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================
! stride interface

function array_stride_int32_r1(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: arr(:)
  integer(c_int32_t) :: stride_(1)
  stride_(1) = array_stride_int32_r1_dim(arr,1)
end function

! =============================================================================

function array_stride_int32_r2(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: arr(:,:)
  integer(c_int32_t) :: stride_(2)
  stride_(1) = array_stride_int32_r2_dim(arr,1)
  stride_(2) = array_stride_int32_r2_dim(arr,2)
end function

! =============================================================================

function array_stride_int32_r3(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: arr(:,:,:)
  integer(c_int32_t) :: stride_(3)
  stride_(1) = array_stride_int32_r3_dim(arr,1)
  stride_(2) = array_stride_int32_r3_dim(arr,2)
  stride_(3) = array_stride_int32_r3_dim(arr,3)
end function

! =============================================================================

function array_stride_int32_r4(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: arr(:,:,:,:)
  integer(c_int32_t) :: stride_(4)
  stride_(1) = array_stride_int32_r4_dim(arr,1)
  stride_(2) = array_stride_int32_r4_dim(arr,2)
  stride_(3) = array_stride_int32_r4_dim(arr,3)
  stride_(4) = array_stride_int32_r4_dim(arr,4)
end function

! =============================================================================

function array_stride_int64_r1(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t) :: arr(:)
  integer(c_int32_t) :: stride_(1)
  stride_(1) = array_stride_int64_r1_dim(arr,1)
end function

! =============================================================================

function array_stride_int64_r2(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t) :: arr(:,:)
  integer(c_int32_t) :: stride_(2)
  stride_(1) = array_stride_int64_r2_dim(arr,1)
  stride_(2) = array_stride_int64_r2_dim(arr,2)
end function

! =============================================================================

function array_stride_int64_r3(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t) :: arr(:,:,:)
  integer(c_int32_t) :: stride_(3)
  stride_(1) = array_stride_int64_r3_dim(arr,1)
  stride_(2) = array_stride_int64_r3_dim(arr,2)
  stride_(3) = array_stride_int64_r3_dim(arr,3)
end function

! =============================================================================

function array_stride_int64_r4(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t) :: arr(:,:,:,:)
  integer(c_int32_t) :: stride_(4)
  stride_(1) = array_stride_int64_r4_dim(arr,1)
  stride_(2) = array_stride_int64_r4_dim(arr,2)
  stride_(3) = array_stride_int64_r4_dim(arr,3)
  stride_(4) = array_stride_int64_r4_dim(arr,4)
end function

! =============================================================================

function array_stride_real32_r1(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_float) :: arr(:)
  integer(c_int32_t) :: stride_(1)
  stride_(1) = array_stride_real32_r1_dim(arr,1)
end function

! =============================================================================

function array_stride_real32_r2(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_float) :: arr(:,:)
  integer(c_int32_t) :: stride_(2)
  stride_(1) = array_stride_real32_r2_dim(arr,1)
  stride_(2) = array_stride_real32_r2_dim(arr,2)
end function

! =============================================================================

function array_stride_real32_r3(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_float) :: arr(:,:,:)
  integer(c_int32_t) :: stride_(3)
  stride_(1) = array_stride_real32_r3_dim(arr,1)
  stride_(2) = array_stride_real32_r3_dim(arr,2)
  stride_(3) = array_stride_real32_r3_dim(arr,3)
end function

! =============================================================================

function array_stride_real32_r4(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_float) :: arr(:,:,:,:)
  integer(c_int32_t) :: stride_(4)
  stride_(1) = array_stride_real32_r4_dim(arr,1)
  stride_(2) = array_stride_real32_r4_dim(arr,2)
  stride_(3) = array_stride_real32_r4_dim(arr,3)
  stride_(4) = array_stride_real32_r4_dim(arr,4)
end function

! =============================================================================

function array_stride_real64_r1(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_double) :: arr(:)
  integer(c_int32_t) :: stride_(1)
  stride_(1) = array_stride_real64_r1_dim(arr,1)
end function

! =============================================================================

function array_stride_real64_r2(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_double) :: arr(:,:)
  integer(c_int32_t) :: stride_(2)
  stride_(1) = array_stride_real64_r2_dim(arr,1)
  stride_(2) = array_stride_real64_r2_dim(arr,2)
end function

! =============================================================================

function array_stride_real64_r3(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_double) :: arr(:,:,:)
  integer(c_int32_t) :: stride_(3)
  stride_(1) = array_stride_real64_r3_dim(arr,1)
  stride_(2) = array_stride_real64_r3_dim(arr,2)
  stride_(3) = array_stride_real64_r3_dim(arr,3)
end function

! =============================================================================

function array_stride_real64_r4(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_double) :: arr(:,:,:,:)
  integer(c_int32_t) :: stride_(4)
  stride_(1) = array_stride_real64_r4_dim(arr,1)
  stride_(2) = array_stride_real64_r4_dim(arr,2)
  stride_(3) = array_stride_real64_r4_dim(arr,3)
  stride_(4) = array_stride_real64_r4_dim(arr,4)
end function

! =============================================================================

function array_stride_logical_r1(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  logical :: arr(:)
  integer(c_int32_t) :: stride_(1)
  stride_(1) = array_stride_logical_r1_dim(arr,1)
end function

! =============================================================================

function array_stride_logical_r2(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  logical :: arr(:,:)
  integer(c_int32_t) :: stride_(2)
  stride_(1) = array_stride_logical_r2_dim(arr,1)
  stride_(2) = array_stride_logical_r2_dim(arr,2)
end function

! =============================================================================

function array_stride_logical_r3(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  logical :: arr(:,:,:)
  integer(c_int32_t) :: stride_(3)
  stride_(1) = array_stride_logical_r3_dim(arr,1)
  stride_(2) = array_stride_logical_r3_dim(arr,2)
  stride_(3) = array_stride_logical_r3_dim(arr,3)
end function

! =============================================================================

function array_stride_logical_r4(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  logical :: arr(:,:,:,:)
  integer(c_int32_t) :: stride_(4)
  stride_(1) = array_stride_logical_r4_dim(arr,1)
  stride_(2) = array_stride_logical_r4_dim(arr,2)
  stride_(3) = array_stride_logical_r4_dim(arr,3)
  stride_(4) = array_stride_logical_r4_dim(arr,4)
end function

! =============================================================================

end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fctest.h"

! -----------------------------------------------------------------------------

TESTSUITE(fctest_fckit_configuration)

! -----------------------------------------------------------------------------

TESTSUITE_INIT
  use fckit_module
  call fckit_main%init()
END_TESTSUITE_INIT

! -----------------------------------------------------------------------------

TESTSUITE_FINALIZE
  use fckit_module
  call fckit_main%final()
END_TESTSUITE_FINALIZE

! -----------------------------------------------------------------------------

TEST( test_configuration )
#if 1
  use fckit_configuration_module
  use fckit_log_module

  type(fckit_Configuration) :: config
  type(fckit_Configuration) :: nested
  type(fckit_Configuration), allocatable :: list(:)
  logical :: found
  logical :: logval
  integer :: intval
  integer :: j

  type(fckit_Configuration) :: anested
  type(fckit_Configuration), allocatable :: alist(:)

  write(0,*) "~~~~~~~~~~~~~~ SCOPE BEGIN ~~~~~~~~~~~~~~~"

  ! --------------------- SET ------------------

  ! Corresponding YAML:
  ! {
  !   nested:
  !     list:
  !       -
  !         l1: 21
  !         l2: 22
  !       -
  !         l1: 21
  !         l2: 22
  !     n1: 11
  !     n2: 12
  !   p1: 1
  !   p2: 2
  !   logical : True
  ! }

  config = fckit_Configuration()


  call config%set("p1",1)
  call config%set("p2",2)
  call config%set("logical_true",.True.)
  call config%set("logical_false",.False.)


  nested = fckit_Configuration()
  call nested%set("n1",11)
  call nested%set("n2",12)

  allocate( list(2) )
  do j=1,2
    list(j) = fckit_Configuration()
    call list(j)%set("l1",21)
    call list(j)%set("l2",22)
  enddo
  call nested%set("list",list)

#if ! FCKIT_HAVE_FINAL || FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY
do j=1,2
  call list(j)%final()
enddo
#endif
  call config%set("nested",nested)
#if ! FCKIT_HAVE_FINAL
  call nested%final()
#endif


  ! --------------------- JSON ------------------

  call fckit_log%info("config = "//config%json())

  FCTEST_CHECK_EQUAL( config%owners(), 1 )


  ! --------------------- GET ------------------

  FCTEST_CHECK_EQUAL( config%size(), 5 )
  FCTEST_CHECK_EQUAL( config%key(1), "p1" )
  FCTEST_CHECK_EQUAL( config%key(2), "p2" )
  FCTEST_CHECK_EQUAL( config%key(3), "logical_true" )
  FCTEST_CHECK_EQUAL( config%key(4), "logical_false" )
  FCTEST_CHECK_EQUAL( config%key(5), "nested" )

  found = config%get("p1",intval)
  FCTEST_CHECK( found )
  FCTEST_CHECK_EQUAL( intval , 1 )

  found = config%get("logical_true",logval)
  FCTEST_CHECK( found )
  FCTEST_CHECK( logval )

  found = config%get("logical_false",logval)
  FCTEST_CHECK( found )
  FCTEST_CHECK( .not. logval )

  found = config%get("nested",anested)
  FCTEST_CHECK( found )
  found = anested%get("n1",intval)
  FCTEST_CHECK( found )
  FCTEST_CHECK_EQUAL(intval, 11)

  found = anested%get("list",alist)
  FCTEST_CHECK( found )
  FCTEST_CHECK_EQUAL( size(alist), 2 )

  found = alist(1)%get("l1",intval)
  FCTEST_CHECK( found )
  FCTEST_CHECK_EQUAL(intval, 21)
  found = alist(1)%get("l2",intval)
  FCTEST_CHECK( found )
  FCTEST_CHECK_EQUAL(intval, 22)






  found = alist(2)%get("l1",intval)
  FCTEST_CHECK( found )
  FCTEST_CHECK_EQUAL(intval, 21)
  found = alist(2)%get("l2",intval)
  FCTEST_CHECK( found )
  FCTEST_CHECK_EQUAL(intval, 22)

  write(0,*) "deallocate alist..."
#if ! FCKIT_HAVE_FINAL || FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
  write(0,*) "  + deallocate_fckit_configuration(alist)"
  call deallocate_fckit_configuration(alist)
#else
   write(0,*) "Rely on automatic deallocation"
!  write(0,*) "  + deallocate(alist)"
!  deallocate(alist)
#endif
  write(0,*) "deallocate alist... done"

  call anested%final()

  ! There is a reported PGI/16.7 bug that makes this test segfault here.
  ! PGI/17.1 has this bug fixed.

  ! ---------------------------------------------

  write(0,*) "config%owners() = ", config%owners()

#if ! FCKIT_HAVE_FINAL
  call config%final()
#endif

  write(0,*) "~~~~~~~~~~~~~~~ SCOPE END ~~~~~~~~~~~~~~~~"

#else
#warning Test "test_configuration" disabled
#endif
END_TEST

! -----------------------------------------------------------------------------

TEST(test_configuration_json_string)
#if 1
  use fckit_configuration_module
  use fckit_log_module

  type(fckit_Configuration) :: config
  type(fckit_Configuration), allocatable :: records(:)
  character (len=:), allocatable :: name
  character (len=:), allocatable :: json
  character(len=1024) :: msg
  integer :: age
  integer :: jrec

  write(0,*) "~~~~~~~~~~~~~~ SCOPE BEGIN ~~~~~~~~~~~~~~~"

  allocate( character(len=256) :: json )
  json='{"records":['//&
   &       '{"name":"Joe",   "age":30},'//&
   &       '{"name":"Alison","age":43}' //&
   &    ']}'

  config = fckit_YAMLConfiguration(json)

  call fckit_log%info(config%json())
  if( config%get("records",records) ) then
    do jrec=1,size(records)
      FCTEST_CHECK( records(jrec)%get("name",name) )
      FCTEST_CHECK( records(jrec)%get("age",age)   )
      write(msg,'(2A,I0,A)') name," is ",age," years old"; call fckit_log%info(msg)
   enddo

   write(0,*) "deallocate records..."
#if ! FCKIT_HAVE_FINAL || FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
    call deallocate_fckit_configuration(records)
#else
    write(0,*) "Rely on automatic deallocation"

    !if( allocated(records) ) deallocate(records)
#endif
    write(0,*) "deallocate records... done"
  endif
  write(0,*) "config%owners() = ", config%owners()

#if ! FCKIT_HAVE_FINAL
  call config%final()
#endif

  write(0,*) "~~~~~~~~~~~~~~~ SCOPE END ~~~~~~~~~~~~~~~~"
#else
#warning Test "test_configuration_json_string" disabled
#endif
END_TEST

TEST(test_configuration_json_file)
#if 1
  use fckit_configuration_module
  use fckit_pathname_module
  use fckit_log_module

  type(fckit_Configuration) :: config
  type(fckit_Configuration), allocatable :: records(:)
  type(fckit_Configuration) :: location
  character(len=:), allocatable :: name, company, street, city
  character(len=:), allocatable :: variables(:)
  integer :: age
  integer :: jrec
  logical :: logval
  character(len=1024) :: msg

  write(0,*) "~~~~~~~~~~~~~~ SCOPE BEGIN ~~~~~~~~~~~~~~~"


  ! Write a json file
  OPEN (UNIT=9 , FILE="fctest_configuration.json", STATUS='REPLACE')
  write(9,'(A)') '{"location":{"city":"Reading","company":"ECMWF","street":"Shinfield Road"},'//&
  &'"records":[{"age":42,"name":"Anne"},{"age":36,"name":"Bob"}],"trueval": true ,"falseval":false,'//&
  &'"variables":["u","o3","co2"]}'
  CLOSE(9)

  config = fckit_YAMLConfiguration( fckit_PathName("fctest_configuration.json") )

  call fckit_log%info("config = "//config%json(),flush=.true.)

  if( config%get("records",records) ) then
    do jrec=1,size(records)
      FCTEST_CHECK( records(jrec)%get("name",name) )
      FCTEST_CHECK( records(jrec)%get("age",age)   )
      write(msg,'(2A,I0,A)') name," is ",age," years old"; call fckit_log%info(msg)
    enddo
    write(0,*) "deallocate records..."
#if ! FCKIT_HAVE_FINAL || FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
    call deallocate_fckit_configuration(records)
#else
    write(0,*) "Rely on automatic deallocation"
    !deallocate(records)
#endif
     write(0,*) "deallocate records... done"
  endif
  if( config%get("location",location) ) then
    call fckit_log%info("location = "//location%json(),flush=.true.)

    if( location%get("company",company) ) then
      write(0,*) "company = ",company
    endif
    if( location%get("street",street) ) then
      write(0,*) "street = ",street
    endif
    if( location%get("city",city) ) then
      write(0,*) "city = ",city
    endif
#if ! FCKIT_HAVE_FINAL
    call location%final()
#endif
  endif

  if( config%get("trueval",logval) ) then
    FCTEST_CHECK( logval )
  endif

  if( config%get("falseval",logval) ) then
    FCTEST_CHECK( .not. logval )
  endif

  if( config%get("variables",variables) ) then
    write(0,*) "variables: ", variables
    if( allocated(variables) ) deallocate(variables)
  endif

  write(0,*) "config%owners() = ", config%owners()
#if ! FCKIT_HAVE_FINAL
  call config%final()
#endif
  write(0,*) "~~~~~~~~~~~~~~~ SCOPE END ~~~~~~~~~~~~~~~~"
#else
#warning Test "test_configuration_json_file" disabled
#endif
END_TEST

! -----------------------------------------------------------------------------

END_TESTSUITE

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_final_module

implicit none
private

!========================================================================
! Public interface

public fckit_final

!========================================================================

type, abstract :: fckit_final
contains
  procedure(final_interface), deferred, public :: final
    !! Finalise object
end type

! =============================================================================
CONTAINS
! =============================================================================

subroutine final_interface(this)
  class(fckit_final), intent(inout) :: this
  FCKIT_SUPPRESS_UNUSED(this)
end subroutine

end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit.h"

module fckit_array_module
use, intrinsic :: iso_c_binding, only: c_int32_t, c_int64_t, c_float, c_double
implicit none
private

!========================================================================
! Public interface

public :: array_view1d
public :: array_stride
public :: array_strides

!========================================================================

private :: c_int32_t, c_int64_t, c_float, c_double

integer(c_int32_t), target :: zero_length_array_int32(0)
integer(c_int64_t),target :: zero_length_array_int64(0)
real(c_float),  target :: zero_length_array_real32(0)
real(c_double), target :: zero_length_array_real64(0)
logical, target :: zero_length_array_logical(0)

interface array_view1d
  module procedure array_view1d_int32_r0
  module procedure array_view1d_int32_r1
  module procedure array_view1d_int32_r2
  module procedure array_view1d_int32_r3
  module procedure array_view1d_int32_r4
  module procedure array_view1d_int64_r0
  module procedure array_view1d_int64_r1
  module procedure array_view1d_int64_r2
  module procedure array_view1d_int64_r3
  module procedure array_view1d_int64_r4
  module procedure array_view1d_real32_r0
  module procedure array_view1d_real32_r1
  module procedure array_view1d_real32_r2
  module procedure array_view1d_real32_r3
  module procedure array_view1d_real32_r4
  module procedure array_view1d_real64_r0
  module procedure array_view1d_real64_r1
  module procedure array_view1d_real64_r2
  module procedure array_view1d_real64_r3
  module procedure array_view1d_real64_r4
  module procedure array_view1d_logical_r0
  module procedure array_view1d_logical_r1
  module procedure array_view1d_logical_r2
  module procedure array_view1d_logical_r3
  module procedure array_view1d_logical_r4
  module procedure array_view1d_logical_r0_mold_int32
  module procedure array_view1d_logical_r1_mold_int32
  module procedure array_view1d_logical_r2_mold_int32
  module procedure array_view1d_logical_r3_mold_int32
  module procedure array_view1d_logical_r4_mold_int32
end interface

interface array_stride
  module procedure array_stride_int32_r1_dim
  module procedure array_stride_int32_r2_dim
  module procedure array_stride_int32_r3_dim
  module procedure array_stride_int32_r4_dim
  module procedure array_stride_int64_r1_dim
  module procedure array_stride_int64_r2_dim
  module procedure array_stride_int64_r3_dim
  module procedure array_stride_int64_r4_dim
  module procedure array_stride_real32_r1_dim
  module procedure array_stride_real32_r2_dim
  module procedure array_stride_real32_r3_dim
  module procedure array_stride_real32_r4_dim
  module procedure array_stride_real64_r1_dim
  module procedure array_stride_real64_r2_dim
  module procedure array_stride_real64_r3_dim
  module procedure array_stride_real64_r4_dim
  module procedure array_stride_logical_r1_dim
  module procedure array_stride_logical_r2_dim
  module procedure array_stride_logical_r3_dim
  module procedure array_stride_logical_r4_dim
end interface

interface array_strides
  module procedure array_stride_int32_r1
  module procedure array_stride_int32_r2
  module procedure array_stride_int32_r3
  module procedure array_stride_int32_r4
  module procedure array_stride_int64_r1
  module procedure array_stride_int64_r2
  module procedure array_stride_int64_r3
  module procedure array_stride_int64_r4
  module procedure array_stride_real32_r1
  module procedure array_stride_real32_r2
  module procedure array_stride_real32_r3
  module procedure array_stride_real32_r4
  module procedure array_stride_real64_r1
  module procedure array_stride_real64_r2
  module procedure array_stride_real64_r3
  module procedure array_stride_real64_r4
  module procedure array_stride_logical_r1
  module procedure array_stride_logical_r2
  module procedure array_stride_logical_r3
  module procedure array_stride_logical_r4
end interface


! =============================================================================
CONTAINS
! =============================================================================

function c_loc_int32(x)
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), target :: x
  type(c_ptr) :: c_loc_int32
  c_loc_int32 = c_loc(x)
end function

! =============================================================================

function c_loc_int64(x)
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), target :: x
  type(c_ptr) :: c_loc_int64
  c_loc_int64 = c_loc(x)
end function

! =============================================================================

function c_loc_real32(x)
  use, intrinsic :: iso_c_binding
  real(c_float), target :: x
  type(c_ptr) :: c_loc_real32
  c_loc_real32 = c_loc(x)
end function

! =============================================================================

function c_loc_real64(x)
  use, intrinsic :: iso_c_binding
  real(c_double), target :: x
  type(c_ptr) :: c_loc_real64
  c_loc_real64 = c_loc(x)
end function

! =============================================================================

function c_loc_logical(x)
  use, intrinsic :: iso_c_binding
  logical, target :: x
  type(c_ptr) :: c_loc_logical
  c_loc_logical = c_loc(x)
end function

! =============================================================================
! view interface
! =============================================================================

function array_view1d_int32_r0(scalar,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), intent(in), target :: scalar
  integer(c_int32_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  array_c_ptr = c_loc_int32(scalar)
  call c_f_pointer ( array_c_ptr , view , (/1/) )
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_int32_r1(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), intent(in), target :: array(:)
  integer(c_int32_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int32(array(1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_int32_r2(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), intent(in), target :: array(:,:)
  integer(c_int32_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int32(array(1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_int32_r3(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), intent(in), target :: array(:,:,:)
  integer(c_int32_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int32(array(1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_int32_r4(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), intent(in), target :: array(:,:,:,:)
  integer(c_int32_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int32(array(1,1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_int64_r0(scalar,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), intent(in), target :: scalar
  integer(c_int64_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int64_t), pointer :: view(:)
  nullify(view)
  array_c_ptr = c_loc_int64(scalar)
  call c_f_pointer ( array_c_ptr , view , (/1/) )
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_int64_r1(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), intent(in), target :: array(:)
  integer(c_int64_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int64_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int64(array(1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int64
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_int64_r2(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), intent(in), target :: array(:,:)
  integer(c_int64_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int64_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int64(array(1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int64
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_int64_r3(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), intent(in), target :: array(:,:,:)
  integer(c_int64_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int64_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int64(array(1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int64
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_int64_r4(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), intent(in), target :: array(:,:,:,:)
  integer(c_int64_t), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int64_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_int64(array(1,1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int64
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_real32_r0(scalar,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_float), intent(in), target :: scalar
  real(c_float), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_float), pointer :: view(:)
  nullify(view)
  array_c_ptr = c_loc_real32(scalar)
  call c_f_pointer ( array_c_ptr , view , (/1/) )
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_real32_r1(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_float), intent(in), target :: array(:)
  real(c_float), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_float), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real32(array(1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real32
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_real32_r2(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_float), intent(in), target :: array(:,:)
  real(c_float), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_float), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real32(array(1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real32
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_real32_r3(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_float), intent(in), target :: array(:,:,:)
  real(c_float), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_float), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real32(array(1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real32
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_real32_r4(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_float), intent(in), target :: array(:,:,:,:)
  real(c_float), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_float), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real32(array(1,1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real32
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_real64_r0(scalar,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_double), intent(in), target :: scalar
  real(c_double), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_double), pointer :: view(:)
  nullify(view)
  array_c_ptr = c_loc_real64(scalar)
  call c_f_pointer ( array_c_ptr , view , (/1/) )
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_real64_r1(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_double), intent(in), target :: array(:)
  real(c_double), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_double), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real64(array(1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real64
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_real64_r2(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_double), intent(in), target :: array(:,:)
  real(c_double), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_double), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real64(array(1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real64
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_real64_r3(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_double), intent(in), target :: array(:,:,:)
  real(c_double), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_double), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real64(array(1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real64
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_real64_r4(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  real(c_double), intent(in), target :: array(:,:,:,:)
  real(c_double), intent(in), optional :: mold
  type(c_ptr) :: array_c_ptr
  real(c_double), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_real64(array(1,1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_real64
  endif
  if (present(mold)) then
    FCKIT_SUPPRESS_UNUSED(mold)
  endif
end function

! =============================================================================

function array_view1d_logical_r0(scalar) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: scalar
  type(c_ptr) :: array_c_ptr
  logical, pointer :: view(:)
  nullify(view)
  array_c_ptr = c_loc_logical(scalar)
  call c_f_pointer ( array_c_ptr , view , (/1/) )
end function

! =============================================================================

function array_view1d_logical_r1(array) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:)
  type(c_ptr) :: array_c_ptr
  logical, pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_logical
  endif
end function

! =============================================================================

function array_view1d_logical_r2(array) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:,:)
  type(c_ptr) :: array_c_ptr
  logical, pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_logical
  endif
end function

! =============================================================================

function array_view1d_logical_r3(array) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:,:,:)
  type(c_ptr) :: array_c_ptr
  logical, pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_logical
  endif
end function

! =============================================================================

function array_view1d_logical_r4(array) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:,:,:,:)
  type(c_ptr) :: array_c_ptr
  logical, pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1,1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_logical
  endif
end function

! =============================================================================

function array_view1d_logical_r0_mold_int32(scalar,mold) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in)  :: scalar
  integer(c_int32_t), intent(in) :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  array_c_ptr = c_loc_logical(scalar)
  call c_f_pointer ( array_c_ptr , view , (/1/) )
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_logical_r1_mold_int32(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:)
  integer(c_int32_t), intent(in) :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_logical_r2_mold_int32(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:,:)
  integer(c_int32_t), intent(in) :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_logical_r3_mold_int32(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:,:,:)
  integer(c_int32_t), intent(in) :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================

function array_view1d_logical_r4_mold_int32(array,mold) result( view )
  use, intrinsic :: iso_c_binding
  logical, intent(in), target :: array(:,:,:,:)
  integer(c_int32_t), intent(in) :: mold
  type(c_ptr) :: array_c_ptr
  integer(c_int32_t), pointer :: view(:)
  nullify(view)
  if( size(array) > 0 ) then
    array_c_ptr = c_loc_logical(array(1,1,1,1))
    call c_f_pointer ( array_c_ptr , view , (/size(array)/) )
  else
    view => zero_length_array_int32
  endif
  FCKIT_SUPPRESS_UNUSED(mold)
end function

! =============================================================================
! stride interface

function array_stride_int32_r1_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  integer(c_int32_t), target :: arr(:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
    int(c_ptr_to_loc(c_loc(arr(2)))-c_ptr_to_loc(c_loc(arr(1))),c_int32_t)/int(4,c_int32_t)
end function

! =============================================================================

function array_stride_int32_r2_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  integer(c_int32_t), target :: arr(:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2,1)))-c_ptr_to_loc(c_loc(arr(1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,2)))-c_ptr_to_loc(c_loc(arr(1,1))),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_int32_r3_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  integer(c_int32_t), target :: arr(:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2,1,1)))-c_ptr_to_loc(c_loc(arr(1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,2,1)))-c_ptr_to_loc(c_loc(arr(1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,1,2)))-c_ptr_to_loc(c_loc(arr(1,1,1))),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_int32_r4_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  integer(c_int32_t), target :: arr(:,:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2,1,1,1)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,2,1,1)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,1,2,1)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 4 .AND. ubound(arr,4) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,1,1,2)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_int64_r1_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  integer(c_int64_t), target :: arr(:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
    int(c_ptr_to_loc(c_loc(arr(2)))-c_ptr_to_loc(c_loc(arr(1))),c_int32_t)/int(4,c_int32_t)
end function

! =============================================================================

function array_stride_int64_r2_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  integer(c_int64_t),target :: arr(:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2,1)))-c_ptr_to_loc(c_loc(arr(1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,2)))-c_ptr_to_loc(c_loc(arr(1,1))),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_int64_r3_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  integer(c_int64_t),target :: arr(:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2,1,1)))-c_ptr_to_loc(c_loc(arr(1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,2,1)))-c_ptr_to_loc(c_loc(arr(1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,1,2)))-c_ptr_to_loc(c_loc(arr(1,1,1))),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_int64_r4_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  integer(c_int64_t),target :: arr(:,:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2,1,1,1)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,2,1,1)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,1,2,1)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 4 .AND. ubound(arr,4) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,1,1,2)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real32_r1_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  real(c_float),target :: arr(:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2)))-c_ptr_to_loc(c_loc(arr(1))),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real32_r2_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  real(c_float),target :: arr(:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2,1)))-c_ptr_to_loc(c_loc(arr(1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,2)))-c_ptr_to_loc(c_loc(arr(1,1))),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real32_r3_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  real(c_float),target :: arr(:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2,1,1)))-c_ptr_to_loc(c_loc(arr(1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,2,1)))-c_ptr_to_loc(c_loc(arr(1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,1,2)))-c_ptr_to_loc(c_loc(arr(1,1,1))),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real32_r4_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  real(c_float),target :: arr(:,:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2,1,1,1)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,2,1,1)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,1,2,1)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 4 .AND. ubound(arr,4) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,1,1,2)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real64_r1_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  real(c_double),target :: arr(:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2)))-c_ptr_to_loc(c_loc(arr(1))),c_int32_t)/int(8,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real64_r2_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  real(c_double),target :: arr(:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr)>0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2,1)))-c_ptr_to_loc(c_loc(arr(1,1))),c_int32_t)/int(8,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,2)))-c_ptr_to_loc(c_loc(arr(1,1))),c_int32_t)/int(8,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real64_r3_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  real(c_double),target :: arr(:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr)>0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2,1,1)))-c_ptr_to_loc(c_loc(arr(1,1,1))),c_int32_t)/int(8,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,2,1)))-c_ptr_to_loc(c_loc(arr(1,1,1))),c_int32_t)/int(8,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,1,2)))-c_ptr_to_loc(c_loc(arr(1,1,1))),c_int32_t)/int(8,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_real64_r4_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  real(c_double),target :: arr(:,:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr)>0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2,1,1,1)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(8,c_int32_t)
    if (dim == 2) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,2,1,1)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(8,c_int32_t)
    if (dim == 3) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,1,2,1)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(8,c_int32_t)
    if (dim == 4) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,1,1,2)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(8,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_logical_r1_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  logical,target :: arr(:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr) > 0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2)))-c_ptr_to_loc(c_loc(arr(1))),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_logical_r2_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  logical,target :: arr(:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr)>0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2,1)))-c_ptr_to_loc(c_loc(arr(1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,2)))-c_ptr_to_loc(c_loc(arr(1,1))),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_logical_r3_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  logical,target :: arr(:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr)>0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2,1,1)))-c_ptr_to_loc(c_loc(arr(1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 2 .AND. ubound(arr,2) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,2,1)))-c_ptr_to_loc(c_loc(arr(1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 3 .AND. ubound(arr,3) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,1,2)))-c_ptr_to_loc(c_loc(arr(1,1,1))),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================

function array_stride_logical_r4_dim(arr,dim) result( stride )
  use, intrinsic :: iso_c_binding
  use :: fckit_c_interop_module
  logical,target :: arr(:,:,:,:)
  integer(c_int32_t) :: dim
  integer(c_int32_t) :: stride
  stride = 1
  if( size(arr)>0 ) then
    if (dim == 1 .AND. ubound(arr,1) > 1) stride = &
      int(c_ptr_to_loc(c_loc(arr(2,1,1,1)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 2) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,2,1,1)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 3) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,1,2,1)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
    if (dim == 4) stride = &
      int(c_ptr_to_loc(c_loc(arr(1,1,1,2)))-c_ptr_to_loc(c_loc(arr(1,1,1,1))),c_int32_t)/int(4,c_int32_t)
  else
    stride = 0
  endif
end function

! =============================================================================
! stride interface

function array_stride_int32_r1(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: arr(:)
  integer(c_int32_t) :: stride_(1)
  stride_(1) = array_stride_int32_r1_dim(arr,1)
end function

! =============================================================================

function array_stride_int32_r2(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: arr(:,:)
  integer(c_int32_t) :: stride_(2)
  stride_(1) = array_stride_int32_r2_dim(arr,1)
  stride_(2) = array_stride_int32_r2_dim(arr,2)
end function

! =============================================================================

function array_stride_int32_r3(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: arr(:,:,:)
  integer(c_int32_t) :: stride_(3)
  stride_(1) = array_stride_int32_r3_dim(arr,1)
  stride_(2) = array_stride_int32_r3_dim(arr,2)
  stride_(3) = array_stride_int32_r3_dim(arr,3)
end function

! =============================================================================

function array_stride_int32_r4(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: arr(:,:,:,:)
  integer(c_int32_t) :: stride_(4)
  stride_(1) = array_stride_int32_r4_dim(arr,1)
  stride_(2) = array_stride_int32_r4_dim(arr,2)
  stride_(3) = array_stride_int32_r4_dim(arr,3)
  stride_(4) = array_stride_int32_r4_dim(arr,4)
end function

! =============================================================================

function array_stride_int64_r1(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t) :: arr(:)
  integer(c_int32_t) :: stride_(1)
  stride_(1) = array_stride_int64_r1_dim(arr,1)
end function

! =============================================================================

function array_stride_int64_r2(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t) :: arr(:,:)
  integer(c_int32_t) :: stride_(2)
  stride_(1) = array_stride_int64_r2_dim(arr,1)
  stride_(2) = array_stride_int64_r2_dim(arr,2)
end function

! =============================================================================

function array_stride_int64_r3(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t) :: arr(:,:,:)
  integer(c_int32_t) :: stride_(3)
  stride_(1) = array_stride_int64_r3_dim(arr,1)
  stride_(2) = array_stride_int64_r3_dim(arr,2)
  stride_(3) = array_stride_int64_r3_dim(arr,3)
end function

! =============================================================================

function array_stride_int64_r4(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  integer(c_int64_t) :: arr(:,:,:,:)
  integer(c_int32_t) :: stride_(4)
  stride_(1) = array_stride_int64_r4_dim(arr,1)
  stride_(2) = array_stride_int64_r4_dim(arr,2)
  stride_(3) = array_stride_int64_r4_dim(arr,3)
  stride_(4) = array_stride_int64_r4_dim(arr,4)
end function

! =============================================================================

function array_stride_real32_r1(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_float) :: arr(:)
  integer(c_int32_t) :: stride_(1)
  stride_(1) = array_stride_real32_r1_dim(arr,1)
end function

! =============================================================================

function array_stride_real32_r2(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_float) :: arr(:,:)
  integer(c_int32_t) :: stride_(2)
  stride_(1) = array_stride_real32_r2_dim(arr,1)
  stride_(2) = array_stride_real32_r2_dim(arr,2)
end function

! =============================================================================

function array_stride_real32_r3(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_float) :: arr(:,:,:)
  integer(c_int32_t) :: stride_(3)
  stride_(1) = array_stride_real32_r3_dim(arr,1)
  stride_(2) = array_stride_real32_r3_dim(arr,2)
  stride_(3) = array_stride_real32_r3_dim(arr,3)
end function

! =============================================================================

function array_stride_real32_r4(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_float) :: arr(:,:,:,:)
  integer(c_int32_t) :: stride_(4)
  stride_(1) = array_stride_real32_r4_dim(arr,1)
  stride_(2) = array_stride_real32_r4_dim(arr,2)
  stride_(3) = array_stride_real32_r4_dim(arr,3)
  stride_(4) = array_stride_real32_r4_dim(arr,4)
end function

! =============================================================================

function array_stride_real64_r1(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_double) :: arr(:)
  integer(c_int32_t) :: stride_(1)
  stride_(1) = array_stride_real64_r1_dim(arr,1)
end function

! =============================================================================

function array_stride_real64_r2(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_double) :: arr(:,:)
  integer(c_int32_t) :: stride_(2)
  stride_(1) = array_stride_real64_r2_dim(arr,1)
  stride_(2) = array_stride_real64_r2_dim(arr,2)
end function

! =============================================================================

function array_stride_real64_r3(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_double) :: arr(:,:,:)
  integer(c_int32_t) :: stride_(3)
  stride_(1) = array_stride_real64_r3_dim(arr,1)
  stride_(2) = array_stride_real64_r3_dim(arr,2)
  stride_(3) = array_stride_real64_r3_dim(arr,3)
end function

! =============================================================================

function array_stride_real64_r4(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  real(c_double) :: arr(:,:,:,:)
  integer(c_int32_t) :: stride_(4)
  stride_(1) = array_stride_real64_r4_dim(arr,1)
  stride_(2) = array_stride_real64_r4_dim(arr,2)
  stride_(3) = array_stride_real64_r4_dim(arr,3)
  stride_(4) = array_stride_real64_r4_dim(arr,4)
end function

! =============================================================================

function array_stride_logical_r1(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  logical :: arr(:)
  integer(c_int32_t) :: stride_(1)
  stride_(1) = array_stride_logical_r1_dim(arr,1)
end function

! =============================================================================

function array_stride_logical_r2(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  logical :: arr(:,:)
  integer(c_int32_t) :: stride_(2)
  stride_(1) = array_stride_logical_r2_dim(arr,1)
  stride_(2) = array_stride_logical_r2_dim(arr,2)
end function

! =============================================================================

function array_stride_logical_r3(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  logical :: arr(:,:,:)
  integer(c_int32_t) :: stride_(3)
  stride_(1) = array_stride_logical_r3_dim(arr,1)
  stride_(2) = array_stride_logical_r3_dim(arr,2)
  stride_(3) = array_stride_logical_r3_dim(arr,3)
end function

! =============================================================================

function array_stride_logical_r4(arr) result( stride_ )
  use, intrinsic :: iso_c_binding
  logical :: arr(:,:,:,:)
  integer(c_int32_t) :: stride_(4)
  stride_(1) = array_stride_logical_r4_dim(arr,1)
  stride_(2) = array_stride_logical_r4_dim(arr,2)
  stride_(3) = array_stride_logical_r4_dim(arr,3)
  stride_(4) = array_stride_logical_r4_dim(arr,4)
end function

! =============================================================================

end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.
#ifndef FORD
#include "fckit/fckit.h"
#endif

module fckit_module
  !! author: Willem Deconinck
  !!
  !! Interface to fckit, forwarding the most used types, variables, and functions
  !!

use fckit_main_module,      only: &
  fckit_main

use fckit_log_module,       only: &
  fckit_log, &
  log ! DEPRECATED. Use fckit_log instead

use fckit_resource_module,  only: &
  fckit_resource

use fckit_mpi_module,       only: &
  fckit_mpi_comm, &
  fckit_mpi

use fckit_exception_module, only: &
  fckit_exception, &
  fckit_exception_handler

use fckit_signal_module, only: &
  fckit_signal, &
  fckit_signal_handler

use fckit_pathname_module, only: &
  fckit_pathname

use fckit_configuration_module, only: &
  fckit_configuration, &
  fckit_YAMLConfiguration, &
  deallocate_fckit_configuration

use fckit_buffer_module, only: &
  fckit_buffer

use fckit_map_module, only: &
  fckit_map

#if FCKIT_HAVE_ECKIT_TENSOR
use fckit_tensor_module, only: &
  fckit_tensor_real32, &
  fckit_tensor_real64
#endif

implicit none
private

public :: fckit_main                      !! - [[fckit_main_module:fckit_main(variable)]]
public :: fckit_log                       !! - [[fckit_log_module:fckit_log(variable)]]
public :: fckit_resource                  !! - [[fckit_resource_module:fckit_resource(interface)]]
public :: fckit_mpi_comm                  !! - [[fckit_mpi_module:fckit_mpi_comm(type)]]
public :: fckit_mpi                       !! - [[fckit_mpi_module:fckit_mpi(variable)]]
public :: fckit_exception                 !! - [[fckit_exception_module:fckit_exception(variable)]]
public :: fckit_exception_handler         !! - [[fckit_exception_module:fckit_exception_handler(interface)]]
public :: fckit_signal                    !! - [[fckit_signal_module:fckit_signal(variable)]]
public :: fckit_signal_handler            !! - [[fckit_signal_module:fckit_signal_handler(interface)]]
public :: fckit_pathname                  !! - [[fckit_pathname_module:fckit_pathname(type)]]
public :: fckit_configuration             !! - [[fckit_configuration_module:fckit_configuration(type)]]
public :: fckit_YAMLConfiguration         !! - [[fckit_configuration_module:fckit_YAMLConfiguration(interface)]]
public :: fckit_buffer                    !! - [[fckit_buffer_module:fckit_buffer(type)]]
public :: fckit_map                       !! - [[fckit_map_module:fckit_map(type)]]
public :: fckit_version                   !! - [[fckit_module:fckit_version(function)]]
public :: fckit_git_sha1                  !! - [[fckit_module:fckit_git_sha1(function)]]
public :: deallocate_fckit_configuration  !! - [[fckit_configuration_module:deallocate_fckit_configuration(subroutine)]]
#if FCKIT_HAVE_ECKIT_TENSOR
public :: fckit_tensor_real32             !! - [[fckit_tensor_module:fckit_tensor_real32(type)]]
public :: fckit_tensor_real64             !! - [[fckit_tensor_module:fckit_tensor_real64(type)]]
#endif

public :: log ! DEPRECATED. Use fckit_log instead.

! =============================================================================
CONTAINS
! =============================================================================

! -----------------------------------------------------------------------------

function fckit_version()
  !! Function that returns the version of fckit

  use, intrinsic :: iso_c_binding, only : c_char
  character(kind=c_char,len=8) :: fckit_version
  fckit_version = FCKIT_VERSION
end function

! -----------------------------------------------------------------------------

function fckit_git_sha1(length) result( sha1 )
  !! Function that returns the git-sha1 of fckit, if compiled from git repository

  use, intrinsic :: iso_c_binding, only : c_char, c_int32_t
  character(kind=c_char,len=40) :: sha1
  integer(c_int32_t), optional :: length
    !! Truncate git sha1 to specified length. Default truncates to 7 chars.
  integer(c_int32_t)           :: opt_length
  opt_length = 7
  if( present(length) ) opt_length = length
  sha1 = FCKIT_GIT_SHA1
  sha1 = sha1(1:min(opt_length, 40))
end function

! -----------------------------------------------------------------------------

end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

module fctest
  use, intrinsic :: iso_c_binding, only: c_float, c_double, c_int32_t, c_int64_t, c_char, c_int
  implicit none
  integer(c_int32_t), parameter :: sp=c_float
  integer(c_int32_t), parameter :: dp=c_double
public
  character(len=1024) :: source_file
  integer(c_int32_t) :: exit_status
  interface FCE
    module procedure fctest_check_equal_int32
    module procedure fctest_check_equal_int64_int32
    module procedure fctest_check_equal_int32_int64
    module procedure fctest_check_equal_int64
    module procedure fctest_check_equal_real32
    module procedure fctest_check_equal_real64
    module procedure fctest_check_equal_string
    module procedure fctest_check_equal_int32_r1
    module procedure fctest_check_equal_int64_r1
    module procedure fctest_check_equal_real32_r1
    module procedure fctest_check_equal_real64_r1
    module procedure fctest_check_equal_logical
  end interface FCE
  interface FCC
    module procedure fctest_check_close_real32
    module procedure fctest_check_close_real64
    module procedure fctest_check_close_real32_r1
    module procedure fctest_check_close_real64_r1
  end interface FCC
  interface ERR
    module procedure fctest_error
  end interface ERR

! TODO: These should be private
! private :: c_float, c_double, c_int32_t, c_int64_t, c_char

contains

function sweep_leading_blanks(in_str)
  character(kind=c_char,len=*), intent(in)  :: in_str
  character(kind=c_char,len=512) :: sweep_leading_blanks
  character(kind=c_char) :: ch
  integer(c_int32_t) :: j
  do j=1, len_trim(in_str)
    ! get j-th char
    ch = in_str(j:j)
    if (ch .ne. " ") then
      sweep_leading_blanks = trim(in_str(j:len_trim(in_str)))
      return
    endif
  end do
end function sweep_leading_blanks

subroutine fctest_error(line)
  integer(c_int32_t), intent(in) :: line
  write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
  exit_status=1
end subroutine

subroutine fctest_check_equal_int32(V1,V2,line)
  integer(c_int32_t), intent(in) :: V1, V2
  integer(c_int32_t), intent(in) :: line
  if(V1/=V2) then
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    write(0,*) "--> [",V1,"!=",V2,"]"
    exit_status=1
  endif
end subroutine

subroutine fctest_check_equal_int64(V1,V2,line)
  integer(c_int64_t), intent(in) :: V1, V2
  integer(c_int32_t), intent(in) :: line
  if(V1/=V2) then
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    write(0,*) "--> [",V1,"!=",V2,"]"
    exit_status=1
  endif
end subroutine

subroutine fctest_check_equal_int64_int32(V1,V2,line)
  integer(c_int64_t), intent(in) :: V1
  integer(c_int32_t), intent(in) :: V2
  integer(c_int32_t), intent(in) :: line
  if(V1/=V2) then
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    write(0,*) "--> [",V1,"!=",V2,"]"
    exit_status=1
  endif
end subroutine

subroutine fctest_check_equal_int32_int64(V1,V2,line)
  integer(c_int32_t), intent(in) :: V1
  integer(c_int64_t), intent(in) :: V2
  integer(c_int32_t), intent(in) :: line
  if(V1/=V2) then
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    write(0,*) "--> [",V1,"!=",V2,"]"
    exit_status=1
  endif
end subroutine

subroutine fctest_check_equal_real32(V1,V2,line)
  real(kind=c_float), intent(in) :: V1, V2
  integer(c_int32_t), intent(in) :: line
  if(V1/=V2) then
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    write(0,*) "--> [",V1,"!=",V2,"]"
    exit_status=1
  endif
end subroutine

subroutine fctest_check_equal_real64(V1,V2,line)
  real(kind=c_double), intent(in) :: V1, V2
  integer(c_int32_t), intent(in) :: line
  if(V1/=V2) then
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    write(0,*) "--> [",V1,"!=",V2,"]"
    exit_status=1
  endif
end subroutine

subroutine fctest_check_equal_logical(V1,V2,line)
  logical, intent(in) :: V1, V2
  integer(c_int32_t), intent(in) :: line
  if(V1.neqv.V2) then
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    write(0,*) "--> [",V1,"!=",V2,"]"
    exit_status=1
  endif
end subroutine

subroutine fctest_check_equal_string(V1,V2,line)
  character(kind=c_char,len=*), intent(in) :: V1, V2
  integer(c_int32_t), intent(in) :: line
  if(V1/=V2) then
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    write(0,*) "--> [",V1,"!=",V2,"]"
    exit_status=1
  endif
end subroutine

subroutine fctest_check_equal_int32_r1(V1,V2,line)
  integer(c_int32_t), intent(in) :: V1(:), V2(:)
  integer(c_int32_t), intent(in) :: line
  logical :: compare = .True.
  integer(c_int32_t) :: j
  if( size(V1) /= size(V2) ) compare = .False.
  if( compare .eqv. .True. ) then
    do j=1,size(V1)
      if( V1(j)/=V2(j) ) compare = .False.
    enddo
  endif
  if( compare .eqv. .False. ) then
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    if( size(V1) <= 30 ) then
      write(0,*) "-->  [ ",V1," ] != [ ",V2," ] "
    endif
    exit_status=1
  endif
end subroutine

subroutine fctest_check_equal_int64_r1(V1,V2,line)
  integer(c_int64_t), intent(in) :: V1(:), V2(:)
  integer(c_int32_t), intent(in) :: line
  logical :: compare = .True.
  integer(c_int32_t) :: j
  if( size(V1) /= size(V2) ) compare = .False.
  if( compare .eqv. .True. ) then
    do j=1,size(V1)
      if( V1(j)/=V2(j) ) compare = .False.
    enddo
  endif
  if( compare .eqv. .False. ) then
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    if( size(V1) <= 30 ) then
      write(0,*) "--> [ ",V1," ] != [ ",V2," ]"
    endif
    exit_status=1
  endif
end subroutine

subroutine fctest_check_equal_real32_r1(V1,V2,line)
  real(kind=c_float), intent(in) :: V1(:), V2(:)
  integer(c_int32_t), intent(in) :: line
  logical :: compare
  integer(c_int32_t) :: j
  compare = .True.
  if( size(V1) /= size(V2) ) compare = .False.
  if( compare .eqv. .True. ) then
    do j=1,size(V1)
      if( V1(j)/=V2(j) ) compare = .False.
    enddo
  endif
  if( compare .eqv. .False. ) then
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    if( size(V1) <= 30 ) then
      write(0,*) "--> [ ",V1," ] != [ ",V2," ]"
    endif
    exit_status=1
  endif
end subroutine

subroutine fctest_check_equal_real64_r1(V1,V2,line)
  real(kind=c_double), intent(in) :: V1(:), V2(:)
  integer(c_int32_t), intent(in) :: line
  logical :: compare
  integer(c_int32_t) :: j
  compare = .True.
  if( size(V1) /= size(V2) ) compare = .False.
  if( compare .eqv. .True. ) then
    do j=1,size(V1)
      if( V1(j)/=V2(j) ) compare = .False.
    enddo
  endif
  if( compare .eqv. .False. ) then
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    if( size(V1) <= 30 ) then
      write(0,*) "--> [ ",V1," ] != [ ",V2," ]"
    endif
    exit_status=1
  endif
end subroutine

subroutine fctest_check_close_real32(V1,V2,TOL,line)
  real(kind=c_float), intent(in) :: V1, V2, TOL
  integer(c_int32_t), intent(in) :: line
  if(.not.(abs(V1-V2)<=TOL)) then;
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    write(0,*) "--> [",V1,"!=",V2,"]"
    exit_status=1
  endif
end subroutine

subroutine fctest_check_close_real64(V1,V2,TOL,line)
  real(kind=c_double), intent(in) :: V1, V2, TOL
  integer(c_int32_t), intent(in) :: line
  if(.not.(abs(V1-V2)<=TOL)) then;
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    write(0,*) "--> [",V1,"!=",V2,"]"
    exit_status=1
  endif
end subroutine

subroutine fctest_check_close_real32_r1(V1,V2,TOL,line)
  real(kind=c_float), intent(in) :: V1(:), V2(:)
  real(kind=c_float), intent(in) :: TOL
  integer(c_int32_t), intent(in) :: line
  logical :: compare
  integer(c_int32_t) :: j
  compare = .True.
  if( size(V1) /= size(V2) ) compare = .False.
  if( compare .eqv. .True. ) then
    do j=1,size(V1)
      if(.not.(abs(V1(j)-V2(j))<=TOL)) compare = .False.
    enddo
  endif
  if( compare .eqv. .False. ) then
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    if( size(V1) <= 30 ) then
      write(0,*) "--> [ ",V1," ] != [ ",V2," ]"
    endif
    exit_status=1
  endif
end subroutine

subroutine fctest_check_close_real64_r1(V1,V2,TOL,line)
  real(kind=c_double), intent(in) :: V1(:), V2(:)
  real(kind=c_double), intent(in) :: TOL
  integer(c_int32_t), intent(in) :: line
  logical :: compare
  integer(c_int32_t) :: j
  compare = .True.
  if( size(V1) /= size(V2) ) compare = .False.
  if( compare .eqv. .True. ) then
    do j=1,size(V1)
      if(.not.(abs(V1(j)-V2(j))<=TOL)) compare = .False.
    enddo
  endif
  if( compare .eqv. .False. ) then
    write(0,'(2A,I0,2A)') trim(source_file),":",line,": warning: ",trim(sweep_leading_blanks(get_source_line(line)))
    if( size(V1) <= 30 ) then
      write(0,*) "--> [ ",V1," ] != [ ",V2," ]"
    endif
    exit_status=1
  endif
end subroutine

function get_source_line(line_number) result(source_line)
  integer(c_int32_t), intent(in)  :: line_number
  ! Variables
  integer(c_int32_t) stat, jline
  character(kind=c_char,len=512) :: source_line

  ! open input file
  open (10, file=source_file, status='old', iostat=stat)
  if (stat .ne. 0)then
    source_line = 'source_file '//trim(source_file)//' can not be opened'
    close(10)
    return
  end if

  ! process file
  do jline=1,line_number
    read (10, '(A)', end=99) source_line ! read line from input file
  enddo
  close(10)

  ! close files
  99 continue
  close (10)
end function get_source_line

end module fctest

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_shared_object_module
use fckit_object_module, only : fckit_object
use fckit_c_interop_module, only : fckit_c_deleter, fckit_c_nodeleter
#if FCKIT_HAVE_ECKIT
use fckit_shared_ptr_module, only : fckit_shared_ptr, fckit_refcount_interface, &
 & fckit_owned
#else
use fckit_shared_ptr_module, only : fckit_shared_ptr, fckit_refcount_interface
#endif

implicit none
private

!========================================================================
! Public interface

public :: fckit_shared_object
public :: fckit_c_deleter
public :: fckit_c_nodeleter
#if FCKIT_HAVE_ECKIT
public :: fckit_owned
#endif
!========================================================================

type, extends(fckit_shared_ptr) :: fckit_shared_object
  class(fckit_object), pointer, public  :: shared_object_ => null()
contains

  procedure, public :: shared_ptr_cast

  procedure, public :: reset_c_ptr

#if !PGIBUG_ATLAS_197_DEBUG
  procedure, public  :: c_ptr => fckit_shared_object_c_ptr
#endif

  procedure, private :: fckit_shared_object_c_ptr

  procedure, public :: is_null

! WARNING: Not strictly necessary, as base class (fckit_shared_ptr) has the
!          destructor defined.
!     - PGI-17.7 needs this, as it does not call the base class destructor (COMPILER BUG!)
!                from derived types
!     - Cray-8.5.6 needs this as well as it otherwise does not call constructor from
!                  from function returns
#if FCKIT_FINAL_NOT_INHERITING
  final :: fckit_shared_object__final_auto
#endif

  procedure, public :: fckit_shared_object__reset_c_ptr => reset_c_ptr
  procedure, public :: fckit_shared_object__shared_ptr_cast => shared_ptr_cast

end type

!========================================================================

private :: fckit_object
private :: fckit_shared_ptr
private :: fckit_refcount_interface

!========================================================================
CONTAINS
!========================================================================

#if FCKIT_FINAL_NOT_INHERITING
FCKIT_FINAL subroutine fckit_shared_object__final_auto(this)
  type(fckit_shared_object), intent(inout) :: this
#if FCKIT_FINAL_DEBUGGING
  write(0,*) "fckit_shared_object__final_auto"
#endif
#if FCKIT_FINAL_NOT_PROPAGATING
  call this%final()
#endif
  FCKIT_SUPPRESS_UNUSED( this )
end subroutine
#endif

function shared_ptr_cast(this) result(success)
  class(fckit_shared_object) :: this
  logical :: success
  class(*), pointer :: shared_object
  success = .false.
  nullify( this%shared_object_ )
  shared_object => this%shared_ptr()
  select type( shared_object )
    class is( fckit_object )
      this%shared_object_ => shared_object
      success = .true.
      return
  end select
end function

subroutine reset_c_ptr(this, cptr, deleter, refcount )
  use, intrinsic :: iso_c_binding, only : c_ptr, c_funptr
  implicit none
  class(fckit_shared_object) :: this
  type(c_ptr), optional :: cptr
  type(c_funptr), optional :: deleter
  type(c_funptr), optional :: refcount
  allocate( fckit_object::this%shared_object_ )
  if( present( cptr ) ) then
    if( present( deleter) ) then
      call this%shared_object_%reset_c_ptr( cptr, deleter )
    else
      call this%shared_object_%reset_c_ptr( cptr )
    endif
  else
    call this%shared_object_%reset_c_ptr()
  endif
  if( present(refcount) ) then
    call this%share( this%shared_object_, refcount )
  else
    call this%share( this%shared_object_ )
  endif
end subroutine

function is_null(this)
  logical :: is_null
  class(fckit_shared_object) :: this
  if( .not. associated(this%shared_object_) ) then
    is_null = .true.
  else
    is_null = this%shared_object_%is_null()
  endif
end function

function fckit_shared_object_c_ptr(this) result(cptr)
  use, intrinsic :: iso_c_binding, only : c_ptr
  type(c_ptr) :: cptr
  class(fckit_shared_object) :: this
  cptr = this%shared_object_%CPTR_PGIBUG_A
end function

end module

#include "fckit/fckit.h"

module fckit_map_module

use, intrinsic :: iso_c_binding, only : c_ptr, &
                                        c_int, &
                                        c_int32_t, &
                                        c_int64_t, &
                                        c_float, &
                                        c_double, &
                                        c_null_char

use fckit_array_module, only: array_view1d
use fckit_shared_object_module, only : fckit_shared_object, fckit_c_deleter

implicit none

public :: fckit_map


private


#include "fckit_map.inc"

type, extends(fckit_shared_object) :: fckit_map

contains

  procedure :: has
  procedure :: size => map_size
  
  ! setters
  procedure :: insert_int32
  procedure :: insert_int64
  procedure :: insert_real32
  procedure :: insert_real64
  procedure :: insert_c_ptr

  generic   :: insert => insert_int32, &
                         insert_int64, & 
                         insert_real32, &
                         insert_real64, &
                         insert_c_ptr

  ! getters
  procedure :: get_int32
  procedure :: get_int64
  procedure :: get_real32
  procedure :: get_real64
  procedure :: get_c_ptr
  
  procedure, private :: get_int32_sub
  procedure, private :: get_int64_sub
  procedure, private :: get_real32_sub
  procedure, private :: get_real64_sub
  procedure, private :: get_c_ptr_sub
  procedure, private :: get_shared_sub

  generic, public :: get => get_int32_sub, &
                            get_int64_sub, &
                            get_real32_sub, &
                            get_real64_sub, &
                            get_c_ptr_sub, &
                            get_shared_sub

#if FCKIT_FINAL_NOT_INHERITING
    final :: fckit_map__final_auto
#endif

end type


! ------ interfaces

interface fckit_map
  module procedure ctor
end interface


interface insert
  module procedure insert_int32
  module procedure insert_int64
  module procedure insert_real32
  module procedure insert_real64
  module procedure insert_c_ptr
end interface

interface get
  module procedure get_int32_sub
  module procedure get_int64_sub
  module procedure get_real32_sub
  module procedure get_real64_sub
  module procedure get_c_ptr_sub
  module procedure get_shared_sub
end interface


! ------ end interfaces 

private :: c_ptr, c_int, c_int32_t, c_int64_t, c_float, c_double, c_null_char
private :: fckit_shared_object
private :: fckit_c_deleter

contains


! ctor's
function ctor() result(this)
    type(fckit_map) :: this
    call this%reset_c_ptr( c_fckit_map_new(), &
      & fckit_c_deleter(c_fckit_map_delete) )
    call this%return()
end function


#if FCKIT_FINAL_NOT_INHERITING
FCKIT_FINAL subroutine fckit_map__final_auto(this)
  type(fckit_map), intent(inout) :: this
#if FCKIT_FINAL_DEBUGGING
  write(0,*) "fckit_map__final_auto"
#endif
#if FCKIT_FINAL_NOT_PROPAGATING
  call this%final()
#endif
  FCKIT_SUPPRESS_UNUSED( this )
end subroutine
#endif


! ============ insert

! ---- insert int
subroutine insert_int32(this, name, value)
  class(fckit_map), intent(inout) :: this  
  character(len=*), intent(in) :: name
  integer(c_int) :: value
  call c_fckit_map_insert_int32(this%c_ptr(), name//c_null_char, value)
end subroutine


! ---- insert int
subroutine insert_int64(this, name, value)
  class(fckit_map), intent(inout) :: this  
  character(len=*), intent(in) :: name
  integer(c_int64_t) :: value
  call c_fckit_map_insert_int64(this%c_ptr(), name//c_null_char, value)
end subroutine


! ---- insert float
subroutine insert_real32(this, name, value)
  class(fckit_map), intent(inout) :: this  
  character(len=*), intent(in) :: name
  real(c_float) :: value
  call c_fckit_map_insert_real32(this%c_ptr(), name//c_null_char, value)
end subroutine


! ---- insert double
subroutine insert_real64(this, name, value)
  class(fckit_map), intent(inout) :: this  
  character(len=*), intent(in) :: name
  real(c_double) :: value
  call c_fckit_map_insert_real64(this%c_ptr(), name//c_null_char, value)
end subroutine


! ---- insert c_ptr
subroutine insert_c_ptr(this, name, value)
  class(fckit_map), intent(inout) :: this  
  character(len=*), intent(in) :: name
  type(c_ptr) :: value
  call c_fckit_map_insert_c_ptr(this%c_ptr(), name//c_null_char, value)
end subroutine


! ============ getters


function get_int32(this, name)
  class(fckit_map), intent(in) :: this
  character(len=*), intent(in) :: name
  integer(c_int) :: get_int32
  call c_fckit_map_get_int32(this%c_ptr(), name//c_null_char, get_int32)
end function


function get_int64(this, name)
  class(fckit_map), intent(in) :: this
  character(len=*), intent(in) :: name
  integer(c_int64_t) :: get_int64
  call c_fckit_map_get_int64(this%c_ptr(), name//c_null_char, get_int64)
end function


function get_real32(this, name)
  class(fckit_map), intent(in) :: this
  character(len=*), intent(in) :: name
  real(c_float) :: get_real32
  call c_fckit_map_get_real32(this%c_ptr(), name//c_null_char, get_real32)
end function


function get_real64(this, name)
  class(fckit_map), intent(in) :: this
  character(len=*), intent(in) :: name
  real(c_double) :: get_real64
  call c_fckit_map_get_real64(this%c_ptr(), name//c_null_char, get_real64)
end function


function get_c_ptr(this, name)
  class(fckit_map), intent(in) :: this
  character(len=*), intent(in) :: name
  type(c_ptr) :: get_c_ptr
  call c_fckit_map_get_c_ptr(this%c_ptr(), name//c_null_char, get_c_ptr)
end function

! ---

subroutine get_int32_sub(this, name, value)
  class(fckit_map), intent(in) :: this
  character(len=*), intent(in) :: name
  integer(c_int32_t), intent(inout) :: value
  call c_fckit_map_get_int32(this%c_ptr(), name//c_null_char, value)
end subroutine

subroutine get_int64_sub(this, name, value)
  class(fckit_map), intent(in) :: this
  character(len=*), intent(in) :: name
  integer(c_int64_t), intent(inout) :: value
  call c_fckit_map_get_int64(this%c_ptr(), name//c_null_char, value)
end subroutine

subroutine get_real32_sub(this, name, value)
  class(fckit_map), intent(in) :: this
  character(len=*), intent(in) :: name
  real(c_float), intent(inout) :: value
  call c_fckit_map_get_real32(this%c_ptr(), name//c_null_char, value)
end subroutine

subroutine get_real64_sub(this, name, value)
  class(fckit_map), intent(in) :: this
  character(len=*), intent(in) :: name
  real(c_double), intent(inout) :: value
  call c_fckit_map_get_real64(this%c_ptr(), name//c_null_char, value)
end subroutine

subroutine get_c_ptr_sub(this, name, value)
  class(fckit_map), intent(in) :: this
  character(len=*), intent(in) :: name
  type(c_ptr) :: value
  call c_fckit_map_get_c_ptr(this%c_ptr(), name//c_null_char, value)
end subroutine

subroutine get_shared_sub(this, name, value)
  class(fckit_map), intent(in) :: this
  character(len=*), intent(in) :: name
  class(fckit_shared_object), intent(inout) :: value
  type(c_ptr) :: shared_cptr
  call c_fckit_map_get_c_ptr(this%c_ptr(), name//c_null_char, shared_cptr)
  call value%reset_c_ptr(shared_cptr)
end subroutine

! =========== other

function has(this, name)
  class(fckit_map), intent(inout) :: this
  character(len=*), intent(in) :: name
  logical :: has
  has = c_fckit_map_has(this%c_ptr(), name//c_null_char)
end function


function map_size(this)
  class(fckit_map), intent(inout) :: this
  integer :: map_size
  map_size = c_fckit_map_size(this%c_ptr() )
end function


end module fckit_map_module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_shared_object_module
use fckit_object_module, only : fckit_object
use fckit_c_interop_module, only : fckit_c_deleter, fckit_c_nodeleter
#if FCKIT_HAVE_ECKIT
use fckit_shared_ptr_module, only : fckit_shared_ptr, fckit_refcount_interface, &
 & fckit_owned
#else
use fckit_shared_ptr_module, only : fckit_shared_ptr, fckit_refcount_interface
#endif

implicit none
private

!========================================================================
! Public interface

public :: fckit_shared_object
public :: fckit_c_deleter
public :: fckit_c_nodeleter
#if FCKIT_HAVE_ECKIT
public :: fckit_owned
#endif
!========================================================================

type, extends(fckit_shared_ptr) :: fckit_shared_object
#ifdef _CRAYFTN
  ! Cray compiler cce/14 has problem with typebound procedure if it is using 'class'
  type(fckit_object), pointer, public  :: shared_object_ => null()
#else
  class(fckit_object), pointer, public  :: shared_object_ => null()
#endif

contains

  procedure, public :: shared_ptr_cast

  procedure, public :: reset_c_ptr

#if !PGIBUG_ATLAS_197_DEBUG
  procedure, public  :: c_ptr => fckit_shared_object_c_ptr
#endif

  procedure, private :: fckit_shared_object_c_ptr

  procedure, public :: is_null

! WARNING: Not strictly necessary, as base class (fckit_shared_ptr) has the
!          destructor defined.
!     - PGI-17.7 needs this, as it does not call the base class destructor (COMPILER BUG!)
!                from derived types
!     - Cray-8.5.6 needs this as well as it otherwise does not call constructor from
!                  from function returns
#if FCKIT_FINAL_NOT_INHERITING
  final :: fckit_shared_object__final_auto
#endif

  procedure, public :: fckit_shared_object__reset_c_ptr => reset_c_ptr
  procedure, public :: fckit_shared_object__shared_ptr_cast => shared_ptr_cast

end type

!========================================================================

private :: fckit_object
private :: fckit_shared_ptr
private :: fckit_refcount_interface

!========================================================================
CONTAINS
!========================================================================

#if FCKIT_FINAL_NOT_INHERITING
FCKIT_FINAL subroutine fckit_shared_object__final_auto(this)
  type(fckit_shared_object), intent(inout) :: this
#if FCKIT_FINAL_DEBUGGING
  write(0,*) "fckit_shared_object__final_auto"
#endif
#if FCKIT_FINAL_NOT_PROPAGATING
  call this%final()
#endif
  FCKIT_SUPPRESS_UNUSED( this )
end subroutine
#endif

function shared_ptr_cast(this) result(success)
  class(fckit_shared_object) :: this
  logical :: success
  class(*), pointer :: shared_object
  success = .false.
  nullify( this%shared_object_ )
  shared_object => this%shared_ptr()
  select type( shared_object )
    class is( fckit_object )
      this%shared_object_ => shared_object
      success = .true.
      return
  end select
end function

subroutine reset_c_ptr(this, cptr, deleter, refcount )
  use, intrinsic :: iso_c_binding, only : c_ptr, c_funptr
  implicit none
  class(fckit_shared_object) :: this
  type(c_ptr), optional :: cptr
  type(c_funptr), optional :: deleter
  type(c_funptr), optional :: refcount
  allocate( fckit_object::this%shared_object_ )
  if( present( cptr ) ) then
    if( present( deleter) ) then
      call this%shared_object_%reset_c_ptr( cptr, deleter )
    else
      call this%shared_object_%reset_c_ptr( cptr )
    endif
  else
    call this%shared_object_%reset_c_ptr()
  endif
  if( present(refcount) ) then
    call this%share( this%shared_object_, refcount )
  else
    call this%share( this%shared_object_ )
  endif
end subroutine

function is_null(this)
  logical :: is_null
  class(fckit_shared_object) :: this
  if( .not. associated(this%shared_object_) ) then
    is_null = .true.
  else
    is_null = this%shared_object_%is_null()
  endif
end function

function fckit_shared_object_c_ptr(this) result(cptr)
  use, intrinsic :: iso_c_binding, only : c_ptr
  type(c_ptr) :: cptr
  class(fckit_shared_object) :: this
  cptr = this%shared_object_%CPTR_PGIBUG_A
end function

end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

module fckit_signal_module
  !! author: Willem Deconinck
  !!
  !! Module providing [[fckit_signal_module:fckit_signal(variable)]] global variable

implicit none
private

#include "fckit_signal.inc"

public :: fckit_signal
public :: fckit_signal_handler


type, FORD_PRIVATE :: fckit_signal_type
  !! Private type of [[fckit_signal_module:fckit_signal(variable)]] module variable
  !! exposing signal codes

contains
  procedure, nopass, public :: raise
    !! Raise a signal with given signal code
    !!
    !!####Example usage:
    !!
    !!```fortran
    !! call fckit_signal%raise(fckit_signal%SIGABRT())
    !!```

  procedure, nopass, public :: set_handler
    !! Set custom signal handler
    !!
    !!####Example usage
    !!
    !!```fortran
    !! subroutine custom_signal_handler( signum ) bind(c)
    !!   integer :: signum
    !!   ! handle abort
    !! end subroutine
    !!
    !! subroutine set_custom_signal_handler()
    !!   external :: custom_signal_handler
    !!   procedure(fckit_signal_handler), pointer :: signal_handler => custom_signal_handler
    !!   call fckit_signal%set_handler( fckit_signal%SIGABRT(), signal_handler )
    !! end subroutine
    !!```

  procedure, nopass, public :: set_handlers
    !! Set signal handlers to a fckit-internal signal handler
    !!
    !! This fckit-internal signal handler will print a message containing the
    !! backtrace, and will then call the abort-handler to terminate. The
    !! abort-handler can be modified with the subroutine
    !! [[fckit_exception_module:fckit_exception(type):set_handler(subroutine)]]
    !!
    !!####Example usage
    !!```fortran
    !! call fckit_signal%set_handlers()
    !!```

  procedure, nopass, public :: restore_handler
    !! Restore the signal handler for the given signal code to the default.
    !!
    !! Available signal codes are shown in [[fckit_signal_module:fckit_signal_type(type)]]
    !!
    !!####Example usage:
    !!
    !!```fortran
    !! call fckit_signal%restore_handler( fckit_signal%SIGABRT() )
    !!```

  procedure, nopass, public :: restore_handlers
    !! Restore all the signal handlers to the default.

  procedure, nopass, public :: SIGABRT !! Return code for Abort
  procedure, nopass, public :: SIGINT  !! Return code for Interrupt (e.g. CTRL+C)
  procedure, nopass, public :: SIGKILL !! Return code for Kill
  procedure, nopass, public :: SIGALRM !! Return code for Alarm
  procedure, nopass, public :: SIGTERM !! Return code for Terminate
  procedure, nopass, public :: SIGILL  !! Return code for Illegal
  procedure, nopass, public :: SIGSEGV !! Return code for Segmentation violation
  procedure, nopass, public :: SIGFPE  !! Return code for Floating Point Exception
  procedure, nopass, public :: SIGTRAP !! Return code for Trap/Breakpoint
end type

type(fckit_signal_type), save :: fckit_signal
  !! Instance of [[fckit_signal_module:fckit_signal_type(type)]]


contains

!------------------------------------------------------------------------------

subroutine set_handler( signum, signal_handler )
  use, intrinsic :: iso_c_binding, only : c_funloc, c_int32_t

  integer(c_int32_t) :: signum
    !! signal code

  procedure(fckit_signal_handler), optional :: signal_handler
    !! procedure with signature

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  if( present( signal_handler) ) then
    call fckit__set_signal_handler( signum, c_funloc(signal_handler) )
  else
    call fckit__set_fckit_signal_handler( signum )
  endif
end subroutine

!------------------------------------------------------------------------------

subroutine set_handlers()
  call fckit__set_fckit_signal_handlers()
end subroutine

!------------------------------------------------------------------------------

subroutine raise( signum )
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  !! Signal code
  call fckit__raise_signal(signum)
end subroutine

!------------------------------------------------------------------------------

subroutine restore_handler( signum )
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
    !! Signal code
  call fckit__restore_signal_handler(signum)
end subroutine

!------------------------------------------------------------------------------

subroutine restore_handlers()
  call fckit__restore_all_signal_handlers()
end subroutine

!------------------------------------------------------------------------------

function SIGABRT() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGABRT()
end function

function SIGINT() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGINT()
end function

function SIGKILL() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGKILL()
end function

function SIGALRM() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGALRM()
end function

function SIGILL() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGILL()
end function

function SIGSEGV() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGSEGV()
end function

function SIGTERM() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGTERM()
end function

function SIGFPE() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGFPE()
end function

function SIGTRAP() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGTRAP()
end function


!------------------------------------------------------------------------------

end module fckit_signal_module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

module example_module

implicit none

private

public :: example_function

contains

function example_function() result(j)
integer :: j
write(0,*) "example_function()"
j = 1
end function

end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fctest.h"

TESTSUITE( fctest_example_simple )

TEST( test1 )
  write(0,*) "test1"
  CHECK_EQUAL( 1, 1 ) ! description here
  CHECK( 1==1 ) ! description here
  CHECK_CLOSE( 0., 1.e-8, 1.e-5 ) ! description here
  CHECK_EQUAL( (/1,2/), (/2,3/) )
  CHECK_EQUAL( (/1._sp,2._sp/),   (/1._sp,2._sp,3._sp/) )
  CHECK_CLOSE( (/1._dp,2.01_dp/), (/1._dp,2._dp/), 0.001_dp )
END_TEST

TEST( test2 )
  write(0,*) "test2"
  CHECK_EQUAL( 1, 2 ) ! description here
  CHECK( 1==2 ) ! description here
  CHECK_CLOSE( 0., 1.e-4, 1.e-5 ) ! description here
  CHECK_EQUAL( (/1._sp,2._sp/), (/1._sp,2._sp/) )
  CHECK_CLOSE( (/1._dp,2.0001_dp/), (/1._dp,2._dp/), 0.001_dp )

END_TEST

TEST( test3 )
 use example_module, only: example_function
 write(0,*) "test3"
 CHECK_EQUAL( example_function(), 1 )
END_TEST

TESTSUITE_FINALIZE
  ! Mark test as passed, as it was supposed to fail otherwise
  exit_status = 0
END_TESTSUITE_FINALIZE

END_TESTSUITE

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

module fckit_signal_module
  !! author: Willem Deconinck
  !!
  !! Module providing [[fckit_signal_module:fckit_signal(variable)]] global variable

implicit none
private

#include "fckit_signal.inc"

public :: fckit_signal
public :: fckit_signal_handler


type, FORD_PRIVATE :: fckit_signal_type
  !! Private type of [[fckit_signal_module:fckit_signal(variable)]] module variable
  !! exposing signal codes

contains
  procedure, nopass, public :: raise
    !! Raise a signal with given signal code
    !!
    !!####Example usage:
    !!
    !!```fortran
    !! call fckit_signal%raise(fckit_signal%SIGABRT())
    !!```

  procedure, nopass, public :: set_handler
    !! Set custom signal handler
    !!
    !!####Example usage
    !!
    !!```fortran
    !! subroutine custom_signal_handler( signum ) bind(c)
    !!   integer :: signum
    !!   ! handle abort
    !! end subroutine
    !!
    !! subroutine set_custom_signal_handler()
    !!   external :: custom_signal_handler
    !!   procedure(fckit_signal_handler), pointer :: signal_handler => custom_signal_handler
    !!   call fckit_signal%set_handler( fckit_signal%SIGABRT(), signal_handler )
    !! end subroutine
    !!```

  procedure, nopass, public :: set_handlers
    !! Set signal handlers to a fckit-internal signal handler
    !!
    !! This fckit-internal signal handler will print a message containing the
    !! backtrace, and will then call the abort-handler to terminate. The
    !! abort-handler can be modified with the subroutine
    !! [[fckit_exception_module:fckit_exception(type):set_handler(subroutine)]]
    !!
    !!####Example usage
    !!```fortran
    !! call fckit_signal%set_handlers()
    !!```

  procedure, nopass, public :: restore_handler
    !! Restore the signal handler for the given signal code to the default.
    !!
    !! Available signal codes are shown in [[fckit_signal_module:fckit_signal_type(type)]]
    !!
    !!####Example usage:
    !!
    !!```fortran
    !! call fckit_signal%restore_handler( fckit_signal%SIGABRT() )
    !!```

  procedure, nopass, public :: restore_handlers
    !! Restore all the signal handlers to the default.

  procedure, nopass, public :: SIGABRT !! Return code for Abort
  procedure, nopass, public :: SIGINT  !! Return code for Interrupt (e.g. CTRL+C)
  procedure, nopass, public :: SIGKILL !! Return code for Kill
  procedure, nopass, public :: SIGALRM !! Return code for Alarm
  procedure, nopass, public :: SIGTERM !! Return code for Terminate
  procedure, nopass, public :: SIGILL  !! Return code for Illegal
  procedure, nopass, public :: SIGSEGV !! Return code for Segmentation violation
  procedure, nopass, public :: SIGFPE  !! Return code for Floating Point Exception
  procedure, nopass, public :: SIGTRAP !! Return code for Trap/Breakpoint
  procedure, nopass, public :: SIGBUS  !! Return code for Bus error 
end type

type(fckit_signal_type), save :: fckit_signal
  !! Instance of [[fckit_signal_module:fckit_signal_type(type)]]


contains

!------------------------------------------------------------------------------

subroutine set_handler( signum, signal_handler )
  use, intrinsic :: iso_c_binding, only : c_funloc, c_int32_t

  integer(c_int32_t) :: signum
    !! signal code

  procedure(fckit_signal_handler), optional :: signal_handler
    !! procedure with signature

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  if( present( signal_handler) ) then
    call fckit__set_signal_handler( signum, c_funloc(signal_handler) )
  else
    call fckit__set_fckit_signal_handler( signum )
  endif
end subroutine

!------------------------------------------------------------------------------

subroutine set_handlers()
  call fckit__set_fckit_signal_handlers()
end subroutine

!------------------------------------------------------------------------------

subroutine raise( signum )
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  !! Signal code
  call fckit__raise_signal(signum)
end subroutine

!------------------------------------------------------------------------------

subroutine restore_handler( signum )
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
    !! Signal code
  call fckit__restore_signal_handler(signum)
end subroutine

!------------------------------------------------------------------------------

subroutine restore_handlers()
  call fckit__restore_all_signal_handlers()
end subroutine

!------------------------------------------------------------------------------

function SIGABRT() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGABRT()
end function

function SIGINT() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGINT()
end function

function SIGKILL() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGKILL()
end function

function SIGALRM() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGALRM()
end function

function SIGILL() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGILL()
end function

function SIGSEGV() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGSEGV()
end function

function SIGTERM() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGTERM()
end function

function SIGFPE() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGFPE()
end function

function SIGTRAP() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGTRAP()
end function

function SIGBUS() result(signum)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int32_t) :: signum
  signum = fckit__SIGBUS()
end function

!------------------------------------------------------------------------------

end module fckit_signal_module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.



! This file is used in conjunction with final-support.cmake to detect compiler behaviour
! for the finalisation of derived types

#ifdef FINAL_FUNCTION_RESULT
#define TEST 1
#endif

#ifdef FINAL_UNINITIALIZED_LOCAL
#define TEST 1
#endif

#ifdef FINAL_UNINITIALIZED_INTENT_OUT
#define TEST 2
#endif

#ifdef FINAL_UNINITIALIZED_INTENT_INOUT
#define TEST 3
#endif

#ifdef FINAL_NOT_PROPAGATING
#define TEST 6
#endif

#ifdef FINAL_NOT_INHERITING
#define TEST 7
#endif

#ifdef FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
#define TEST 8
#endif

#ifdef FINAL_BROKEN_FOR_AUTOMATIC_ARRAY
#define TEST 9
#endif

#ifndef TEST
#define OUTPUT
#endif

module final_support_module
implicit none
public
integer, parameter :: output_unit = 6

type :: Object
  logical, public :: return = .false.
  logical, public :: initialized = .false.
  logical, public :: finalized = .false.
contains
  procedure, public :: copy => copy_f
  generic, public :: assignment(=) => copy
  final :: destructor
endtype

interface Object
  module procedure construct_Object
end interface

type, extends(Object) :: ObjectDerivedWithFinal
contains
  final :: destructor_ObjectDerivedWithFinal
endtype

interface ObjectDerivedWithFinal
  module procedure construct_ObjectDerivedWithFinal
end interface

type, extends(Object) :: ObjectDerivedWithoutFinal
contains
endtype

interface ObjectDerivedWithoutFinal
  module procedure construct_ObjectDerivedWithoutFinal
end interface


integer :: final_uninitialized = 0
integer :: final_return        = 0
integer :: final_initialized   = 0
integer :: final_base         = 0
integer :: final_derived       = 0
integer :: indent=0

contains

subroutine reset()
  final_uninitialized = 0
  final_return        = 0
  final_initialized   = 0
  final_base          = 0
  final_derived       = 0
end subroutine

subroutine write_indented( string )
  character(len=*) :: string
  integer :: i
#ifdef OUTPUT
  do i=1,indent
    write(0,'(A)',advance='no') '  '
  enddo
  write(0,'(A)') string
#endif
end subroutine
subroutine write_counters()
#ifdef OUTPUT
  write(0,*) ''
  write(0,*) 'final_uninitialized: ',final_uninitialized
  write(0,*) 'final_initialized:   ',final_initialized
  write(0,*) 'final_return:        ',final_return
  write(0,*) 'final_base:          ',final_base
  write(0,*) 'final_derived:       ',final_derived
#endif
end subroutine

function construct_Object() result(this)
  type(Object) :: this
  this%initialized = .true.
  this%return = .true.
end function

function construct_ObjectDerivedWithFinal() result(this)
  type(ObjectDerivedWithFinal) :: this
  this%initialized = .true.
  this%return = .true.
end function

function construct_ObjectDerivedWithoutFinal() result(this)
  type(ObjectDerivedWithoutFinal) :: this
  this%initialized = .true.
  this%return = .true.
end function

subroutine destructor_ObjectDerivedWithFinal(this)
  type(ObjectDerivedWithFinal) :: this
  call write_indented( 'final( derived )' )
  final_derived = final_derived + 1
  associate( unused => this )
  end associate
end subroutine

subroutine copy_f(this,obj_in)
  class(Object), intent(inout) :: this
  class(Object), target, intent(in) :: obj_in
#if 1
  if( obj_in%return ) then
     if( .not. this%initialized ) then
        call write_indented( 'copy uninitialized from rvalue' )
     else
        call write_indented( 'copy initialized from rvalue' )
     endif
  else if ( obj_in%initialized ) then
     if( .not. this%initialized ) then
        call write_indented( 'copy uninitialized from already existing initialized' )
     else
        call write_indented( 'copy initialized from already existing initialized' )
     endif
  endif
#endif
  this%initialized = obj_in%initialized
  this%return = .false.
end subroutine

impure elemental subroutine destructor(this)
  type(Object), intent(inout) :: this
  final_base = final_base + 1

  if( .not. this%initialized ) then
    call write_indented( 'final( uninitialized )' )
    final_uninitialized = final_uninitialized+1
  else
    if( this%return ) then
      call write_indented( 'final( returned )' )
      final_return = final_return+1
    else
      call write_indented( 'final( initialized )' )
      final_initialized = final_initialized+1
    endif
  endif
end subroutine


subroutine create_obj_out(obj)
  implicit none
  type(Object), intent(out) :: obj
  call write_indented( 'obj = Object()' )
  indent = indent+1
  obj = Object()
  indent = indent-1
end subroutine

subroutine create_obj_inout(obj)
  implicit none
  type(Object), intent(inout) :: obj
  call write_indented( 'obj = Object()' )
  indent = indent+1
  obj = Object()
  indent = indent-1
end subroutine

subroutine test1
  implicit none
  type(Object) :: obj
  call write_indented( 'obj = Object()' )
  indent = indent+1
  obj = Object()
  indent = indent-1
end subroutine

subroutine test2
  implicit none
  type(Object) :: obj
  call write_indented( 'subroutine create_obj_out(obj)' )
  indent = indent+1
  call create_obj_out(obj)
  indent = indent-1
  call write_indented( 'end subroutine create_obj_out(obj)' )
end subroutine

subroutine test3
  implicit none
  type(Object) :: obj
  call write_indented( 'subroutine create_obj_inout(obj)' )
  indent = indent+1
  call create_obj_inout(obj)
  indent = indent-1
  call write_indented( 'end subroutine create_obj_inout(obj)' )
end subroutine

subroutine test4
  implicit none
  type(Object) :: obj1, obj2
  call write_indented( 'subroutine create_obj_inout(obj1)' )
  indent = indent+1
  call create_obj_inout(obj1)
  indent = indent-1
  call write_indented( 'end subroutine create_obj_inout(obj)' )
  call write_indented( 'obj2 = obj1' )
  indent = indent+1
  obj2 = obj1
  indent = indent-1
end subroutine

subroutine test5
  implicit none
  type(Object) :: obj1, obj2
  call write_indented( 'subroutine create_obj_inout(obj1)' )
  indent = indent+1
  call create_obj_inout(obj1)
  indent = indent-1
  call write_indented( 'end subroutine create_obj_inout(obj)' )
  call write_indented( 'obj2 = obj1' )
  indent = indent+1
  obj2 = obj1
  indent = indent-1
  call write_indented( 'obj2 = obj1' )
  indent = indent+1
  obj1 = obj2
  indent = indent-1
end subroutine

subroutine test6
  implicit none
  type(ObjectDerivedWithFinal) :: obj
  indent = indent+1
  obj = ObjectDerivedWithFinal()
  indent = indent-1
  call write_indented('--- scope end ---')
end subroutine

subroutine test7
  implicit none
  type(ObjectDerivedWithoutFinal) :: obj
  indent = indent+1
  obj = ObjectDerivedWithoutFinal()
  indent = indent-1
  call write_indented('--- scope end ---')
end subroutine

subroutine test8
  implicit none
  type(Object), allocatable :: list(:)
  allocate( list(2) )
  call write_indented('list(1) = Object()')
  indent=indent+1
  list(1) = Object()
  indent=indent-1
  call write_indented('list(2) = Object()')
  indent=indent+1
  list(2) = Object()
  indent=indent-1
  call write_indented('--- deallocate ---')
  deallocate( list )
  call write_indented('--- scope end ---')
end subroutine

subroutine test9
  implicit none
  type(Object) :: list(2)
  call write_indented('list(1) = Object()')
  indent=indent+1
  list(1) = Object()
  indent=indent-1
  call write_indented('list(2) = Object()')
  indent=indent+1
  list(2) = Object()
  indent=indent-1
  call write_indented('--- scope end ---')
end subroutine

subroutine run_test(i)
  integer, intent(in) :: i
  character(len=1) :: test_number
  write(test_number,'(I0)') i
#ifndef TEST
#define COMPARE_TEST(x) (x == i)
#else
#define COMPARE_TEST(x) (x == TEST)
#endif
#ifdef OUTPUT
  write(0,'(A)') '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
#endif
  call write_indented( 'subroutine test'//test_number )
  indent = indent+1
  call reset
  if( COMPARE_TEST(1) ) call test1
  if( COMPARE_TEST(2) ) call test2
  if( COMPARE_TEST(3) ) call test3
  if( COMPARE_TEST(4) ) call test4
  if( COMPARE_TEST(5) ) call test5
  if( COMPARE_TEST(6) ) call test6
  if( COMPARE_TEST(7) ) call test7
  if( COMPARE_TEST(8) ) call test8
  if( COMPARE_TEST(9) ) call test9
  indent = indent-1
  call write_indented( 'end subroutine test'//test_number )
  call write_counters()
end subroutine


end module


program final_support
  use final_support_module
  implicit none

  call run_test(1)
  call write_indented( 'test1 summary:' )
  if( final_return > 0 ) then
    call write_indented( 'rvalue Object() was finalised' )
  endif
  if( final_uninitialized > 0 ) then
    call write_indented( 'Locally scoped object is finalised before assignment' )
  endif
  if( final_return == 0 .and. final_uninitialized == 0 ) then
    call write_indented( 'Behaviour of GNU 6.3.0' )
  endif
  if( final_return == 0 .and. final_uninitialized == 1 ) then
    call write_indented( 'Behaviour of PGI 17.10' )
  endif
  if( final_return == 1 .and. final_uninitialized == 0 ) then
    call write_indented( 'Behaviour of Cray 8.6.2' )
    call write_indented( 'Behaviour of Intel 17-18' )
  endif
#ifdef FINAL_FUNCTION_RESULT
  write(output_unit,'(I0)',advance='no') final_return
#endif
#ifdef FINAL_UNINITIALIZED_LOCAL
  write(output_unit,'(I0)',advance='no') final_uninitialized
#endif

  call run_test(2)
  call write_indented( 'test2 summary:' )
  if( final_uninitialized > 0 ) then
    call write_indented( 'object with intent OUT is finalised before assignment' )
  endif
  if( final_uninitialized == 1 ) then
    call write_indented( 'Behaviour of GNU 6.3.0' )
    call write_indented( 'Behaviour of Intel 17-18' )
  endif
  if( final_uninitialized == 0 ) then
    call write_indented( 'Behaviour of Cray 8.6.2' )
    call write_indented( 'Behaviour of PGI 17.10' )
  endif
#ifdef FINAL_UNINITIALIZED_INTENT_OUT
  write(output_unit,'(I0)',advance='no') final_uninitialized
#endif


  call run_test(3)
  call write_indented( 'test3 summary:' )
  if( final_uninitialized > 0 ) then
    call write_indented('object with intent INOUT is finalised before assignment')
  endif
  if( final_uninitialized == 0 ) then
    call write_indented( 'Behaviour of GNU 6.3.0' )
    call write_indented( 'Behaviour of Cray 8.6.2' )
    call write_indented( 'Behaviour of Intel 17-18' )
    call write_indented( 'Behaviour of PGI 17.1' )
  endif
#ifdef FINAL_UNINITIALIZED_INTENT_INOUT
  write(output_unit,'(I0)',advance='no') final_uninitialized
#endif

  call run_test(4)

  call write_indented( 'test4 summary:' )
  if( final_uninitialized == 0 .and. final_initialized == 2 ) then
    call write_indented( 'Behaviour of GNU 6.3.0' )
  endif

  call run_test(5)

  call write_indented( 'test5 summary:' )
  if( final_uninitialized == 0 .and. final_initialized == 2 ) then
    call write_indented( 'Behaviour of GNU 6.3.0' )
  endif

  call run_test(6)
#ifdef FINAL_NOT_PROPAGATING
  if( final_derived > 0 .and. final_initialized == 0 ) then
    write(output_unit,'(I0)',advance='no') 1
  else
    write(output_unit,'(I0)',advance='no') 0
  endif
#endif

  call run_test(7)
#ifdef FINAL_NOT_INHERITING
  if( final_initialized == 0 ) then
    write(output_unit,'(I0)',advance='no') 1
  else
    write(output_unit,'(I0)',advance='no') 0
  endif
#endif

  call run_test(8)
#ifdef FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
  if( final_initialized == 0 ) then
    write(output_unit,'(I0)',advance='no') 1
  else
    write(output_unit,'(I0)',advance='no') 0
  endif
#endif

  call run_test(9)
#ifdef FINAL_BROKEN_FOR_AUTOMATIC_ARRAY
  if( final_initialized == 0 ) then
    write(output_unit,'(I0)',advance='no') 1
  else
    write(output_unit,'(I0)',advance='no') 0
  endif
#endif

end program

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fctest.h"

! -----------------------------------------------------------------------------

TESTSUITE(fctest_fckit_configuration_fails)

! -----------------------------------------------------------------------------

TESTSUITE_INIT
  use fckit_module
  call fckit_main%init()

  ! With Apple Silicon (M1), using Apple clang 12.0.0 for C++ and Homebrew GCC 10.2.0_4 for Fortran
  ! it appears that the Fortran needs to trap the C++ exceptions via SIGTRAP
  call fckit_signal%set_handler( fckit_signal%SIGTRAP() )
END_TESTSUITE_INIT

! -----------------------------------------------------------------------------

TESTSUITE_FINALIZE
  use fckit_module
  call fckit_main%final()
END_TESTSUITE_FINALIZE

! -----------------------------------------------------------------------------

TEST(test_throw)
!! ENABLE TO TEST IF THROW WILL WORK
#if 1
  use fckit_configuration_module
  type(fckit_Configuration) :: config

  integer :: missing_value

  write(0,*) "~~~~~~~~~~~~~~ SCOPE BEGIN ~~~~~~~~~~~~~~~"

  config = fckit_Configuration()

  call config%get_or_die("missing",missing_value)

  call config%final()
  write(0,*) "~~~~~~~~~~~~~~~ SCOPE END ~~~~~~~~~~~~~~~~"
#endif
END_TEST
! -----------------------------------------------------------------------------

END_TESTSUITE

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_main_module
  !! author: Willem Deconinck
  !!
  !! Module providing [[fckit_main_module:fckit_main(variable)]] global variable
  !! to set up the ```eckit::Main``` object required by all libraries relying on eckit
  !!
  !!@Note
  !! ```fckit_main%initialize()``` will set up default log channels to be used by ```eckit::Log``` and ```fckit_log```.
  !! Refer to [[fckit_log_module:fckit_log(variable)]] to adapt the log channels to suit your needs
  !!@Endnote
  !!

implicit none
private

#include "fckit_main.inc"

public :: fckit_main

type, FORD_PRIVATE :: fckit_main_type
  !! Private type of [[fckit_main_module:fckit_main(variable)]] module variable
  !!
  !! It wraps ```eckit::Main```, allowing C++ compatibility
  !! with understanding the command-line arguments

contains

  procedure, nopass, public :: ready
    !! Check if Main was initialised.
    !!
    !!####Example usage:
    !!
    !!```fortran
    !! if( fckit_main%ready() ) then
    !!   ! fckit/eckit Main is ready (initialised)
    !! endif
    !!```

  procedure, nopass, public :: initialise
    !! display: none
    !! Initialise Main if not initialised
    !!
    !! Internally calls eckit::Main::initialise(argc,argv)
    !! with the command-line arguments acquired from the Fortran runtime.
    !!
    !! When using fckit or libraries based on eckit/fckit, this
    !! should be called as early as possible in the main program.
    !!
    !!####Example usage:
    !!
    !!```fortran
    !! call fckit_main%initialise()
    !!```

  procedure, nopass, public :: finalise
    !! Finalise Main if not finalised
    !!
    !! This function is to be called at the end of the main program.
    !! Calling this function is optional as the program should be capable to clean up
    !! itself. It may however provide a hook to clean up and print in future
    !! eckit/fckit releases.
    !!
    !!####Example usage:
    !!
    !!```fortran
    !! call fckit_main%finalise()
    !!```

  procedure, nopass, public :: taskID
    !! Get the taskID; typically this is the ```MPI_RANK``` in ```MPI_COMM_WORLD```
    !!
    !! This value can be changed using [[fckit_main_type:set_taskID(bound)]]
    !!
    !!####Example usage:
    !!
    !!```fortran
    !! integer :: taskID
    !! taskID = fckit_main%taskID()
    !!```

  procedure, nopass, public :: set_taskID
    !! Set the taskID; typically this is the MPI rank
    !!
    !! Upon ```call fckit_main%initialise()```, the taskID is
    !! set to the ```MPI_RANK``` in ```MPI_COMM_WORLD```.
    !!
    !! Use this function to change this afterwards.
    !!
    !!####Example usage:
    !!
    !!```fortran
    !! call fckit_main%set_taskID( int(taskID) )
    !!```

  procedure, nopass, public :: debug
    !! Check if debug flag is set (environment or command-line)

  procedure, nopass, public :: name => main_name
    !! Get the name of the program (command-line name)
    !!
    !!####Example usage:
    !!
    !!```fortran
    !! character(len=:), allocatable :: name
    !! call fckit_main%name( name )
    !!```

  procedure, nopass, public :: displayname
    !! Get the displayname of the program.
    !!
    !! This is by default the command-line name but can be overwritten
    !! using --displayname=\<NAME\> command-line argument
    !!
    !!####Example usage:
    !!
    !!```fortran
    !!    character(len=:), allocatable :: displayname
    !!    call fckit_main%displayname( displayname )
    !!```

  procedure, nopass, public :: init => initialise
    !! deprecated: true
    !! Deprecated. Use [[fckit_main_type:initialise(bound)]] instead

  procedure, nopass, public :: final => finalise
    !! deprecated: true
    !! Finalise Main if not finalised
    !! Deprecated. Use [[fckit_main_type:finalise(bound)]] instead

end type fckit_main_type

type(fckit_main_type), save :: fckit_main
  !! Instance of [[fckit_main_module:fckit_main_type(type)]]

contains

!------------------------------------------------------------------------------

subroutine initialise()
  use, intrinsic :: iso_c_binding, only : c_ptr, c_int32_t
  use fckit_c_interop_module
  integer, save :: argc
  type(c_ptr), save :: argv(15)
  integer(c_int32_t):: error_code
  call get_c_commandline_arguments(argc,argv)
  error_code = fckit__main_init(argc,argv)
end subroutine

subroutine finalise()
  call fckit__main_finalise()
end subroutine

function ready()
  use, intrinsic :: iso_c_binding, only : c_int32_t
  use fckit_c_interop_module
  logical :: ready
  integer(c_int32_t) :: ready_int
  integer(c_int32_t) :: error_code
  error_code = fckit__main_ready(ready_int)
  if( ready_int == 0 ) then
    ready = .false.
  else
    ready = .true.
  endif
end function

function taskID()
  use, intrinsic :: iso_c_binding, only : c_int32_t
  use fckit_c_interop_module
  integer(c_int32_t) :: taskID
  integer(c_int32_t) :: error_code
  error_code = fckit__main_taskID(taskID)
end function

subroutine set_taskID(taskID)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  use fckit_c_interop_module
  integer(c_int32_t), intent(in) :: taskID
  integer(c_int32_t) :: error_code
  error_code = fckit__main_setTaskID(taskID)
end subroutine

function debug()
  use, intrinsic :: iso_c_binding, only : c_int32_t
  logical :: debug
  integer(c_int32_t) :: debug_int
  debug_int = fckit__main_debug()
  debug = .false.
  if( debug_int==1 ) debug = .true.
end function

subroutine main_name(name)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module
  character(kind=c_char,len=:), allocatable, intent(inout) :: name
    !! Name will be allocated.
  type(c_ptr) :: name_c_ptr
  integer(c_size_t) :: name_size
  integer(c_int32_t) :: error_code
  error_code = fckit__main_name(name_c_ptr,name_size)
  FCKIT_ALLOCATE_CHARACTER(name,name_size)
  name = c_ptr_to_string(name_c_ptr)
  call c_ptr_free(name_c_ptr)
end subroutine

subroutine displayname(name)
  use, intrinsic :: iso_c_binding
  use fckit_c_interop_module
  character(kind=c_char,len=:), allocatable, intent(inout) :: name
    !! Name will be allocated.
  type(c_ptr) :: name_c_ptr
  integer(c_size_t) :: name_size
  integer(c_int32_t) :: error_code
  error_code = fckit__main_displayname(name_c_ptr,name_size)
  FCKIT_ALLOCATE_CHARACTER(name,name_size)
  name = c_ptr_to_string(name_c_ptr)
  call c_ptr_free(name_c_ptr)
end subroutine

end module fckit_main_module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

#if FCKIT_FINAL_DEBUGGING
#define FCKIT_WRITE_LOC write(0,'(A,I0,A)',advance='NO') "fckit_owned_object.F90 @ ",__LINE__,'  : '
#define FCKIT_WRITE_DEBUG write(0,*)
#else
#define FCKIT_WRITE_LOC
#define FCKIT_WRITE_DEBUG if(.false.)write(0,*)
#endif

module fckit_owned_object_module
use, intrinsic :: iso_c_binding, only: c_ptr, c_funptr, c_null_ptr, c_null_funptr, c_int32_t
implicit none
private

!========================================================================
! Public interface

public fckit_owned_object

!========================================================================

type :: fckit_owned_object
  !! Abstract base class for objects that wrap a C++ object

#if !PGIBUG_ATLAS_197
  type(c_ptr), private :: cpp_object_ptr = c_null_ptr
#else
  type(c_ptr), public :: cpp_object_ptr = c_null_ptr
#endif
  type(c_funptr), private :: deleter = c_null_funptr
    !! Internal C pointer

  logical, private :: return_value = .false.
    ! This variable should not be necessary,
    ! but seems to overcome compiler issues (gfortran 5.3, 6.3)

contains

  procedure, public :: is_null
    !! Check if internal C pointer is set

#if !PGIBUG_ATLAS_197_DEBUG
  procedure, public :: c_ptr   => fckit_owned_object__c_ptr
    !! Access to internal C pointer
#endif

  procedure, public :: reset_c_ptr
    !! Nullify internal C pointer

  procedure, private :: equal
    !! Compare two object C pointers

  procedure, private :: not_equal
    !! Compare two object C pointers

  generic, public :: operator(==) => equal
    !! Compare two objects internal C pointer

  generic, public :: operator(/=) => not_equal
    !! Compare two objects internal C pointer

  ! Following line is to avoid PGI compiler bug
  procedure, private :: fckit_owned_object__c_ptr

  procedure, public :: final => fckit_owned_object__final

#if FCKIT_HAVE_FINAL
  final :: fckit_owned_object__final_auto
#endif

  procedure, private :: assignment_operator
  generic, public :: assignment(=) => assignment_operator
  procedure, public :: owners
  procedure, public :: attach
  procedure, public :: detach
  procedure, public :: return
  procedure, public :: assignment_operator_hook

  procedure, public :: consumed
end type

!========================================================================

private :: c_ptr
private :: c_null_ptr
private :: c_funptr
private :: c_null_funptr
private :: c_int32_t

!========================================================================

interface

  subroutine fckit__delete_Owned(this) bind(c,name="fckit__delete_Owned")
    use, intrinsic :: iso_c_binding, only: c_ptr
    type(c_ptr), value :: this
  end subroutine

  function fckit__Owned__owners(this) bind(c,name="fckit__Owned__owners")
    use, intrinsic :: iso_c_binding, only: c_int32_t, c_ptr
    integer(c_int32_t) :: fckit__Owned__owners
    type(c_ptr), value :: this
  end function

  subroutine fckit__Owned__attach(this) bind(c,name="fckit__Owned__attach")
    use, intrinsic :: iso_c_binding, only: c_ptr
    type(c_ptr), value :: this
  end subroutine

  subroutine fckit__Owned__detach(this) bind(c,name="fckit__Owned__detach")
    use, intrinsic :: iso_c_binding, only: c_ptr
    type(c_ptr), value :: this
  end subroutine

end interface

!========================================================================
CONTAINS
!========================================================================

FCKIT_FINAL subroutine fckit_owned_object__final_auto(this)
#ifdef _CRAYFTN
  use, intrinsic :: iso_c_binding, only : c_loc, c_null_ptr
#endif
  type(fckit_owned_object), intent(inout) :: this
  FCKIT_WRITE_LOC
  FCKIT_WRITE_DEBUG "fckit_owned_object__final_auto"
  ! Guard necessary for Cray compiler...
  ! ... when "this" has already been deallocated, and then
  ! fckit_owned_object__final_auto is called...
#ifdef _CRAYFTN
  if( c_loc(this) == c_null_ptr ) then
    return
  endif
#endif

  call this%final()
end subroutine

subroutine fckit_owned_object__delete( this )
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funptr, c_f_procpointer, c_associated, c_null_ptr
  use fckit_c_interop_module, only : fckit_c_deleter_interface
  class(fckit_owned_object), intent(inout) :: this
  procedure(fckit_c_deleter_interface), pointer :: deleter
  FCKIT_WRITE_LOC
  FCKIT_WRITE_DEBUG "fckit_owned_object__delete"
  if( c_associated( this%cpp_object_ptr ) ) then
    if( c_associated( this%deleter ) ) then
      call c_f_procpointer( this%deleter, deleter )
      call deleter( this%cpp_object_ptr )
      this%cpp_object_ptr = c_null_ptr
    endif
  endif
  this%cpp_object_ptr = c_null_ptr
end subroutine

subroutine fckit_owned_object__final(this)
  class(fckit_owned_object), intent(inout) :: this

  if( this%is_null() ) then
    FCKIT_WRITE_LOC
    FCKIT_WRITE_DEBUG "fckit_owned_object__final  (uninitialised --> no-op)"
    return
  endif

#if FCKIT_FINAL_DEBUGGING
  if( this%return_value ) then
    FCKIT_WRITE_LOC
    FCKIT_WRITE_DEBUG "fckit_owned_object__final on return value, owners = ", this%owners()
  endif
#endif

  if( this%owners() > 0 ) then
    FCKIT_WRITE_LOC
    FCKIT_WRITE_DEBUG "fckit_owned_object__final  , owners = ", this%owners()
    call this%detach()
    if( this%owners() == 0 ) then
      call fckit_owned_object__delete(this)
    endif
  endif
  FCKIT_WRITE_LOC
  FCKIT_WRITE_DEBUG "fckit_owned_object__final  , owners = ", this%owners()
  call this%reset_c_ptr()
end subroutine



subroutine assignment_operator(this,other)
  class(fckit_owned_object), intent(inout) :: this
  class(fckit_owned_object), intent(in)    :: other
  if( other%is_null() ) then
    write(0,*) "ERROR! other was not initialised"
  endif
#if FCKIT_FINAL_DEBUGGING
  if( other%return_value ) then
    FCKIT_WRITE_LOC
    FCKIT_WRITE_DEBUG "other is a return value"
  endif
#endif
  if( this /= other ) then
#if FCKIT_FINAL_DEBUGGING
    if( this%is_null() ) then
      FCKIT_WRITE_LOC
      FCKIT_WRITE_DEBUG "assignment_operator of uninitialised"
    else
      FCKIT_WRITE_LOC
      FCKIT_WRITE_DEBUG "assignment_operator of initialised"
    endif
#endif
    call this%final()
    call this%reset_c_ptr( other%CPTR_PGIBUG_A, other%deleter )
    FCKIT_WRITE_LOC
    FCKIT_WRITE_DEBUG "  \-> owners ", this%owners()
  else
    FCKIT_WRITE_LOC
    FCKIT_WRITE_DEBUG "assignment_operator ( obj_out = obj_in )"
  endif
  call this%assignment_operator_hook(other)
 end subroutine

subroutine attach(this)
  class(fckit_owned_object), intent(inout) :: this
  if( .not. this%is_null() ) then
    call fckit__Owned__attach(this%cpp_object_ptr)
    FCKIT_WRITE_LOC
    FCKIT_WRITE_DEBUG "attach"
  endif
end subroutine

subroutine detach(this)
  class(fckit_owned_object), intent(inout) :: this
  if( .not. this%is_null() ) then
    call fckit__Owned__detach(this%cpp_object_ptr)
    FCKIT_WRITE_LOC
    FCKIT_WRITE_DEBUG "detach"
  endif
end subroutine

function owners(this)
  integer(c_int32_t) :: owners
  class(fckit_owned_object), intent(in) :: this
  if( this%is_null() ) then
    owners = 0
  else
    owners = fckit__Owned__owners(this%cpp_object_ptr)
  endif
end function

subroutine return(this)
  !! Transfer ownership to left hand side of "assignment(=)"
  class(fckit_owned_object), intent(inout) :: this
#if FCKIT_FINAL_FUNCTION_RESULT
  ! Cray example
  ! final will be called, which will detach, so attach first
  if( this%owners() == 0 ) then
    FCKIT_WRITE_LOC
    FCKIT_WRITE_DEBUG "return --> attach"
    call this%attach()
  endif
#else
  ! final will not be called, so detach manually
  if( this%owners() > 0 ) then
    FCKIT_WRITE_LOC
    FCKIT_WRITE_DEBUG "return --> detach"
    call this%detach()
  endif
#endif
#if FCKIT_FINAL_DEBUGGING
  this%return_value = .true.
#endif
end subroutine


subroutine assignment_operator_hook(this, other)
  class(fckit_owned_object) :: this
  class(fckit_owned_object) :: other
  FCKIT_SUPPRESS_UNUSED( this )
  FCKIT_SUPPRESS_UNUSED( other )
end subroutine


subroutine consumed(this)
  class(fckit_owned_object), intent(in) :: this
  type(fckit_owned_object) :: consumed_object
  consumed_object = this
  call consumed_object%final()
end subroutine


function fckit_owned_object__c_ptr(this)
  use, intrinsic :: iso_c_binding, only: c_ptr
  type(c_ptr) :: fckit_owned_object__c_ptr
  class(fckit_owned_object), intent(in) :: this
  fckit_owned_object__c_ptr = this%cpp_object_ptr
end function


function is_null(this)
  use, intrinsic :: iso_c_binding, only: c_associated
  logical :: is_null
  class(fckit_owned_object) :: this
  if( c_associated( this%cpp_object_ptr ) ) then
    is_null = .False.
  else
    is_null = .True.
  endif
end function

logical function equal(obj1,obj2)
  use fckit_c_interop_module, only : c_ptr_compare_equal
  class(fckit_owned_object), intent(in) :: obj1
  class(fckit_owned_object), intent(in) :: obj2
  equal = c_ptr_compare_equal(obj1%cpp_object_ptr,obj2%cpp_object_ptr)
end function

logical function not_equal(obj1,obj2)
  use fckit_c_interop_module, only : c_ptr_compare_equal
  class(fckit_owned_object), intent(in) :: obj1
  class(fckit_owned_object), intent(in) :: obj2
  if( c_ptr_compare_equal(obj1%cpp_object_ptr,obj2%cpp_object_ptr) ) then
    not_equal = .False.
  else
    not_equal = .True.
  endif
end function

subroutine reset_c_ptr(this,cptr,deleter)
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funptr, c_null_funptr
  use fckit_c_interop_module
  class(fckit_owned_object) :: this
  type(c_ptr), optional :: cptr
  type(c_funptr), optional :: deleter
  if( present(cptr) ) then
    this%cpp_object_ptr = cptr
    call this%attach()

    if( present(deleter) ) then
      this%deleter = deleter
    else
      this%deleter = fckit_c_deleter(fckit__delete_Owned)
    endif

  else
    this%cpp_object_ptr = c_null_ptr
    this%deleter = c_null_funptr
  endif

end subroutine

end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_object_module
  !! Provides abstract base class [[fckit_object_module:fckit_object(type)]]

use, intrinsic :: iso_c_binding, only: c_ptr, c_funptr, c_null_ptr, c_null_funptr
use fckit_final_module, only: fckit_final
implicit none
private

!========================================================================
! Public interface

public fckit_object

!========================================================================

type, extends(fckit_final) :: fckit_object
  !! Abstract base class for objects that wrap a C++ object

#if !PGIBUG_ATLAS_197
  type(c_ptr), private :: cpp_object_ptr = c_null_ptr
#else
  type(c_ptr), public :: cpp_object_ptr = c_null_ptr
#endif

  type(c_funptr), private :: deleter = c_null_funptr
    !! Internal C pointer

  logical, private :: dummy = .false.
    ! This variable should not be necessary,
    ! but seems to overcome compiler issues (gfortran 5.3, 6.3)

contains

  procedure, public :: is_null
    !! Check if internal C pointer is set

#if !PGIBUG_ATLAS_197
  procedure, public :: c_ptr   => fckit_object__c_ptr
    !! Access to internal C pointer
#endif

  procedure, public :: reset_c_ptr
    !! Nullify internal C pointer

  procedure, private :: equal
    !! Compare two object C pointers

  procedure, private :: not_equal
    !! Compare two object C pointers

  generic, public :: operator(==) => equal
    !! Compare two objects internal C pointer

  generic, public :: operator(/=) => not_equal
    !! Compare two objects internal C pointer

  ! Following line is to avoid PGI compiler bug
  procedure, private :: fckit_object__c_ptr

  procedure, public :: final
  procedure, public :: fckit_object__final => final
#if FCKIT_HAVE_FINAL
  final :: fckit_object_final_auto
#endif

end type

interface fckit_object
  module procedure fckit_object_constructor
end interface

!========================================================================

private :: fckit_final
private :: c_ptr
private :: c_null_ptr
private :: c_funptr
private :: c_null_funptr

! =============================================================================
CONTAINS
! =============================================================================

function fckit_object_constructor( cptr, deleter ) result(this)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_funptr
  type(fckit_object) :: this
  type(c_ptr) :: cptr
  type(c_funptr), optional :: deleter
  if( present(deleter) ) then
    call this%reset_c_ptr( cptr, deleter )
  else
    call this%reset_c_ptr( cptr )
  endif
end function

function fckit_object__c_ptr(this)
  use, intrinsic :: iso_c_binding, only: c_ptr
  type(c_ptr) :: fckit_object__c_ptr
  class(fckit_object), intent(in) :: this
  fckit_object__c_ptr = this%cpp_object_ptr
end function

subroutine reset_c_ptr(this,cptr,deleter)
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funptr, c_null_funptr
  use fckit_c_interop_module
  class(fckit_object) :: this
  type(c_ptr), optional :: cptr
  type(c_funptr), optional :: deleter
#if FCKIT_FINAL_DEBUGGING
  if( present(cptr) ) then
     write(0,*) "fckit_object::reset_c_ptr( ",c_ptr_to_loc(cptr), ")"
  else
     write(0,*) "fckit_object::reset_c_ptr( )"
  endif
#endif
  if( present(cptr) ) then
    this%cpp_object_ptr = cptr
    if( present(deleter) ) then
      this%deleter = deleter
    else
      this%deleter = c_null_funptr
    endif
  else
    this%cpp_object_ptr = c_null_ptr
    this%deleter = c_null_funptr
  endif
end subroutine

function is_null(this)
  use, intrinsic :: iso_c_binding, only: c_associated
  logical :: is_null
  class(fckit_object) :: this
  if( c_associated( this%cpp_object_ptr ) ) then
    is_null = .False.
  else
    is_null = .True.
  endif
end function

logical function equal(obj1,obj2)
  use fckit_c_interop_module, only : c_ptr_compare_equal
  class(fckit_object), intent(in) :: obj1
  class(fckit_object), intent(in) :: obj2
  equal = c_ptr_compare_equal(obj1%cpp_object_ptr,obj2%cpp_object_ptr)
end function

logical function not_equal(obj1,obj2)
  use fckit_c_interop_module, only : c_ptr_compare_equal
  class(fckit_object), intent(in) :: obj1
  class(fckit_object), intent(in) :: obj2
  if( c_ptr_compare_equal(obj1%cpp_object_ptr,obj2%cpp_object_ptr) ) then
    not_equal = .False.
  else
    not_equal = .True.
  endif
end function

subroutine final( this )
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funptr, c_f_procpointer, c_associated, c_null_ptr
  use fckit_c_interop_module, only : fckit_c_deleter_interface
  class(fckit_object), intent(inout) :: this
  procedure(fckit_c_deleter_interface), pointer :: deleter
  if( c_associated( this%cpp_object_ptr ) ) then
    if( c_associated( this%deleter ) ) then
      call c_f_procpointer( this%deleter, deleter )
      call deleter( this%cpp_object_ptr )
      this%cpp_object_ptr = c_null_ptr
    endif
  endif
  this%cpp_object_ptr = c_null_ptr
end subroutine

FCKIT_FINAL subroutine fckit_object_final_auto( this )
  type(fckit_object), intent(inout) :: this
#if FCKIT_FINAL_DEBUGGING
  write(0,*) "fckit_object_final_auto"
#endif
  call this%final()
end subroutine

end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fctest.h"

TESTSUITE( array )

TEST( test_array_view1d )
  use fckit_array_module, only: array_view1d
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: array_int32_r2(20,10)
  integer(c_int32_t), pointer :: view(:)

  write(0,*) "test_array_view1d"
  view => array_view1d(array_int32_r2)
  FCTEST_CHECK_EQUAL( size(view), 200 )
END_TEST

TEST( test_array_stride )
  use fckit_array_module, only: array_stride, array_strides
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: array_int32_r2(20,10)

  write(0,*) "test_array_stride"
  FCTEST_CHECK_EQUAL( array_stride(array_int32_r2,1), 1  )
  FCTEST_CHECK_EQUAL( array_stride(array_int32_r2,2), 20 )

  FCTEST_CHECK_EQUAL( array_strides(array_int32_r2), ([1,20]) )

END_TEST

END_TESTSUITE

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.


#include "fckit/fctest.h"

! -----------------------------------------------------------------------------

TESTSUITE(fckit_test_log)

TESTSUITE_INIT
  use fckit_module
  implicit none
  call fckit_main%init()
END_TESTSUITE_INIT

TESTSUITE_FINALIZE
  use fckit_module
  implicit none
  call fckit_main%final()
END_TESTSUITE_FINALIZE

! -----------------------------------------------------------------------------

TEST( test_main )
  use fckit_module
  character(len=:), allocatable :: displayname, name
  character(len=128) :: logmsg
  call fckit_main%name(name)
  call fckit_main%displayname(displayname)
  write(logmsg,*) "name = "//name//" , displayname = "//displayname
  call fckit_log%info(logmsg)
END_TEST

! -----------------------------------------------------------------------------

TEST( test_log )
  use fckit_module, only: log => fckit_log

  call log%set_stdout()

  call log%debug("debug")
  call log%info("info")
  call log%warning("warning")
  call log%error("error")
  call log%error("   ")
  call log%error("hello again")

END_TEST

! -----------------------------------------------------------------------------

TEST( test_file )
  use fckit_module, only: log => fckit_log

  call log%add_file("output_file",style=log%SIMPLE)

  call log%info("FILE info",newl=.true.,flush=.true.)
  call log%info("more FILE info",flush=.true.)
  call log%warning(" more FILE warning",flush=.true.)

END_TEST

! -----------------------------------------------------------------------------

TEST( test_fortran_unit )
  use fckit_module, only: log => fckit_log

  call log%set_fortran_unit(unit=6,style=log%TIMESTAMP)

  call log%info("FORTRAN info",newl=.true.,flush=.true.)
  call log%warning("FORTRAN warning",newl=.false.)
  call log%warning(" more FORTRAN warning",flush=.true.)
  call log%info("more FORTRAN info",flush=.true.)

END_TEST

! -----------------------------------------------------------------------------

END_TESTSUITE

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.



! This file is used in conjunction with final-support.cmake to detect compiler behaviour
! for the finalisation of derived types

#ifdef FINAL_FUNCTION_RESULT
#define TEST 1
#endif

#ifdef FINAL_UNINITIALIZED_LOCAL
#define TEST 1
#endif

#ifdef FINAL_UNINITIALIZED_INTENT_OUT
#define TEST 2
#endif

#ifdef FINAL_UNINITIALIZED_INTENT_INOUT
#define TEST 3
#endif

#ifdef FINAL_NOT_PROPAGATING
#define TEST 6
#endif

#ifdef FINAL_NOT_INHERITING
#define TEST 7
#endif

#ifdef FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
#define TEST 8
#endif

#ifdef FINAL_BROKEN_FOR_AUTOMATIC_ARRAY
#define TEST 9
#endif

#ifdef FINAL_NOT_INHERITING_FOR_ALLOCATABLE_ARRAY
#define TEST 10
#endif

#ifdef FINAL_NOT_INHERITING_FOR_AUTOMATIC_ARRAY
#define TEST 11
#endif

#ifndef TEST
#define OUTPUT
#endif

module final_support_module
implicit none
public
integer, parameter :: output_unit = 6

type :: Object
  logical, public :: return = .false.
  logical, public :: initialized = .false.
  logical, public :: finalized = .false.
contains
  procedure, public :: copy => copy_f
  generic, public :: assignment(=) => copy
  final :: destructor
endtype

interface Object
  module procedure construct_Object
end interface

type, extends(Object) :: ObjectDerivedWithFinal
contains
  final :: destructor_ObjectDerivedWithFinal
endtype

interface ObjectDerivedWithFinal
  module procedure construct_ObjectDerivedWithFinal
end interface

type, extends(Object) :: ObjectDerivedWithoutFinal
contains
endtype

interface ObjectDerivedWithoutFinal
  module procedure construct_ObjectDerivedWithoutFinal
end interface


integer :: final_uninitialized = 0
integer :: final_return        = 0
integer :: final_initialized   = 0
integer :: final_base         = 0
integer :: final_derived       = 0
integer :: indent=0

contains

subroutine reset()
  final_uninitialized = 0
  final_return        = 0
  final_initialized   = 0
  final_base          = 0
  final_derived       = 0
end subroutine

subroutine write_indented( string )
  character(len=*) :: string
  integer :: i
#ifdef OUTPUT
  do i=1,indent
    write(0,'(A)',advance='no') '  '
  enddo
  write(0,'(A)') string
#endif
end subroutine
subroutine write_counters()
#ifdef OUTPUT
  write(0,*) ''
  write(0,*) 'final_uninitialized: ',final_uninitialized
  write(0,*) 'final_initialized:   ',final_initialized
  write(0,*) 'final_return:        ',final_return
  write(0,*) 'final_base:          ',final_base
  write(0,*) 'final_derived:       ',final_derived
#endif
end subroutine

function construct_Object() result(this)
  type(Object) :: this
  this%initialized = .true.
  this%return = .true.
end function

function construct_ObjectDerivedWithFinal() result(this)
  type(ObjectDerivedWithFinal) :: this
  this%initialized = .true.
  this%return = .true.
end function

function construct_ObjectDerivedWithoutFinal() result(this)
  type(ObjectDerivedWithoutFinal) :: this
  this%initialized = .true.
  this%return = .true.
end function

subroutine destructor_ObjectDerivedWithFinal(this)
  type(ObjectDerivedWithFinal) :: this
  call write_indented( 'final( derived )' )
  final_derived = final_derived + 1
  associate( unused => this )
  end associate
end subroutine

subroutine copy_f(this,obj_in)
  class(Object), intent(inout) :: this
  class(Object), target, intent(in) :: obj_in
#if 1
  if( obj_in%return ) then
     if( .not. this%initialized ) then
        call write_indented( 'copy uninitialized from rvalue' )
     else
        call write_indented( 'copy initialized from rvalue' )
     endif
  else if ( obj_in%initialized ) then
     if( .not. this%initialized ) then
        call write_indented( 'copy uninitialized from already existing initialized' )
     else
        call write_indented( 'copy initialized from already existing initialized' )
     endif
  endif
#endif
  this%initialized = obj_in%initialized
  this%return = .false.
end subroutine

impure elemental subroutine destructor(this)
  type(Object), intent(inout) :: this
  final_base = final_base + 1

  if( .not. this%initialized ) then
    call write_indented( 'final( uninitialized )' )
    final_uninitialized = final_uninitialized+1
  else
    if( this%return ) then
      call write_indented( 'final( returned )' )
      final_return = final_return+1
    else
      call write_indented( 'final( initialized )' )
      final_initialized = final_initialized+1
    endif
  endif
end subroutine


subroutine create_obj_out(obj)
  implicit none
  type(Object), intent(out) :: obj
  call write_indented( 'obj = Object()' )
  indent = indent+1
  obj = Object()
  indent = indent-1
end subroutine

subroutine create_obj_inout(obj)
  implicit none
  type(Object), intent(inout) :: obj
  call write_indented( 'obj = Object()' )
  indent = indent+1
  obj = Object()
  indent = indent-1
end subroutine

subroutine test1
  implicit none
  type(Object) :: obj
  call write_indented( 'obj = Object()' )
  indent = indent+1
  obj = Object()
  indent = indent-1
end subroutine

subroutine test2
  implicit none
  type(Object) :: obj
  call write_indented( 'subroutine create_obj_out(obj)' )
  indent = indent+1
  call create_obj_out(obj)
  indent = indent-1
  call write_indented( 'end subroutine create_obj_out(obj)' )
end subroutine

subroutine test3
  implicit none
  type(Object) :: obj
  call write_indented( 'subroutine create_obj_inout(obj)' )
  indent = indent+1
  call create_obj_inout(obj)
  indent = indent-1
  call write_indented( 'end subroutine create_obj_inout(obj)' )
end subroutine

subroutine test4
  implicit none
  type(Object) :: obj1, obj2
  call write_indented( 'subroutine create_obj_inout(obj1)' )
  indent = indent+1
  call create_obj_inout(obj1)
  indent = indent-1
  call write_indented( 'end subroutine create_obj_inout(obj)' )
  call write_indented( 'obj2 = obj1' )
  indent = indent+1
  obj2 = obj1
  indent = indent-1
end subroutine

subroutine test5
  implicit none
  type(Object) :: obj1, obj2
  call write_indented( 'subroutine create_obj_inout(obj1)' )
  indent = indent+1
  call create_obj_inout(obj1)
  indent = indent-1
  call write_indented( 'end subroutine create_obj_inout(obj)' )
  call write_indented( 'obj2 = obj1' )
  indent = indent+1
  obj2 = obj1
  indent = indent-1
  call write_indented( 'obj2 = obj1' )
  indent = indent+1
  obj1 = obj2
  indent = indent-1
end subroutine

subroutine test6
  implicit none
  type(ObjectDerivedWithFinal) :: obj
  indent = indent+1
  obj = ObjectDerivedWithFinal()
  indent = indent-1
  call write_indented('--- scope end ---')
end subroutine

subroutine test7
  implicit none
  type(ObjectDerivedWithoutFinal) :: obj
  indent = indent+1
  obj = ObjectDerivedWithoutFinal()
  indent = indent-1
  call write_indented('--- scope end ---')
end subroutine

subroutine test8
  implicit none
  type(Object), allocatable :: list(:)
  allocate( list(2) )
  call write_indented('list(1) = Object()')
  indent=indent+1
  list(1) = Object()
  indent=indent-1
  call write_indented('list(2) = Object()')
  indent=indent+1
  list(2) = Object()
  indent=indent-1
  call write_indented('--- deallocate ---')
  deallocate( list )
  call write_indented('--- scope end ---')
end subroutine

subroutine test9
  implicit none
  type(Object) :: list(2)
  call write_indented('list(1) = Object()')
  indent=indent+1
  list(1) = Object()
  indent=indent-1
  call write_indented('list(2) = Object()')
  indent=indent+1
  list(2) = Object()
  indent=indent-1
  call write_indented('--- scope end ---')
end subroutine

subroutine test10
  implicit none
  type(ObjectDerivedWithoutFinal), allocatable :: list(:)
  allocate(list(2))
  call write_indented('list(1) = ObjectDerivedWithoutFinal()')
  indent=indent+1
  list(1) = ObjectDerivedWithoutFinal()
  indent=indent-1
  call write_indented('list(2) = ObjectDerivedWithoutFinal()')
  indent=indent+1
  list(2) = ObjectDerivedWithoutFinal()
  indent=indent-1
  call write_indented('--- scope end ---')
end subroutine

subroutine test11
  implicit none
  type(ObjectDerivedWithoutFinal) :: list(2)
  call write_indented('list(1) = ObjectDerivedWithoutFinal()')
  indent=indent+1
  list(1) = ObjectDerivedWithoutFinal()
  indent=indent-1
  call write_indented('list(2) = ObjectDerivedWithoutFinal()')
  indent=indent+1
  list(2) = ObjectDerivedWithoutFinal()
  indent=indent-1
  call write_indented('--- scope end ---')
end subroutine

subroutine run_test(i)
  integer, intent(in) :: i
  character(len=2) :: test_number
  write(test_number,'(I0)') i
#ifndef TEST
#define COMPARE_TEST(x) (x == i)
#else
#define COMPARE_TEST(x) (x == TEST)
#endif
#ifdef OUTPUT
  write(0,'(A)') '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
#endif
  call write_indented( 'subroutine test'//trim(test_number) )
  indent = indent+1
  call reset
  if( COMPARE_TEST(1) ) call test1
  if( COMPARE_TEST(2) ) call test2
  if( COMPARE_TEST(3) ) call test3
  if( COMPARE_TEST(4) ) call test4
  if( COMPARE_TEST(5) ) call test5
  if( COMPARE_TEST(6) ) call test6
  if( COMPARE_TEST(7) ) call test7
  if( COMPARE_TEST(8) ) call test8
  if( COMPARE_TEST(9) ) call test9
  if( COMPARE_TEST(10)) call test10
  if( COMPARE_TEST(11)) call test11
  indent = indent-1
  call write_indented( 'end subroutine test'//trim(test_number) )
  call write_counters()
end subroutine


end module


program final_support
  use final_support_module
  implicit none

  call run_test(1)
  call write_indented( 'test1 summary:' )
  if( final_return > 0 ) then
    call write_indented( 'rvalue Object() was finalised' )
  endif
  if( final_uninitialized > 0 ) then
    call write_indented( 'Locally scoped object is finalised before assignment' )
  endif
  if( final_return == 0 .and. final_uninitialized == 0 ) then
    call write_indented( 'Behaviour of GNU 6.3.0' )
  endif
  if( final_return == 0 .and. final_uninitialized == 1 ) then
    call write_indented( 'Behaviour of PGI 17.10' )
  endif
  if( final_return == 1 .and. final_uninitialized == 0 ) then
    call write_indented( 'Behaviour of Cray 8.6.2' )
    call write_indented( 'Behaviour of Intel 17-18' )
  endif
#ifdef FINAL_FUNCTION_RESULT
  write(output_unit,'(I0)',advance='no') final_return
#endif
#ifdef FINAL_UNINITIALIZED_LOCAL
  write(output_unit,'(I0)',advance='no') final_uninitialized
#endif

  call run_test(2)
  call write_indented( 'test2 summary:' )
  if( final_uninitialized > 0 ) then
    call write_indented( 'object with intent OUT is finalised before assignment' )
  endif
  if( final_uninitialized == 1 ) then
    call write_indented( 'Behaviour of GNU 6.3.0' )
    call write_indented( 'Behaviour of Intel 17-18' )
  endif
  if( final_uninitialized == 0 ) then
    call write_indented( 'Behaviour of Cray 8.6.2' )
    call write_indented( 'Behaviour of PGI 17.10' )
  endif
#ifdef FINAL_UNINITIALIZED_INTENT_OUT
  write(output_unit,'(I0)',advance='no') final_uninitialized
#endif


  call run_test(3)
  call write_indented( 'test3 summary:' )
  if( final_uninitialized > 0 ) then
    call write_indented('object with intent INOUT is finalised before assignment')
  endif
  if( final_uninitialized == 0 ) then
    call write_indented( 'Behaviour of GNU 6.3.0' )
    call write_indented( 'Behaviour of Cray 8.6.2' )
    call write_indented( 'Behaviour of Intel 17-18' )
    call write_indented( 'Behaviour of PGI 17.1' )
  endif
#ifdef FINAL_UNINITIALIZED_INTENT_INOUT
  write(output_unit,'(I0)',advance='no') final_uninitialized
#endif

  call run_test(4)

  call write_indented( 'test4 summary:' )
  if( final_uninitialized == 0 .and. final_initialized == 2 ) then
    call write_indented( 'Behaviour of GNU 6.3.0' )
  endif

  call run_test(5)

  call write_indented( 'test5 summary:' )
  if( final_uninitialized == 0 .and. final_initialized == 2 ) then
    call write_indented( 'Behaviour of GNU 6.3.0' )
  endif

  call run_test(6)
#ifdef FINAL_NOT_PROPAGATING
  if( final_derived > 0 .and. final_initialized == 0 ) then
    write(output_unit,'(I0)',advance='no') 1
  else
    write(output_unit,'(I0)',advance='no') 0
  endif
#endif

  call run_test(7)
#ifdef FINAL_NOT_INHERITING
  if( final_initialized == 0 ) then
    write(output_unit,'(I0)',advance='no') 1
  else
    write(output_unit,'(I0)',advance='no') 0
  endif
#endif

  call run_test(8)
#ifdef FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
  if( final_initialized /= 0 ) then
    write(output_unit,'(I0)',advance='no') 1
  else
    write(output_unit,'(I0)',advance='no') 0
  endif
#endif

  call run_test(9)
#ifdef FINAL_BROKEN_FOR_AUTOMATIC_ARRAY
  if( final_initialized /= 2 ) then
    write(output_unit,'(I0)',advance='no') 1
  else
    write(output_unit,'(I0)',advance='no') 0
  endif
#endif

 call run_test(10)
 call write_indented( 'test10 summary:' )
 if (final_initialized < 2) then
    call write_indented( 'Array is not completely finalized')
    call write_indented( 'This is a bug in aocc 4.0.0' )
 endif
#ifdef FINAL_NOT_INHERITING_FOR_ALLOCATABLE_ARRAY
  if( final_initialized /= 2 ) then
    write(output_unit,'(I0)',advance='no') 1
  else
    write(output_unit,'(I0)',advance='no') 0
  endif
#endif

 call run_test(11)
 call write_indented( 'test11 summary:' )
 if (final_initialized < 2) then
    call write_indented( 'Array is not completely finalized')
    call write_indented( 'This is a bug in aocc 4.0.0' )
 endif
#ifdef FINAL_NOT_INHERITING_FOR_AUTOMATIC_ARRAY
  if( final_initialized /= 2 ) then
    write(output_unit,'(I0)',advance='no') 1
  else
    write(output_unit,'(I0)',advance='no') 0
  endif
#endif

end program

#include "fckit/fctest.h"

! test fixture for f2c interop
module fcta_tensor_f_fxt

  use fckit_array_module, only: array_view1d

interface


! float tensor C++ checks..
subroutine cxx_check_tensor_float(cptr, esize, erank, layout) bind(c,name="cxx_check_tensor_float")
  use iso_c_binding, only : c_ptr, c_size_t, c_int
  type(c_ptr), value :: cptr
  integer(c_size_t), value :: esize
  integer(c_size_t), value :: erank
  integer(c_int), value :: layout
end subroutine

subroutine cxx_check_tensor_float_layout_r3(cptr, data, data_size) &
  & bind(c,name="cxx_check_tensor_float_layout_rank3")
  use iso_c_binding, only : c_ptr, c_float, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_float), dimension(*) :: data
  integer(c_size_t), intent(in), value :: data_size
end subroutine

subroutine cxx_check_tensor_float_layout_r4(cptr, data, data_size) &
  & bind(c,name="cxx_check_tensor_float_layout_rank4")
  use iso_c_binding, only : c_ptr, c_float, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_float), dimension(*) :: data
  integer(c_size_t), intent(in), value :: data_size
end subroutine

function cxx_create_tensor_float_filled(shape, shape_size, layout) &
  & bind(c,name="cxx_create_tensor_float_filled")
  use iso_c_binding, only : c_ptr, c_int
  integer(c_int), intent(in), dimension(*) :: shape
  integer(c_int), intent(in), value :: shape_size
  integer(c_int), intent(in), value :: layout
  type(c_ptr) :: cxx_create_tensor_float_filled
end function

subroutine cxx_delete_tensor_float(ptr) &
  & bind(c,name="cxx_delete_tensor_float")
  use iso_c_binding, only : c_ptr
  type(c_ptr), intent(in), value :: ptr
end subroutine


! double tensor C++ checks..
subroutine cxx_check_tensor_double(cptr, esize, erank, layout) bind(c,name="cxx_check_tensor_double")
  use iso_c_binding, only : c_ptr, c_size_t, c_int
  type(c_ptr), value :: cptr
  integer(c_size_t), value :: esize
  integer(c_size_t), value :: erank
  integer(c_int), value :: layout
end subroutine

subroutine cxx_check_tensor_double_layout_r3(cptr, data, data_size) &
  & bind(c,name="cxx_check_tensor_double_layout_rank3")
  use iso_c_binding, only : c_ptr, c_double, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_double), dimension(*) :: data
  integer(c_size_t), intent(in), value :: data_size
end subroutine

subroutine cxx_check_tensor_double_layout_r4(cptr, data, data_size) &
  & bind(c,name="cxx_check_tensor_double_layout_rank4")
  use iso_c_binding, only : c_ptr, c_double, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_double), dimension(*) :: data
  integer(c_size_t), intent(in), value :: data_size
end subroutine

function cxx_create_tensor_double_filled(shape, shape_size, layout) &
  & bind(c,name="cxx_create_tensor_double_filled")
  use iso_c_binding, only : c_ptr, c_int
  integer(c_int), intent(in), dimension(*) :: shape
  integer(c_int), intent(in), value :: shape_size
  integer(c_int), intent(in), value :: layout
  type(c_ptr) :: cxx_create_tensor_double_filled
end function

subroutine cxx_delete_tensor_double(ptr) &
  & bind(c,name="cxx_delete_tensor_double")
  use iso_c_binding, only : c_ptr
  type(c_ptr), intent(in), value :: ptr
end subroutine

end interface

contains

! float tensor checks..
subroutine check_tensor_float(cptr, esize, erank, layout)
  use iso_c_binding, only : c_ptr, c_size_t, c_int
  type(c_ptr) :: cptr
  integer(c_size_t) :: esize
  integer(c_size_t) :: erank
  integer(c_int) :: layout
  call cxx_check_tensor_float(cptr, esize, erank, layout)
end subroutine

subroutine check_tensor_float_layout_r3(cptr, data)
  use iso_c_binding, only : c_ptr, c_float, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_float), intent(in) :: data(:,:,:)
  real(c_float), pointer :: data_vec(:)
  integer(c_size_t)  :: shape_vec(3)
  integer(c_size_t)  :: data_rank
  integer(c_size_t)  :: data_size 
  data_vec => array_view1d( data )
  shape_vec = shape(data)
  data_rank = size(shape_vec)
  data_size = size(data)
  call cxx_check_tensor_float_layout_r3(cptr, data_vec, data_size )
end subroutine

subroutine check_tensor_float_layout_r4(cptr, data)
  use iso_c_binding, only : c_ptr, c_float, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_float), intent(in) :: data(:,:,:,:)
  real(c_float), pointer :: data_vec(:)
  integer(c_size_t)  :: shape_vec(4)
  integer(c_size_t)  :: data_rank
  integer(c_size_t)  :: data_size
  data_vec => array_view1d( data )
  shape_vec = shape(data)
  data_rank = size(shape_vec)
  data_size = size(data)
  call cxx_check_tensor_float_layout_r4(cptr, data_vec, data_size )
end subroutine

function create_tensor_float_filled(shape, shape_size, layout)
  use iso_c_binding, only : c_ptr, c_int
  integer(c_int), intent(in), dimension(*) :: shape
  integer(c_int), intent(in), value :: shape_size
  integer(c_int), intent(in), value :: layout
  type(c_ptr) :: create_tensor_float_filled
  create_tensor_float_filled = cxx_create_tensor_float_filled(shape, shape_size, layout)
end function

subroutine delete_tensor_float(ptr)
  use iso_c_binding, only : c_ptr
  type(c_ptr), intent(in) :: ptr
  call cxx_delete_tensor_float(ptr)
end subroutine


! double tensor checks..
subroutine check_tensor_double(cptr, esize, erank, layout)
  use iso_c_binding, only : c_ptr, c_size_t, c_int
  type(c_ptr) :: cptr
  integer(c_size_t) :: esize
  integer(c_size_t) :: erank
  integer(c_int) :: layout
  call cxx_check_tensor_double(cptr, esize, erank, layout)
end subroutine

subroutine check_tensor_double_layout_r3(cptr, data)
  use iso_c_binding, only : c_ptr, c_double, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_double), intent(in) :: data(:,:,:)
  real(c_double), pointer :: data_vec(:)
  integer(c_size_t)  :: shape_vec(3)
  integer(c_size_t)  :: data_rank
  integer(c_size_t)  :: data_size
  data_vec => array_view1d( data )
  shape_vec = shape(data)
  data_rank = size(shape_vec)
  data_size = size(data)
  call cxx_check_tensor_double_layout_r3(cptr, data_vec, data_size )
end subroutine

subroutine check_tensor_double_layout_r4(cptr, data)
  use iso_c_binding, only : c_ptr, c_double, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_double), intent(in) :: data(:,:,:,:)
  real(c_double), pointer :: data_vec(:)
  integer(c_size_t)  :: shape_vec(4)
  integer(c_size_t)  :: data_rank
  integer(c_size_t)  :: data_size 
  data_vec => array_view1d( data )
  shape_vec = shape(data)
  data_rank = size(shape_vec)
  data_size = size(data)
  call cxx_check_tensor_double_layout_r4(cptr, data_vec, data_size )
end subroutine

function create_tensor_double_filled(shape, shape_size, layout)
  use iso_c_binding, only : c_ptr, c_int
  integer(c_int), intent(in), dimension(*) :: shape
  integer(c_int), intent(in), value :: shape_size
  integer(c_int), intent(in), value :: layout
  type(c_ptr) :: create_tensor_double_filled
  create_tensor_double_filled = cxx_create_tensor_double_filled(shape, shape_size, layout)
end function

subroutine delete_tensor_double(ptr)
  use iso_c_binding, only : c_ptr
  type(c_ptr), intent(in) :: ptr
  call cxx_delete_tensor_double(ptr)
end subroutine


end module fcta_tensor_f_fxt

! -----------------------------------------------------------------------------

TESTSUITE_WITH_FIXTURE(fctest_test_tensor_suite, fcta_tensor_f_fxt)

! -----------------------------------------------------------------------------

TESTSUITE_INIT
  use fckit_module
  call fckit_main%init()
END_TESTSUITE_INIT

! -----------------------------------------------------------------------------

TESTSUITE_FINALIZE
  use fckit_module
  call fckit_main%final()
END_TESTSUITE_FINALIZE

! -----------------------------------------------------------------------------


! ============= TensorFloat tests =============
TEST( test_float_tensor_creation )
#if 1

use iso_c_binding, only : c_float, c_size_t
use fckit_tensor_module, only : fckit_tensor_real32

type(fckit_tensor_real32) :: tensor_empty
type(fckit_tensor_real32) :: tensor_from_shape
type(fckit_tensor_real32) :: tensor_rank1
type(fckit_tensor_real32) :: tensor_rank2
type(fckit_tensor_real32) :: tensor_rank3
type(fckit_tensor_real32) :: tensor_rank4

integer(c_size_t)  :: shape(4) = (/ 4,2,3,4 /)
real(c_float)   :: data_rank1(10) = 0.0
real(c_float)   :: data_rank2(3,4)
real(c_float)   :: data_rank3(3,3,3)
real(c_float)   :: data_rank4(2,3,4,5)

integer(c_size_t) :: tensor_size
integer(c_size_t) :: rank
integer(c_size_t), allocatable :: tensor_shape(:)

! an empty tensor
tensor_empty = fckit_tensor_real32()

! a tensor from shape
tensor_from_shape = fckit_tensor_real32(shape)

! a tensor from an array
tensor_rank1 = fckit_tensor_real32(data_rank1)

! a tensor from an array rank 2
data_rank2(1,:) = 0.0
data_rank2(2,:) = 1.0
data_rank2(3,:) = 2.0
tensor_rank2 = fckit_tensor_real32(data_rank2)

! a tensor from an array rank 3
data_rank3 = 0.0
tensor_rank3 = fckit_tensor_real32(data_rank3)

! a tensor from an array rank 4
data_rank4 = 0.0
tensor_rank4 = fckit_tensor_real32(data_rank4)


! check rank1 - tensor size/shape
tensor_size = tensor_rank1%size()
rank = tensor_rank1%rank()
tensor_shape = tensor_rank1%shape()
FCTEST_CHECK_EQUAL( tensor_size , 10 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 1 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 10 )
deallocate(tensor_shape)

! check rank2 - tensor size/shape
tensor_size = tensor_rank2%size()
rank = tensor_rank2%rank()
tensor_shape = tensor_rank2%shape()
FCTEST_CHECK_EQUAL( tensor_size , 3*4 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 2 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(2) , 4 )
deallocate(tensor_shape)

! check rank3 - tensor size/shape
tensor_size = tensor_rank3%size()
rank = tensor_rank3%rank()
tensor_shape = tensor_rank3%shape()
FCTEST_CHECK_EQUAL( tensor_size , 3*3*3 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(2) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(3) , 3 )
deallocate(tensor_shape)

! check rank4 - tensor size/shape
tensor_size = tensor_rank4%size()
rank = tensor_rank3%rank()
tensor_shape = tensor_rank4%shape()
FCTEST_CHECK_EQUAL( tensor_size , 2*3*4*5 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 4 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 2 )
FCTEST_CHECK_EQUAL( tensor_shape(2) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(3) , 4 )
FCTEST_CHECK_EQUAL( tensor_shape(4) , 5 )
deallocate(tensor_shape)


! finalise
call tensor_empty%final()
call tensor_from_shape%final()
call tensor_rank1%final()
call tensor_rank2%final()
call tensor_rank3%final()
call tensor_rank4%final()


#else
#warning Test "test_float_tensor_creation" disabled
#endif
END_TEST



TEST( test_tensor_float_interop )
#if 1

use iso_c_binding, only : c_float, c_size_t
use fckit_tensor_module, only : fckit_tensor_real32, fckit_tensor

type(fckit_tensor_real32) :: tensor_r3
type(fckit_tensor_real32) :: tensor_r4
real(c_float) :: data_r3(3,3,3)
real(c_float) :: data_r4(2,4,5,6)
integer(c_size_t) :: expected_size
integer(c_size_t) :: expected_rank

integer(c_int) :: expected_layout

! ---------------------- rank 3
data_r3(1,:,:) = 0.04
data_r3(2,:,:) = 1.04
data_r3(3,:,:) = 2.04
tensor_r3 = fckit_tensor_real32(data_r3, fckit_tensor%layout_rowmajor())

expected_size = 3*3*3
expected_rank = 3
expected_layout = fckit_tensor%layout_rowmajor()

! check tensor info from c++
call check_tensor_float(tensor_r3%c_ptr(), expected_size, expected_rank, expected_layout)

! check internal data.. 
call check_tensor_float_layout_r3(tensor_r3%c_ptr(), data_r3)


! ---------------------- rank 4
data_r4(1,:,:,:) = 1.14
data_r4(2,:,:,:) = 2.24
data_r4(:,:,:,6) = 3.34
tensor_r4 = fckit_tensor_real32(data_r4) ! layout is colmajor (by default)

expected_size = 2*4*5*6
expected_rank = 4
expected_layout = fckit_tensor%layout_colmajor()

! check tensor info from c++
call check_tensor_float(tensor_r4%c_ptr(), expected_size, expected_rank, expected_layout)

! check internal data.. 
call check_tensor_float_layout_r4(tensor_r4%c_ptr(), data_r4)


#else
#warning Test "test_tensor_float_interop" disabled
#endif
END_TEST
  

TEST ( test_tensor_float_creation_from_cpp )
#if 1

use iso_c_binding, only : c_ptr, c_int, c_size_t
use fckit_tensor_module, only : fckit_tensor_real32, fckit_tensor

type(fckit_tensor_real32) :: tensor

integer(c_int) :: tensor_shape_input(4) = (/ 4,2,3,4 /)
integer(c_size_t), allocatable :: tensor_shape(:)
integer(c_size_t) :: expected_size = 4*2*3*4
integer(c_size_t) :: expected_rank = 4
integer(c_size_t) :: expected_shape(4) = (/ 4,2,3,4 /)

call tensor%reset_c_ptr(create_tensor_float_filled(tensor_shape_input, size(tensor_shape_input), fckit_tensor%layout_colmajor()))

FCTEST_CHECK_EQUAL( tensor%size(), expected_size )
FCTEST_CHECK_EQUAL( tensor%rank(), expected_rank )

tensor_shape = tensor%shape()

FCTEST_CHECK_EQUAL( tensor_shape(1), expected_shape(1) )
FCTEST_CHECK_EQUAL( tensor_shape(2), expected_shape(2) )
FCTEST_CHECK_EQUAL( tensor_shape(3), expected_shape(3) )
FCTEST_CHECK_EQUAL( tensor_shape(4), expected_shape(4) )

FCTEST_CHECK_EQUAL( tensor%layout(), fckit_tensor%layout_colmajor() )

! deallocation
deallocate(tensor_shape)
call delete_tensor_float(tensor%c_ptr())

#else
#warning Test "test_tensor_float_creation_from_cpp" disabled
#endif
END_TEST


! ============= TensorDouble tests =============
TEST( test_double_tensor_creation )
#if 1

use iso_c_binding, only : c_double, c_size_t
use fckit_tensor_module, only : fckit_tensor_real64

type(fckit_tensor_real64) :: tensor_empty
type(fckit_tensor_real64) :: tensor_from_shape
type(fckit_tensor_real64) :: tensor_rank1
type(fckit_tensor_real64) :: tensor_rank2
type(fckit_tensor_real64) :: tensor_rank3
type(fckit_tensor_real64) :: tensor_rank4

integer(c_size_t)  :: shape(4) = (/ 4,2,3,4 /)
real(c_double)   :: data_rank1(10) = 0.0
real(c_double)   :: data_rank2(3,4)
real(c_double)   :: data_rank3(3,3,3)
real(c_double)   :: data_rank4(2,3,4,5)

integer(c_size_t) :: tensor_size
integer(c_size_t) :: rank
integer(c_size_t), allocatable :: tensor_shape(:)

! an empty tensor
tensor_empty = fckit_tensor_real64()

! a tensor from shape
tensor_from_shape = fckit_tensor_real64(shape)

! a tensor from an array
tensor_rank1 = fckit_tensor_real64(data_rank1)

! a tensor from an array rank 2
data_rank2(1,:) = 0.06
data_rank2(2,:) = 1.06
data_rank2(3,:) = 2.06
tensor_rank2 = fckit_tensor_real64(data_rank2)

! a tensor from an array rank 3
data_rank3 = 0.0
tensor_rank3 = fckit_tensor_real64(data_rank3)

! a tensor from an array rank 4
data_rank4 = 0.0
tensor_rank4 = fckit_tensor_real64(data_rank4)


! check rank1 - tensor size/shape
tensor_size = tensor_rank1%size()
rank = tensor_rank1%rank()
tensor_shape = tensor_rank1%shape()
FCTEST_CHECK_EQUAL( tensor_size , 10 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 1 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 10 )
deallocate(tensor_shape)

! check rank2 - tensor size/shape
tensor_size = tensor_rank2%size()
rank = tensor_rank2%rank()
tensor_shape = tensor_rank2%shape()
FCTEST_CHECK_EQUAL( tensor_size , 3*4 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 2 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(2) , 4 )
deallocate(tensor_shape)

! check rank3 - tensor size/shape
tensor_size = tensor_rank3%size()
rank = tensor_rank3%rank()
tensor_shape = tensor_rank3%shape()
FCTEST_CHECK_EQUAL( tensor_size , 3*3*3 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(2) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(3) , 3 )
deallocate(tensor_shape)

! check rank4 - tensor size/shape
tensor_size = tensor_rank4%size()
rank = tensor_rank3%rank()
! allocate(tensor_shape(rank))
tensor_shape = tensor_rank4%shape()
FCTEST_CHECK_EQUAL( tensor_size , 2*3*4*5 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 4 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 2 )
FCTEST_CHECK_EQUAL( tensor_shape(2) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(3) , 4 )
FCTEST_CHECK_EQUAL( tensor_shape(4) , 5 )
deallocate(tensor_shape)


! finalise
call tensor_empty%final()
call tensor_from_shape%final()
call tensor_rank1%final()
call tensor_rank2%final()
call tensor_rank3%final()
call tensor_rank4%final()


#else
#warning Test "test_double_tensor_creation" disabled
#endif
END_TEST



TEST( test_tensor_double_interop )
#if 1

use iso_c_binding, only : c_double, c_size_t
use fckit_tensor_module, only : fckit_tensor_real64, fckit_tensor

type(fckit_tensor_real64) :: tensor_r3
type(fckit_tensor_real64) :: tensor_r4
real(c_double) :: data_r3(3,3,3)
real(c_double) :: data_r4(2,4,5,6)

integer(c_size_t) :: expected_size
integer(c_size_t) :: expected_rank
integer(c_int) :: expected_layout

! ---------------------- rank 3
data_r3(1,:,:) = 0.06
data_r3(2,:,:) = 1.06
data_r3(3,:,:) = 2.06
tensor_r3 = fckit_tensor_real64(data_r3, fckit_tensor%layout_rowmajor())

expected_size = 3*3*3
expected_rank = 3
expected_layout = fckit_tensor%layout_rowmajor()

! check tensor info from c++
call check_tensor_double(tensor_r3%c_ptr(), expected_size, expected_rank, expected_layout)

! check internal data.. 
call check_tensor_double_layout_r3(tensor_r3%c_ptr(), data_r3)


! ---------------------- rank 4
data_r4(1,:,:,:) = 1.16
data_r4(2,:,:,:) = 2.26
data_r4(:,:,:,6) = 3.36
tensor_r4 = fckit_tensor_real64(data_r4)  ! layout is colmajor (by default)

expected_size = 2*4*5*6
expected_rank = 4
expected_layout = fckit_tensor%layout_colmajor()

! check tensor info from c++
call check_tensor_double(tensor_r4%c_ptr(), expected_size, expected_rank, expected_layout)

! check internal data.. 
call check_tensor_double_layout_r4(tensor_r4%c_ptr(), data_r4)


#else
#warning Test "test_tensor_double_interop" disabled
#endif
END_TEST



TEST ( test_tensor_double_creation_from_cpp )
#if 1

use iso_c_binding, only : c_ptr, c_int, c_size_t
use fckit_tensor_module, only : fckit_tensor_real64, fckit_tensor

type(fckit_tensor_real64) :: tensor

integer(c_int) :: tensor_shape_input(4) = (/ 4,2,3,4 /)
integer(c_size_t), allocatable :: tensor_shape(:)
integer(c_size_t) :: expected_size = 4*2*3*4
integer(c_size_t) :: expected_rank = 4
integer(c_size_t) :: expected_shape(4) = (/ 4,2,3,4 /)

call tensor%reset_c_ptr(create_tensor_double_filled(tensor_shape_input, size(tensor_shape_input), fckit_tensor%layout_colmajor()))

FCTEST_CHECK_EQUAL( tensor%size(), expected_size )
FCTEST_CHECK_EQUAL( tensor%rank(), expected_rank )


tensor_shape = tensor%shape()

FCTEST_CHECK_EQUAL( tensor_shape(1), expected_shape(1) )
FCTEST_CHECK_EQUAL( tensor_shape(2), expected_shape(2) )
FCTEST_CHECK_EQUAL( tensor_shape(3), expected_shape(3) )
FCTEST_CHECK_EQUAL( tensor_shape(4), expected_shape(4) )

FCTEST_CHECK_EQUAL( tensor%layout(), fckit_tensor%layout_colmajor() )

! deallocation
deallocate(tensor_shape)
call delete_tensor_double(tensor%c_ptr())

#else
#warning Test "test_tensor_double_creation_from_cpp" disabled
#endif
END_TEST


END_TESTSUITE

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fctest.h"

! -----------------------------------------------------------------------------

TESTSUITE(fctest_fckit_configuration_fails)

! -----------------------------------------------------------------------------

TESTSUITE_INIT
  use fckit_module
  call fckit_main%init()

  ! With Apple Silicon (M1), using Apple clang 12.0.0 for C++ and Homebrew GCC 10.2.0_4 for Fortran
  ! it appears that the Fortran needs to trap the C++ exceptions via SIGTRAP
  call fckit_signal%set_handler( fckit_signal%SIGTRAP() )
  call fckit_signal%set_handler( fckit_signal%SIGBUS() )
END_TESTSUITE_INIT

! -----------------------------------------------------------------------------

TESTSUITE_FINALIZE
  use fckit_module
  call fckit_main%final()
END_TESTSUITE_FINALIZE

! -----------------------------------------------------------------------------

TEST(test_throw)
!! ENABLE TO TEST IF THROW WILL WORK
#if 1
  use fckit_configuration_module
  type(fckit_Configuration) :: config

  integer :: missing_value

  write(0,*) "~~~~~~~~~~~~~~ SCOPE BEGIN ~~~~~~~~~~~~~~~"

  config = fckit_Configuration()

  call config%get_or_die("missing",missing_value)

  call config%final()
  write(0,*) "~~~~~~~~~~~~~~~ SCOPE END ~~~~~~~~~~~~~~~~"
#endif
END_TEST
! -----------------------------------------------------------------------------

END_TESTSUITE

#include "fckit/fckit.h"

module fckit_tensor_module

use iso_c_binding, only : c_int, &
                          c_ptr, &
                          c_size_t, &
                          c_float, &
                          c_double, &
                          c_f_pointer

use fckit_array_module, only: array_view1d
use fckit_c_interop_module, only : c_ptr_free
use fckit_shared_object_module, only : fckit_shared_object, &
                                       fckit_c_deleter, &
                                       fckit_c_nodeleter

implicit none

public :: fckit_tensor_real32
public :: fckit_tensor_real64

private

#include "fckit_tensor.inc"



! ======================================================
!                   fckit_tensor_real32
! ======================================================
type, extends(fckit_shared_object) :: fckit_tensor_real32
contains
  procedure         :: size     => fckit_tensor_real32__size
  procedure         :: rank     => fckit_tensor_real32__rank
  procedure         :: shape    => fckit_tensor_real32__shape
  procedure         :: fill     => fckit_tensor_real32__fill
  procedure         :: zero     => fckit_tensor_real32__zero
  procedure         :: layout   => fckit_tensor_real32__layout

  ! tensor layouts
  procedure, nopass :: layout_right    => fckit_tensor_layout_right
  procedure, nopass :: layout_left     => fckit_tensor_layout_left
  procedure, nopass :: layout_rowmajor => fckit_tensor_layout_rowmajor
  procedure, nopass :: layout_colmajor => fckit_tensor_layout_colmajor

#if FCKIT_FINAL_NOT_INHERITING
  final :: fckit_tensor_real32__final_auto
#endif
end type fckit_tensor_real32


! ======================================================
!                  fckit_tensor_real64
! ======================================================
type, extends(fckit_shared_object) :: fckit_tensor_real64
contains
  procedure         :: size     => fckit_tensor_real64__size
  procedure         :: rank     => fckit_tensor_real64__rank
  procedure         :: shape    => fckit_tensor_real64__shape
  procedure         :: fill     => fckit_tensor_real64__fill
  procedure         :: zero     => fckit_tensor_real64__zero
  procedure         :: layout   => fckit_tensor_real64__layout

  ! tensor layouts
  procedure, nopass :: layout_right    => fckit_tensor_layout_right
  procedure, nopass :: layout_left     => fckit_tensor_layout_left
  procedure, nopass :: layout_rowmajor => fckit_tensor_layout_rowmajor
  procedure, nopass :: layout_colmajor => fckit_tensor_layout_colmajor

#if FCKIT_FINAL_NOT_INHERITING
  final :: fckit_tensor_real64__final_auto
#endif
end type fckit_tensor_real64


interface fckit_tensor_real32
  module procedure ctor_float_empty
  module procedure ctor_float_from_cptr
  module procedure ctor_float_from_shape
  module procedure ctor_from_float_array_rank1
  module procedure ctor_from_float_array_rank2
  module procedure ctor_from_float_array_rank3
  module procedure ctor_from_float_array_rank4
end interface


interface fckit_tensor_real64
  module procedure ctor_double_empty
  module procedure ctor_double_from_cptr
  module procedure ctor_double_from_shape
  module procedure ctor_from_double_array_rank1
  module procedure ctor_from_double_array_rank2
  module procedure ctor_from_double_array_rank3
  module procedure ctor_from_double_array_rank4
end interface


! used to access layout "nopass" methods
type(fckit_tensor_real32) :: fckit_tensor

public :: fckit_tensor

private :: c_int, c_ptr, c_size_t, c_float, c_double, c_f_pointer
private :: fckit_shared_object
private :: fckit_c_deleter
private :: fckit_c_nodeleter

contains


! --- tensor layouts ---
function fckit_tensor_layout_right() result(code)
  integer(c_int) :: code
  code = c_fckit_tensor_layout_right()
end function

function fckit_tensor_layout_left() result(code)
  integer(c_int) :: code
  code = c_fckit_tensor_layout_left()
end function

function fckit_tensor_layout_rowmajor() result(code)
  integer(c_int) :: code
  code = c_fckit_tensor_layout_rowmajor()
end function

function fckit_tensor_layout_colmajor() result(code)
  integer(c_int) :: code
  code = c_fckit_tensor_layout_colmajor()
end function



! ctor's
function ctor_float_empty(layout) result(this)
  type(fckit_tensor_real32) :: this
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  type(c_ptr) :: obj

  if (present(layout)) layout_actual = layout

  obj = c_fckit_tensor_real32_empty_new(layout_actual)
  call this%reset_c_ptr( obj, fckit_c_deleter(c_fckit_tensor_real32_delete) )
  call this%return() 
end function

function ctor_float_from_cptr(cptr, own) result(this)
  type(c_ptr), value :: cptr
  type(fckit_tensor_real32) :: this
  logical, optional :: own
  logical :: opt_own
  opt_own = .false.
  if( present(own) ) opt_own = own
  if( opt_own ) then
    call this%reset_c_ptr( cptr, fckit_c_deleter(c_fckit_tensor_real32_delete) )
  else
    call this%reset_c_ptr( cptr, fckit_c_nodeleter() )
  endif
  call this%return()
end function


function ctor_float_from_shape(shape, layout) result(this)
  type(fckit_tensor_real32) :: this
  integer(c_size_t),  intent(in) :: shape(:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  rank = size(shape)
  call this%reset_c_ptr( c_fckit_tensor_real32_from_shape_new(rank, shape, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real32_delete) )
  call this%return()
end function


function ctor_from_float_array_rank1(tensor, layout) result(this)
  type(fckit_tensor_real32) :: this
  real(c_float), intent(in) :: tensor(:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_float), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(1)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real32_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real32_delete) )
  call this%return()  
end function


function ctor_from_float_array_rank2(tensor, layout) result(this)
  type(fckit_tensor_real32) :: this
  real(c_float), intent(in) :: tensor(:,:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_float), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(2)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real32_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real32_delete) )
  call this%return()  
end function

function ctor_from_float_array_rank3(tensor, layout) result(this)
  type(fckit_tensor_real32) :: this
  real(c_float), intent(in) :: tensor(:,:,:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_float), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(3)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real32_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real32_delete) )
  call this%return()  
end function


function ctor_from_float_array_rank4(tensor, layout) result(this)
  type(fckit_tensor_real32) :: this
  real(c_float), intent(in) :: tensor(:,:,:,:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_float), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(4)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real32_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real32_delete) )
  call this%return()  
end function
  

! number of elements
function fckit_tensor_real32__size(this) result(val)
  class(fckit_tensor_real32), intent(in) :: this
  integer(c_size_t) :: val
  val = c_fckit_tensor_real32_size(this%c_ptr())
end function


! number of elements
function fckit_tensor_real32__rank(this) result(val)
  class(fckit_tensor_real32), intent(in) :: this
  integer(c_size_t) :: val
  val = c_fckit_tensor_real32_rank(this%c_ptr())
end function


! shape of the tensor
function fckit_tensor_real32__shape(this) result(shape_array)
  class(fckit_tensor_real32), intent(in)  :: this
  integer(c_size_t),   allocatable :: shape_array(:)
  integer(c_size_t),   pointer     :: shape_fptr(:)
  type(c_ptr)                      :: shape_cptr
  integer(c_size_t)                :: rank
  ! get shape and shape-size
  call c_fckit_tensor_real32_shape(this%c_ptr(), shape_cptr, rank)
  call c_f_pointer(shape_cptr, shape_fptr, (/rank/))
  allocate(shape_array(rank))
  shape_array(:) = shape_fptr(:)
  call c_ptr_free(shape_cptr)
end function

! fill it in with value
subroutine fckit_tensor_real32__fill(this, val)
  class(fckit_tensor_real32), intent(inout) :: this
  real(c_float), intent(in) :: val
  call c_fckit_tensor_real32_fill(this%c_ptr(), val)
end subroutine

! fill it in with "0"s
subroutine fckit_tensor_real32__zero(this)
  class(fckit_tensor_real32), intent(inout) :: this
  call c_fckit_tensor_real32_zero(this%c_ptr())
end subroutine

! tensor layout
function fckit_tensor_real32__layout(this) result(val)
  class(fckit_tensor_real32), intent(in) :: this
  integer(c_int) :: val
  val = c_fckit_tensor_real32_layout(this%c_ptr())
end function



#if FCKIT_FINAL_NOT_INHERITING
FCKIT_FINAL subroutine fckit_tensor_real32__final_auto(this)
  type(fckit_tensor_real32), intent(inout) :: this
#if FCKIT_FINAL_DEBUGGING
  write(0,*) "fckit_tensor_real32__final_auto"
#endif
#if FCKIT_FINAL_NOT_PROPAGATING
  call this%final()
#endif
  FCKIT_SUPPRESS_UNUSED( this )
end subroutine
#endif



! ======================================================
!                  fckit_tensor_real64
! ======================================================

! ctor's
function ctor_double_empty(layout) result(this)
  type(fckit_tensor_real64) :: this
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  type(c_ptr) :: obj

  if (present(layout)) layout_actual = layout
  obj = c_fckit_tensor_real64_empty_new(layout_actual)

  call this%reset_c_ptr( obj, fckit_c_deleter(c_fckit_tensor_real64_delete) )
  call this%return() 
end function


function ctor_double_from_cptr(cptr, own) result(this)
  type(c_ptr), value :: cptr
  type(fckit_tensor_real64) :: this
  logical, optional :: own
  logical :: opt_own
  opt_own = .false.
  if( present(own) ) opt_own = own
  if( opt_own ) then
    call this%reset_c_ptr( cptr, fckit_c_deleter(c_fckit_tensor_real64_delete) )
  else
    call this%reset_c_ptr( cptr, fckit_c_nodeleter() )
  endif
  call this%return()
end function


function ctor_double_from_shape(shape, layout) result(this)
  type(fckit_tensor_real64) :: this
  integer(c_size_t),  intent(in) :: shape(:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  integer(c_size_t)     :: rank

  if (present(layout)) layout_actual = layout
  rank = size(shape)
  call this%reset_c_ptr( c_fckit_tensor_real64_from_shape_new(rank, shape, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real64_delete) )
  call this%return()
end function


function ctor_from_double_array_rank1(tensor, layout) result(this)
  type(fckit_tensor_real64) :: this
  real(c_double), intent(in) :: tensor(:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_double), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(1)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real64_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real64_delete) )
  call this%return()  
end function


function ctor_from_double_array_rank2(tensor, layout) result(this)
  type(fckit_tensor_real64) :: this
  real(c_double), intent(in) :: tensor(:,:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_double), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(2)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real64_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real64_delete) )
  call this%return()  
end function

function ctor_from_double_array_rank3(tensor, layout) result(this)
  type(fckit_tensor_real64) :: this
  real(c_double), intent(in) :: tensor(:,:,:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_double), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(3)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real64_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real64_delete) )
  call this%return()  
end function


function ctor_from_double_array_rank4(tensor, layout) result(this)
  type(fckit_tensor_real64) :: this
  real(c_double), intent(in) :: tensor(:,:,:,:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_double), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(4)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real64_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real64_delete) )
  call this%return()  
end function
  

! number of elements
function fckit_tensor_real64__size(this) result(val)
  class(fckit_tensor_real64), intent(in) :: this
  integer(c_size_t) :: val
  val = c_fckit_tensor_real64_size(this%c_ptr())
end function

! number of elements
function fckit_tensor_real64__rank(this) result(val)
  class(fckit_tensor_real64), intent(in) :: this
  integer(c_size_t) :: val
  val = c_fckit_tensor_real64_rank(this%c_ptr())
end function

! shape of the tensor
function fckit_tensor_real64__shape(this) result(shape_array)
  class(fckit_tensor_real64), intent(in)  :: this
  integer(c_size_t),   allocatable :: shape_array(:)
  integer(c_size_t),   pointer     :: shape_fptr(:)
  type(c_ptr)                      :: shape_cptr
  integer(c_size_t)                :: rank
  ! get shape and shape-size
  call c_fckit_tensor_real64_shape(this%c_ptr(), shape_cptr, rank)
  call c_f_pointer(shape_cptr, shape_fptr, (/rank/))
  allocate(shape_array(rank))
  shape_array(:) = shape_fptr(:)
  call c_ptr_free(shape_cptr)
end function

! fill it in with value
subroutine fckit_tensor_real64__fill(this, val)
  class(fckit_tensor_real64), intent(inout) :: this
  real(c_double), intent(in) :: val
  call c_fckit_tensor_real64_fill(this%c_ptr(), val)
end subroutine

! fill it in with "0"s
subroutine fckit_tensor_real64__zero(this)
  class(fckit_tensor_real64), intent(inout) :: this
  call c_fckit_tensor_real64_zero(this%c_ptr())
end subroutine

! is right-layout tensor? 
function fckit_tensor_real64__layout(this) result(val)
  class(fckit_tensor_real64), intent(in) :: this
  integer(c_int) :: val
  val = c_fckit_tensor_real64_layout(this%c_ptr())
end function



#if FCKIT_FINAL_NOT_INHERITING
FCKIT_FINAL subroutine fckit_tensor_real64__final_auto(this)
  type(fckit_tensor_real64), intent(inout) :: this
#if FCKIT_FINAL_DEBUGGING
  write(0,*) "fckit_tensor_real64__final_auto"
#endif
#if FCKIT_FINAL_NOT_PROPAGATING
  call this%final()
#endif
  FCKIT_SUPPRESS_UNUSED( this )
end subroutine
#endif

end module fckit_tensor_module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

#if FCKIT_FINAL_DEBUGGING
#define FCKIT_WRITE_LOC if (fckit_mpi%rank() == 0 ) write(0,'(A,I0,A)',advance='NO') "fckit_owned_object.F90 @ ",__LINE__,'  : '
#define FCKIT_WRITE(unit,format) if (fckit_mpi%rank() == 0 ) write(unit,format)
#else
#define FCKIT_WRITE_LOC
#endif
#define FCKIT_WRITE_DEBUG if(.false.)write(0,*)

module fckit_owned_object_module
use, intrinsic :: iso_c_binding, only: c_ptr, c_funptr, c_null_ptr, c_null_funptr, c_int32_t
#if FCKIT_FINAL_DEBUGGING
use fckit_c_interop_module, only : c_ptr_to_loc
use fckit_mpi_module, only : fckit_mpi
#endif
implicit none
private

!========================================================================
! Public interface

public fckit_owned_object

!========================================================================

type :: fckit_owned_object
  !! Abstract base class for objects that wrap a C++ object

#if !PGIBUG_ATLAS_197
  type(c_ptr), private :: cpp_object_ptr = c_null_ptr
#else
  type(c_ptr), public :: cpp_object_ptr = c_null_ptr
#endif
  type(c_funptr), private :: deleter = c_null_funptr
    !! Internal C pointer

  logical, private :: return_value = .false.

contains

  procedure, public :: is_null
    !! Check if internal C pointer is set

#if !PGIBUG_ATLAS_197_DEBUG
  procedure, public :: c_ptr   => fckit_owned_object__c_ptr
    !! Access to internal C pointer
#endif

  procedure, public :: reset_c_ptr
    !! Nullify internal C pointer

  procedure, private :: equal
    !! Compare two object C pointers

  procedure, private :: not_equal
    !! Compare two object C pointers

  generic, public :: operator(==) => equal
    !! Compare two objects internal C pointer

  generic, public :: operator(/=) => not_equal
    !! Compare two objects internal C pointer

  ! Following line is to avoid PGI compiler bug
  procedure, private :: fckit_owned_object__c_ptr

  procedure, public :: final => fckit_owned_object__final

#if FCKIT_HAVE_FINAL
  final :: fckit_owned_object__final_auto
#endif

  procedure, private :: fckit_owned_object_assignment_operator
  generic, public :: assignment(=) => fckit_owned_object_assignment_operator
  procedure, public :: owners
  procedure, public :: attach
  procedure, public :: detach
  procedure, public :: return
  procedure, public :: assignment_operator_hook

  procedure, public :: consumed
end type

!========================================================================

private :: c_ptr
private :: c_null_ptr
private :: c_funptr
private :: c_null_funptr
private :: c_int32_t

!========================================================================

interface

  subroutine fckit__delete_Owned(this) bind(c,name="fckit__delete_Owned")
    use, intrinsic :: iso_c_binding, only: c_ptr
    type(c_ptr), value :: this
  end subroutine

  function fckit__Owned__owners(this) bind(c,name="fckit__Owned__owners")
    use, intrinsic :: iso_c_binding, only: c_int32_t, c_ptr
    integer(c_int32_t) :: fckit__Owned__owners
    type(c_ptr), value :: this
  end function

  subroutine fckit__Owned__attach(this) bind(c,name="fckit__Owned__attach")
    use, intrinsic :: iso_c_binding, only: c_ptr
    type(c_ptr), value :: this
  end subroutine

  subroutine fckit__Owned__detach(this) bind(c,name="fckit__Owned__detach")
    use, intrinsic :: iso_c_binding, only: c_ptr
    type(c_ptr), value :: this
  end subroutine

end interface

!========================================================================
CONTAINS
!========================================================================

FCKIT_FINAL subroutine fckit_owned_object__final_auto(this)
#ifdef _CRAYFTN
  use, intrinsic :: iso_c_binding, only : c_loc, c_null_ptr
#endif
  type(fckit_owned_object), intent(inout) :: this
#ifdef _CRAYFTN
  ! Guard necessary for Cray compiler...
  ! ... when "this" has already been deallocated, and then
  ! fckit_owned_object__final_auto is called...
  if( c_loc(this) == c_null_ptr ) then
    return
  endif
#endif
#if FCKIT_FINAL_DEBUGGING
  FCKIT_WRITE_LOC
  FCKIT_WRITE(0,'(A,I0)') "BEGIN fckit_owned_object__final_auto    address: ", &
    & c_ptr_to_loc(this%cpp_object_ptr)
#endif

if (.not. this%return_value) then
  if (.not. this%is_null()) then
#if FCKIT_FINAL_DEBUGGING
  FCKIT_WRITE_LOC
  FCKIT_WRITE(0,'(A,I0)') "this%final() address:",c_ptr_to_loc(this%cpp_object_ptr)
#endif
    call this%final()
  endif
else
#if FCKIT_FINAL_DEBUGGING
    FCKIT_WRITE_LOC
    FCKIT_WRITE(0,'(A,A)') "Applying return-value-optimisation during assignment_operator, ", &
      & "this%final not called"
#endif
endif
#if FCKIT_FINAL_DEBUGGING
  FCKIT_WRITE_LOC
  FCKIT_WRITE(0,'(A,I0)') "END fckit_owned_object__final_auto    address:",  &
    &c_ptr_to_loc(this%cpp_object_ptr)
#endif
end subroutine

subroutine fckit_owned_object__delete( this )
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funptr, c_f_procpointer, c_associated, c_null_ptr
  use fckit_c_interop_module, only : fckit_c_deleter_interface
  class(fckit_owned_object), intent(inout) :: this
  procedure(fckit_c_deleter_interface), pointer :: deleter
#if FCKIT_FINAL_DEBUGGING
  FCKIT_WRITE_LOC
  FCKIT_WRITE(0,'(A)') "fckit_owned_object__delete"
#endif
  if( c_associated( this%cpp_object_ptr ) ) then
    if( c_associated( this%deleter ) ) then
      call c_f_procpointer( this%deleter, deleter )
      call deleter( this%cpp_object_ptr )
      this%cpp_object_ptr = c_null_ptr
    endif
  endif
  this%cpp_object_ptr = c_null_ptr
end subroutine

subroutine fckit_owned_object__final(this)
  class(fckit_owned_object), intent(inout) :: this

#if FCKIT_FINAL_DEBUGGING
  FCKIT_WRITE_LOC
  FCKIT_WRITE(0,'(A,I0)') "fckit_owned_object__final address BEGIN: ", c_ptr_to_loc(this%cpp_object_ptr)
#endif
  if( this%is_null() ) then
#if FCKIT_FINAL_DEBUGGING
    FCKIT_WRITE_LOC
    FCKIT_WRITE(0,'(A,I0)') "fckit_owned_object__final  (uninitialised --> no-op),  address: ", &
      & c_ptr_to_loc(this%cpp_object_ptr)
#endif
    return
  endif

#if FCKIT_FINAL_DEBUGGING
  if( this%return_value ) then
    FCKIT_WRITE_LOC
    FCKIT_WRITE(0,'(A,I0,A,I0,A)') "fckit_owned_object__final on return value, owners = ", &
      & this%owners(), "    address: ", &
      & loc(this%cpp_object_ptr), " Not applying final() due to return-value-optimisation"
    return
  endif
#endif

  if( this%owners() > 0 ) then
#if FCKIT_FINAL_DEBUGGING
    FCKIT_WRITE_LOC
    FCKIT_WRITE(0,'(A,I0,A,I0)') "fckit_owned_object__final  , owners = ", this%owners(), &
      & "   address: ", c_ptr_to_loc(this%cpp_object_ptr)
#endif
    call this%detach()
    if( this%owners() == 0 ) then
      call fckit_owned_object__delete(this)
    endif
  endif
#if FCKIT_FINAL_DEBUGGING
  FCKIT_WRITE_LOC
  FCKIT_WRITE(0,'(A,I0,A,I0)') "fckit_owned_object__final  , owners = ", this%owners(), "    address: ", &
    & c_ptr_to_loc(this%cpp_object_ptr)
#endif
  call this%reset_c_ptr()
end subroutine



subroutine fckit_owned_object_assignment_operator(this,other)
  class(fckit_owned_object), intent(inout) :: this
  class(fckit_owned_object), intent(in)    :: other
  if( other%is_null() ) then
    write(0,*) "ERROR! other was not initialised"
  endif
  if( this /= other ) then
#if FCKIT_FINAL_DEBUGGING
    if( this%is_null() ) then
      FCKIT_WRITE_LOC
      FCKIT_WRITE(0,'(A)') "fckit_owned_object_assignment_operator of uninitialised BEGIN"
    else
      FCKIT_WRITE_LOC
      FCKIT_WRITE(0,'(A)') "fckit_owned_object_assignment_operator of initialised BEGIN"
    endif
#endif
    call this%final()
    if( other%return_value ) then
#if FCKIT_FINAL_DEBUGGING
      FCKIT_WRITE_LOC
      FCKIT_WRITE(0,'(A)') "    rhs is a return value"
#endif
    endif
    call this%reset_c_ptr( other%cpp_object_ptr, other%deleter )
#if FCKIT_FINAL_DEBUGGING
    FCKIT_WRITE_LOC
    FCKIT_WRITE(0,'(A,I0)') "  \-> owners ", this%owners()
#endif
  else
#if FCKIT_FINAL_DEBUGGING
    FCKIT_WRITE_LOC
    FCKIT_WRITE(0,'(A)') "fckit_owned_object_assignment_operator ( obj_out = obj_in )"
#endif
  endif
  call this%assignment_operator_hook(other)
 end subroutine

subroutine attach(this)
  class(fckit_owned_object), intent(inout) :: this
  if( .not. this%is_null() ) then
    call fckit__Owned__attach(this%cpp_object_ptr)
#if FCKIT_FINAL_DEBUGGING
    FCKIT_WRITE_LOC
    FCKIT_WRITE(0,'(A)') "attach"
#endif
  endif
end subroutine

subroutine detach(this)
  class(fckit_owned_object), intent(inout) :: this
  if( .not. this%is_null() ) then
    call fckit__Owned__detach(this%cpp_object_ptr)
#if FCKIT_FINAL_DEBUGGING
    FCKIT_WRITE_LOC
    FCKIT_WRITE(0,'(A)') "detach"
#endif
  endif
end subroutine

function owners(this)
  integer(c_int32_t) :: owners
  class(fckit_owned_object), intent(in) :: this
  if( this%is_null() ) then
    owners = 0
  else
    owners = fckit__Owned__owners(this%cpp_object_ptr)
  endif
end function

subroutine return(this)
  class(fckit_owned_object), intent(inout) :: this
  this%return_value = .true.
#if FCKIT_FINAL_DEBUGGING
  FCKIT_WRITE_LOC
  FCKIT_WRITE(0,'(A)') "return"
#endif
  call this%detach()
end subroutine


subroutine assignment_operator_hook(this, other)
  class(fckit_owned_object) :: this
  class(fckit_owned_object) :: other
  FCKIT_SUPPRESS_UNUSED( this )
  FCKIT_SUPPRESS_UNUSED( other )
end subroutine


subroutine consumed(this)
  class(fckit_owned_object), intent(in) :: this
  type(fckit_owned_object) :: consumed_object
  consumed_object = this
  call consumed_object%final()
end subroutine


function fckit_owned_object__c_ptr(this)
  use, intrinsic :: iso_c_binding, only: c_ptr
  type(c_ptr) :: fckit_owned_object__c_ptr
  class(fckit_owned_object), intent(in) :: this
  fckit_owned_object__c_ptr = this%cpp_object_ptr
end function


function is_null(this)
  use, intrinsic :: iso_c_binding, only: c_associated
  logical :: is_null
  class(fckit_owned_object) :: this
  if( c_associated( this%cpp_object_ptr ) ) then
    is_null = .False.
  else
    is_null = .True.
  endif
end function

logical function equal(obj1,obj2)
  use fckit_c_interop_module, only : c_ptr_compare_equal
  class(fckit_owned_object), intent(in) :: obj1
  class(fckit_owned_object), intent(in) :: obj2
  equal = c_ptr_compare_equal(obj1%cpp_object_ptr,obj2%cpp_object_ptr)
end function

logical function not_equal(obj1,obj2)
  use fckit_c_interop_module, only : c_ptr_compare_equal
  class(fckit_owned_object), intent(in) :: obj1
  class(fckit_owned_object), intent(in) :: obj2
  if( c_ptr_compare_equal(obj1%cpp_object_ptr,obj2%cpp_object_ptr) ) then
    not_equal = .False.
  else
    not_equal = .True.
  endif
end function

subroutine reset_c_ptr(this,cptr,deleter)
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funptr, c_null_funptr
  use fckit_c_interop_module
  class(fckit_owned_object) :: this
  type(c_ptr), optional :: cptr
  type(c_funptr), optional :: deleter
  if( present(cptr) ) then
    this%cpp_object_ptr = cptr
#if FCKIT_FINAL_DEBUGGING
    FCKIT_WRITE_LOC
    FCKIT_WRITE(0,'(A)') "reset_c_ptr -> attach"
#endif
    call this%attach()

    if( present(deleter) ) then
      this%deleter = deleter
    else
      this%deleter = fckit_c_deleter(fckit__delete_Owned)
    endif

  else
    this%cpp_object_ptr = c_null_ptr
    this%deleter = c_null_funptr
  endif

#if FCKIT_FINAL_DEBUGGING
    FCKIT_WRITE_LOC
    FCKIT_WRITE(0,'(A)') "reset_c_ptr .. done"
#endif
end subroutine

end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

function c_get_a( conf_cptr ) result(a) bind(c)
    use, intrinsic :: iso_c_binding, only : c_ptr, c_int
    use fckit_configuration_module
    implicit none
    integer(c_int) :: a
    type(c_ptr), value :: conf_cptr
    type(fckit_configuration) :: conf
    write(0,*) "c_get_a ..."
    conf = fckit_configuration( conf_cptr )
    if( .not. conf%get("a",a) ) a = 0
    write(0,*) "c_get_a ... done"
end function

!! Following function could be called instead in above function "c_get_a" as:
!!   a = get_a( fckit_configuration( conf_c_ptr ) )

function get_a( conf ) result(a)
    use fckit_configuration_module
    implicit none
    integer :: a
    type(fckit_configuration), intent(in) :: conf
    write(0,*) "get_a ..."
    if( .not. conf%get("a",a) ) a = 0
    write(0,*) "get_a ... done"
end function

#include "fckit/fctest.h"

! -----------------------------------------------------------------------------

TESTSUITE(fctest_test_map_suite)

! -----------------------------------------------------------------------------

TESTSUITE_INIT
  use fckit_module
  call fckit_main%init()
END_TESTSUITE_INIT

! -----------------------------------------------------------------------------

TESTSUITE_FINALIZE
  use fckit_module
  call fckit_main%final()
END_TESTSUITE_FINALIZE

! -----------------------------------------------------------------------------




TEST( test_map )
#if 1

use iso_c_binding, only : c_float, c_double
use fckit_map_module

type(fckit_map) :: tmap

tmap = fckit_map()

#else
#warning Test "test_map" disabled
#endif
END_TEST



TEST( test_map_insert )
#if 1

use iso_c_binding, only : c_float, c_double, c_int
use fckit_map_module
use fckit_configuration_module

type(fckit_map) :: tmap1

integer(c_int)  :: ivalue = 999
real(c_float)   :: fvalue = 1.11
real(c_double)  :: dvalue = 2.22

type(fckit_configuration) :: test_config
type(fckit_configuration) :: retrieved_config
logical :: found
logical :: logval
integer :: intval


test_config = fckit_Configuration()
call test_config%set("int1",1)
call test_config%set("int2",2)
call test_config%set("logical_true",.True.)
call test_config%set("logical_false",.False.)



tmap1 = fckit_map()

call tmap1%insert("ivalue", ivalue)
call tmap1%insert("fvalue", fvalue)
call tmap1%insert("dvalue", dvalue)
call tmap1%insert("config_ptr", test_config%c_ptr())


! must contain
FCTEST_CHECK(tmap1%has("ivalue"))
FCTEST_CHECK(tmap1%has("fvalue"))
FCTEST_CHECK(tmap1%has("dvalue"))
FCTEST_CHECK(tmap1%has("config_ptr"))

! must not contain
FCTEST_CHECK_EQUAL(tmap1%has("non-existent-key"),.false.)

! check size
FCTEST_CHECK_EQUAL(tmap1%size(),4)

! get values..
FCTEST_CHECK_EQUAL(tmap1%get_int32("ivalue"), 999)
FCTEST_CHECK_EQUAL(tmap1%get_real32("fvalue"), fvalue)
FCTEST_CHECK_EQUAL(tmap1%get_real64("dvalue"), dvalue)

call retrieved_config%reset_c_ptr( tmap1%get_c_ptr("config_ptr") )

found = retrieved_config%get("int1",intval)
FCTEST_CHECK( found )
FCTEST_CHECK_EQUAL( intval , 1 )

found = retrieved_config%get("int2",intval)
FCTEST_CHECK( found )
FCTEST_CHECK_EQUAL( intval , 2 )

found = retrieved_config%get("logical_true",logval)
FCTEST_CHECK( found )
FCTEST_CHECK_EQUAL( logval , .true. )

found = retrieved_config%get("logical_false",logval)
FCTEST_CHECK( found )
FCTEST_CHECK_EQUAL( logval , .false. )

#else
#warning Test "test_map_insert" disabled
#endif
END_TEST






TEST( test_map_of_tensor )
#if 1

use iso_c_binding, only : c_float
use fckit_map_module
use fckit_tensor_module, only : fckit_tensor_real32

type(fckit_map)    :: tensor_map

real(c_float)      :: data_rank2(3,4)
type(fckit_tensor_real32) :: tensor_rank2
type(fckit_tensor_real32) :: tensor_rank2_retrieved
type(fckit_tensor_real32) :: tensor_rank2_retrieved_ptr2ctor
type(fckit_tensor_real32) :: tensor_rank2_retrieved_sub

integer(c_int32_t), allocatable :: tensor_shape(:)



! construct a map
tensor_map = fckit_map()

! tensor from an array rank 2
data_rank2(1,:) = 0.0
data_rank2(2,:) = 1.0
data_rank2(3,:) = 2.0
tensor_rank2 = fckit_tensor_real32(data_rank2)
FCTEST_CHECK_EQUAL( tensor_rank2%size(), 3*4)
FCTEST_CHECK_EQUAL( tensor_rank2%rank(), 2)

allocate(tensor_shape(tensor_rank2%rank()))
tensor_shape = tensor_rank2%shape()
FCTEST_CHECK_EQUAL( size(tensor_shape), 2)
FCTEST_CHECK_EQUAL( tensor_shape(1) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(2) , 4 )
deallocate(tensor_shape)

! insert the tensor into the map
call tensor_map%insert("tensor_rank2_ptr", tensor_rank2%c_ptr())

! map must contain the key
FCTEST_CHECK(tensor_map%has("tensor_rank2_ptr"))

! get the c_ptr
call tensor_rank2_retrieved%reset_c_ptr( tensor_map%get_c_ptr("tensor_rank2_ptr") )
FCTEST_CHECK_EQUAL( tensor_rank2%size() , tensor_rank2_retrieved%size() )
FCTEST_CHECK_EQUAL( tensor_rank2%rank() , tensor_rank2_retrieved%rank() )

! try to construct from pointer
tensor_rank2_retrieved_ptr2ctor = fckit_tensor_real32( tensor_map%get_c_ptr("tensor_rank2_ptr") )
FCTEST_CHECK_EQUAL( tensor_rank2%size() , tensor_rank2_retrieved_ptr2ctor%size() )
FCTEST_CHECK_EQUAL( tensor_rank2%rank() , tensor_rank2_retrieved_ptr2ctor%rank() )

! retrieve directly the fckit_shared_obj
call tensor_map%get("tensor_rank2_ptr", tensor_rank2_retrieved_sub)
FCTEST_CHECK_EQUAL( tensor_rank2%size() , tensor_rank2_retrieved_sub%size() )
FCTEST_CHECK_EQUAL( tensor_rank2%rank() , tensor_rank2_retrieved_sub%rank() )


allocate(tensor_shape(tensor_rank2_retrieved%rank()))
tensor_shape = tensor_rank2_retrieved%shape()
FCTEST_CHECK_EQUAL( size(tensor_shape), 2)
FCTEST_CHECK_EQUAL( tensor_shape(1) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(2) , 4 )
deallocate(tensor_shape)

#else
#warning Test "test_map_of_tensor" disabled
#endif
END_TEST












END_TESTSUITE

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"
#define FCKIT_WRITE_LOC write(0,'(A,I0,A)',advance='NO') "fckit_object.F90 @ ",__LINE__,'  : '

module fckit_object_module
  !! Provides abstract base class [[fckit_object_module:fckit_object(type)]]

use, intrinsic :: iso_c_binding, only: c_ptr, c_funptr, c_null_ptr, c_null_funptr
use fckit_final_module, only: fckit_final
implicit none
private

!========================================================================
! Public interface

public fckit_object

!========================================================================

type, extends(fckit_final) :: fckit_object
  !! Abstract base class for objects that wrap a C++ object

#if !PGIBUG_ATLAS_197
  type(c_ptr), private :: cpp_object_ptr = c_null_ptr
#else
  type(c_ptr), public :: cpp_object_ptr = c_null_ptr
#endif

  type(c_funptr), private :: deleter = c_null_funptr
    !! Internal C pointer

  logical, private :: return_value = .false.

contains

  procedure, public :: is_null
    !! Check if internal C pointer is set

#if !PGIBUG_ATLAS_197
  procedure, public :: c_ptr   => fckit_object__c_ptr
    !! Access to internal C pointer
#endif

  procedure, public :: reset_c_ptr
    !! Nullify internal C pointer

  procedure, private :: equal
    !! Compare two object C pointers

  procedure, private :: not_equal
    !! Compare two object C pointers

  generic, public :: operator(==) => equal
    !! Compare two objects internal C pointer

  generic, public :: operator(/=) => not_equal
    !! Compare two objects internal C pointer

  ! Following line is to avoid PGI compiler bug
  procedure, private :: fckit_object__c_ptr

  procedure, public :: final
  procedure, public :: fckit_object__final => final
#if FCKIT_HAVE_FINAL
  final :: fckit_object_final_auto
#endif

  procedure, private :: assignment_operator
  generic, public :: assignment(=) => assignment_operator
  procedure, public :: return

end type

interface fckit_object
  module procedure fckit_object_constructor
end interface

!========================================================================

private :: fckit_final
private :: c_ptr
private :: c_null_ptr
private :: c_funptr
private :: c_null_funptr

! =============================================================================
CONTAINS
! =============================================================================

function fckit_object_constructor( cptr, deleter ) result(this)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_funptr
  type(fckit_object) :: this
  type(c_ptr) :: cptr
  type(c_funptr), optional :: deleter
  if( present(deleter) ) then
    call this%reset_c_ptr( cptr, deleter )
  else
    call this%reset_c_ptr( cptr )
  endif
end function

function fckit_object__c_ptr(this)
  use, intrinsic :: iso_c_binding, only: c_ptr
  type(c_ptr) :: fckit_object__c_ptr
  class(fckit_object), intent(in) :: this
  fckit_object__c_ptr = this%cpp_object_ptr
end function

subroutine assignment_operator(this,other)
  class(fckit_object), intent(inout) :: this
  class(fckit_object), intent(in)    :: other
  call this%final()
  this%cpp_object_ptr = other%cpp_object_ptr
  this%deleter = other%deleter
  this%return_value = .false.
end subroutine

subroutine reset_c_ptr(this,cptr,deleter)
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funptr, c_null_funptr
  use fckit_c_interop_module
  class(fckit_object) :: this
  type(c_ptr), optional :: cptr
  type(c_funptr), optional :: deleter
#if FCKIT_FINAL_DEBUGGING
  if( present(cptr) ) then
    if( present(deleter) ) then
      FCKIT_WRITE_LOC
      write(0,*) "fckit_object::reset_c_ptr( ", c_ptr_to_loc(cptr), " , deleter )"
    else
      FCKIT_WRITE_LOC
      write(0,*) "fckit_object::reset_c_ptr( ", c_ptr_to_loc(cptr), ")"
    endif
  else
    FCKIT_WRITE_LOC
    write(0,*) "fckit_object::reset_c_ptr( )"
  endif
#endif
  call this%final()
  if( present(cptr) ) then
    this%cpp_object_ptr = cptr
    if( present(deleter) ) then
      this%deleter = deleter
    else
      this%deleter = c_null_funptr
    endif
  else
    this%cpp_object_ptr = c_null_ptr
    this%deleter = c_null_funptr
  endif
end subroutine

function is_null(this)
  use, intrinsic :: iso_c_binding, only: c_associated
  logical :: is_null
  class(fckit_object) :: this
  if( c_associated( this%cpp_object_ptr ) ) then
    is_null = .False.
  else
    is_null = .True.
  endif
end function

logical function equal(obj1,obj2)
  use fckit_c_interop_module, only : c_ptr_compare_equal
  class(fckit_object), intent(in) :: obj1
  class(fckit_object), intent(in) :: obj2
  equal = c_ptr_compare_equal(obj1%cpp_object_ptr,obj2%cpp_object_ptr)
end function

logical function not_equal(obj1,obj2)
  use fckit_c_interop_module, only : c_ptr_compare_equal
  class(fckit_object), intent(in) :: obj1
  class(fckit_object), intent(in) :: obj2
  if( c_ptr_compare_equal(obj1%cpp_object_ptr,obj2%cpp_object_ptr) ) then
    not_equal = .False.
  else
    not_equal = .True.
  endif
end function

subroutine final( this )
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funptr, c_f_procpointer, c_associated, c_null_ptr
  use fckit_c_interop_module, only : fckit_c_deleter_interface, c_ptr_to_loc
  class(fckit_object), intent(inout) :: this
  procedure(fckit_c_deleter_interface), pointer :: deleter
#if FCKIT_FINAL_DEBUGGING
  FCKIT_WRITE_LOC
  write(0,*) "FINAL BEGIN", c_ptr_to_loc(this%cpp_object_ptr)
#endif
  if( c_associated( this%cpp_object_ptr ) ) then
    if( c_associated( this%deleter ) ) then
      call c_f_procpointer( this%deleter, deleter )
#if FCKIT_FINAL_DEBUGGING
      write(0,*) "fckit_object.F90 @ ", __LINE__, ": call deleter( ", c_ptr_to_loc(this%cpp_object_ptr), ")"
#endif
      call deleter( this%cpp_object_ptr )
      this%cpp_object_ptr = c_null_ptr
      this%deleter = c_null_funptr
    endif
  endif
  this%cpp_object_ptr = c_null_ptr
#if FCKIT_FINAL_DEBUGGING
  FCKIT_WRITE_LOC
  write(0,*) "FINAL END", c_ptr_to_loc(this%cpp_object_ptr)
#endif
end subroutine

FCKIT_FINAL subroutine fckit_object_final_auto( this )
  use fckit_c_interop_module, only : fckit_c_deleter_interface, c_ptr_to_loc
  type(fckit_object), intent(inout) :: this
#if FCKIT_FINAL_DEBUGGING
  FCKIT_WRITE_LOC
  write(0,*) "fckit_object_final_auto cptr: ", c_ptr_to_loc(this%cpp_object_ptr)
#endif
  if (this%return_value) then
#if FCKIT_FINAL_DEBUGGING
    FCKIT_WRITE_LOC
    write(0,'(A)') "Applying return-value-optimisation during assignment_operator, this%final not called"
#endif
  else
#if FCKIT_FINAL_DEBUGGING
      FCKIT_WRITE_LOC
      write(0,'(A)') "Calling final"
#endif
      call this%final()
  endif
end subroutine

subroutine return(this)
  class(fckit_object), intent(inout) :: this
  this%return_value = .true.
end subroutine

end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fctest.h"

TESTSUITE( array )

TEST( test_array_view1d )
  use fckit_array_module, only: array_view1d
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), target :: array_int32_r2(20,10)
  integer(c_int32_t), pointer :: view(:)

  write(0,*) "test_array_view1d"
  view => array_view1d(array_int32_r2)
  FCTEST_CHECK_EQUAL( size(view), 200 )
END_TEST

TEST( test_array_stride )
  use fckit_array_module, only: array_stride, array_strides
  use, intrinsic :: iso_c_binding
  integer(c_int32_t) :: array_int32_r2(20,10)

  write(0,*) "test_array_stride"
  FCTEST_CHECK_EQUAL( array_stride(array_int32_r2,1), 1  )
  FCTEST_CHECK_EQUAL( array_stride(array_int32_r2,2), 20 )

  FCTEST_CHECK_EQUAL( array_strides(array_int32_r2), ([1,20]) )

END_TEST

END_TESTSUITE

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fctest.h"

TESTSUITE( test_mpi )

TESTSUITE_INIT
  use fckit_module
  call fckit_main%init()
END_TESTSUITE_INIT

TESTSUITE_FINALIZE
  use fckit_module
  call fckit_main%final()
END_TESTSUITE_FINALIZE

TEST( test_default_comm )
  use fckit_module
  use, intrinsic :: iso_c_binding
  implicit none

  write(0,*) "test_default_comm"
  write(0,*) "default size:", fckit_mpi%size()
  write(0,*) "default rank:", fckit_mpi%rank()
END_TEST

TEST( test_comm )
  use fckit_module
  use, intrinsic :: iso_c_binding
  implicit none
  type(fckit_mpi_comm) :: comm

  write(0,*) "test_comm"

  comm = fckit_mpi_comm()
  write(0,*) "default size:", comm%size()
  write(0,*) "default rank:", comm%rank()

  comm = fckit_mpi_comm("world")
  write(0,*) "world size:", comm%size()
  write(0,*) "default world:", comm%rank()

  comm = fckit_mpi_comm("self")
  FCTEST_CHECK_EQUAL( comm%size(), 1 )
  FCTEST_CHECK_EQUAL( comm%rank(), 0 )
END_TEST


TEST( test_self_comm )
  use fckit_module
  use, intrinsic :: iso_c_binding
  implicit none
  integer :: fcomm_self
  type(fckit_mpi_comm) :: comm1, comm2

  comm1 = fckit_mpi_comm("self")
  fcomm_self = comm1%communicator()

  comm2 = fckit_mpi_comm(fcomm_self)

  FCTEST_CHECK_EQUAL( comm2%size(), 1 )
  FCTEST_CHECK_EQUAL( comm2%rank(), 0 )

END_TEST

TEST( test_add_comm )
  use fckit_mpi_module
  use, intrinsic :: iso_c_binding
  implicit none
  integer :: fcomm_self
  type(fckit_mpi_comm) :: comm_self, comm2

  comm_self = fckit_mpi_comm("self")
  fcomm_self = comm_self%communicator()

  call fckit_mpi_addComm("another_self",fcomm_self)

  comm2 = fckit_mpi_comm("another_self")

  FCTEST_CHECK_EQUAL( comm2%size(), 1 )
  FCTEST_CHECK_EQUAL( comm2%rank(), 0 )

END_TEST


TEST( test_set_comm_default )
  use fckit_mpi_module
  use, intrinsic :: iso_c_binding
  implicit none
  type(fckit_mpi_comm) :: comm

  write(0,*) "test_set_comm_default"
  call fckit_mpi_setCommDefault("self")
  comm = fckit_mpi_comm()
  FCTEST_CHECK_EQUAL( comm%size(), 1 )
  FCTEST_CHECK_EQUAL( comm%rank(), 0 )

END_TEST

TEST( test_uninitialised )
  use fckit_module
  use, intrinsic :: iso_c_binding
  type(fckit_mpi_comm) :: comm

  write(0,*) "test_uninitialised"
  FCTEST_CHECK_EQUAL( comm%size(), 1 )
  FCTEST_CHECK_EQUAL( comm%rank(), 0 )

END_TEST

TEST( test_allreduce )
  use fckit_mpi_module
  use, intrinsic :: iso_c_binding
  implicit none
  type(fckit_mpi_comm) :: comm
  real(c_double)  :: real64, res_real64, real64_r1(2),      res_real64_r1(2)
  real(c_float)   :: real32, res_real32, real32_r2(3,2),    res_real32_r2(3,2)
  integer(c_int32_t) :: int32,  res_int32, res_int32_r3(4,3,2), j
  integer(c_long) :: int64,  res_int64,  int64_r4(4,3,2,2), res_int64_r4(4,3,2,2), check_prod, check_sum

  FCKIT_SUPPRESS_UNUSED( real64_r1 )
  FCKIT_SUPPRESS_UNUSED( res_real64_r1 )
  FCKIT_SUPPRESS_UNUSED( res_int32_r3 )
  FCKIT_SUPPRESS_UNUSED( res_real32_r2 )
  FCKIT_SUPPRESS_UNUSED( real32_r2 )

  write(0,*) "test_allreduce"
  comm = fckit_mpi_comm("world")

  real64 = 2
  call comm%allreduce(real64,res_real64,fckit_mpi_sum())
  FCTEST_CHECK_EQUAL( int(res_real64), 2*comm%size() )
  real64 = comm%rank()+1
  call comm%allreduce(real64,res_real64,fckit_mpi_max())
  FCTEST_CHECK_EQUAL( int(res_real64), comm%size())
  call comm%allreduce(real64,res_real64,fckit_mpi_min())
  FCTEST_CHECK_EQUAL( int(res_real64), 1 )

  check_prod = 1
  check_sum = 0
  do j=1,comm%size()
    check_prod = check_prod * j
    check_sum  = check_sum + j
  enddo
  call comm%allreduce(real64,res_real64,fckit_mpi_prod())
  FCTEST_CHECK_EQUAL( int(res_real64), int(check_prod) )

  real32 = 3
  call comm%allreduce(real32,res_real32,fckit_mpi_sum())
  FCTEST_CHECK_EQUAL( int(res_real32), 3*comm%size() )

  int32 = 4
  call comm%allreduce(int32,res_int32,fckit_mpi_sum())
  FCTEST_CHECK_EQUAL( int(res_int32), 4*comm%size() )

  int64 = 5
  call comm%allreduce(int64,res_int64,fckit_mpi_sum())
  FCTEST_CHECK_EQUAL( int(res_int64), 5*comm%size() )


  int64_r4(1,1,1,1) = 2
  int64_r4(2,3,1,2) = comm%rank()+1
  int64_r4(3,1,2,1) = comm%size()

  call comm%allreduce(int64_r4,res_int64_r4,fckit_mpi_prod())
  FCTEST_CHECK_EQUAL(res_int64_r4(2,3,1,2),check_prod)

  call comm%allreduce(int64_r4,res_int64_r4,fckit_mpi_sum())
  FCTEST_CHECK_EQUAL(res_int64_r4(2,3,1,2),check_sum)
  FCTEST_CHECK_EQUAL(res_int64_r4(3,1,2,1),int(comm%size()*comm%size(),c_long))
  FCTEST_CHECK_EQUAL(res_int64_r4(1,1,1,1),int(comm%size()*2,c_long))

  call comm%allreduce(int64_r4,res_int64_r4,fckit_mpi_max())
  FCTEST_CHECK_EQUAL(res_int64_r4(2,3,1,2),int(comm%size(),c_long))
  FCTEST_CHECK_EQUAL(res_int64_r4(3,1,2,1),int(comm%size(),c_long))
  FCTEST_CHECK_EQUAL(res_int64_r4(1,1,1,1),int(2,c_long))

  call comm%allreduce(int64_r4,res_int64_r4,fckit_mpi_min())
  FCTEST_CHECK_EQUAL(res_int64_r4(2,3,1,2),int(1,c_long))
  FCTEST_CHECK_EQUAL(res_int64_r4(3,1,2,1),int(comm%size(),c_long))
  FCTEST_CHECK_EQUAL(res_int64_r4(1,1,1,1),int(2,c_long))

END_TEST

TEST( test_allreduce_inplace )
  use fckit_mpi_module
  use, intrinsic :: iso_c_binding
  implicit none
  type(fckit_mpi_comm) :: comm
  real(c_double)  :: real64, real64_r1(2)
  real(c_float)   :: real32, real32_r2(3,2)
  integer(c_int32_t) :: int32,  int32_r3(4,3,2), j
  integer(c_long) :: int64,  int64_r4(4,3,2,2), check_prod, check_sum

  FCKIT_SUPPRESS_UNUSED( real64_r1 )
  FCKIT_SUPPRESS_UNUSED( int32_r3 )
  FCKIT_SUPPRESS_UNUSED( real32_r2 )

  write(0,*) "test_allreduce_inplace"
  comm = fckit_mpi_comm("world")

  real64 = 2
  call comm%allreduce(real64,fckit_mpi_sum())
  FCTEST_CHECK_EQUAL( int(real64), 2*comm%size() )
  real64 = comm%rank()+1
  call comm%allreduce(real64,fckit_mpi_max())
  FCTEST_CHECK_EQUAL( int(real64), comm%size())
  real64 = comm%rank()+1
  call comm%allreduce(real64,fckit_mpi_min())
  FCTEST_CHECK_EQUAL( int(real64), 1 )

  check_prod = 1
  check_sum = 0
  do j=1,comm%size()
    check_prod = check_prod * j
    check_sum  = check_sum + j
  enddo
  real64 = comm%rank()+1
  call comm%allreduce(real64,fckit_mpi_prod())
  FCTEST_CHECK_EQUAL( int(real64), int(check_prod) )

  real32 = 3
  call comm%allreduce(real32,fckit_mpi_sum())
  FCTEST_CHECK_EQUAL( int(real32), 3*comm%size() )

  int32 = 4
  call comm%allreduce(int32,fckit_mpi_sum())
  FCTEST_CHECK_EQUAL( int(int32), 4*comm%size() )

  int64 = 5
  call comm%allreduce(int64,fckit_mpi_sum())
  FCTEST_CHECK_EQUAL( int(int64), 5*comm%size() )


  int64_r4(1,1,1,1) = 2
  int64_r4(2,3,1,2) = comm%rank()+1
  int64_r4(3,1,2,1) = comm%size()

  call comm%allreduce(int64_r4,fckit_mpi_prod())
  FCTEST_CHECK_EQUAL(int64_r4(2,3,1,2),check_prod)

  int64_r4(1,1,1,1) = 2
  int64_r4(2,3,1,2) = comm%rank()+1
  int64_r4(3,1,2,1) = comm%size()

  call comm%allreduce(int64_r4,fckit_mpi_sum())
  FCTEST_CHECK_EQUAL(int64_r4(2,3,1,2),check_sum)
  FCTEST_CHECK_EQUAL(int64_r4(3,1,2,1),int(comm%size()*comm%size(),c_long))
  FCTEST_CHECK_EQUAL(int64_r4(1,1,1,1),int(comm%size()*2,c_long))

  int64_r4(1,1,1,1) = 2
  int64_r4(2,3,1,2) = comm%rank()+1
  int64_r4(3,1,2,1) = comm%size()

  call comm%allreduce(int64_r4,fckit_mpi_max())
  FCTEST_CHECK_EQUAL(int64_r4(2,3,1,2),int(comm%size(),c_long))
  FCTEST_CHECK_EQUAL(int64_r4(3,1,2,1),int(comm%size(),c_long))
  FCTEST_CHECK_EQUAL(int64_r4(1,1,1,1),int(2,c_long))

  int64_r4(1,1,1,1) = 2
  int64_r4(2,3,1,2) = comm%rank()+1
  int64_r4(3,1,2,1) = comm%size()

  call comm%allreduce(int64_r4,fckit_mpi_min())
  FCTEST_CHECK_EQUAL(int64_r4(2,3,1,2),int(1,c_long))
  FCTEST_CHECK_EQUAL(int64_r4(3,1,2,1),int(comm%size(),c_long))
  FCTEST_CHECK_EQUAL(int64_r4(1,1,1,1),int(2,c_long))

END_TEST

TEST( test_allgather )
  use fckit_module
  use, intrinsic ::iso_c_binding
  implicit none
  type(fckit_mpi_comm) :: comm
  real(c_double)  :: real64, real64_r1(2)
  real(c_double), allocatable :: res_real64(:), res_real64_r1(:)
  real(c_double), allocatable :: real64v_r1(:), res_real64v_r1(:)
  real(c_float)   :: real32, real32_r1(2)
  real(c_float), allocatable :: res_real32(:), res_real32_r1(:)
  real(c_float), allocatable :: real32v_r1(:), res_real32v_r1(:)
  integer(c_int32_t) :: int32,  int32_r1(2), j
  integer(c_int32_t), allocatable :: res_int32(:),  res_int32_r1(:)
  integer(c_int32_t), allocatable :: int32v_r1(:),  res_int32v_r1(:)
  integer(c_long) :: int64,  int64_r1(2)
  integer(c_long), allocatable :: res_int64(:),  res_int64_r1(:)
  integer(c_long), allocatable :: int64v_r1(:),  res_int64v_r1(:)
  integer, allocatable :: recvcounts(:), displs(:)

  write(0,*) "test_allgather"
  comm = fckit_mpi_comm("world")

  int32 = 2
  allocate(res_int32(comm%size()))
  call comm%allgather(int32,res_int32)
  FCTEST_CHECK_EQUAL(minval(res_int32),int32)
  FCTEST_CHECK_EQUAL(maxval(res_int32),int32)
  deallocate(res_int32)

  int64 = 3
  allocate(res_int64(comm%size()))
  call comm%allgather(int64,res_int64)
  FCTEST_CHECK_EQUAL(minval(res_int64),int64)
  FCTEST_CHECK_EQUAL(maxval(res_int64),int64)
  deallocate(res_int64)

  real32 = 4
  allocate(res_real32(comm%size()))
  call comm%allgather(real32,res_real32)
  FCTEST_CHECK_EQUAL(minval(res_real32),real32)
  FCTEST_CHECK_EQUAL(maxval(res_real32),real32)
  deallocate(res_real32)

  real64 = 5
  allocate(res_real64(comm%size()))
  call comm%allgather(real64,res_real64)
  FCTEST_CHECK_EQUAL(minval(res_real64),real64)
  FCTEST_CHECK_EQUAL(maxval(res_real64),real64)
  deallocate(res_real64)

  int32_r1 = (/ 2,3 /)
  allocate(res_int32_r1(size(int32_r1)*comm%size()))
  call comm%allgather(int32_r1,res_int32_r1,size(int32_r1))
  FCTEST_CHECK_EQUAL(minval(res_int32_r1),minval(int32_r1))
  FCTEST_CHECK_EQUAL(maxval(res_int32_r1),maxval(int32_r1))
  deallocate(res_int32_r1)

  int64_r1 = (/ 4,5 /)
  allocate(res_int64_r1(size(int64_r1)*comm%size()))
  call comm%allgather(int64_r1,res_int64_r1,size(int64_r1))
  FCTEST_CHECK_EQUAL(minval(res_int64_r1),minval(int64_r1))
  FCTEST_CHECK_EQUAL(maxval(res_int64_r1),maxval(int64_r1))
  deallocate(res_int64_r1)

  real32_r1 = (/ 6,7 /)
  allocate(res_real32_r1(size(real32_r1)*comm%size()))
  call comm%allgather(real32_r1,res_real32_r1,size(real32_r1))
  FCTEST_CHECK_EQUAL(minval(res_real32_r1),minval(real32_r1))
  FCTEST_CHECK_EQUAL(maxval(res_real32_r1),maxval(real32_r1))
  deallocate(res_real32_r1)

  real64_r1 = (/ 8,9 /)
  allocate(res_real64_r1(size(real64_r1)*comm%size()))
  call comm%allgather(real64_r1,res_real64_r1,size(real64_r1))
  FCTEST_CHECK_EQUAL(minval(res_real64_r1),minval(real64_r1))
  FCTEST_CHECK_EQUAL(maxval(res_real64_r1),maxval(real64_r1))
  deallocate(res_real64_r1)

  allocate(recvcounts(comm%size()),displs(comm%size()))

  allocate(int32v_r1(comm%rank()+1))
  int32v_r1 = comm%rank()
  recvcounts(1) = 1
  displs(1) = 0
  do j = 2,comm%size()
     recvcounts(j) = j
     displs(j) = displs(j-1)+recvcounts(j-1)
  enddo
  allocate(res_int32v_r1(sum(recvcounts)))
  call comm%allgather(int32v_r1,res_int32v_r1,size(int32v_r1),recvcounts,displs)
  FCTEST_CHECK_EQUAL(minval(res_int32v_r1),0)
  FCTEST_CHECK_EQUAL(maxval(res_int32v_r1),comm%size()-1)
  deallocate(int32v_r1,res_int32v_r1)

  allocate(int64v_r1(comm%size()-comm%rank()))
  int64v_r1 = comm%rank()
  recvcounts(1) = comm%size()
  displs(1) = 0
  do j = 2,comm%size()
     recvcounts(j) = comm%size() - j + 1
     displs(j) = displs(j-1)+recvcounts(j-1)
  enddo
  allocate(res_int64v_r1(sum(recvcounts)))
  call comm%allgather(int64v_r1,res_int64v_r1,size(int64v_r1),recvcounts,displs)
  FCTEST_CHECK_EQUAL(int(minval(res_int64v_r1)),0)
  FCTEST_CHECK_EQUAL(int(maxval(res_int64v_r1)),comm%size()-1)
  deallocate(int64v_r1,res_int64v_r1)

  allocate(real32v_r1(comm%rank()+1))
  real32v_r1 = comm%rank()
  recvcounts(1) = 1
  displs(1) = 0
  do j = 2,comm%size()
     recvcounts(j) = j
     displs(j) = displs(j-1)+recvcounts(j-1)
  enddo
  allocate(res_real32v_r1(sum(recvcounts)))
  call comm%allgather(real32v_r1,res_real32v_r1,size(real32v_r1),recvcounts,displs)
  FCTEST_CHECK_EQUAL(minval(res_real32v_r1),real(0,c_float))
  FCTEST_CHECK_EQUAL(maxval(res_real32v_r1),real(comm%size()-1,c_float))
  deallocate(real32v_r1,res_real32v_r1)

  allocate(real64v_r1(comm%size()-comm%rank()))
  real64v_r1 = comm%rank()
  recvcounts(1) = comm%size()
  displs(1) = 0
  do j = 2,comm%size()
     recvcounts(j) = comm%size() - j + 1
     displs(j) = displs(j-1)+recvcounts(j-1)
  enddo
  allocate(res_real64v_r1(sum(recvcounts)))
  call comm%allgather(real64v_r1,res_real64v_r1,size(real64v_r1),recvcounts,displs)
  FCTEST_CHECK_EQUAL(minval(res_real64v_r1),real(0,c_double))
  FCTEST_CHECK_EQUAL(maxval(res_real64v_r1),real(comm%size()-1,c_double))
  deallocate(real64v_r1,res_real64v_r1)

  deallocate(recvcounts,displs)

END_TEST

TEST( test_broadcast )
  use fckit_mpi_module
  use, intrinsic :: iso_c_binding
  implicit none
  type(fckit_mpi_comm) :: comm
  real(c_double)  :: real64, real64_r1(2)
  real(c_float)   :: real32, real32_r2(3,2)
  integer(c_int32_t) :: int32,  int32_r3(4,3,2)
  integer(c_long) :: int64,  int64_r4(4,3,2,2)
  logical :: logical_r1(4)
  character(len=30) :: string_r0

  FCKIT_SUPPRESS_UNUSED( real64_r1 )
  FCKIT_SUPPRESS_UNUSED( int64 )
  FCKIT_SUPPRESS_UNUSED( real32_r2 )

  write(0,*) "test_broadcast"
  comm = fckit_mpi_comm("world")
  if(comm%rank()==0) real64 = 0.1_c_double
  call comm%broadcast(real64,root=0)
  FCTEST_CHECK_CLOSE(real64, 0.1_c_double,1.e-9_c_double)

  if(comm%rank()==0) real32 = 0.2_c_float
  call comm%broadcast(real32,root=0)
  FCTEST_CHECK_CLOSE(real32, 0.2_c_float,1.e-5_c_float)

  if(comm%rank()==comm%size()-1) int32 = 3
  call comm%broadcast(int32,root=comm%size()-1)
  FCTEST_CHECK_EQUAL(int32, 3)

  if(comm%rank()==0) int64_r4(2,2,1,2) = 1_c_long
  call comm%broadcast(int64_r4,root=0)
  FCTEST_CHECK_EQUAL(int64_r4(2,2,1,2), 1_c_long)

  if(comm%rank()==0) int32_r3(1,3,2) = 2
  call comm%broadcast(int32_r3,root=0)
  FCTEST_CHECK_EQUAL(int32_r3(1,3,2), 2_c_int32_t)

  if(comm%rank()==comm%size()-1) int32_r3(2,1,1) = 3
  call comm%broadcast(int32_r3,root=comm%size()-1)
  FCTEST_CHECK_EQUAL(int32_r3(2,1,1), 3)

  if(comm%rank()==comm%size()-1) logical_r1(2) = .true.
  call comm%broadcast(logical_r1,root=comm%size()-1)
  FCTEST_CHECK_EQUAL(logical_r1(2), .true.)

  if(comm%rank()==comm%size()-1) string_r0 = "path/filename"
  call comm%broadcast(string_r0,root=comm%size()-1)
  FCTEST_CHECK_EQUAL(string_r0, "path/filename")

END_TEST


TEST( test_nonblocking_send_receive )
  use fckit_mpi_module
  use, intrinsic :: iso_c_binding
  implicit none
  type(fckit_mpi_comm) :: comm
  integer :: sendreq, recvreq
  type(fckit_mpi_status) :: status
  integer :: tag=1
  real(c_double)  :: send_real64, recv_real64

  write(0,*) "test_nonblocking_send_receive"
  comm = fckit_mpi_comm("world")

  send_real64 = 0._c_double


  if( comm%rank()==comm%size()-1) then

    recvreq = comm%ireceive(recv_real64,0,tag)

    write(0,*) "receive-request:",recvreq

  endif

  if(comm%rank()==0) then

    send_real64 = 0.1_c_double
    sendreq = comm%isend(send_real64,comm%size()-1,tag)

    write(0,*) "send-request:",sendreq

  endif


  if( comm%rank()==comm%size()-1) then
    call comm%wait(recvreq,status)
    FCTEST_CHECK_CLOSE(recv_real64, 0.1_c_double,1.e-9_c_double)
  endif

  if(comm%rank()==0) then
    call comm%wait(sendreq,status)
  endif

!   FCTEST_CHECK_EQUAL(status%source(), 0)
!   FCTEST_CHECK_EQUAL(status%tag(), tag)
!   FCTEST_CHECK_EQUAL(status%error(), 0)

END_TEST

TEST( test_blocking_send_receive )
  use fckit_mpi_module
  use, intrinsic :: iso_c_binding
  implicit none
  type(fckit_mpi_comm) :: comm
  type(fckit_mpi_status) :: status
  integer :: tag=99
  real(c_double)  :: send_real64, recv_real64

  write(0,*) "test_blocking_send_receive"
  comm = fckit_mpi_comm("world")

  send_real64 = 0._c_double

  if(comm%rank()==0) then

    send_real64 = 0.1_c_double
    call comm%send(send_real64,comm%size()-1,tag)

    send_real64 = 0.2_c_double
    call comm%send(send_real64,comm%size()-1,tag+1)

  endif
  if( comm%rank()==comm%size()-1) then

    call comm%receive(recv_real64,0,tag,status)
    FCTEST_CHECK_CLOSE(recv_real64, 0.1_c_double,1.e-9_c_double)
    FCTEST_CHECK_EQUAL(status%source(), 0)
    FCTEST_CHECK_EQUAL(status%tag(), tag)
    FCTEST_CHECK_EQUAL(status%error(), 0)

    call comm%receive(recv_real64,0,tag=comm%anytag(),status=status)
    FCTEST_CHECK_EQUAL(status%tag(), tag+1)
    FCTEST_CHECK_CLOSE(recv_real64, 0.2_c_double,1.e-9_c_double)

  endif

END_TEST

TEST( test_blocking_send_receive_real64_rank1 )
  use fckit_mpi_module
  use, intrinsic :: iso_c_binding
  implicit none
  type(fckit_mpi_comm) :: comm
  type(fckit_mpi_status) :: status
  integer :: tag=99
  real(c_double)  :: send_real64(2), recv_real64(2)

  write(0,*) "test_blocking_send_receive_rank1"
  comm = fckit_mpi_comm("world")

  send_real64 = [ 0._c_double , 0._c_double ]

  if(comm%rank()==0) then

    send_real64 = [ 0.1_c_double , 0.1_c_double ]
    call comm%send(send_real64,comm%size()-1,tag)

    send_real64 = [ 0.2_c_double , 0.2_c_double ]
    call comm%send(send_real64,comm%size()-1,tag+1)

  endif
  if( comm%rank()==comm%size()-1) then

    call comm%receive(recv_real64,0,tag,status)
    FCTEST_CHECK_CLOSE(recv_real64, ( [0.1_c_double,0.1_c_double] ),1.e-9_c_double)
    FCTEST_CHECK_EQUAL(status%source(), 0)
    FCTEST_CHECK_EQUAL(status%tag(), tag)
    FCTEST_CHECK_EQUAL(status%error(), 0)

    call comm%receive(recv_real64,0,tag=comm%anytag(),status=status)
    FCTEST_CHECK_EQUAL(status%tag(), tag+1)
    FCTEST_CHECK_CLOSE(recv_real64, ( [0.2_c_double,0.2_c_double] ),1.e-9_c_double)

  endif

END_TEST


TEST( test_blocking_send_receive_int32_rank1 )
  use fckit_mpi_module
  use, intrinsic :: iso_c_binding
  implicit none
  type(fckit_mpi_comm) :: comm
  type(fckit_mpi_status) :: status
  integer :: tag=99
  integer(c_int32_t)  :: send(2), recv(2)

  write(0,*) "test_blocking_send_receive_int32_rank1"
  comm = fckit_mpi_comm("world")

  send = [ 0_c_int32_t , 0_c_int32_t ]

  if(comm%rank()==0) then

    send = [ 1_c_int32_t , 2_c_int32_t ]
    call comm%send(send,comm%size()-1,tag)

    send = [ 3_c_int32_t , 4_c_int32_t ]
    call comm%send(send,comm%size()-1,tag+1)

  endif
  if( comm%rank()==comm%size()-1) then

    call comm%receive(recv,0,tag,status)
    FCTEST_CHECK_EQUAL(recv, ( [1_c_int32_t,2_c_int32_t] ) )
    FCTEST_CHECK_EQUAL(status%source(), 0)
    FCTEST_CHECK_EQUAL(status%tag(), tag)
    FCTEST_CHECK_EQUAL(status%error(), 0)

    call comm%receive(recv,0,tag=comm%anytag(),status=status)
    FCTEST_CHECK_EQUAL(status%tag(), tag+1)
    FCTEST_CHECK_EQUAL(recv, ( [3_c_int32_t,4_c_int32_t] ) )

  endif

END_TEST

TEST( test_blocking_send_receive_int64_rank1 )
  use fckit_mpi_module
  use, intrinsic :: iso_c_binding
  implicit none
  type(fckit_mpi_comm) :: comm
  type(fckit_mpi_status) :: status
  integer :: tag=99
  integer(c_int64_t)  :: send(2), recv(2)

  write(0,*) "test_blocking_send_receive_int64_rank1"
  comm = fckit_mpi_comm("world")

  send = [ 0_c_int64_t , 0_c_int64_t ]

  if(comm%rank()==0) then

    send = [ 1_c_int64_t , 2_c_int64_t ]
    call comm%send(send,comm%size()-1,tag)

    send = [ 3_c_int64_t , 4_c_int64_t ]
    call comm%send(send,comm%size()-1,tag+1)

  endif
  if( comm%rank()==comm%size()-1) then

    call comm%receive(recv,0,tag,status)
    FCTEST_CHECK_EQUAL(recv, ( [1_c_int64_t,2_c_int64_t] ) )
    FCTEST_CHECK_EQUAL(status%source(), 0)
    FCTEST_CHECK_EQUAL(status%tag(), tag)
    FCTEST_CHECK_EQUAL(status%error(), 0)

    call comm%receive(recv,0,tag=comm%anytag(),status=status)
    FCTEST_CHECK_EQUAL(status%tag(), tag+1)
    FCTEST_CHECK_EQUAL(recv, ( [3_c_int64_t,4_c_int64_t] ) )

  endif

END_TEST

TEST( test_split_comm_delete )
  use fckit_mpi_module
  use, intrinsic :: iso_c_binding
  implicit none
  type(fckit_mpi_comm) :: world  ! a handle for the world comm
  type(fckit_mpi_comm) :: split  ! a handle for the split comm
  integer :: i

  world = fckit_mpi_comm("world")
  if( mod(world%size(),2) == 0 ) then

    do i=1,10
        split = world%split( merge(1,2,world%rank()<world%size()/2), "split" )
        FCTEST_CHECK_EQUAL( split%size(),  world%size()/2 )
        FCTEST_CHECK      ( split%rank() < split%size() )

        ! Set the default communicator to "split" ( a typical use case )
        call split%set_default()

        FCTEST_CHECK_EQUAL( fckit_mpi%name(), "split" )
        FCTEST_CHECK_EQUAL( fckit_mpi%size(), split%size() )

        ! We cannot delete split if it is set as default, so set the default back to world first
        call world%set_default()
        call split%delete()
    enddo

  endif
END_TEST

TEST( test_mpi_info_null )
  use fckit_mpi_module
  use, intrinsic :: iso_c_binding
  implicit none
  integer(c_int32_t) :: mpi_info_null
  mpi_info_null = fckit_mpi_info_null()
  mpi_info_null = fckit_mpi%info_null()
END_TEST


END_TESTSUITE

#include "fckit/fctest.h"

! test fixture for f2c interop
module fcta_tensor_f_fxt

  use fckit_array_module, only: array_view1d

interface


! float tensor C++ checks..
subroutine cxx_check_tensor_float(cptr, esize, erank, layout) bind(c,name="cxx_check_tensor_float")
  use iso_c_binding, only : c_ptr, c_size_t, c_int
  type(c_ptr), value :: cptr
  integer(c_size_t), value :: esize
  integer(c_size_t), value :: erank
  integer(c_int), value :: layout
end subroutine

subroutine cxx_check_tensor_float_layout_r3(cptr, data, data_size) &
  & bind(c,name="cxx_check_tensor_float_layout_rank3")
  use iso_c_binding, only : c_ptr, c_float, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_float), dimension(*) :: data
  integer(c_size_t), intent(in), value :: data_size
end subroutine

subroutine cxx_check_tensor_float_layout_r4(cptr, data, data_size) &
  & bind(c,name="cxx_check_tensor_float_layout_rank4")
  use iso_c_binding, only : c_ptr, c_float, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_float), dimension(*) :: data
  integer(c_size_t), intent(in), value :: data_size
end subroutine

function cxx_create_tensor_float_filled(shape, shape_size, layout) &
  & bind(c,name="cxx_create_tensor_float_filled")
  use iso_c_binding, only : c_ptr, c_int
  integer(c_int), intent(in), dimension(*) :: shape
  integer(c_int), intent(in), value :: shape_size
  integer(c_int), intent(in), value :: layout
  type(c_ptr) :: cxx_create_tensor_float_filled
end function

subroutine cxx_delete_tensor_float(ptr) &
  & bind(c,name="cxx_delete_tensor_float")
  use iso_c_binding, only : c_ptr
  type(c_ptr), intent(in), value :: ptr
end subroutine


! double tensor C++ checks..
subroutine cxx_check_tensor_double(cptr, esize, erank, layout) bind(c,name="cxx_check_tensor_double")
  use iso_c_binding, only : c_ptr, c_size_t, c_int
  type(c_ptr), value :: cptr
  integer(c_size_t), value :: esize
  integer(c_size_t), value :: erank
  integer(c_int), value :: layout
end subroutine

subroutine cxx_check_tensor_double_layout_r3(cptr, data, data_size) &
  & bind(c,name="cxx_check_tensor_double_layout_rank3")
  use iso_c_binding, only : c_ptr, c_double, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_double), dimension(*) :: data
  integer(c_size_t), intent(in), value :: data_size
end subroutine

subroutine cxx_check_tensor_double_layout_r4(cptr, data, data_size) &
  & bind(c,name="cxx_check_tensor_double_layout_rank4")
  use iso_c_binding, only : c_ptr, c_double, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_double), dimension(*) :: data
  integer(c_size_t), intent(in), value :: data_size
end subroutine

function cxx_create_tensor_double_filled(shape, shape_size, layout) &
  & bind(c,name="cxx_create_tensor_double_filled")
  use iso_c_binding, only : c_ptr, c_int
  integer(c_int), intent(in), dimension(*) :: shape
  integer(c_int), intent(in), value :: shape_size
  integer(c_int), intent(in), value :: layout
  type(c_ptr) :: cxx_create_tensor_double_filled
end function

subroutine cxx_delete_tensor_double(ptr) &
  & bind(c,name="cxx_delete_tensor_double")
  use iso_c_binding, only : c_ptr
  type(c_ptr), intent(in), value :: ptr
end subroutine

end interface

contains

! float tensor checks..
subroutine check_tensor_float(cptr, esize, erank, layout)
  use iso_c_binding, only : c_ptr, c_size_t, c_int
  type(c_ptr) :: cptr
  integer(c_size_t) :: esize
  integer(c_size_t) :: erank
  integer(c_int) :: layout
  call cxx_check_tensor_float(cptr, esize, erank, layout)
end subroutine

subroutine check_tensor_float_layout_r3(cptr, data)
  use iso_c_binding, only : c_ptr, c_float, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_float), intent(in), target :: data(:,:,:)
  real(c_float), pointer :: data_vec(:)
  integer(c_size_t)  :: shape_vec(3)
  integer(c_size_t)  :: data_rank
  integer(c_size_t)  :: data_size 
  data_vec => array_view1d( data )
  shape_vec = shape(data)
  data_rank = size(shape_vec)
  data_size = size(data)
  call cxx_check_tensor_float_layout_r3(cptr, data_vec, data_size )
end subroutine

subroutine check_tensor_float_layout_r4(cptr, data)
  use iso_c_binding, only : c_ptr, c_float, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_float), intent(in), target :: data(:,:,:,:)
  real(c_float), pointer :: data_vec(:)
  integer(c_size_t)  :: shape_vec(4)
  integer(c_size_t)  :: data_rank
  integer(c_size_t)  :: data_size
  data_vec => array_view1d( data )
  shape_vec = shape(data)
  data_rank = size(shape_vec)
  data_size = size(data)
  call cxx_check_tensor_float_layout_r4(cptr, data_vec, data_size )
end subroutine

function create_tensor_float_filled(shape, shape_size, layout)
  use iso_c_binding, only : c_ptr, c_int
  integer(c_int), intent(in), dimension(*) :: shape
  integer(c_int), intent(in), value :: shape_size
  integer(c_int), intent(in), value :: layout
  type(c_ptr) :: create_tensor_float_filled
  create_tensor_float_filled = cxx_create_tensor_float_filled(shape, shape_size, layout)
end function

subroutine delete_tensor_float(ptr)
  use iso_c_binding, only : c_ptr
  type(c_ptr), intent(in) :: ptr
  call cxx_delete_tensor_float(ptr)
end subroutine


! double tensor checks..
subroutine check_tensor_double(cptr, esize, erank, layout)
  use iso_c_binding, only : c_ptr, c_size_t, c_int
  type(c_ptr) :: cptr
  integer(c_size_t) :: esize
  integer(c_size_t) :: erank
  integer(c_int) :: layout
  call cxx_check_tensor_double(cptr, esize, erank, layout)
end subroutine

subroutine check_tensor_double_layout_r3(cptr, data)
  use iso_c_binding, only : c_ptr, c_double, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_double), intent(in), target :: data(:,:,:)
  real(c_double), pointer :: data_vec(:)
  integer(c_size_t)  :: shape_vec(3)
  integer(c_size_t)  :: data_rank
  integer(c_size_t)  :: data_size
  data_vec => array_view1d( data )
  shape_vec = shape(data)
  data_rank = size(shape_vec)
  data_size = size(data)
  call cxx_check_tensor_double_layout_r3(cptr, data_vec, data_size )
end subroutine

subroutine check_tensor_double_layout_r4(cptr, data)
  use iso_c_binding, only : c_ptr, c_double, c_size_t, c_int
  type(c_ptr), value :: cptr
  real(c_double), intent(in), target :: data(:,:,:,:)
  real(c_double), pointer :: data_vec(:)
  integer(c_size_t)  :: shape_vec(4)
  integer(c_size_t)  :: data_rank
  integer(c_size_t)  :: data_size 
  data_vec => array_view1d( data )
  shape_vec = shape(data)
  data_rank = size(shape_vec)
  data_size = size(data)
  call cxx_check_tensor_double_layout_r4(cptr, data_vec, data_size )
end subroutine

function create_tensor_double_filled(shape, shape_size, layout)
  use iso_c_binding, only : c_ptr, c_int
  integer(c_int), intent(in), dimension(*) :: shape
  integer(c_int), intent(in), value :: shape_size
  integer(c_int), intent(in), value :: layout
  type(c_ptr) :: create_tensor_double_filled
  create_tensor_double_filled = cxx_create_tensor_double_filled(shape, shape_size, layout)
end function

subroutine delete_tensor_double(ptr)
  use iso_c_binding, only : c_ptr
  type(c_ptr), intent(in) :: ptr
  call cxx_delete_tensor_double(ptr)
end subroutine


end module fcta_tensor_f_fxt

! -----------------------------------------------------------------------------

TESTSUITE_WITH_FIXTURE(fctest_test_tensor_suite, fcta_tensor_f_fxt)

! -----------------------------------------------------------------------------

TESTSUITE_INIT
  use fckit_module
  call fckit_main%init()
END_TESTSUITE_INIT

! -----------------------------------------------------------------------------

TESTSUITE_FINALIZE
  use fckit_module
  call fckit_main%final()
END_TESTSUITE_FINALIZE

! -----------------------------------------------------------------------------


! ============= TensorFloat tests =============
TEST( test_float_tensor_creation )
#if 1

use iso_c_binding, only : c_float, c_size_t
use fckit_tensor_module, only : fckit_tensor_real32

type(fckit_tensor_real32) :: tensor_empty
type(fckit_tensor_real32) :: tensor_from_shape
type(fckit_tensor_real32) :: tensor_rank1
type(fckit_tensor_real32) :: tensor_rank2
type(fckit_tensor_real32) :: tensor_rank3
type(fckit_tensor_real32) :: tensor_rank4

integer(c_size_t)  :: shape(4) = (/ 4,2,3,4 /)
real(c_float)   :: data_rank1(10) = 0.0
real(c_float)   :: data_rank2(3,4)
real(c_float)   :: data_rank3(3,3,3)
real(c_float)   :: data_rank4(2,3,4,5)

integer(c_size_t) :: tensor_size
integer(c_size_t) :: rank
integer(c_size_t), allocatable :: tensor_shape(:)

! an empty tensor
tensor_empty = fckit_tensor_real32()

! a tensor from shape
tensor_from_shape = fckit_tensor_real32(shape)

! a tensor from an array
tensor_rank1 = fckit_tensor_real32(data_rank1)

! a tensor from an array rank 2
data_rank2(1,:) = 0.0
data_rank2(2,:) = 1.0
data_rank2(3,:) = 2.0
tensor_rank2 = fckit_tensor_real32(data_rank2)

! a tensor from an array rank 3
data_rank3 = 0.0
tensor_rank3 = fckit_tensor_real32(data_rank3)

! a tensor from an array rank 4
data_rank4 = 0.0
tensor_rank4 = fckit_tensor_real32(data_rank4)


! check rank1 - tensor size/shape
tensor_size = tensor_rank1%size()
rank = tensor_rank1%rank()
tensor_shape = tensor_rank1%shape()
FCTEST_CHECK_EQUAL( tensor_size , 10 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 1 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 10 )
deallocate(tensor_shape)

! check rank2 - tensor size/shape
tensor_size = tensor_rank2%size()
rank = tensor_rank2%rank()
tensor_shape = tensor_rank2%shape()
FCTEST_CHECK_EQUAL( tensor_size , 3*4 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 2 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(2) , 4 )
deallocate(tensor_shape)

! check rank3 - tensor size/shape
tensor_size = tensor_rank3%size()
rank = tensor_rank3%rank()
tensor_shape = tensor_rank3%shape()
FCTEST_CHECK_EQUAL( tensor_size , 3*3*3 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(2) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(3) , 3 )
deallocate(tensor_shape)

! check rank4 - tensor size/shape
tensor_size = tensor_rank4%size()
rank = tensor_rank3%rank()
tensor_shape = tensor_rank4%shape()
FCTEST_CHECK_EQUAL( tensor_size , 2*3*4*5 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 4 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 2 )
FCTEST_CHECK_EQUAL( tensor_shape(2) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(3) , 4 )
FCTEST_CHECK_EQUAL( tensor_shape(4) , 5 )
deallocate(tensor_shape)


! finalise
call tensor_empty%final()
call tensor_from_shape%final()
call tensor_rank1%final()
call tensor_rank2%final()
call tensor_rank3%final()
call tensor_rank4%final()


#else
#warning Test "test_float_tensor_creation" disabled
#endif
END_TEST



TEST( test_tensor_float_interop )
#if 1

use iso_c_binding, only : c_float, c_size_t
use fckit_tensor_module, only : fckit_tensor_real32, fckit_tensor

type(fckit_tensor_real32) :: tensor_r3
type(fckit_tensor_real32) :: tensor_r4
real(c_float) :: data_r3(3,3,3)
real(c_float) :: data_r4(2,4,5,6)
integer(c_size_t) :: expected_size
integer(c_size_t) :: expected_rank

integer(c_int) :: expected_layout

! ---------------------- rank 3
data_r3(1,:,:) = 0.04
data_r3(2,:,:) = 1.04
data_r3(3,:,:) = 2.04
tensor_r3 = fckit_tensor_real32(data_r3, fckit_tensor%layout_rowmajor())

expected_size = 3*3*3
expected_rank = 3
expected_layout = fckit_tensor%layout_rowmajor()

! check tensor info from c++
call check_tensor_float(tensor_r3%c_ptr(), expected_size, expected_rank, expected_layout)

! check internal data.. 
call check_tensor_float_layout_r3(tensor_r3%c_ptr(), data_r3)


! ---------------------- rank 4
data_r4(1,:,:,:) = 1.14
data_r4(2,:,:,:) = 2.24
data_r4(:,:,:,6) = 3.34
tensor_r4 = fckit_tensor_real32(data_r4) ! layout is colmajor (by default)

expected_size = 2*4*5*6
expected_rank = 4
expected_layout = fckit_tensor%layout_colmajor()

! check tensor info from c++
call check_tensor_float(tensor_r4%c_ptr(), expected_size, expected_rank, expected_layout)

! check internal data.. 
call check_tensor_float_layout_r4(tensor_r4%c_ptr(), data_r4)


#else
#warning Test "test_tensor_float_interop" disabled
#endif
END_TEST
  

TEST ( test_tensor_float_creation_from_cpp )
#if 1

use iso_c_binding, only : c_ptr, c_int, c_size_t
use fckit_tensor_module, only : fckit_tensor_real32, fckit_tensor

type(fckit_tensor_real32) :: tensor

integer(c_int) :: tensor_shape_input(4) = (/ 4,2,3,4 /)
integer(c_size_t), allocatable :: tensor_shape(:)
integer(c_size_t) :: expected_size = 4*2*3*4
integer(c_size_t) :: expected_rank = 4
integer(c_size_t) :: expected_shape(4) = (/ 4,2,3,4 /)

call tensor%reset_c_ptr(create_tensor_float_filled(tensor_shape_input, size(tensor_shape_input), fckit_tensor%layout_colmajor()))

FCTEST_CHECK_EQUAL( tensor%size(), expected_size )
FCTEST_CHECK_EQUAL( tensor%rank(), expected_rank )

tensor_shape = tensor%shape()

FCTEST_CHECK_EQUAL( tensor_shape(1), expected_shape(1) )
FCTEST_CHECK_EQUAL( tensor_shape(2), expected_shape(2) )
FCTEST_CHECK_EQUAL( tensor_shape(3), expected_shape(3) )
FCTEST_CHECK_EQUAL( tensor_shape(4), expected_shape(4) )

FCTEST_CHECK_EQUAL( tensor%layout(), fckit_tensor%layout_colmajor() )

! deallocation
deallocate(tensor_shape)
call delete_tensor_float(tensor%c_ptr())

#else
#warning Test "test_tensor_float_creation_from_cpp" disabled
#endif
END_TEST


! ============= TensorDouble tests =============
TEST( test_double_tensor_creation )
#if 1

use iso_c_binding, only : c_double, c_size_t
use fckit_tensor_module, only : fckit_tensor_real64

type(fckit_tensor_real64) :: tensor_empty
type(fckit_tensor_real64) :: tensor_from_shape
type(fckit_tensor_real64) :: tensor_rank1
type(fckit_tensor_real64) :: tensor_rank2
type(fckit_tensor_real64) :: tensor_rank3
type(fckit_tensor_real64) :: tensor_rank4

integer(c_size_t)  :: shape(4) = (/ 4,2,3,4 /)
real(c_double)   :: data_rank1(10) = 0.0
real(c_double)   :: data_rank2(3,4)
real(c_double)   :: data_rank3(3,3,3)
real(c_double)   :: data_rank4(2,3,4,5)

integer(c_size_t) :: tensor_size
integer(c_size_t) :: rank
integer(c_size_t), allocatable :: tensor_shape(:)

! an empty tensor
tensor_empty = fckit_tensor_real64()

! a tensor from shape
tensor_from_shape = fckit_tensor_real64(shape)

! a tensor from an array
tensor_rank1 = fckit_tensor_real64(data_rank1)

! a tensor from an array rank 2
data_rank2(1,:) = 0.06
data_rank2(2,:) = 1.06
data_rank2(3,:) = 2.06
tensor_rank2 = fckit_tensor_real64(data_rank2)

! a tensor from an array rank 3
data_rank3 = 0.0
tensor_rank3 = fckit_tensor_real64(data_rank3)

! a tensor from an array rank 4
data_rank4 = 0.0
tensor_rank4 = fckit_tensor_real64(data_rank4)


! check rank1 - tensor size/shape
tensor_size = tensor_rank1%size()
rank = tensor_rank1%rank()
tensor_shape = tensor_rank1%shape()
FCTEST_CHECK_EQUAL( tensor_size , 10 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 1 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 10 )
deallocate(tensor_shape)

! check rank2 - tensor size/shape
tensor_size = tensor_rank2%size()
rank = tensor_rank2%rank()
tensor_shape = tensor_rank2%shape()
FCTEST_CHECK_EQUAL( tensor_size , 3*4 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 2 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(2) , 4 )
deallocate(tensor_shape)

! check rank3 - tensor size/shape
tensor_size = tensor_rank3%size()
rank = tensor_rank3%rank()
tensor_shape = tensor_rank3%shape()
FCTEST_CHECK_EQUAL( tensor_size , 3*3*3 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(2) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(3) , 3 )
deallocate(tensor_shape)

! check rank4 - tensor size/shape
tensor_size = tensor_rank4%size()
rank = tensor_rank3%rank()
! allocate(tensor_shape(rank))
tensor_shape = tensor_rank4%shape()
FCTEST_CHECK_EQUAL( tensor_size , 2*3*4*5 )
FCTEST_CHECK_EQUAL( size(tensor_shape) , 4 )
FCTEST_CHECK_EQUAL( tensor_shape(1) , 2 )
FCTEST_CHECK_EQUAL( tensor_shape(2) , 3 )
FCTEST_CHECK_EQUAL( tensor_shape(3) , 4 )
FCTEST_CHECK_EQUAL( tensor_shape(4) , 5 )
deallocate(tensor_shape)


! finalise
call tensor_empty%final()
call tensor_from_shape%final()
call tensor_rank1%final()
call tensor_rank2%final()
call tensor_rank3%final()
call tensor_rank4%final()


#else
#warning Test "test_double_tensor_creation" disabled
#endif
END_TEST



TEST( test_tensor_double_interop )
#if 1

use iso_c_binding, only : c_double, c_size_t
use fckit_tensor_module, only : fckit_tensor_real64, fckit_tensor

type(fckit_tensor_real64) :: tensor_r3
type(fckit_tensor_real64) :: tensor_r4
real(c_double) :: data_r3(3,3,3)
real(c_double) :: data_r4(2,4,5,6)

integer(c_size_t) :: expected_size
integer(c_size_t) :: expected_rank
integer(c_int) :: expected_layout

! ---------------------- rank 3
data_r3(1,:,:) = 0.06
data_r3(2,:,:) = 1.06
data_r3(3,:,:) = 2.06
tensor_r3 = fckit_tensor_real64(data_r3, fckit_tensor%layout_rowmajor())

expected_size = 3*3*3
expected_rank = 3
expected_layout = fckit_tensor%layout_rowmajor()

! check tensor info from c++
call check_tensor_double(tensor_r3%c_ptr(), expected_size, expected_rank, expected_layout)

! check internal data.. 
call check_tensor_double_layout_r3(tensor_r3%c_ptr(), data_r3)


! ---------------------- rank 4
data_r4(1,:,:,:) = 1.16
data_r4(2,:,:,:) = 2.26
data_r4(:,:,:,6) = 3.36
tensor_r4 = fckit_tensor_real64(data_r4)  ! layout is colmajor (by default)

expected_size = 2*4*5*6
expected_rank = 4
expected_layout = fckit_tensor%layout_colmajor()

! check tensor info from c++
call check_tensor_double(tensor_r4%c_ptr(), expected_size, expected_rank, expected_layout)

! check internal data.. 
call check_tensor_double_layout_r4(tensor_r4%c_ptr(), data_r4)


#else
#warning Test "test_tensor_double_interop" disabled
#endif
END_TEST



TEST ( test_tensor_double_creation_from_cpp )
#if 1

use iso_c_binding, only : c_ptr, c_int, c_size_t
use fckit_tensor_module, only : fckit_tensor_real64, fckit_tensor

type(fckit_tensor_real64) :: tensor

integer(c_int) :: tensor_shape_input(4) = (/ 4,2,3,4 /)
integer(c_size_t), allocatable :: tensor_shape(:)
integer(c_size_t) :: expected_size = 4*2*3*4
integer(c_size_t) :: expected_rank = 4
integer(c_size_t) :: expected_shape(4) = (/ 4,2,3,4 /)

call tensor%reset_c_ptr(create_tensor_double_filled(tensor_shape_input, size(tensor_shape_input), fckit_tensor%layout_colmajor()))

FCTEST_CHECK_EQUAL( tensor%size(), expected_size )
FCTEST_CHECK_EQUAL( tensor%rank(), expected_rank )


tensor_shape = tensor%shape()

FCTEST_CHECK_EQUAL( tensor_shape(1), expected_shape(1) )
FCTEST_CHECK_EQUAL( tensor_shape(2), expected_shape(2) )
FCTEST_CHECK_EQUAL( tensor_shape(3), expected_shape(3) )
FCTEST_CHECK_EQUAL( tensor_shape(4), expected_shape(4) )

FCTEST_CHECK_EQUAL( tensor%layout(), fckit_tensor%layout_colmajor() )

! deallocation
deallocate(tensor_shape)
call delete_tensor_double(tensor%c_ptr())

#else
#warning Test "test_tensor_double_creation_from_cpp" disabled
#endif
END_TEST


END_TESTSUITE

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

subroutine run() bind(c)
  use fckit_module
  character(len=:), allocatable :: name

  call fckit_main%name(name)
  call fckit_log%info("info: "//name)
  call fckit_log%debug("debug")
  if( .not. fckit_main%debug() ) then
    call fckit_log%warning("main debug not active")
  endif
end subroutine

#include "fckit/fckit.h"

module fckit_tensor_module

use iso_c_binding, only : c_int, &
                          c_ptr, &
                          c_size_t, &
                          c_float, &
                          c_double, &
                          c_f_pointer

use fckit_array_module, only: array_view1d
use fckit_c_interop_module, only : c_ptr_free
use fckit_shared_object_module, only : fckit_shared_object, &
                                       fckit_c_deleter, &
                                       fckit_c_nodeleter

implicit none

public :: fckit_tensor_real32
public :: fckit_tensor_real64

private

#include "fckit_tensor.inc"



! ======================================================
!                   fckit_tensor_real32
! ======================================================
type, extends(fckit_shared_object) :: fckit_tensor_real32
contains
  procedure         :: size     => fckit_tensor_real32__size
  procedure         :: rank     => fckit_tensor_real32__rank
  procedure         :: shape    => fckit_tensor_real32__shape
  procedure         :: fill     => fckit_tensor_real32__fill
  procedure         :: zero     => fckit_tensor_real32__zero
  procedure         :: layout   => fckit_tensor_real32__layout

  ! tensor layouts
  procedure, nopass :: layout_right    => fckit_tensor_layout_right
  procedure, nopass :: layout_left     => fckit_tensor_layout_left
  procedure, nopass :: layout_rowmajor => fckit_tensor_layout_rowmajor
  procedure, nopass :: layout_colmajor => fckit_tensor_layout_colmajor

#if FCKIT_FINAL_NOT_INHERITING
  final :: fckit_tensor_real32__final_auto
#endif
end type fckit_tensor_real32


! ======================================================
!                  fckit_tensor_real64
! ======================================================
type, extends(fckit_shared_object) :: fckit_tensor_real64
contains
  procedure         :: size     => fckit_tensor_real64__size
  procedure         :: rank     => fckit_tensor_real64__rank
  procedure         :: shape    => fckit_tensor_real64__shape
  procedure         :: fill     => fckit_tensor_real64__fill
  procedure         :: zero     => fckit_tensor_real64__zero
  procedure         :: layout   => fckit_tensor_real64__layout

  ! tensor layouts
  procedure, nopass :: layout_right    => fckit_tensor_layout_right
  procedure, nopass :: layout_left     => fckit_tensor_layout_left
  procedure, nopass :: layout_rowmajor => fckit_tensor_layout_rowmajor
  procedure, nopass :: layout_colmajor => fckit_tensor_layout_colmajor

#if FCKIT_FINAL_NOT_INHERITING
  final :: fckit_tensor_real64__final_auto
#endif
end type fckit_tensor_real64


interface fckit_tensor_real32
  module procedure ctor_float_empty
  module procedure ctor_float_from_cptr
  module procedure ctor_float_from_shape
  module procedure ctor_from_float_array_rank1
  module procedure ctor_from_float_array_rank2
  module procedure ctor_from_float_array_rank3
  module procedure ctor_from_float_array_rank4
end interface


interface fckit_tensor_real64
  module procedure ctor_double_empty
  module procedure ctor_double_from_cptr
  module procedure ctor_double_from_shape
  module procedure ctor_from_double_array_rank1
  module procedure ctor_from_double_array_rank2
  module procedure ctor_from_double_array_rank3
  module procedure ctor_from_double_array_rank4
end interface


! used to access layout "nopass" methods
type(fckit_tensor_real32) :: fckit_tensor

public :: fckit_tensor

private :: c_int, c_ptr, c_size_t, c_float, c_double, c_f_pointer
private :: fckit_shared_object
private :: fckit_c_deleter
private :: fckit_c_nodeleter

contains


! --- tensor layouts ---
function fckit_tensor_layout_right() result(code)
  integer(c_int) :: code
  code = c_fckit_tensor_layout_right()
end function

function fckit_tensor_layout_left() result(code)
  integer(c_int) :: code
  code = c_fckit_tensor_layout_left()
end function

function fckit_tensor_layout_rowmajor() result(code)
  integer(c_int) :: code
  code = c_fckit_tensor_layout_rowmajor()
end function

function fckit_tensor_layout_colmajor() result(code)
  integer(c_int) :: code
  code = c_fckit_tensor_layout_colmajor()
end function



! ctor's
function ctor_float_empty(layout) result(this)
  type(fckit_tensor_real32) :: this
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  type(c_ptr) :: obj

  if (present(layout)) layout_actual = layout

  obj = c_fckit_tensor_real32_empty_new(layout_actual)
  call this%reset_c_ptr( obj, fckit_c_deleter(c_fckit_tensor_real32_delete) )
  call this%return() 
end function

function ctor_float_from_cptr(cptr, own) result(this)
  type(c_ptr), value :: cptr
  type(fckit_tensor_real32) :: this
  logical, optional :: own
  logical :: opt_own
  opt_own = .false.
  if( present(own) ) opt_own = own
  if( opt_own ) then
    call this%reset_c_ptr( cptr, fckit_c_deleter(c_fckit_tensor_real32_delete) )
  else
    call this%reset_c_ptr( cptr, fckit_c_nodeleter() )
  endif
  call this%return()
end function


function ctor_float_from_shape(shape, layout) result(this)
  type(fckit_tensor_real32) :: this
  integer(c_size_t),  intent(in) :: shape(:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  rank = size(shape)
  call this%reset_c_ptr( c_fckit_tensor_real32_from_shape_new(rank, shape, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real32_delete) )
  call this%return()
end function


function ctor_from_float_array_rank1(tensor, layout) result(this)
  type(fckit_tensor_real32) :: this
  real(c_float), intent(in), target :: tensor(:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_float), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(1)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real32_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real32_delete) )
  call this%return()  
end function


function ctor_from_float_array_rank2(tensor, layout) result(this)
  type(fckit_tensor_real32) :: this
  real(c_float), intent(in), target :: tensor(:,:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_float), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(2)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real32_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real32_delete) )
  call this%return()  
end function

function ctor_from_float_array_rank3(tensor, layout) result(this)
  type(fckit_tensor_real32) :: this
  real(c_float), intent(in), target :: tensor(:,:,:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_float), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(3)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real32_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real32_delete) )
  call this%return()  
end function


function ctor_from_float_array_rank4(tensor, layout) result(this)
  type(fckit_tensor_real32) :: this
  real(c_float), intent(in), target :: tensor(:,:,:,:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_float), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(4)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real32_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real32_delete) )
  call this%return()  
end function
  

! number of elements
function fckit_tensor_real32__size(this) result(val)
  class(fckit_tensor_real32), intent(in) :: this
  integer(c_size_t) :: val
  val = c_fckit_tensor_real32_size(this%c_ptr())
end function


! number of elements
function fckit_tensor_real32__rank(this) result(val)
  class(fckit_tensor_real32), intent(in) :: this
  integer(c_size_t) :: val
  val = c_fckit_tensor_real32_rank(this%c_ptr())
end function


! shape of the tensor
function fckit_tensor_real32__shape(this) result(shape_array)
  class(fckit_tensor_real32), intent(in)  :: this
  integer(c_size_t),   allocatable :: shape_array(:)
  integer(c_size_t),   pointer     :: shape_fptr(:)
  type(c_ptr)                      :: shape_cptr
  integer(c_size_t)                :: rank
  ! get shape and shape-size
  call c_fckit_tensor_real32_shape(this%c_ptr(), shape_cptr, rank)
  call c_f_pointer(shape_cptr, shape_fptr, (/rank/))
  allocate(shape_array(rank))
  shape_array(:) = shape_fptr(:)
  call c_ptr_free(shape_cptr)
end function

! fill it in with value
subroutine fckit_tensor_real32__fill(this, val)
  class(fckit_tensor_real32), intent(inout) :: this
  real(c_float), intent(in) :: val
  call c_fckit_tensor_real32_fill(this%c_ptr(), val)
end subroutine

! fill it in with "0"s
subroutine fckit_tensor_real32__zero(this)
  class(fckit_tensor_real32), intent(inout) :: this
  call c_fckit_tensor_real32_zero(this%c_ptr())
end subroutine

! tensor layout
function fckit_tensor_real32__layout(this) result(val)
  class(fckit_tensor_real32), intent(in) :: this
  integer(c_int) :: val
  val = c_fckit_tensor_real32_layout(this%c_ptr())
end function



#if FCKIT_FINAL_NOT_INHERITING
FCKIT_FINAL subroutine fckit_tensor_real32__final_auto(this)
  type(fckit_tensor_real32), intent(inout) :: this
#if FCKIT_FINAL_DEBUGGING
  write(0,*) "fckit_tensor_real32__final_auto"
#endif
#if FCKIT_FINAL_NOT_PROPAGATING
  call this%final()
#endif
  FCKIT_SUPPRESS_UNUSED( this )
end subroutine
#endif



! ======================================================
!                  fckit_tensor_real64
! ======================================================

! ctor's
function ctor_double_empty(layout) result(this)
  type(fckit_tensor_real64) :: this
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  type(c_ptr) :: obj

  if (present(layout)) layout_actual = layout
  obj = c_fckit_tensor_real64_empty_new(layout_actual)

  call this%reset_c_ptr( obj, fckit_c_deleter(c_fckit_tensor_real64_delete) )
  call this%return() 
end function


function ctor_double_from_cptr(cptr, own) result(this)
  type(c_ptr), value :: cptr
  type(fckit_tensor_real64) :: this
  logical, optional :: own
  logical :: opt_own
  opt_own = .false.
  if( present(own) ) opt_own = own
  if( opt_own ) then
    call this%reset_c_ptr( cptr, fckit_c_deleter(c_fckit_tensor_real64_delete) )
  else
    call this%reset_c_ptr( cptr, fckit_c_nodeleter() )
  endif
  call this%return()
end function


function ctor_double_from_shape(shape, layout) result(this)
  type(fckit_tensor_real64) :: this
  integer(c_size_t),  intent(in) :: shape(:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  integer(c_size_t)     :: rank

  if (present(layout)) layout_actual = layout
  rank = size(shape)
  call this%reset_c_ptr( c_fckit_tensor_real64_from_shape_new(rank, shape, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real64_delete) )
  call this%return()
end function


function ctor_from_double_array_rank1(tensor, layout) result(this)
  type(fckit_tensor_real64) :: this
  real(c_double), intent(in), target :: tensor(:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_double), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(1)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real64_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real64_delete) )
  call this%return()  
end function


function ctor_from_double_array_rank2(tensor, layout) result(this)
  type(fckit_tensor_real64) :: this
  real(c_double), intent(in), target :: tensor(:,:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_double), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(2)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real64_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real64_delete) )
  call this%return()  
end function

function ctor_from_double_array_rank3(tensor, layout) result(this)
  type(fckit_tensor_real64) :: this
  real(c_double), intent(in), target :: tensor(:,:,:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_double), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(3)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real64_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real64_delete) )
  call this%return()  
end function


function ctor_from_double_array_rank4(tensor, layout) result(this)
  type(fckit_tensor_real64) :: this
  real(c_double), intent(in), target :: tensor(:,:,:,:)
  integer(c_int), intent(in), optional :: layout
  integer(c_int) :: layout_actual = 1 ! left-layout (col-major)
  real(c_double), pointer :: data_vec(:)
  integer(c_size_t) :: shape_vec(4)
  integer(c_size_t) :: rank

  if (present(layout)) layout_actual = layout
  data_vec => array_view1d( tensor )
  shape_vec = shape(tensor)
  rank = size(shape_vec)

  call this%reset_c_ptr( c_fckit_tensor_real64_from_array_rank1_new(rank, shape_vec, data_vec, layout_actual), &
                         fckit_c_deleter(c_fckit_tensor_real64_delete) )
  call this%return()  
end function
  

! number of elements
function fckit_tensor_real64__size(this) result(val)
  class(fckit_tensor_real64), intent(in) :: this
  integer(c_size_t) :: val
  val = c_fckit_tensor_real64_size(this%c_ptr())
end function

! number of elements
function fckit_tensor_real64__rank(this) result(val)
  class(fckit_tensor_real64), intent(in) :: this
  integer(c_size_t) :: val
  val = c_fckit_tensor_real64_rank(this%c_ptr())
end function

! shape of the tensor
function fckit_tensor_real64__shape(this) result(shape_array)
  class(fckit_tensor_real64), intent(in)  :: this
  integer(c_size_t),   allocatable :: shape_array(:)
  integer(c_size_t),   pointer     :: shape_fptr(:)
  type(c_ptr)                      :: shape_cptr
  integer(c_size_t)                :: rank
  ! get shape and shape-size
  call c_fckit_tensor_real64_shape(this%c_ptr(), shape_cptr, rank)
  call c_f_pointer(shape_cptr, shape_fptr, (/rank/))
  allocate(shape_array(rank))
  shape_array(:) = shape_fptr(:)
  call c_ptr_free(shape_cptr)
end function

! fill it in with value
subroutine fckit_tensor_real64__fill(this, val)
  class(fckit_tensor_real64), intent(inout) :: this
  real(c_double), intent(in) :: val
  call c_fckit_tensor_real64_fill(this%c_ptr(), val)
end subroutine

! fill it in with "0"s
subroutine fckit_tensor_real64__zero(this)
  class(fckit_tensor_real64), intent(inout) :: this
  call c_fckit_tensor_real64_zero(this%c_ptr())
end subroutine

! is right-layout tensor? 
function fckit_tensor_real64__layout(this) result(val)
  class(fckit_tensor_real64), intent(in) :: this
  integer(c_int) :: val
  val = c_fckit_tensor_real64_layout(this%c_ptr())
end function



#if FCKIT_FINAL_NOT_INHERITING
FCKIT_FINAL subroutine fckit_tensor_real64__final_auto(this)
  type(fckit_tensor_real64), intent(inout) :: this
#if FCKIT_FINAL_DEBUGGING
  write(0,*) "fckit_tensor_real64__final_auto"
#endif
#if FCKIT_FINAL_NOT_PROPAGATING
  call this%final()
#endif
  FCKIT_SUPPRESS_UNUSED( this )
end subroutine
#endif

end module fckit_tensor_module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.


#include "fckit/fctest.h"

module fctest_TestFixture
  implicit none
  integer, allocatable :: array(:)
end module

TESTSUITE_WITH_FIXTURE( fctest_example_with_fixture, fctest_TestFixture )

TESTSUITE_INIT
  write(0,*) "initializing testsuite"
  allocate( array(4) )
END_TESTSUITE_INIT

TESTSUITE_FINALIZE
  write(0,*) "finalizing testsuite"
  deallocate( array )
  ! Mark test as passed, as it was supposed to fail otherwise
  exit_status = 0
END_TESTSUITE_FINALIZE



TEST( test1 )
  write(0,*) "test1"
  CHECK_EQUAL( size(array), 4 ) ! description here
END_TEST

TEST( test2 )
  write(0,*) "test2"
  CHECK_EQUAL( size(array), 2 ) ! description here
END_TEST

END_TESTSUITE

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_C_interop_module
implicit none
private

!========================================================================
! Public interface

public :: c_ptr_free
public :: c_ptr_compare_equal
public :: c_ptr_to_loc
public :: get_c_commandline_arguments
public :: c_str_to_string
public :: c_ptr_to_string
public :: copy_c_ptr_to_string
public :: copy_c_str_to_string
public :: c_str
public :: c_str_no_trim
public :: c_str_right_trim
public :: fckit_c_deleter_interface
public :: fckit_c_deleter
public :: fckit_c_nodeleter

! =============================================================================
! External functions

interface

  subroutine c_ptr_free(ptr) bind(c, name="fckit__cptr_free")
    use, intrinsic :: iso_c_binding, only: c_ptr
    type(c_ptr), value :: ptr
  end subroutine

  !int fckit__compare_cptr_equal( void* p1, void* p2 )
  function fckit__compare_cptr_equal(p1,p2) bind(c,name="fckit__compare_cptr_equal") result(equal)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_int32_t
    integer(c_int32_t) :: equal
    type(c_ptr), value :: p1
    type(c_ptr), value :: p2
  end function

  function fckit__cptr_to_loc(cptr) bind(c,name="fckit__cptr_to_loc") result(loc)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_int64_t
    integer(c_int64_t) :: loc
    type(c_ptr), value :: cptr
  end function
end interface

abstract interface
  subroutine fckit_c_deleter_interface(cptr) bind(c)
    use, intrinsic :: iso_c_binding
    type(c_ptr), value :: cptr
  end subroutine
end interface


! =============================================================================
CONTAINS
! =============================================================================

function fckit_c_deleter( deleter )
  use, intrinsic :: iso_c_binding, only : c_funloc, c_funptr
  type(c_funptr) :: fckit_c_deleter
  procedure(fckit_c_deleter_interface) :: deleter
  fckit_c_deleter = c_funloc(deleter)
end function

subroutine fckit_c_nodelete(cptr) bind(c)
  use, intrinsic :: iso_c_binding
  type(c_ptr), value :: cptr
  FCKIT_SUPPRESS_UNUSED(cptr)
end subroutine

function fckit_c_nodeleter()
  use, intrinsic :: iso_c_binding, only : c_funloc, c_funptr
  type(c_funptr) :: fckit_c_nodeleter
  fckit_c_nodeleter = c_funloc(fckit_c_nodelete)
end function

function c_ptr_compare_equal(p1,p2) result(equal)
  use, intrinsic :: iso_c_binding, only: c_ptr
  logical :: equal
  type(c_ptr), intent(in) :: p1, p2
  if( fckit__compare_cptr_equal(p1,p2) == 1 ) then
    equal = .True.
  else
    equal = .False.
  endif
end function

function c_ptr_to_loc(cptr) result(loc)
  use, intrinsic :: iso_c_binding, only: c_ptr, c_int64_t
  integer(c_int64_t) :: loc
  type(c_ptr), intent(in) :: cptr
  loc = fckit__cptr_to_loc(cptr)
end function

! =============================================================================

subroutine get_c_commandline_arguments(argc,argv)
  use, intrinsic :: iso_c_binding
  integer(c_int), intent(out) :: argc
  type(c_ptr), intent(inout) :: argv(:)
  character(kind=c_char,len=1), save, target :: args(255)
  character(kind=c_char,len=255), save, target :: cmd
  character(kind=c_char,len=255) :: arg
  integer(c_int) :: iarg, arglen, pos, ich, argpos
  call get_command(cmd)
  do ich=1,len(cmd)
    if (cmd(ich:ich) == " ") then
      cmd(ich:ich) = c_null_char
      exit
    endif
  enddo
  argv(1) = c_loc(cmd(1:1))
  argc = command_argument_count()+1
  pos = 1
  do iarg=1,argc
    argpos = pos
    call get_command_argument(iarg, arg )
    arglen = len_trim(arg)
    do ich=1,arglen
      args(pos) = arg(ich:ich)
      pos = pos+1
    end do
    args(pos) = c_null_char;  pos = pos+1
    args(pos) = " ";          pos = pos+1
    argv(iarg+1) = c_loc(args(argpos))
  enddo
end subroutine

! =============================================================================

function c_str_to_string(s) result(string)
  use, intrinsic :: iso_c_binding
  character(kind=c_char,len=1), intent(in) :: s(*)
  character(len=:), allocatable :: string
  integer i, nchars
  i = 1
  do
     if (s(i) == c_null_char) exit
     i = i + 1
  enddo
  nchars = i - 1  ! Exclude null character from Fortran string
  FCKIT_ALLOCATE_CHARACTER(string,nchars)
  do i=1,nchars
    string(i:i) = s(i)
  enddo
end function

! =============================================================================

subroutine copy_c_str_to_string(s,string)
  use, intrinsic :: iso_c_binding
  character(kind=c_char,len=1), intent(in) :: s(*)
  character(len=:), allocatable :: string
  integer i, nchars
  i = 1
  do
     if (s(i) == c_null_char) exit
     i = i + 1
  enddo
  nchars = i - 1  ! Exclude null character from Fortran string
  FCKIT_ALLOCATE_CHARACTER(string,nchars)
  do i=1,nchars
    string(i:i) = s(i)
  enddo
end subroutine

! =============================================================================

subroutine copy_c_ptr_to_string(cptr,string)
  use, intrinsic :: iso_c_binding
  type(c_ptr), intent(in) :: cptr
  character(kind=c_char,len=:), allocatable :: string
  character(kind=c_char), dimension(:), pointer  :: s
  integer(c_int), parameter :: MAX_STR_LEN = 255
  call c_f_pointer ( cptr , s, (/MAX_STR_LEN/) )
  call copy_c_str_to_string( s, string )
end subroutine

! =============================================================================

function c_ptr_to_string(cptr) result(string)
  use, intrinsic :: iso_c_binding
  type(c_ptr), intent(in) :: cptr
  character(kind=c_char,len=:), allocatable :: string
  character(kind=c_char), dimension(:), pointer  :: s
  integer(c_int), parameter :: MAX_STR_LEN = 255
  call c_f_pointer ( cptr , s, (/MAX_STR_LEN/) )
  call copy_c_str_to_string( s, string )
end function

! =============================================================================

function c_str(f_str)
  use, intrinsic :: iso_c_binding, only: c_char, c_null_char
  character(kind=c_char,len=*), intent(in) :: f_str
  character(kind=c_char,len=len_trim(f_str)+1) :: c_str
  c_str = trim(f_str) // c_null_char
end function

! =============================================================================

function c_str_no_trim(f_str)
  use, intrinsic :: iso_c_binding, only: c_char, c_null_char
  character(kind=c_char,len=*), intent(in) :: f_str
  character(kind=c_char,len=len(f_str)+1) :: c_str_no_trim
  c_str_no_trim = f_str // c_null_char
end function

! =============================================================================

function c_str_right_trim(f_str)
  use, intrinsic :: iso_c_binding, only: c_char, c_null_char
  character(kind=c_char,len=*), intent(in) :: f_str
  character(kind=c_char,len=len(f_str)+1) :: c_str_right_trim
  c_str_right_trim = f_str(1:len_trim(f_str)) // c_null_char
end function

! =============================================================================
end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.



#include "fckit/fctest.h"

! -----------------------------------------------------------------------------

module fcta_shared_ptr_f_fxt
! use fckit_object_module
use fckit_final_module
use fckit_shared_ptr_module
use fckit_shared_object_module
! use fckit_c_interop_module

use fctest
implicit none

integer, SAVE :: final_called = 0
integer, SAVE :: final_called_after_scope = 0
logical, SAVE :: scope_ended = .false.
logical, SAVE :: deallocate_called = .false.

! -----------------------------------------------------------------------------

! Unsafe because final is not guaranteed
type :: ObjectFortranUnsafe
  integer :: id = -1
    !! Data of Object (could be anything, like allocatable pointers)
contains
#if FCKIT_HAVE_FINAL
  final :: ObjectFortranUnsafe_final
#endif
endtype

! Safer because even if auto-final is not guaranteed, a manual final may finalise
type, extends(fckit_final) :: ObjectFortranSafer
  integer :: id = -1
    !! Data of Object (could be anything, like allocatable pointers)
contains
  procedure :: final => ObjectFortranSafer_final
    !! Destructor of the data (e.g. if deallocations need to happen)
endtype

! -----------------------------------------------------------------------------

interface
    function new_Object(i) bind(c,name="new_Object")
      use, intrinsic :: iso_c_binding, only : c_ptr, c_int32_t
      type(c_ptr) :: new_Object
      integer(c_int32_t), value :: i
    end function

   subroutine delete_Object(cptr) bind(c,name="delete_Object")
     use, intrinsic :: iso_c_binding, only : c_ptr
     type(c_ptr), value :: cptr
   end subroutine

   function Object__id(this) bind(c,name="Object__id")
     use, intrinsic :: iso_c_binding, only : c_ptr, c_int32_t
     type(c_ptr), value :: this
     integer(c_int32_t) :: Object__id
   end function

   function cxx_destructor_called() bind(c,name="cxx_destructor_called")
     use, intrinsic :: iso_c_binding, only : c_int32_t
     integer(c_int32_t) :: cxx_destructor_called
   end function

   function cxx_destructor_called_after_scope() bind(c,name="cxx_destructor_called_after_scope")
     use, intrinsic :: iso_c_binding, only : c_int32_t
     integer(c_int32_t) :: cxx_destructor_called_after_scope
   end function

   subroutine cxx_reset_counters() bind(c,name="cxx_reset_counters")
   end subroutine

   subroutine cxx_end_scope() bind(c,name="cxx_end_scope")
   end subroutine

end interface

type, extends(fckit_shared_object) :: ObjectCXX
contains
! public :
  procedure :: id => ObjectCXX_id

#if FCKIT_FINAL_NOT_INHERITING
  final :: ObjectCXX_final_auto
#endif
end type

interface ObjectCXX
  module procedure ObjectCXX_constructor
end interface

! -----------------------------------------------------------------------------
contains
! -----------------------------------------------------------------------------

subroutine reset_counters()
  deallocate_called = .false.
  final_called = 0
  final_called_after_scope = 0
  scope_ended = .false.
  call cxx_reset_counters()
end subroutine

subroutine end_scope()
  scope_ended = .true.
  call cxx_end_scope()
end subroutine

function ObjectCXX_constructor(id) result(this)
  type(ObjectCXX) :: this
  integer :: id
  call this%reset_c_ptr( new_Object(id) , fckit_c_deleter(delete_Object) )
  FCTEST_CHECK_EQUAL( this%owners(), 1 )
  call this%return()
end function

function ObjectCXX_id(this) result(id)
  class(ObjectCXX) :: this
  integer :: id
  id = Object__id( this%CPTR_PGIBUG_B )
end function

FCKIT_FINAL subroutine ObjectCXX_final_auto(this)
  type(ObjectCXX), intent(inout) :: this
  write(0,*) "ObjectCXX_final_auto"
#if FCKIT_FINAL_NOT_PROPAGATING
  call this%final()
#endif
  FCKIT_SUPPRESS_UNUSED( this )
end subroutine


subroutine ObjectFortranSafer_final(this)
  class(ObjectFortranSafer), intent(inout) :: this
  write(0,'(A,I0)') "ObjectFortranSafer_final id",this%id
  this%id = 0
  final_called = final_called + 1
  if( scope_ended ) final_called_after_scope = final_called_after_scope+1
end subroutine

FCKIT_FINAL subroutine ObjectFortranUnSafe_final(this)
  type(ObjectFortranUnSafe), intent(inout) :: this
  write(0,'(A,I0)') "ObjectFortranUnSafe_final id",this%id
  this%id = 0
  final_called = final_called + 1
  if( scope_ended ) final_called_after_scope = final_called_after_scope+1
end subroutine

! -----------------------------------------------------------------------------

end module fcta_shared_ptr_f_fxt

! -----------------------------------------------------------------------------

TESTSUITE_WITH_FIXTURE(fckit_test_shared_ptr_f,fcta_shared_ptr_f_fxt)

! -----------------------------------------------------------------------------

TESTSUITE_INIT
END_TESTSUITE_INIT

! -----------------------------------------------------------------------------

TESTSUITE_FINALIZE
END_TESTSUITE_FINALIZE

! -----------------------------------------------------------------------------

function create_ObjectFortranSafer(id) result(this)
  type(fckit_shared_ptr) :: this
  integer :: id
  class(ObjectFortranSafer), pointer :: ptr
  write(0,'(A,I0)') "Constructing ObjectFortranSafer, id = ",id
  allocate( ObjectFortranSafer::ptr )
  ptr%id = id
  write(0,'(A)') "----> this = fckit_make_shared( obj_ptr )"
  !this = fckit_make_shared( ptr )
  call this%share( ptr )
  write(0,'(A)') "<---- this = fckit_make_shared( obj_ptr )"
  FCTEST_CHECK_EQUAL( this%owners(), 1 )
  call this%return()
end function

subroutine test_shared_ptr_safer( final_auto )
  logical :: final_auto
  type(fckit_shared_ptr) :: obj1
  class(ObjectFortranSafer), pointer :: obj2_ptr => null()
  type(fckit_shared_ptr) :: obj2
  type(fckit_shared_ptr) :: obj3
  class(*), pointer :: shared_ptr

  write(0,'(A)') "~~~~~~~~~~~~~~ BEGIN SCOPE ~~~~~~~~~~~~~~"

  obj1 = create_ObjectFortranSafer(5)
  FCTEST_CHECK_EQUAL( obj1%owners(), 1 )

  obj2 = obj1
  FCTEST_CHECK_EQUAL( obj1%owners(), 2 )
  shared_ptr => obj2%shared_ptr()
  select type(shared_ptr)
    class is(ObjectFortranSafer)
      obj2_ptr=>shared_ptr
  end select
  FCTEST_CHECK( associated(obj2_ptr) )
  FCTEST_CHECK_EQUAL( obj2_ptr%id, 5 )
  obj3 = obj2
  FCTEST_CHECK_EQUAL( obj1%owners(), 3 )
  obj1 = obj3
  FCTEST_CHECK_EQUAL( obj1%owners(), 3 )
  if( .not. final_auto ) then
    write(0,*) "manual final , owners = ", obj1%owners()
    call obj1%final()
    FCTEST_CHECK_EQUAL( obj2%owners(), 2 )
    call obj2%final()
    FCTEST_CHECK_EQUAL( obj3%owners(), 1 )
    call obj3%final()
  endif

  write(0,'(A)') "~~~~~~~~~~~~~~~ END SCOPE ~~~~~~~~~~~~~~~"
  call end_scope()
end subroutine

TEST( test_shared_ptr_safer_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_ptr_safer_manual"

  call reset_counters()
  call test_shared_ptr_safer( .false. )
  FCTEST_CHECK_EQUAL( final_called , 1 )
  FCTEST_CHECK_EQUAL( final_called_after_scope , 0 )
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_ptr_safer_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_ptr_safer_auto"

  call reset_counters()
  call test_shared_ptr_safer( .true. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( final_called, 1 )
  FCTEST_CHECK_EQUAL( final_called_after_scope, 1 )
#else
  FCTEST_CHECK_EQUAL( final_called, 0 )
  FCTEST_CHECK_EQUAL( final_called_after_scope, 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

! -----------------------------------------------------------------------------

function create_ObjectFortranUnSafe(id) result(this)
  type(fckit_shared_ptr) :: this
  integer :: id
  class(ObjectFortranUnSafe), pointer :: ptr
  write(0,'(A,I0)') "Constructing ObjectFortranUnsafe, id = ",id
  allocate( ObjectFortranUnSafe::ptr )
  ptr%id = id
  call this%share( ptr )
  call this%return()
end function

subroutine test_shared_ptr_unsafe( final_auto )
  logical :: final_auto
  type(fckit_shared_ptr) :: obj1
  class(ObjectFortranUnSafe), pointer :: obj2_ptr => null()
  type(fckit_shared_ptr) :: obj2
  class(*), pointer :: shared_ptr

  write(0,'(A)') "~~~~~~~~~~~~~~ BEGIN SCOPE ~~~~~~~~~~~~~~"

  obj1 = create_ObjectFortranUnSafe(5)
  obj2 = obj1
  shared_ptr => obj2%shared_ptr()
  select type(shared_ptr)
    class is(ObjectFortranUnSafe)
      obj2_ptr=>shared_ptr
  end select
  FCTEST_CHECK( associated(obj2_ptr) )
  FCTEST_CHECK_EQUAL( obj2_ptr%id, 5 )

  if( .not. final_auto ) then
    call obj1%final()
    call obj2%final()
  endif

  write(0,'(A)') "~~~~~~~~~~~~~~~ END SCOPE ~~~~~~~~~~~~~~"
  call end_scope()
end subroutine

TEST( test_shared_ptr_unsafe_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST    test_shared_ptr_unsafe_manual"

  call reset_counters()
  FCTEST_CHECK_EQUAL( final_called, 0 )
  call test_shared_ptr_unsafe( .false. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( final_called, 1 )
  FCTEST_CHECK_EQUAL( final_called_after_scope, 0 )
#else
  FCTEST_CHECK_EQUAL( final_called, 0 )  ! --> without finalisation this didnt work as opposed to "safer"
  FCTEST_CHECK_EQUAL( final_called_after_scope, 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_ptr_unsafe_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST    test_shared_ptr_unsafe_auto"

  call reset_counters()
  call test_shared_ptr_unsafe( .true. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( final_called, 1 )
  FCTEST_CHECK_EQUAL( final_called_after_scope, 1 )
#else
  FCTEST_CHECK_EQUAL( final_called, 0 )
  FCTEST_CHECK_EQUAL( final_called_after_scope, 0 )
  write(0,'(A)') "WARNING    memory leaked"
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

! -----------------------------------------------------------------------------

subroutine test_shared_object( final_auto )

  logical :: final_auto
  type(ObjectCXX) :: obj1
  type(fckit_shared_ptr) :: obj2
  type(ObjectCXX) :: obj3

  write(0,'(A)') "~~~~~~~~~~~~~~ BEGIN SCOPE ~~~~~~~~~~~~~~~"

  obj1 = ObjectCXX(7)
  FCTEST_CHECK_EQUAL( obj1%id(), 7 )
  FCTEST_CHECK_EQUAL( obj1%owners(), 1 )

  write(0,*) "obj2 = obj1"
  obj2 = obj1
  FCTEST_CHECK_EQUAL( obj1%owners(), 2 )

  write(0,*) "obj3 = obj2"
  obj3 = obj2
  FCTEST_CHECK_EQUAL( obj1%owners(), 3 )
  FCTEST_CHECK_EQUAL( obj3%id(), 7 )

  write(0,*) "obj1 = obj3"
  obj1 = obj3

  FCTEST_CHECK_EQUAL( obj1%owners(), 3 )
  FCTEST_CHECK_EQUAL( obj2%owners(), 3 )

  write(0,*) "obj1 = ObjectCXX(4)"
  obj1 = ObjectCXX(4)
  FCTEST_CHECK_EQUAL( obj1%owners(), 1 )
  FCTEST_CHECK_EQUAL( obj2%owners(), 2 )

  if( .not. final_auto ) then
    call obj1%final()
    FCTEST_CHECK_EQUAL( obj2%owners(), 2 )
    call obj2%final()
    FCTEST_CHECK_EQUAL( obj3%owners(), 1 )
    call obj3%final()
  endif

  write(0,'(A)') "~~~~~~~~~~~~~~~ END SCOPE ~~~~~~~~~~~~~~~"
  call end_scope()
end subroutine

TEST( test_shared_object_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_manual"
  call reset_counters()
  call test_shared_object( final_auto = .false. )
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_auto"
  call reset_counters()
  call test_shared_object( final_auto = .true. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

! -----------------------------------------------------------------------------

subroutine test_shared_object_allocatable( final_auto, deallocate_auto )

  logical :: final_auto
  logical :: deallocate_auto
  type(ObjectCXX), allocatable :: obj1

  write(0,'(A)') "~~~~~~~~~~~~~~ BEGIN SCOPE ~~~~~~~~~~~~~~~"

  allocate( obj1 )
  obj1 = ObjectCXX(7)
  FCTEST_CHECK_EQUAL( obj1%id(), 7 )
  FCTEST_CHECK_EQUAL( obj1%owners(), 1 )

  if( .not. final_auto ) then
    call obj1%final()
  endif

  if( .not. deallocate_auto ) then
    write(0,'(A)') "~~~~~~~~~~~~~~ DEALLOCATE ~~~~~~~~~~~~~~~"
    deallocate_called = .true.
    deallocate( obj1 )
  endif

  write(0,'(A)') "~~~~~~~~~~~~~~~ END SCOPE ~~~~~~~~~~~~~~~"
  call end_scope()
end subroutine

TEST( test_shared_object_allocatable_auto_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_auto_auto"
  call reset_counters()
  call test_shared_object_allocatable( final_auto = .true., deallocate_auto = .true. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 1 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 1 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_allocatable_auto_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_auto_manual"
  call reset_counters()
  call test_shared_object_allocatable( final_auto = .true., deallocate_auto = .false. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 1 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_allocatable_manual_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_manual_auto"
  call reset_counters()
  call test_shared_object_allocatable( final_auto = .false., deallocate_auto = .true. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 1 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 1 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_allocatable_manual_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_manual_manual"
  call reset_counters()
  call test_shared_object_allocatable( final_auto = .false., deallocate_auto = .false. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 1 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 1 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

! -----------------------------------------------------------------------------

#if defined(_CRAYFTN) && FCKIT_HAVE_FINAL
#define CRAY_WORKAROUND .true.
#else
#define CRAY_WORKAROUND .false.
#endif

subroutine test_shared_object_allocatable_list( final_auto, deallocate_auto )

  logical :: final_auto
  logical :: deallocate_auto
  type(ObjectCXX), allocatable :: list(:)

  write(0,'(A)') "~~~~~~~~~~~~~~ BEGIN SCOPE ~~~~~~~~~~~~~~~"

  allocate( list(2) )
  list(1) = ObjectCXX(1)
  list(2) = ObjectCXX(2)
  write(0,*) "assigned"
  FCTEST_CHECK_EQUAL( list(1)%id(), 1 )
  FCTEST_CHECK_EQUAL( list(1)%owners(), 1 )
  FCTEST_CHECK_EQUAL( list(2)%id(), 2 )
  FCTEST_CHECK_EQUAL( list(2)%owners(), 1 )

  if( .not. final_auto ) then
    write(0,'(A)') "~~~~~~~~~~~~~~ MANNUALLY DEALLOCATE EACH LIST ELEMENT ~~~~~~~~~~~~~~~"
    call list(1)%final()
    call list(2)%final()
  endif

  if( .not. deallocate_auto ) then
    write(0,'(A)') "~~~~~~~~~~~~~~ DEALLOCATE LIST ~~~~~~~~~~~~~~~"
    deallocate_called = .true.
    if( CRAY_WORKAROUND ) then
      write(0,'(A)') "Cray compiler bug (cce/8.5 tested) causes SEGV when the automatic finalization at end of scope kicks in."
      write(0,'(A)') "Therefore we avoid the deallocate( list ) above, to make test pass."
      write(0,'(A)') "This means that with FCKIT_HAVE_FINAL turn on, we cannot manually call deallocate(list)"
    else
      deallocate( list )
    endif
  endif

  write(0,'(A)') "~~~~~~~~~~~~~~~ END SCOPE ~~~~~~~~~~~~~~~"
  call end_scope()
end subroutine

TEST( test_shared_object_allocatable_list_auto_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_list_auto_auto"
  call reset_counters()
  call test_shared_object_allocatable_list( final_auto = .true., deallocate_auto = .true. )
#if FCKIT_HAVE_FINAL
#if ! FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 2 )
#endif
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_allocatable_list_auto_manual )
#if 1
  integer :: zero
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_list_auto_manual"
  call reset_counters()
  call test_shared_object_allocatable_list( final_auto = .true., deallocate_auto = .false. )
  write(0,'(A)') '----'

  zero = 0
  if( CRAY_WORKAROUND ) zero = 2

#if FCKIT_HAVE_FINAL
#if ! FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), zero )
#endif
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#else
#ifndef __ibmxl__
#warning test_shared_object_allocatable_list_auto_manual disabled
#endif
#endif
END_TEST

TEST( test_shared_object_allocatable_list_manual_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_list_manual_auto"
  call reset_counters()
  call test_shared_object_allocatable_list( final_auto = .false., deallocate_auto = .true. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#else
#ifndef __ibmxl__
#warning test_shared_object_allocatable_list_manual_auto disabled
#endif
#endif
END_TEST

TEST( test_shared_object_allocatable_list_manual_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_list_manual_manual"
  call reset_counters()
  call test_shared_object_allocatable_list( final_auto = .false., deallocate_auto = .false. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#else
#ifndef __ibmxl__
#warning test_shared_object_allocatable_list_manual_manual disabled
#endif
#endif
END_TEST

! -----------------------------------------------------------------------------

subroutine test_shared_object_pointer_list( final_auto, deallocate_auto )

  logical :: final_auto
  logical :: deallocate_auto
  type(ObjectCXX), pointer :: list(:)

  write(0,'(A)') "~~~~~~~~~~~~~~ BEGIN SCOPE ~~~~~~~~~~~~~~~"

  allocate( list(2) )
  write(0,*) "allocated"
  list(1) = ObjectCXX(1)
  list(2) = ObjectCXX(2)
  write(0,*) "assigned"
  FCTEST_CHECK_EQUAL( list(1)%id(), 1 )
  FCTEST_CHECK_EQUAL( list(1)%owners(), 1 )
  FCTEST_CHECK_EQUAL( list(2)%id(), 2 )
  FCTEST_CHECK_EQUAL( list(2)%owners(), 1 )

  if( .not. final_auto ) then
    call list(1)%final()
    call list(2)%final()
  endif

  if( .not. deallocate_auto ) then
    write(0,'(A)') "~~~~~~~~~~~~~~ DEALLOCATE ~~~~~~~~~~~~~~~"
    deallocate_called = .true.
    deallocate( list )
  endif

  write(0,'(A)') "~~~~~~~~~~~~~~~ END SCOPE ~~~~~~~~~~~~~~~"
  call end_scope()
  if( associated(list) ) deallocate( list )
end subroutine

TEST( test_shared_object_pointer_list_auto_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_pointer_list_auto_auto"
  call reset_counters()
  call test_shared_object_pointer_list( final_auto = .true., deallocate_auto = .true. )
#if FCKIT_HAVE_FINAL
#if ! FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 2 )
#endif
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_pointer_list_auto_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_pointer_list_auto_manual"
  call reset_counters()
  call test_shared_object_pointer_list( final_auto = .true., deallocate_auto = .false. )
#if FCKIT_HAVE_FINAL
#if ! FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#endif
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_pointer_list_manual_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_pointer_list_manual_auto"
  call reset_counters()
  call test_shared_object_pointer_list( final_auto = .false., deallocate_auto = .true. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_pointer_list_manual_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_pointer_list_manual_manual"
  call reset_counters()
  call test_shared_object_pointer_list( final_auto = .false., deallocate_auto = .false. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST


! -----------------------------------------------------------------------------

subroutine test_shared_object_automatic_list( final_auto )
#if 1
  logical :: final_auto
  type(ObjectCXX) :: list(2)

  write(0,'(A)') "~~~~~~~~~~~~~~ BEGIN SCOPE ~~~~~~~~~~~~~~~"

  list(1) = ObjectCXX(1)
  list(2) = ObjectCXX(2)
  write(0,'(A)') "assigned"
  FCTEST_CHECK_EQUAL( list(1)%id(), 1 )
  FCTEST_CHECK_EQUAL( list(1)%owners(), 1 )
  FCTEST_CHECK_EQUAL( list(2)%id(), 2 )
  FCTEST_CHECK_EQUAL( list(2)%owners(), 1 )

  if( .not. final_auto ) then
    call list(1)%final()
    call list(2)%final()
  endif

  write(0,'(A)') "~~~~~~~~~~~~~~~ END SCOPE ~~~~~~~~~~~~~~~"
  call end_scope()
#endif
end subroutine

TEST( test_shared_object_automatic_list_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_automatic_list_auto"
  call reset_counters()
  call test_shared_object_automatic_list( final_auto = .true. )
#if FCKIT_HAVE_FINAL
#if ! FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 2 )
#endif
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_automatic_list_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_automatic_list_manual"
  call reset_counters()
  call test_shared_object_automatic_list( final_auto = .false. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

! -----------------------------------------------------------------------------

END_TESTSUITE

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

#include "fckit/fckit.h"

module fckit_C_interop_module
implicit none
private

!========================================================================
! Public interface

public :: c_ptr_free
public :: c_ptr_compare_equal
public :: c_ptr_to_loc
public :: get_c_commandline_arguments
public :: c_str_to_string
public :: c_ptr_to_string
public :: copy_c_ptr_to_string
public :: copy_c_str_to_string
public :: c_str
public :: c_str_no_trim
public :: c_str_right_trim
public :: fckit_c_deleter_interface
public :: fckit_c_deleter
public :: fckit_c_nodeleter

! =============================================================================
! External functions

interface

  subroutine c_ptr_free(ptr) bind(c, name="fckit__cptr_free")
    use, intrinsic :: iso_c_binding, only: c_ptr
    type(c_ptr), value :: ptr
  end subroutine

  !int fckit__compare_cptr_equal( void* p1, void* p2 )
  function fckit__compare_cptr_equal(p1,p2) bind(c,name="fckit__compare_cptr_equal") result(equal)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_int32_t
    integer(c_int32_t) :: equal
    type(c_ptr), value :: p1
    type(c_ptr), value :: p2
  end function

  function fckit__cptr_to_loc(cptr) bind(c,name="fckit__cptr_to_loc") result(loc)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_int64_t
    integer(c_int64_t) :: loc
    type(c_ptr), value :: cptr
  end function
end interface

abstract interface
  subroutine fckit_c_deleter_interface(cptr) bind(c)
    use, intrinsic :: iso_c_binding
    type(c_ptr), value :: cptr
  end subroutine
end interface


! =============================================================================
CONTAINS
! =============================================================================

function fckit_c_deleter( deleter )
  use, intrinsic :: iso_c_binding, only : c_funloc, c_funptr
  type(c_funptr) :: fckit_c_deleter
  procedure(fckit_c_deleter_interface) :: deleter
  fckit_c_deleter = c_funloc(deleter)
end function

subroutine fckit_c_nodelete(cptr) bind(c)
  use, intrinsic :: iso_c_binding
  type(c_ptr), value :: cptr
  FCKIT_SUPPRESS_UNUSED(cptr)
end subroutine

function fckit_c_nodeleter()
  use, intrinsic :: iso_c_binding, only : c_funloc, c_funptr
  type(c_funptr) :: fckit_c_nodeleter
  fckit_c_nodeleter = c_funloc(fckit_c_nodelete)
end function

function c_ptr_compare_equal(p1,p2) result(equal)
  use, intrinsic :: iso_c_binding, only: c_ptr
  logical :: equal
  type(c_ptr), intent(in) :: p1, p2
  if( fckit__compare_cptr_equal(p1,p2) == 1 ) then
    equal = .True.
  else
    equal = .False.
  endif
end function

function c_ptr_to_loc(cptr) result(loc)
  use, intrinsic :: iso_c_binding, only: c_ptr, c_int64_t
  integer(c_int64_t) :: loc
  type(c_ptr), intent(in) :: cptr
  loc = fckit__cptr_to_loc(cptr)
end function

! =============================================================================

subroutine get_c_commandline_arguments(argc,argv)
  use, intrinsic :: iso_c_binding
  integer(c_int), intent(out) :: argc
  type(c_ptr), intent(inout) :: argv(:)
  character(kind=c_char,len=1), save, target :: args(255)
  character(kind=c_char,len=255), save, target :: cmd
  character(kind=c_char,len=255) :: arg
  integer(c_int) :: iarg, arglen, pos, ich, argpos
  call get_command(cmd)
  do ich=1,len(cmd)
    if (cmd(ich:ich) == " ") then
      cmd(ich:ich) = c_null_char
      exit
    endif
  enddo
  argv(1) = c_loc(cmd(1:1))
  argc = command_argument_count()+1
  pos = 1
  do iarg=1,argc
    argpos = pos
    call get_command_argument(iarg, arg )
    arglen = len_trim(arg)
    do ich=1,arglen
      args(pos) = arg(ich:ich)
      pos = pos+1
    end do
    args(pos) = c_null_char;  pos = pos+1
    args(pos) = " ";          pos = pos+1
    argv(iarg+1) = c_loc(args(argpos))
  enddo
end subroutine

! =============================================================================

function c_str_to_string(s) result(string)
  use, intrinsic :: iso_c_binding
  character(kind=c_char,len=1), intent(in) :: s(*)
  character(len=:), allocatable :: string
  integer i, nchars
  i = 1
  do
     if (s(i) == c_null_char) exit
     i = i + 1
  enddo
  nchars = i - 1  ! Exclude null character from Fortran string
  FCKIT_ALLOCATE_CHARACTER(string,nchars)
  do i=1,nchars
    string(i:i) = s(i)
  enddo
end function

! =============================================================================

subroutine copy_c_str_to_string(s,string)
  use, intrinsic :: iso_c_binding
  character(kind=c_char,len=1), intent(in) :: s(:)
  character(len=:), allocatable :: string
  integer i, nchars
  do i = 1, size(s)
     if (s(i) == c_null_char) exit
  enddo
  nchars = i - 1  ! Exclude null character from Fortran string
  FCKIT_ALLOCATE_CHARACTER(string,nchars)
  do i=1,nchars
    string(i:i) = s(i)
  enddo
end subroutine

! =============================================================================

subroutine copy_c_ptr_to_string(cptr,string)
  use, intrinsic :: iso_c_binding
  type(c_ptr), intent(in) :: cptr
  character(kind=c_char,len=:), allocatable :: string
  character(kind=c_char), dimension(:), pointer  :: s
  integer(c_int), parameter :: MAX_STR_LEN = 2550
  call c_f_pointer ( cptr , s, (/MAX_STR_LEN/) )
  call copy_c_str_to_string( s, string )
end subroutine

! =============================================================================

function c_ptr_to_string(cptr) result(string)
  use, intrinsic :: iso_c_binding
  type(c_ptr), intent(in) :: cptr
  character(kind=c_char,len=:), allocatable :: string
  character(kind=c_char), dimension(:), pointer  :: s
  integer(c_int), parameter :: MAX_STR_LEN = 2550
  call c_f_pointer ( cptr , s, (/MAX_STR_LEN/) )
  call copy_c_str_to_string( s, string )
end function

! =============================================================================

function c_str(f_str)
  use, intrinsic :: iso_c_binding, only: c_char, c_null_char
  character(kind=c_char,len=*), intent(in) :: f_str
  character(kind=c_char,len=len_trim(f_str)+1) :: c_str
  c_str = trim(f_str) // c_null_char
end function

! =============================================================================

function c_str_no_trim(f_str)
  use, intrinsic :: iso_c_binding, only: c_char, c_null_char
  character(kind=c_char,len=*), intent(in) :: f_str
  character(kind=c_char,len=len(f_str)+1) :: c_str_no_trim
  c_str_no_trim = f_str // c_null_char
end function

! =============================================================================

function c_str_right_trim(f_str)
  use, intrinsic :: iso_c_binding, only: c_char, c_null_char
  character(kind=c_char,len=*), intent(in) :: f_str
  character(kind=c_char,len=len(f_str)+1) :: c_str_right_trim
  c_str_right_trim = f_str(1:len_trim(f_str)) // c_null_char
end function

! =============================================================================
end module

! (C) Copyright 2013 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.



#include "fckit/fctest.h"

! -----------------------------------------------------------------------------

module fcta_shared_ptr_f_fxt
! use fckit_object_module
use fckit_final_module
use fckit_shared_ptr_module
use fckit_shared_object_module
! use fckit_c_interop_module

use fctest
implicit none

integer, SAVE :: final_called = 0
integer, SAVE :: final_called_after_scope = 0
logical, SAVE :: scope_ended = .false.
logical, SAVE :: deallocate_called = .false.

! -----------------------------------------------------------------------------

! Unsafe because final is not guaranteed
type :: ObjectFortranUnsafe
  integer :: id = -1
    !! Data of Object (could be anything, like allocatable pointers)
contains
#if FCKIT_HAVE_FINAL
  final :: ObjectFortranUnsafe_final
#endif
endtype

! Safer because even if auto-final is not guaranteed, a manual final may finalise
type, extends(fckit_final) :: ObjectFortranSafer
  integer :: id = -1
    !! Data of Object (could be anything, like allocatable pointers)
contains
  procedure :: final => ObjectFortranSafer_final
    !! Destructor of the data (e.g. if deallocations need to happen)
endtype

! -----------------------------------------------------------------------------

interface
    function new_Object(i) bind(c,name="new_Object")
      use, intrinsic :: iso_c_binding, only : c_ptr, c_int32_t
      type(c_ptr) :: new_Object
      integer(c_int32_t), value :: i
    end function

   subroutine delete_Object(cptr) bind(c,name="delete_Object")
     use, intrinsic :: iso_c_binding, only : c_ptr
     type(c_ptr), value :: cptr
   end subroutine

   function Object__id(this) bind(c,name="Object__id")
     use, intrinsic :: iso_c_binding, only : c_ptr, c_int32_t
     type(c_ptr), value :: this
     integer(c_int32_t) :: Object__id
   end function

   function cxx_destructor_called() bind(c,name="cxx_destructor_called")
     use, intrinsic :: iso_c_binding, only : c_int32_t
     integer(c_int32_t) :: cxx_destructor_called
   end function

   function cxx_destructor_called_after_scope() bind(c,name="cxx_destructor_called_after_scope")
     use, intrinsic :: iso_c_binding, only : c_int32_t
     integer(c_int32_t) :: cxx_destructor_called_after_scope
   end function

   subroutine cxx_reset_counters() bind(c,name="cxx_reset_counters")
   end subroutine

   subroutine cxx_end_scope() bind(c,name="cxx_end_scope")
   end subroutine

end interface

type, extends(fckit_shared_object) :: ObjectCXX
contains
! public :
  procedure :: id => ObjectCXX_id

#if FCKIT_FINAL_NOT_INHERITING
  final :: ObjectCXX_final_auto
#endif
end type

interface ObjectCXX
  module procedure ObjectCXX_constructor
end interface

! -----------------------------------------------------------------------------
contains
! -----------------------------------------------------------------------------

subroutine reset_counters()
  deallocate_called = .false.
  final_called = 0
  final_called_after_scope = 0
  scope_ended = .false.
  call cxx_reset_counters()
end subroutine

subroutine end_scope()
  scope_ended = .true.
  call cxx_end_scope()
end subroutine

function ObjectCXX_constructor(id) result(this)
  type(ObjectCXX) :: this
  integer :: id
  call this%reset_c_ptr( new_Object(id) , fckit_c_deleter(delete_Object) )
  FCTEST_CHECK_EQUAL( this%owners(), 1 )
  call this%return()
end function

function ObjectCXX_id(this) result(id)
  class(ObjectCXX) :: this
  integer :: id
  id = Object__id( this%CPTR_PGIBUG_B )
end function

FCKIT_FINAL subroutine ObjectCXX_final_auto(this)
  type(ObjectCXX), intent(inout) :: this
  write(0,*) "ObjectCXX_final_auto"
#if FCKIT_FINAL_NOT_PROPAGATING
  call this%final()
#endif
  FCKIT_SUPPRESS_UNUSED( this )
end subroutine


subroutine ObjectFortranSafer_final(this)
  class(ObjectFortranSafer), intent(inout) :: this
  write(0,'(A,I0)') "ObjectFortranSafer_final id",this%id
  this%id = 0
  final_called = final_called + 1
  if( scope_ended ) final_called_after_scope = final_called_after_scope+1
end subroutine

FCKIT_FINAL subroutine ObjectFortranUnSafe_final(this)
  type(ObjectFortranUnSafe), intent(inout) :: this
  write(0,'(A,I0)') "ObjectFortranUnSafe_final id",this%id
  this%id = 0
  final_called = final_called + 1
  if( scope_ended ) final_called_after_scope = final_called_after_scope+1
end subroutine

! -----------------------------------------------------------------------------

end module fcta_shared_ptr_f_fxt

! -----------------------------------------------------------------------------

TESTSUITE_WITH_FIXTURE(fckit_test_shared_ptr_f,fcta_shared_ptr_f_fxt)

! -----------------------------------------------------------------------------

TESTSUITE_INIT
END_TESTSUITE_INIT

! -----------------------------------------------------------------------------

TESTSUITE_FINALIZE
END_TESTSUITE_FINALIZE

! -----------------------------------------------------------------------------

function create_ObjectFortranSafer(id) result(this)
  type(fckit_shared_ptr) :: this
  integer :: id
  class(ObjectFortranSafer), pointer :: ptr
  write(0,'(A,I0)') "Constructing ObjectFortranSafer, id = ",id
  allocate( ObjectFortranSafer::ptr )
  ptr%id = id
  write(0,'(A)') "----> this = fckit_make_shared( obj_ptr )"
  !this = fckit_make_shared( ptr )
  call this%share( ptr )
  write(0,'(A)') "<---- this = fckit_make_shared( obj_ptr )"
  FCTEST_CHECK_EQUAL( this%owners(), 1 )
  call this%return()
end function

subroutine test_shared_ptr_safer( final_auto )
  logical :: final_auto
  type(fckit_shared_ptr) :: obj1
  class(ObjectFortranSafer), pointer :: obj2_ptr => null()
  type(fckit_shared_ptr) :: obj2
  type(fckit_shared_ptr) :: obj3
  class(*), pointer :: shared_ptr

  write(0,'(A)') "~~~~~~~~~~~~~~ BEGIN SCOPE ~~~~~~~~~~~~~~"

  obj1 = create_ObjectFortranSafer(5)
  FCTEST_CHECK_EQUAL( obj1%owners(), 1 )

  obj2 = obj1
  FCTEST_CHECK_EQUAL( obj1%owners(), 2 )
  shared_ptr => obj2%shared_ptr()
  select type(shared_ptr)
    class is(ObjectFortranSafer)
      obj2_ptr=>shared_ptr
  end select
  FCTEST_CHECK( associated(obj2_ptr) )
  FCTEST_CHECK_EQUAL( obj2_ptr%id, 5 )
  obj3 = obj2
  FCTEST_CHECK_EQUAL( obj1%owners(), 3 )
  obj1 = obj3
  FCTEST_CHECK_EQUAL( obj1%owners(), 3 )
  if( .not. final_auto ) then
    write(0,*) "manual final , owners = ", obj1%owners()
    call obj1%final()
    FCTEST_CHECK_EQUAL( obj2%owners(), 2 )
    call obj2%final()
    FCTEST_CHECK_EQUAL( obj3%owners(), 1 )
    call obj3%final()
  endif

  write(0,'(A)') "~~~~~~~~~~~~~~~ END SCOPE ~~~~~~~~~~~~~~~"
  call end_scope()
end subroutine

TEST( test_shared_ptr_safer_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_ptr_safer_manual"

  call reset_counters()
  call test_shared_ptr_safer( .false. )
  FCTEST_CHECK_EQUAL( final_called , 1 )
  FCTEST_CHECK_EQUAL( final_called_after_scope , 0 )
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_ptr_safer_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_ptr_safer_auto"

  call reset_counters()
  call test_shared_ptr_safer( .true. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( final_called, 1 )
  FCTEST_CHECK_EQUAL( final_called_after_scope, 1 )
#else
  FCTEST_CHECK_EQUAL( final_called, 0 )
  FCTEST_CHECK_EQUAL( final_called_after_scope, 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

! -----------------------------------------------------------------------------

function create_ObjectFortranUnSafe(id) result(this)
  type(fckit_shared_ptr) :: this
  integer :: id
  class(ObjectFortranUnSafe), pointer :: ptr
  write(0,'(A,I0)') "Constructing ObjectFortranUnsafe, id = ",id
  allocate( ObjectFortranUnSafe::ptr )
  ptr%id = id
  call this%share( ptr )
  call this%return()
end function

subroutine test_shared_ptr_unsafe( final_auto )
  logical :: final_auto
  type(fckit_shared_ptr) :: obj1
  class(ObjectFortranUnSafe), pointer :: obj2_ptr => null()
  type(fckit_shared_ptr) :: obj2
  class(*), pointer :: shared_ptr

  write(0,'(A)') "~~~~~~~~~~~~~~ BEGIN SCOPE ~~~~~~~~~~~~~~"

  obj1 = create_ObjectFortranUnSafe(5)
  obj2 = obj1
  shared_ptr => obj2%shared_ptr()
  select type(shared_ptr)
    class is(ObjectFortranUnSafe)
      obj2_ptr=>shared_ptr
  end select
  FCTEST_CHECK( associated(obj2_ptr) )
  FCTEST_CHECK_EQUAL( obj2_ptr%id, 5 )

  if( .not. final_auto ) then
    call obj1%final()
    call obj2%final()
  endif

  write(0,'(A)') "~~~~~~~~~~~~~~~ END SCOPE ~~~~~~~~~~~~~~"
  call end_scope()
end subroutine

TEST( test_shared_ptr_unsafe_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST    test_shared_ptr_unsafe_manual"

  call reset_counters()
  FCTEST_CHECK_EQUAL( final_called, 0 )
  call test_shared_ptr_unsafe( .false. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( final_called, 1 )
  FCTEST_CHECK_EQUAL( final_called_after_scope, 0 )
#else
  FCTEST_CHECK_EQUAL( final_called, 0 )  ! --> without finalisation this didnt work as opposed to "safer"
  FCTEST_CHECK_EQUAL( final_called_after_scope, 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_ptr_unsafe_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST    test_shared_ptr_unsafe_auto"

  call reset_counters()
  call test_shared_ptr_unsafe( .true. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( final_called, 1 )
  FCTEST_CHECK_EQUAL( final_called_after_scope, 1 )
#else
  FCTEST_CHECK_EQUAL( final_called, 0 )
  FCTEST_CHECK_EQUAL( final_called_after_scope, 0 )
  write(0,'(A)') "WARNING    memory leaked"
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

! -----------------------------------------------------------------------------

subroutine test_shared_object( final_auto )

  logical :: final_auto
  type(ObjectCXX) :: obj1
  type(fckit_shared_ptr) :: obj2
  type(ObjectCXX) :: obj3

  write(0,'(A)') "~~~~~~~~~~~~~~ BEGIN SCOPE ~~~~~~~~~~~~~~~"

  obj1 = ObjectCXX(7)
  FCTEST_CHECK_EQUAL( obj1%id(), 7 )
  FCTEST_CHECK_EQUAL( obj1%owners(), 1 )

  write(0,*) "obj2 = obj1"
  obj2 = obj1
  FCTEST_CHECK_EQUAL( obj1%owners(), 2 )

  write(0,*) "obj3 = obj2"
  obj3 = obj2
  FCTEST_CHECK_EQUAL( obj1%owners(), 3 )
  FCTEST_CHECK_EQUAL( obj3%id(), 7 )

  write(0,*) "obj1 = obj3"
  obj1 = obj3

  FCTEST_CHECK_EQUAL( obj1%owners(), 3 )
  FCTEST_CHECK_EQUAL( obj2%owners(), 3 )

  write(0,*) "obj1 = ObjectCXX(4)"
  obj1 = ObjectCXX(4)
  FCTEST_CHECK_EQUAL( obj1%owners(), 1 )
  FCTEST_CHECK_EQUAL( obj2%owners(), 2 )

  if( .not. final_auto ) then
    call obj1%final()
    FCTEST_CHECK_EQUAL( obj2%owners(), 2 )
    call obj2%final()
    FCTEST_CHECK_EQUAL( obj3%owners(), 1 )
    call obj3%final()
  endif

  write(0,'(A)') "~~~~~~~~~~~~~~~ END SCOPE ~~~~~~~~~~~~~~~"
  call end_scope()
end subroutine

TEST( test_shared_object_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_manual"
  call reset_counters()
  call test_shared_object( final_auto = .false. )
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_auto"
  call reset_counters()
  call test_shared_object( final_auto = .true. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

! -----------------------------------------------------------------------------

subroutine test_shared_object_allocatable( final_auto, deallocate_auto )

  logical :: final_auto
  logical :: deallocate_auto
  type(ObjectCXX), allocatable :: obj1

  write(0,'(A)') "~~~~~~~~~~~~~~ BEGIN SCOPE ~~~~~~~~~~~~~~~"

  allocate( obj1 )
  obj1 = ObjectCXX(7)
  FCTEST_CHECK_EQUAL( obj1%id(), 7 )
  FCTEST_CHECK_EQUAL( obj1%owners(), 1 )

  if( .not. final_auto ) then
    call obj1%final()
  endif

  if( .not. deallocate_auto ) then
    write(0,'(A)') "~~~~~~~~~~~~~~ DEALLOCATE ~~~~~~~~~~~~~~~"
    deallocate_called = .true.
    deallocate( obj1 )
  endif

  write(0,'(A)') "~~~~~~~~~~~~~~~ END SCOPE ~~~~~~~~~~~~~~~"
  call end_scope()
end subroutine

TEST( test_shared_object_allocatable_auto_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_auto_auto"
  call reset_counters()
  call test_shared_object_allocatable( final_auto = .true., deallocate_auto = .true. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 1 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 1 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_allocatable_auto_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_auto_manual"
  call reset_counters()
  call test_shared_object_allocatable( final_auto = .true., deallocate_auto = .false. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 1 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_allocatable_manual_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_manual_auto"
  call reset_counters()
  call test_shared_object_allocatable( final_auto = .false., deallocate_auto = .true. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 1 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 1 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_allocatable_manual_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_manual_manual"
  call reset_counters()
  call test_shared_object_allocatable( final_auto = .false., deallocate_auto = .false. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 1 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 1 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

! -----------------------------------------------------------------------------

#if defined(_CRAYFTN) && FCKIT_HAVE_FINAL
#define CRAY_WORKAROUND .true.
#else
#define CRAY_WORKAROUND .false.
#endif

subroutine test_shared_object_allocatable_list( final_auto, deallocate_auto )

  logical :: final_auto
  logical :: deallocate_auto
  type(ObjectCXX), allocatable :: list(:)

  write(0,'(A)') "~~~~~~~~~~~~~~ BEGIN SCOPE ~~~~~~~~~~~~~~~"

  allocate( list(2) )
  list(1) = ObjectCXX(1)
  list(2) = ObjectCXX(2)
  write(0,*) "assigned"
  FCTEST_CHECK_EQUAL( list(1)%id(), 1 )
  FCTEST_CHECK_EQUAL( list(1)%owners(), 1 )
  FCTEST_CHECK_EQUAL( list(2)%id(), 2 )
  FCTEST_CHECK_EQUAL( list(2)%owners(), 1 )

  if( .not. final_auto ) then
    write(0,'(A)') "~~~~~~~~~~~~~~ MANNUALLY DEALLOCATE EACH LIST ELEMENT ~~~~~~~~~~~~~~~"
    call list(1)%final()
    call list(2)%final()
  endif

  if( .not. deallocate_auto ) then
    write(0,'(A)') "~~~~~~~~~~~~~~ DEALLOCATE LIST ~~~~~~~~~~~~~~~"
    deallocate_called = .true.
    if( CRAY_WORKAROUND ) then
      write(0,'(A)') "Cray compiler bug (cce/8.5 tested) causes SEGV when the automatic finalization at end of scope kicks in."
      write(0,'(A)') "Therefore we avoid the deallocate( list ) above, to make test pass."
      write(0,'(A)') "This means that with FCKIT_HAVE_FINAL turn on, we cannot manually call deallocate(list)"
    else
      deallocate( list )
    endif
  endif

  write(0,'(A)') "~~~~~~~~~~~~~~~ END SCOPE ~~~~~~~~~~~~~~~"
  call end_scope()
end subroutine

TEST( test_shared_object_allocatable_list_auto_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_list_auto_auto"
  call reset_counters()
  call test_shared_object_allocatable_list( final_auto = .true., deallocate_auto = .true. )
#if FCKIT_HAVE_FINAL
#if ! FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY && ! FCKIT_FINAL_NOT_INHERITING_FOR_ALLOCATABLE_ARRAY
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 2 )
#else
  write(0,'(A)') "-----------------------------------------"
  write(0,'(A)') "WARNING: known to fail test"
  write(0,'(A,I0)') "    FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY         = ", FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
  write(0,'(A,I0)') "    FCKIT_FINAL_NOT_INHERITING_FOR_ALLOCATABLE_ARRAY = ", FCKIT_FINAL_NOT_INHERITING_FOR_ALLOCATABLE_ARRAY
#endif
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_allocatable_list_auto_manual )
#if 1
  integer :: zero
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_list_auto_manual"
  call reset_counters()
  call test_shared_object_allocatable_list( final_auto = .true., deallocate_auto = .false. )
  write(0,'(A)') '----'

  zero = 0
  if( CRAY_WORKAROUND ) zero = 2

#if FCKIT_HAVE_FINAL
#if ! FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY && ! FCKIT_FINAL_NOT_INHERITING_FOR_ALLOCATABLE_ARRAY
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), zero )
#endif
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#else
#ifndef __ibmxl__
#warning test_shared_object_allocatable_list_auto_manual disabled
#endif
#endif
END_TEST

TEST( test_shared_object_allocatable_list_manual_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_list_manual_auto"
  call reset_counters()
  call test_shared_object_allocatable_list( final_auto = .false., deallocate_auto = .true. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#else
#ifndef __ibmxl__
#warning test_shared_object_allocatable_list_manual_auto disabled
#endif
#endif
END_TEST

TEST( test_shared_object_allocatable_list_manual_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_allocatable_list_manual_manual"
  call reset_counters()
  call test_shared_object_allocatable_list( final_auto = .false., deallocate_auto = .false. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#else
#ifndef __ibmxl__
#warning test_shared_object_allocatable_list_manual_manual disabled
#endif
#endif
END_TEST

! -----------------------------------------------------------------------------

subroutine test_shared_object_pointer_list( final_auto, deallocate_auto )

  logical :: final_auto
  logical :: deallocate_auto
  type(ObjectCXX), pointer :: list(:)

  write(0,'(A)') "~~~~~~~~~~~~~~ BEGIN SCOPE ~~~~~~~~~~~~~~~"

  allocate( list(2) )
  write(0,*) "allocated"
  list(1) = ObjectCXX(1)
  list(2) = ObjectCXX(2)
  write(0,*) "assigned"
  FCTEST_CHECK_EQUAL( list(1)%id(), 1 )
  FCTEST_CHECK_EQUAL( list(1)%owners(), 1 )
  FCTEST_CHECK_EQUAL( list(2)%id(), 2 )
  FCTEST_CHECK_EQUAL( list(2)%owners(), 1 )

  if( .not. final_auto ) then
    call list(1)%final()
    call list(2)%final()
  endif

  if( .not. deallocate_auto ) then
    write(0,'(A)') "~~~~~~~~~~~~~~ DEALLOCATE ~~~~~~~~~~~~~~~"
    deallocate_called = .true.
    deallocate( list )
  endif

  write(0,'(A)') "~~~~~~~~~~~~~~~ END SCOPE ~~~~~~~~~~~~~~~"
  call end_scope()
  if( associated(list) ) deallocate( list )
end subroutine

TEST( test_shared_object_pointer_list_auto_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_pointer_list_auto_auto"
  call reset_counters()
  call test_shared_object_pointer_list( final_auto = .true., deallocate_auto = .true. )
#if FCKIT_HAVE_FINAL
#if ! FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY && ! FCKIT_FINAL_NOT_INHERITING_FOR_ALLOCATABLE_ARRAY
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 2 )
#else
  write(0,'(A)') "-----------------------------------------"
  write(0,'(A)') "WARNING: known to fail test"
  write(0,'(A,I0)') "    FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY         = ", FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
  write(0,'(A,I0)') "    FCKIT_FINAL_NOT_INHERITING_FOR_ALLOCATABLE_ARRAY = ", FCKIT_FINAL_NOT_INHERITING_FOR_ALLOCATABLE_ARRAY
#endif
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_pointer_list_auto_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_pointer_list_auto_manual"
  call reset_counters()
  call test_shared_object_pointer_list( final_auto = .true., deallocate_auto = .false. )
#if FCKIT_HAVE_FINAL
#if ! FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY && ! FCKIT_FINAL_NOT_INHERITING_FOR_ALLOCATABLE_ARRAY
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  write(0,'(A)') "-----------------------------------------"
  write(0,'(A)') "WARNING: known to fail test"
  write(0,'(A,I0)') "    FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY         = ", FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY
  write(0,'(A,I0)') "    FCKIT_FINAL_NOT_INHERITING_FOR_ALLOCATABLE_ARRAY = ", FCKIT_FINAL_NOT_INHERITING_FOR_ALLOCATABLE_ARRAY
#endif
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_pointer_list_manual_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_pointer_list_manual_auto"
  call reset_counters()
  call test_shared_object_pointer_list( final_auto = .false., deallocate_auto = .true. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_pointer_list_manual_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_pointer_list_manual_manual"
  call reset_counters()
  call test_shared_object_pointer_list( final_auto = .false., deallocate_auto = .false. )
#if FCKIT_HAVE_FINAL
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST


! -----------------------------------------------------------------------------

subroutine test_shared_object_automatic_list( final_auto )
#if 1
  logical :: final_auto
  type(ObjectCXX) :: list(2)

  write(0,'(A)') "~~~~~~~~~~~~~~ BEGIN SCOPE ~~~~~~~~~~~~~~~"

  list(1) = ObjectCXX(1)
  list(2) = ObjectCXX(2)
  write(0,'(A)') "assigned"
  FCTEST_CHECK_EQUAL( list(1)%id(), 1 )
  FCTEST_CHECK_EQUAL( list(1)%owners(), 1 )
  FCTEST_CHECK_EQUAL( list(2)%id(), 2 )
  FCTEST_CHECK_EQUAL( list(2)%owners(), 1 )

  if( .not. final_auto ) then
    call list(1)%final()
    call list(2)%final()
  endif

  write(0,'(A)') "~~~~~~~~~~~~~~~ END SCOPE ~~~~~~~~~~~~~~~"
  call end_scope()
#endif
end subroutine

TEST( test_shared_object_automatic_list_auto )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_automatic_list_auto"
  call reset_counters()
  call test_shared_object_automatic_list( final_auto = .true. )
#if FCKIT_HAVE_FINAL
#if ! FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY && ! FCKIT_FINAL_NOT_INHERITING_FOR_AUTOMATIC_ARRAY
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 2 )
#else
  write(0,'(A)') "-----------------------------------------"
  write(0,'(A)') "WARNING: known to fail test"
  write(0,'(A,I0)') "    FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY       = ", FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY
  write(0,'(A,I0)') "    FCKIT_FINAL_NOT_INHERITING_FOR_AUTOMATIC_ARRAY = ", FCKIT_FINAL_NOT_INHERITING_FOR_AUTOMATIC_ARRAY
#endif
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 0 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

TEST( test_shared_object_automatic_list_manual )
#if 1
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)') "TEST     test_shared_object_automatic_list_manual"
  call reset_counters()
  call test_shared_object_automatic_list( final_auto = .false. )
#if FCKIT_HAVE_FINAL
#if ! FCKIT_FINAL_NOT_INHERITING_FOR_AUTOMATIC_ARRAY
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
  FCTEST_CHECK_EQUAL( cxx_destructor_called_after_scope(), 0 )
#else
  write(0,'(A)') "-----------------------------------------"
  write(0,'(A)') "WARNING: known to fail test"
  write(0,'(A,I0)') "    FCKIT_FINAL_NOT_INHERITING_FOR_AUTOMATIC_ARRAY = ", FCKIT_FINAL_NOT_INHERITING_FOR_AUTOMATIC_ARRAY
#endif
#else
  FCTEST_CHECK_EQUAL( cxx_destructor_called(), 2 )
#endif
  write(0,'(A)') "-------------------------------------------------------------"
  write(0,'(A)')
#endif
END_TEST

! -----------------------------------------------------------------------------

END_TESTSUITE

#!/bin/bash

set -e

SCRIPTDIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

MPI="$1"
os=$(uname)
OMPIVER=openmpi-3.0.0
MPICHVER=3.2.1

PREFIX=$(pwd)/${MPI}
mkdir -p ${PREFIX}
touch ${PREFIX}/env.sh

MPI_INSTALLED=false

case "$os" in
    Darwin)
        case "$MPI" in
            mpich)
                brew ls --versions mpich || brew install mpich
                ;;
            openmpi)
                brew ls --versions openmpi || brew install openmpi
                echo "localhost slots=72" >> /usr/local/etc/openmpi-default-hostfile
                ;;
            *)
                echo "Unknown MPI implementation: $MPI"
                exit 1
                ;;
        esac
    ;;

    Linux)
        if [ -n "${MPI_HOME}" ]; then
          echo "MPI is already installed at MPI_HOME=${MPI_HOME}."
          echo "Not taking any action."
          exit 0
        fi
        case "$MPI" in
            mpich)
                if [ -f mpich/include/mpi.h ]; then
                  echo "mpich/include/mpi.h found."
                fi
                if [ -f mpich/lib/libmpich.so ]; then
                  echo "libmpich.so found -- nothing to build."
                else
                  echo "Downloading mpich source..."
                  wget http://www.mpich.org/static/downloads/${MPICHVER}/mpich-${MPICHVER}.tar.gz
                  tar xfz mpich-${MPICHVER}.tar.gz
                  rm mpich-${MPICHVER}.tar.gz
                  echo "Configuring and building mpich..."
                  cd mpich-${MPICHVER}
                  ${SCRIPTDIR}/reduce-output.sh ./configure \
                          --prefix=${PREFIX} \
                          --enable-static=false \
                          --enable-alloca=true \
                          --enable-threads=single \
                          --enable-fortran=yes \
                          --enable-fast=all \
                          --enable-g=none \
                          --enable-timing=none
                  ${SCRIPTDIR}/reduce-output.sh make -j4
                  ${SCRIPTDIR}/reduce-output.sh make install
                  MPI_INSTALLED=true
                  cd -
                fi
                ;;
            openmpi)
                if [ -f openmpi/include/mpi.h ]; then
                  echo "openmpi/include/mpi.h found."
                fi
                if [ -f openmpi/lib/libmpi.so ] || [ -f openmpi/lib64/libmpi.so ]; then
                  echo "libmpi.so found -- nothing to build."
                else
                  echo "Downloading openmpi source..."
                  wget --no-check-certificate https://www.open-mpi.org/software/ompi/v3.0/downloads/$OMPIVER.tar.gz
                  tar -zxf $OMPIVER.tar.gz
                  rm $OMPIVER.tar.gz
                  echo "Configuring and building openmpi..."
                  cd $OMPIVER
                  ${SCRIPTDIR}/reduce-output.sh ./configure \
                          --prefix=${PREFIX}
                  ${SCRIPTDIR}/reduce-output.sh make -j4
                  ${SCRIPTDIR}/reduce-output.sh make install
                  MPI_INSTALLED=true
                  echo "localhost slots=72" >> ${PREFIX}/etc/openmpi-default-hostfile
                  cd -
                fi
                ;;
            *)
                echo "Unknown MPI implementation: $MPI"
                exit 1
                ;;
        esac
        ;;

    *)
        echo "Unknown operating system: $os"
        exit 1
        ;;
esac


if ${MPI_INSTALLED} ; then
cat > ${PREFIX}/env.sh << EOF
export MPI_HOME=${PREFIX}
export PATH=\${MPI_HOME}/bin:\${PATH}
EOF
fi

echo "Please source ${PREFIX}/env.sh, containing:"
cat ${PREFIX}/env.sh

#!/bin/bash
testdir="$(dirname $0)"
if [ $# -gt 0 ]; then
  pythons=$*
else
  pythons="python3"
fi
root=".."
if [ -z "$PYTHONPATH" ]; then
  export PYTHONPATH="$root/src"
else
  export PYTHONPATH="$root/src:$PYTHONPATH"
fi
cd $testdir
failed="0"
failing_pythons=""
for python in $pythons; do
  echo "Testing with interpreter '$python'"
  $python test_fypp.py
  exitcode=$?
  if [ $exitcode != 0 ]; then
    failed="$(($failed + 1))"
    if [ -z "$failing_pythons" ]; then
      failing_pythons=$python
    else
      failing_pythons="$failing_pythons, $python"
    fi
  fi
done
echo
if [ $failed -gt 0 ]; then
  echo "Failing test runs: $failed" >&2
  echo "Failing interpreter(s): $failing_pythons" >&2
  exit 1
else
  echo "All test runs finished successfully"
  exit 0
fi

#!/bin/bash

[[ $(uname) == "Darwin" ]] && return # no module environment on the Mac

# initialise module environment if it is not
if [[ ! $(command -v module > /dev/null 2>&1) ]]; then
  . /usr/local/apps/module/init/bash
fi

module unload grib_api
module unload eccodes
module unload emos
module unload fftw
module unload libemos
module unload metview
module unload netcdf4

module load cmake/3.16.5
module load python3/3.8.8-01

#! /usr/bin/env bash

SCRIPTDIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
export PATH=$SCRIPTDIR:$PATH

# Some defaults for the arguments
owner=ecmwf
repo="unknown"
branch=master
PREFIX=$(pwd)/install
skip_install=true

while [ $# != 0 ]; do
    case "$1" in
    "--owner")
        owner="$2"; shift
        ;;
    "--repo")
        repo="$2"; shift
        ;;
    "--branch")
        branch="$2"; shift
        ;;
    "--depends")
        depends=($2); shift
        ;;
    "--cmake")
        CMAKE_OPTIONS="$2"; shift
        ;;
    "--prefix")
        PREFIX="$2"; shift
        ;;
    "--no-cache")
        skip_install=false;
        ;;
    *)
        echo "Unrecognized argument '$1'"
        exit 1
        ;;
    esac
    shift
done

SHA=$(github-sha.sh ${owner} ${repo} ${branch})
echo "Installing ${owner}/${repo} branch ${branch} at sha [${SHA}]"

all_deps_uptodate=true
for dep in "${depends[@]}"; do
  DEP=$(echo ${dep} | awk '{print toupper($0)}')
  DEP_PATH=$(eval "echo \$${DEP}_PATH")
  curr_sha=$(cat ${DEP_PATH}/sha/${dep})

  if [[ -f ${PREFIX}/sha/${dep} ]]; then
    prev_sha=$(cat ${PREFIX}/sha/${dep})
    if [ "${prev_sha}" == "${curr_sha}" ]; then
      uptodate=true
    else
      uptodate=false
    fi
  else
    uptodate=true
  fi
  mkdir -p ${PREFIX}/sha
  touch ${PREFIX}/sha/${dep}
  echo ${curr_sha} > ${PREFIX}/sha/${dep}

  if ! ${uptodate}; then
    all_deps_uptodate=false
  fi
done
if ${skip_install} ; then
  skip_install=${all_deps_uptodate}
fi

if [[ -f "${PREFIX}/sha-${SHA}" ]]; then
  echo "Cached ${repo} (sha-${SHA}) is up to date."
else
  skip_install=false
  if ls ${PREFIX}/sha-* 1> /dev/null 2>&1; then
     echo "Cached ${repo} $(ls -1 ${PREFIX}/sha-*) is out of date."
  fi
fi

if ! ${skip_install} ; then
  echo "Installing ${repo} sha-${SHA}"
  pushd . >> /dev/null 2>&1
  if [ -z "${TMPDIR}" ]; then
    TMPDIR=${HOME}/tmp
  fi
  SOURCE_DIR=${TMPDIR}/downloads/${repo}
  BUILD_DIR=${TMPDIR}/builds/${repo}
  rm -rf ${PREFIX} ${SOURCE_DIR} ${BUILD_DIR}

  # Download
  mkdir -p ${TMPDIR}/downloads
  echo "+ git clone -b ${branch} https://github.com/${owner}/${repo} ${SOURCE_DIR}"
  git clone -b ${branch} https://github.com/${owner}/${repo} ${SOURCE_DIR}

  # Configure and install
  mkdir -p ${BUILD_DIR} && cd ${BUILD_DIR}
  echo "+ cmake -DCMAKE_MODULE_PATH=${ECBUILD_MODULE_PATH} -DCMAKE_INSTALL_PREFIX=${PREFIX} ${CMAKE_OPTIONS} ${SOURCE_DIR}"
  cmake -DCMAKE_MODULE_PATH=${ECBUILD_MODULE_PATH} -DCMAKE_INSTALL_PREFIX=${PREFIX} ${CMAKE_OPTIONS} ${SOURCE_DIR}
  make -j4 install

  # Store version information
  mkdir -p ${PREFIX}/sha
  touch ${PREFIX}/sha-${SHA}
  echo ${SHA} > ${PREFIX}/sha/${repo}
  for dep in "${depends[@]}"; do
    DEP=$(echo ${dep} | awk '{print toupper($0)}')
    DEP_PATH=$(eval "echo \$${DEP}_PATH")
    curr_sha=$(cat ${DEP_PATH}/sha/${dep})
    echo ${curr_sha} > ${PREFIX}/sha/${dep}
  done
  popd >> /dev/null 2>&1
  rm -rf ${SOURCE_DIR} ${BUILD_DIR}

fi

# Export
REPO=$(echo $repo | awk '{print toupper($0)}')
echo "To make it easier to find ${repo}, execute now"
echo "export ${REPO}_PATH=${PREFIX}"

#!/usr/bin/env bash
set -e

if [[ ${FCKIT_EVAL_ARGS_EXCLUDE:-unset} != unset ]]; then
  excludes=()
  IFS=${FCKIT_EVAL_ARGS_EXCLUDE_DELIMITER:-,} read -r -a excludes <<< "$FCKIT_EVAL_ARGS_EXCLUDE"
  args=("$@")
  for ((i=0; i<"${#args[@]}"; ++i)); do
    for exclude in "${excludes[@]}"; do
      if [[ "${args[i]}" =~ ${exclude} ]]; then
        unset args[i];
      fi
    done
  done
  if [[ ${FCKIT_EVAL_VERBOSE:-unset} == 1 ]]; then
    echo "+ ${args[@]}"
  fi
  eval "${args[@]}"
else
  if [[ ${FCKIT_EVAL_VERBOSE:-unset} == 1 ]]; then
    echo "+ $@"
  fi
  eval "$@"
fi

#!/bin/bash

if [[ $(uname) == "Darwin" ]]; then
   # Up to date CMake version required
   export PATH=${HOME}/Applications/CMake.app/Contents/bin:${PATH}
   # No module environment on the Mac
   return
fi

# initialise module environment if it is not
if [[ ! $(command -v module > /dev/null 2>&1) ]]; then
  . /usr/local/apps/module/init/bash
fi

module unload grib_api
module unload eccodes
module unload emos
module unload fftw
module unload libemos
module unload metview
module unload netcdf4

module load cmake/3.16.5
module load python3/3.8.8-01

module switch gnu clang

# Features:
#
# - Keeps carriage returns (unlike [:space:]), so it works fine on Windows/DOS-style files.
# - Only worries about "normal" whitespace - If you have vertical tabs or such in your files it's probably intentional (test code or raw data).
# - Skips the .git and .svn VCS directories.
# - Only modifies files which file thinks is a text file.
# - Reports all paths which were skipped.
# - Works with any filename.

while IFS= read -r -d '' -u 9
do
    if [[ "$(file -bs --mime-type -- "$REPLY")" = text/* ]]
    then
        sed -i -e 's/[ \t]\+\(\r\?\)$/\1/;$a\' -- "$REPLY"
    else
        echo "Skipping $REPLY" >&2
    fi
done 9< <(find . \( -type d -regex '^.*/\.\(git\|svn\|hg\)$' -prune -false \) -o -type f -print0)

#!/bin/sh

# Install PGI Community Edition on Travis
# https://github.com/nemequ/pgi-travis
#
# Originally written for Squash <https://github.com/quixdb/squash> by
# Evan Nemerson.  For documentation, bug reports, support requests,
# etc. please use <https://github.com/nemequ/pgi-travis>.
#
# To the extent possible under law, the author(s) of this script have
# waived all copyright and related or neighboring rights to this work.
# See <https://creativecommons.org/publicdomain/zero/1.0/> for
# details.

TEMPORARY_FILES="/tmp"

export PGI_SILENT=true
export PGI_ACCEPT_EULA=accept
export PGI_INSTALL_DIR="${HOME}/pgi"
export PGI_INSTALL_NVIDIA=false
export PGI_INSTALL_AMD=false
export PGI_INSTALL_JAVA=false
export PGI_INSTALL_MPI=false
export PGI_MPI_GPU_SUPPORT=false
export PGI_INSTALL_MANAGED=false


VERBOSE=false

while [ $# != 0 ]; do
    case "$1" in
    "--prefix")
        export PGI_INSTALL_DIR="$2"; shift
        ;;
    "--tmpdir")
        TEMPORARY_FILES="$2"; shift
        ;;
    "--nvidia")
        export PGI_INSTALL_NVIDIA=true
        ;;
    "--amd")
        export PGI_INSTALL_AMD=true
        ;;
    "--java")
        export PGI_INSTALL_JAVA=true
        ;;
    "--mpi")
        export PGI_INSTALL_MPI=true
        ;;
    "--mpi-gpu")
        export PGI_INSTALL_MPI_GPU=true
        ;;
    "--managed")
        export PGI_INSTALL_MANAGED=true
        ;;
    "--verbose")
        VERBOSE=true;
        ;;
    *)
        echo "Unrecognized argument '$1'"
        exit 1
        ;;
    esac
    shift
done

if [ ! -e "${TEMPORARY_FILES}" ]; then
    mkdir -p "${TEMPORARY_FILES}"
fi
cd "${TEMPORARY_FILES}"

PGI_URL="https://www.pgroup.com/support/downloader.php?file=pgi-community-linux-x64"

curl --location \
     --user-agent "pgi-travis (https://github.com/nemequ/pgi-travis; ${TRAVIS_REPO_SLUG})" \
     --referer "http://www.pgroup.com/products/community.htm" \
     --header "X-Travis-Build-Number: ${TRAVIS_BUILD_NUMBER}" \
     --header "X-Travis-Event-Type: ${TRAVIS_EVENT_TYPE}" \
     --header "X-Travis-Job-Number: ${TRAVIS_JOB_NUMBER}" \
     "${PGI_URL}" | tar zxf -

if [ x"${VERBOSE}" = "xtrue" ]; then
    VERBOSE_SHORT="-v"
    VERBOSE_V="v"
fi

cd "${TEMPORARY_FILES}"/install_components && ./install

PGI_VERSION=$(basename "${PGI_INSTALL_DIR}"/linux86-64/*.*/)


cat > ${PGI_INSTALL_DIR}/env.sh << EOF
### Variables
PGI_INSTALL_DIR=${PGI_INSTALL_DIR}
PGI_VERSION=${PGI_VERSION}

### Compilers
PGI_DIR=\${PGI_INSTALL_DIR}/linux86-64/\${PGI_VERSION}
export PATH=\${PGI_DIR}/bin:\${PATH}
EOF

if ${PGI_INSTALL_MPI} ; then
cat >> ${PGI_INSTALL_DIR}/env.sh << EOF

### MPI
export MPI_HOME=\${PGI_DIR}/mpi/openmpi
export PATH=\${MPI_HOME}/bin:\${PATH}
EOF
fi


# INSTALL_BINDIR="${HOME}/bin"
# if [ ! -e "${INSTALL_BINDIR}" ]; then
#     mkdir -p "${INSTALL_BINDIR}"
# fi

# for file in "${PGI_INSTALL_DIR}"/linux86-64/"${PGI_VERSION}"/bin/*; do
#     dest="${INSTALL_BINDIR}/$(basename "${file}")"
#     if [ -x "${file}" ]; then
#     echo "#!/bin/sh" > "${dest}"
#     echo "PGI=${PGI_INSTALL_DIR} PGI_INSTALL=\"\${PGI}\"/linux86-64/${PGI_VERSION} ${file} \$@" >> "${dest}"
#     chmod 0755 "${dest}"
#     fi
# done

#!/bin/bash
# Abort on Error
set -e

PING_SLEEP=30s

dump_output() {
   echo " ++ Tailing the last 100 lines of output from $BUILD_OUTPUT"
   tail -100 $BUILD_OUTPUT  
}
error_handler() {
  echo ERROR: An error was encountered with the build.
  kill $PING_LOOP_PID
  dump_output
  exit 1
}
# If an error occurs, run our error handler to output a tail of the build
trap 'error_handler' ERR

# Set up a repeating loop to display some output regularly.
bash -c "while true; do sleep $PING_SLEEP; echo \" ++ \$(date) - running ... \"; done" &
PING_LOOP_PID=$!
BUILD_OUTPUT=build-$PING_LOOP_PID.out
touch $BUILD_OUTPUT
echo " + $@"
echo " ++ Output redirected to $BUILD_OUTPUT"
$@ >> $BUILD_OUTPUT 2>&1

# The build finished without returning an error so dump a tail of the output
dump_output

# nicely terminate the ping output loop
kill $PING_LOOP_PID

#!/usr/bin/env bash

owner=$1
repo=$2
branch=$3

if [ -z "${TMPDIR}" ]; then
  TMPDIR=${HOME}/tmp
fi
SOURCE_DIR=${TMPDIR}/check-git-${repo}

dump_output() {
   echo " ++ Tailing the last 500 lines of output from ${BUILD_OUTPUT}"
   tail -500 ${BUILD_OUTPUT}
}
error_handler() {
  echo ERROR: An error was encountered with the build.
  rm -rf ${SOURCE_DIR}
  dump_output
  exit 1
}
# If an error occurs, run our error handler to output a tail of the build
trap 'error_handler' ERR

BUILD_OUTPUT=${TMPDIR}/tmp-${repo}.log

mkdir -p ${TMPDIR}
touch $BUILD_OUTPUT
pushd . >> ${BUILD_OUTPUT} 2>&1
git clone --depth=1 -b ${branch} https://github.com/${owner}/${repo} ${SOURCE_DIR} >> ${BUILD_OUTPUT} 2>&1 
cd ${SOURCE_DIR} >> ${BUILD_OUTPUT} 2>&1 
git rev-parse HEAD
cd ..
rm -rf ${SOURCE_DIR}
popd >> ${BUILD_OUTPUT} 2>&1

#!/bin/bash

# NOTE we dont use auditwheel because we dont want eckit and its deps to end up
# here. We could use --exclude, but thats more work than what we have, and we'd
# additionally need to not have names mangled

set -euo pipefail
source_target=python/fckitlib/src/copying
mkdir -p $source_target
mkdir -p /tmp/fckit/target/fckit/lib64/

# NOTE we hardcode lib list here, but note it may change with compiler version
# in that case rerun:
# `auditwheel lddtree /tmp/fckit/build/lib/libfckit.so 2>&1 | grep realpath | grep intel`
# or refactor to do this in post-compile/post-build step (but thats more work)

if [ -d /opt/intel/oneapi ] ; then
    libs="libifport.so.5 libimf.so libintlc.so.5 libifcoremt.so.5 libsvml.so libirc.so"
    echo "bundling in libs $libs"
    root="/opt/intel/oneapi/compiler/latest/lib/"
    for lib in $libs ; do
        cp $root/$lib /tmp/fckit/target/fckit/lib64/
        patchelf --add-rpath '$ORIGIN' /tmp/fckit/target/fckit/lib64/$lib
    done
    # a bug in the intel libraries themselves -- dependency not declared but actually there
    patchelf --add-needed libifcoremt.so.5 /tmp/fckit/target/fckit/lib64/libifport.so.5

    cp /opt/intel/oneapi/compiler/latest/share/doc/compiler/licensing/fortran/LICENSE $source_target/intel.LICENSE
    cp /opt/intel/oneapi/compiler/latest/share/doc/compiler/licensing/fortran/third-party-programs.txt $source_target/intel.third-party-programs.txt
    echo "{\"$(echo $libs | tr ' ' ',')\": {\"home\": \"https://www.intel.com/content/www/us/en/developer/articles/license/end-user-license-agreement.html\", \"path\": \"copying/intel*\"}}" > $source_target/list.json

    intel_version=$(ls /opt/intel/oneapi/compiler/ | grep -v latest | sort -r | head -n 1)
    echo "intel: $intel_version" >> $source_target/../versions.txt
else
    # TODO macos support ???
    # TODO nvidia fortran on arm ???
    echo "no external bundle"
fi

#!/bin/bash
testdir="$(dirname $0)"
if [ $# -gt 0 ]; then
  pythons=$*
else
  pythons="python"
fi
root=".."
if [ -z "$PYTHONPATH" ]; then
  export PYTHONPATH="$root/src"
else
  export PYTHONPATH="$root/src:$PYTHONPATH"
fi
cd $testdir
failed="0"
failing_pythons=""
for python in $pythons; do
  echo "Testing with interpreter '$python'"
  $python test_fypp.py
  exitcode=$?
  if [ $exitcode != 0 ]; then
    failed="$(($failed + 1))"
    if [ -z "$failing_pythons" ]; then
      failing_pythons=$python
    else
      failing_pythons="$failing_pythons, $python"
    fi
  fi
done
echo
if [ $failed -gt 0 ]; then
  echo "Failing test runs: $failed" >&2
  echo "Failing interpreter(s): $failing_pythons" >&2
  exit 1
else
  echo "All test runs finished successfully"
  exit 0
fi
